
'''
This is auto-generated file,
which includes metadata for module Cisco_IOS_XR_infra_syslog_oper
'''

from ydk._core._dm_meta_info import _MetaInfoClassMember, _MetaInfoClass, _MetaInfoEnum
from ydk._core._dm_meta_info import ATTRIBUTE, REFERENCE_LIST, REFERENCE_LEAFLIST, REFERENCE_BITS, REFERENCE_UNION
from ydk._core._dm_meta_info import REFERENCE_CLASS, REFERENCE_IDENTITY_CLASS, REFERENCE_ENUM_CLASS, ANYXML_CLASS
from ydk._core._importer import _yang_ns

_meta_table = {
    'SystemMessageSeverity' : _MetaInfoEnum('SystemMessageSeverity',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
        '''System message severity''',
        {
            'message-severity-unknown':'message_severity_unknown',
            'message-severity-emergency':'message_severity_emergency',
            'message-severity-alert':'message_severity_alert',
            'message-severity-critical':'message_severity_critical',
            'message-severity-error':'message_severity_error',
            'message-severity-warning':'message_severity_warning',
            'message-severity-notice':'message_severity_notice',
            'message-severity-informational':'message_severity_informational',
            'message-severity-debug':'message_severity_debug',
        }, 'Cisco-IOS-XR-infra-syslog-oper', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper']),
    'GetSyslog.Input.Filters' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Input.Filters', REFERENCE_CLASS,
            '''A set of filters of syslog messages to be returned''',
            False, 
            [
            _MetaInfoClassMember('start-time', ATTRIBUTE, 'str', 'yang:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                Start timestamp of syslog messages to be returned
                ''',
                'start_time',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('end-time', ATTRIBUTE, 'str', 'yang:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                End timestamp of syslog messages to be returned
                ''',
                'end_time',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'filters',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            has_must=True,
        ),
    },
    'GetSyslog.Input' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Input', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('filters', REFERENCE_CLASS, 'Filters', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Input.Filters',
                [], [],
                '''                A set of filters of syslog messages to be returned
                ''',
                'filters',
                'Cisco-IOS-XR-infra-syslog-oper', False, has_must=True),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'input',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog.Output.Data.Syslog.Messages.Message' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Output.Data.Syslog.Messages.Message', REFERENCE_LIST,
            '''A system message''',
            False, 
            [
            _MetaInfoClassMember('message-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message ID of the system message
                ''',
                'message_id',
                'Cisco-IOS-XR-infra-syslog-oper', True),
            _MetaInfoClassMember('card-type', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message card location: 'RP', 'DRP', 'LC', 'SC',
                'SP' or 'UNK' 
                ''',
                'card_type',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('node-name', ATTRIBUTE, 'str', 'xr:Node-id',
                None, None,
                [], [b'([a-zA-Z0-9_]*\\d+/){1,2}([a-zA-Z0-9_]*\\d+)'],
                '''                Message source location
                ''',
                'node_name',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('time-stamp', ATTRIBUTE, 'int', 'uint64',
                None, None,
                [('0', '18446744073709551615')], [],
                '''                Time in milliseconds since 00:00:00 UTC, January
                11970 of when message was generated
                ''',
                'time_stamp',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('time-of-day', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Time of day of event in DDD MMM DD  YYYY HH:MM
                :SS format, e.g Wed Apr 01 2009  15:50:26
                ''',
                'time_of_day',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('time-zone', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Time Zone in UTC+/-HH:MM format,  e.g UTC+5:30,
                UTC-6
                ''',
                'time_zone',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('process-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Process name
                ''',
                'process_name',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('category', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message category
                ''',
                'category',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('group', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message group
                ''',
                'group',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('message-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message name
                ''',
                'message_name',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Message severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('text', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Additional message text
                ''',
                'text',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'message',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog.Output.Data.Syslog.Messages' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Output.Data.Syslog.Messages', REFERENCE_CLASS,
            '''Message table information''',
            False, 
            [
            _MetaInfoClassMember('message', REFERENCE_LIST, 'Message', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Output.Data.Syslog.Messages.Message',
                [], [],
                '''                A system message
                ''',
                'message',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'messages',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog.Output.Data.Syslog' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Output.Data.Syslog', REFERENCE_CLASS,
            '''syslog''',
            False, 
            [
            _MetaInfoClassMember('messages', REFERENCE_CLASS, 'Messages', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Output.Data.Syslog.Messages',
                [], [],
                '''                Message table information
                ''',
                'messages',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'syslog',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog.Output.Data' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Output.Data', REFERENCE_CLASS,
            '''Output for RPC operation''',
            False, 
            [
            _MetaInfoClassMember('syslog', REFERENCE_CLASS, 'Syslog', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Output.Data.Syslog',
                [], [],
                '''                syslog
                ''',
                'syslog',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'data',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog.Output' : {
        'meta_info' : _MetaInfoClass('GetSyslog.Output', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('data', REFERENCE_CLASS, 'Data', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Output.Data',
                [], [],
                '''                Output for RPC operation
                ''',
                'data',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'output',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'GetSyslog' : {
        'meta_info' : _MetaInfoClass('GetSyslog', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('input', REFERENCE_CLASS, 'Input', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Input',
                [], [],
                '''                ''',
                'input',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            _MetaInfoClassMember('output', REFERENCE_CLASS, 'Output', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'GetSyslog.Output',
                [], [],
                '''                ''',
                'output',
                'Cisco-IOS-XR-infra-syslog-oper', False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'get-syslog',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
        ),
    },
    'Logging.History' : {
        'meta_info' : _MetaInfoClass('Logging.History', REFERENCE_CLASS,
            '''Syslog Info ''',
            False, 
            [
            _MetaInfoClassMember('properties', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Syslog Properties
                ''',
                'properties',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Syslog Message
                ''',
                'message',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'history',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Logging' : {
        'meta_info' : _MetaInfoClass('Logging', REFERENCE_CLASS,
            '''Logging History data''',
            False, 
            [
            _MetaInfoClassMember('history', REFERENCE_CLASS, 'History', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Logging.History',
                [], [],
                '''                Syslog Info 
                ''',
                'history',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'logging',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingFiles.FileLogDetail' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingFiles.FileLogDetail', REFERENCE_LIST,
            '''Logging Files''',
            False, 
            [
            _MetaInfoClassMember('file-path', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                File path for logging messages
                ''',
                'file_path',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('file-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                File name for logging messages
                ''',
                'file_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'file-log-detail',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingFiles' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingFiles', REFERENCE_CLASS,
            '''Logging Files information''',
            False, 
            [
            _MetaInfoClassMember('file-log-detail', REFERENCE_LIST, 'FileLogDetail', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingFiles.FileLogDetail',
                [], [],
                '''                Logging Files
                ''',
                'file_log_detail',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'logging-files',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.AnRemoteServers.AnRemoteLogServer' : {
        'meta_info' : _MetaInfoClass('Syslog.AnRemoteServers.AnRemoteLogServer', REFERENCE_LIST,
            '''AN Remote Log Servers''',
            False, 
            [
            _MetaInfoClassMember('ip-address', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                IP Address
                ''',
                'ip_address',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('vrf-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                VRF Name
                ''',
                'vrf_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('vrf-severity', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                VRF Severity
                ''',
                'vrf_severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('rh-discriminator', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Remote-Host Discriminator
                ''',
                'rh_discriminator',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'an-remote-log-server',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.AnRemoteServers' : {
        'meta_info' : _MetaInfoClass('Syslog.AnRemoteServers', REFERENCE_CLASS,
            '''Logging AN remote servers information''',
            False, 
            [
            _MetaInfoClassMember('an-remote-log-server', REFERENCE_LIST, 'AnRemoteLogServer', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.AnRemoteServers.AnRemoteLogServer',
                [], [],
                '''                AN Remote Log Servers
                ''',
                'an_remote_log_server',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'an-remote-servers',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.Messages.Message' : {
        'meta_info' : _MetaInfoClass('Syslog.Messages.Message', REFERENCE_LIST,
            '''A system message''',
            False, 
            [
            _MetaInfoClassMember('message-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message ID of the system message
                ''',
                'message_id',
                'Cisco-IOS-XR-infra-syslog-oper', True, is_config=False),
            _MetaInfoClassMember('card-type', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message card location: 'RP', 'DRP', 'LC', 'SC',
                'SP' or 'UNK' 
                ''',
                'card_type',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('node-name', ATTRIBUTE, 'str', 'xr:Node-id',
                None, None,
                [], [b'([a-zA-Z0-9_]*\\d+/){1,2}([a-zA-Z0-9_]*\\d+)'],
                '''                Message source location
                ''',
                'node_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('time-stamp', ATTRIBUTE, 'int', 'uint64',
                None, None,
                [('0', '18446744073709551615')], [],
                '''                Time in milliseconds since 00:00:00 UTC, January
                11970 of when message was generated
                ''',
                'time_stamp',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('time-of-day', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Time of day of event in DDD MMM DD  YYYY HH:MM
                :SS format, e.g Wed Apr 01 2009  15:50:26
                ''',
                'time_of_day',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('time-zone', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Time Zone in UTC+/-HH:MM format,  e.g UTC+5:30,
                UTC-6
                ''',
                'time_zone',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('process-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Process name
                ''',
                'process_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('category', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message category
                ''',
                'category',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('group', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message group
                ''',
                'group',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message name
                ''',
                'message_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Message severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('text', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Additional message text
                ''',
                'text',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'message',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.Messages' : {
        'meta_info' : _MetaInfoClass('Syslog.Messages', REFERENCE_CLASS,
            '''Message table information''',
            False, 
            [
            _MetaInfoClassMember('message', REFERENCE_LIST, 'Message', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.Messages.Message',
                [], [],
                '''                A system message
                ''',
                'message',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'messages',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.LoggingStats' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.LoggingStats', REFERENCE_CLASS,
            '''Logging statistics''',
            False, 
            [
            _MetaInfoClassMember('is-log-enabled', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is log enabled
                ''',
                'is_log_enabled',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('drop-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of messages dropped
                ''',
                'drop_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('flush-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of messages flushed
                ''',
                'flush_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('overrun-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of messages overrun
                ''',
                'overrun_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'logging-stats',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.ConsoleLoggingStats' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.ConsoleLoggingStats', REFERENCE_CLASS,
            '''Console logging statistics''',
            False, 
            [
            _MetaInfoClassMember('is-log-enabled', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is log enabled
                ''',
                'is_log_enabled',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Configured severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('buffer-size', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Buffer size in bytes if logging buffer isenabled
                ''',
                'buffer_size',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'console-logging-stats',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.MonitorLoggingStats' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.MonitorLoggingStats', REFERENCE_CLASS,
            '''Monitor loggingstatistics''',
            False, 
            [
            _MetaInfoClassMember('is-log-enabled', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is log enabled
                ''',
                'is_log_enabled',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Configured severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('buffer-size', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Buffer size in bytes if logging buffer isenabled
                ''',
                'buffer_size',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'monitor-logging-stats',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.TrapLoggingStats' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.TrapLoggingStats', REFERENCE_CLASS,
            '''Trap logging statistics''',
            False, 
            [
            _MetaInfoClassMember('is-log-enabled', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is log enabled
                ''',
                'is_log_enabled',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Configured severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('buffer-size', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Buffer size in bytes if logging buffer isenabled
                ''',
                'buffer_size',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'trap-logging-stats',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.BufferLoggingStats' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.BufferLoggingStats', REFERENCE_CLASS,
            '''Buffer logging statistics''',
            False, 
            [
            _MetaInfoClassMember('is-log-enabled', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is log enabled
                ''',
                'is_log_enabled',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('severity', REFERENCE_ENUM_CLASS, 'SystemMessageSeverity', 'System-message-severity',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'SystemMessageSeverity',
                [], [],
                '''                Configured severity
                ''',
                'severity',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('buffer-size', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Buffer size in bytes if logging buffer isenabled
                ''',
                'buffer_size',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'buffer-logging-stats',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.RemoteLoggingStat' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.RemoteLoggingStat', REFERENCE_LIST,
            '''Remote logging statistics''',
            False, 
            [
            _MetaInfoClassMember('remote-host-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Remote hostname
                ''',
                'remote_host_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'remote-logging-stat',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.TlsRemoteLoggingStat' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.TlsRemoteLoggingStat', REFERENCE_LIST,
            '''TLS Remote logging statistics''',
            False, 
            [
            _MetaInfoClassMember('remote-host-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                TLS Remote hostname
                ''',
                'remote_host_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'tls-remote-logging-stat',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics.FileLoggingStat' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics.FileLoggingStat', REFERENCE_LIST,
            '''File logging statistics''',
            False, 
            [
            _MetaInfoClassMember('file-name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                File name for logging messages
                ''',
                'file_name',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('message-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Message count
                ''',
                'message_count',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'file-logging-stat',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog.LoggingStatistics' : {
        'meta_info' : _MetaInfoClass('Syslog.LoggingStatistics', REFERENCE_CLASS,
            '''Logging statistics information''',
            False, 
            [
            _MetaInfoClassMember('logging-stats', REFERENCE_CLASS, 'LoggingStats', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.LoggingStats',
                [], [],
                '''                Logging statistics
                ''',
                'logging_stats',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('console-logging-stats', REFERENCE_CLASS, 'ConsoleLoggingStats', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.ConsoleLoggingStats',
                [], [],
                '''                Console logging statistics
                ''',
                'console_logging_stats',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('monitor-logging-stats', REFERENCE_CLASS, 'MonitorLoggingStats', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.MonitorLoggingStats',
                [], [],
                '''                Monitor loggingstatistics
                ''',
                'monitor_logging_stats',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('trap-logging-stats', REFERENCE_CLASS, 'TrapLoggingStats', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.TrapLoggingStats',
                [], [],
                '''                Trap logging statistics
                ''',
                'trap_logging_stats',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('buffer-logging-stats', REFERENCE_CLASS, 'BufferLoggingStats', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.BufferLoggingStats',
                [], [],
                '''                Buffer logging statistics
                ''',
                'buffer_logging_stats',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('remote-logging-stat', REFERENCE_LIST, 'RemoteLoggingStat', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.RemoteLoggingStat',
                [], [],
                '''                Remote logging statistics
                ''',
                'remote_logging_stat',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('tls-remote-logging-stat', REFERENCE_LIST, 'TlsRemoteLoggingStat', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.TlsRemoteLoggingStat',
                [], [],
                '''                TLS Remote logging statistics
                ''',
                'tls_remote_logging_stat',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('file-logging-stat', REFERENCE_LIST, 'FileLoggingStat', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics.FileLoggingStat',
                [], [],
                '''                File logging statistics
                ''',
                'file_logging_stat',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'logging-statistics',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
    'Syslog' : {
        'meta_info' : _MetaInfoClass('Syslog', REFERENCE_CLASS,
            '''syslog''',
            False, 
            [
            _MetaInfoClassMember('logging-files', REFERENCE_CLASS, 'LoggingFiles', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingFiles',
                [], [],
                '''                Logging Files information
                ''',
                'logging_files',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('an-remote-servers', REFERENCE_CLASS, 'AnRemoteServers', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.AnRemoteServers',
                [], [],
                '''                Logging AN remote servers information
                ''',
                'an_remote_servers',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('messages', REFERENCE_CLASS, 'Messages', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.Messages',
                [], [],
                '''                Message table information
                ''',
                'messages',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            _MetaInfoClassMember('logging-statistics', REFERENCE_CLASS, 'LoggingStatistics', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper', 'Syslog.LoggingStatistics',
                [], [],
                '''                Logging statistics information
                ''',
                'logging_statistics',
                'Cisco-IOS-XR-infra-syslog-oper', False, is_config=False),
            ],
            'Cisco-IOS-XR-infra-syslog-oper',
            'syslog',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-infra-syslog-oper'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_syslog_oper',
            is_config=False,
        ),
    },
}
_meta_table['GetSyslog.Input.Filters']['meta_info'].parent =_meta_table['GetSyslog.Input']['meta_info']
_meta_table['GetSyslog.Output.Data.Syslog.Messages.Message']['meta_info'].parent =_meta_table['GetSyslog.Output.Data.Syslog.Messages']['meta_info']
_meta_table['GetSyslog.Output.Data.Syslog.Messages']['meta_info'].parent =_meta_table['GetSyslog.Output.Data.Syslog']['meta_info']
_meta_table['GetSyslog.Output.Data.Syslog']['meta_info'].parent =_meta_table['GetSyslog.Output.Data']['meta_info']
_meta_table['GetSyslog.Output.Data']['meta_info'].parent =_meta_table['GetSyslog.Output']['meta_info']
_meta_table['GetSyslog.Input']['meta_info'].parent =_meta_table['GetSyslog']['meta_info']
_meta_table['GetSyslog.Output']['meta_info'].parent =_meta_table['GetSyslog']['meta_info']
_meta_table['Logging.History']['meta_info'].parent =_meta_table['Logging']['meta_info']
_meta_table['Syslog.LoggingFiles.FileLogDetail']['meta_info'].parent =_meta_table['Syslog.LoggingFiles']['meta_info']
_meta_table['Syslog.AnRemoteServers.AnRemoteLogServer']['meta_info'].parent =_meta_table['Syslog.AnRemoteServers']['meta_info']
_meta_table['Syslog.Messages.Message']['meta_info'].parent =_meta_table['Syslog.Messages']['meta_info']
_meta_table['Syslog.LoggingStatistics.LoggingStats']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.ConsoleLoggingStats']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.MonitorLoggingStats']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.TrapLoggingStats']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.BufferLoggingStats']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.RemoteLoggingStat']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.TlsRemoteLoggingStat']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingStatistics.FileLoggingStat']['meta_info'].parent =_meta_table['Syslog.LoggingStatistics']['meta_info']
_meta_table['Syslog.LoggingFiles']['meta_info'].parent =_meta_table['Syslog']['meta_info']
_meta_table['Syslog.AnRemoteServers']['meta_info'].parent =_meta_table['Syslog']['meta_info']
_meta_table['Syslog.Messages']['meta_info'].parent =_meta_table['Syslog']['meta_info']
_meta_table['Syslog.LoggingStatistics']['meta_info'].parent =_meta_table['Syslog']['meta_info']
