
'''
This is auto-generated file,
which includes metadata for module Cisco_IOS_XR_sysadmin_issu
'''

from ydk._core._dm_meta_info import _MetaInfoClassMember, _MetaInfoClass, _MetaInfoEnum
from ydk._core._dm_meta_info import ATTRIBUTE, REFERENCE_LIST, REFERENCE_LEAFLIST, REFERENCE_BITS, REFERENCE_UNION
from ydk._core._dm_meta_info import REFERENCE_CLASS, REFERENCE_IDENTITY_CLASS, REFERENCE_ENUM_CLASS, ANYXML_CLASS
from ydk._core._importer import _yang_ns

_meta_table = {
    'OpStartResult' : _MetaInfoEnum('OpStartResult',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStartResult',
        '''Enumeration of errors that can be encountered while attempting to begin an ISSU operation''',
        {
            'start-success':'start_success',
            'error-operation-in-progress':'error_operation_in_progress',
            'activate-error-no-prepare':'activate_error_no_prepare',
            'prepare-error-previous-prepare':'prepare_error_previous_prepare',
            'recover-error-unrecoverable':'recover_error_unrecoverable',
            'start-error-internal':'start_error_internal',
            'prepare-error-previous-operation-not-committed':'prepare_error_previous_operation_not_committed',
            'prepare-error-already-in-progress':'prepare_error_already_in_progress',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'OpResult' : _MetaInfoEnum('OpResult',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpResult',
        '''Enumeration of errors that can be encountered during an ISSU operation''',
        {
            'success':'success',
            'error-input':'error_input',
            'error-orchestration':'error_orchestration',
            'error-install':'error_install',
            'error-node-redundancy':'error_node_redundancy',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'IssuNotif' : _MetaInfoEnum('IssuNotif',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'IssuNotif',
        '''Enumeration of notifications that features can be registered for''',
        {
            'notif-sysadmin-op-start':'notif_sysadmin_op_start',
            'notif-sysadmin-phase-start':'notif_sysadmin_phase_start',
            'notif-sysadmin-op-end':'notif_sysadmin_op_end',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'OpStage' : _MetaInfoEnum('OpStage',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
        '''Enumeration of stages that the ISSU operation can be in''',
        {
            'prepare-preamble':'prepare_preamble',
            'prepare-host':'prepare_host',
            'prepare-sysadmin':'prepare_sysadmin',
            'prepare-aborting':'prepare_aborting',
            'prepare-postamble':'prepare_postamble',
            'prepare-complete':'prepare_complete',
            'activate-preamble':'activate_preamble',
            'activate-sysadmin-phase-one':'activate_sysadmin_phase_one',
            'activate-sysadmin-phase-two':'activate_sysadmin_phase_two',
            'activate-host':'activate_host',
            'activate-aborting':'activate_aborting',
            'activate-paused':'activate_paused',
            'activate-postamble':'activate_postamble',
            'activate-complete':'activate_complete',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'IssuAction' : {
        'meta_info' : _MetaInfoClass('IssuAction', REFERENCE_CLASS,
            '''ISSU action commands''',
            False, 
            [
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'issu_action',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Status.Prepare' : {
        'meta_info' : _MetaInfoClass('Issu.Status.Prepare', REFERENCE_CLASS,
            '''State specific to the prepare phase''',
            False, 
            [
            _MetaInfoClassMember('stage', REFERENCE_ENUM_CLASS, 'OpStage', 'op-stage',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
                [], [],
                '''                Progress of the prepare phase
                ''',
                'stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                When this ehase was started
                ''',
                'start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                A description of the current orchestration activity being executed
                ''',
                'activity',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity-start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                When the current activity was started
                ''',
                'activity_start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'prepare',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Status.Activate' : {
        'meta_info' : _MetaInfoClass('Issu.Status.Activate', REFERENCE_CLASS,
            '''State specific to the activate phase''',
            False, 
            [
            _MetaInfoClassMember('stage', REFERENCE_ENUM_CLASS, 'OpStage', 'op-stage',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
                [], [],
                '''                Progress of the activate phase
                ''',
                'stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                When this phase was started
                ''',
                'start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                A description of the current orchestration activity being executed
                ''',
                'activity',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity-nodes', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Nodes on which the current orchestration activity is being executed
                ''',
                'activity_nodes',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity-waiting-for', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                A description of what needs to happen before the next orchestration activity can be started
                ''',
                'activity_waiting_for',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activity-start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                When the current activity was started
                ''',
                'activity_start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'activate',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Status.Error.Details' : {
        'meta_info' : _MetaInfoClass('Issu.Status.Error.Details', REFERENCE_CLASS,
            '''Details specific to the error. Contents are only filled in if it is relevant to the error that occured.''',
            False, 
            [
            _MetaInfoClassMember('nodes', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                A list of the nodes affected by or causing the error.
                ''',
                'nodes',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('clients', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                A list of the registered features affected by or causing the error.
                ''',
                'clients',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('packages', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                A list of the packages affected by or causing the error.
                ''',
                'packages',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('operation-ids', REFERENCE_LEAFLIST, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                A list of the operation IDs affected by or causing the error.
                ''',
                'operation_ids',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'details',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Status.Error' : {
        'meta_info' : _MetaInfoClass('Issu.Status.Error', REFERENCE_CLASS,
            '''Details of the first error that was encountered, if there were any.''',
            False, 
            [
            _MetaInfoClassMember('result', REFERENCE_ENUM_CLASS, 'OpResult', 'op-result',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpResult',
                [], [],
                '''                If the operation has completed, an indication of whether the operation succeeded or failed, and the error if any
                ''',
                'result',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('stage', REFERENCE_ENUM_CLASS, 'OpStage', 'op-stage',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
                [], [],
                '''                The stage during which the error was encountered
                ''',
                'stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error-message', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Message describing the error.
                ''',
                'error_message',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('details', REFERENCE_CLASS, 'Details', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.Error.Details',
                [], [],
                '''                Details specific to the error. Contents are only filled in if it is relevant to the error that occured.
                ''',
                'details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'error',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Status.OperationType' : _MetaInfoEnum('OperationType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.OperationType',
        '''Whether the operation is an activate or deactivate. Both types of operation go through 'prepare' and 'activate' phases.The difference is the end result: whether the target packages are made to run, or removed from the running software.''',
        {
            'no-operation':'no_operation',
            'activate-operation':'activate_operation',
            'deactivate-operation':'deactivate_operation',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Status' : {
        'meta_info' : _MetaInfoClass('Issu.Status', REFERENCE_CLASS,
            '''Status of the in-progress or last completed ISSU operation''',
            False, 
            [
            _MetaInfoClassMember('operation-type', REFERENCE_ENUM_CLASS, 'OperationType', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.OperationType',
                [], [],
                '''                Whether the operation is an activate or deactivate. Both types of operation go through 'prepare' and 'activate' phases.The difference is the end result: whether the target packages are made to run, or removed from the running software.
                ''',
                'operation_type',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                ID for the current/latest phase of the operation
                ''',
                'id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('prepare-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                ID for the prepare phase of the operation
                ''',
                'prepare_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activate-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                ID for the activate or deactivate phase of the operation
                ''',
                'activate_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('sysadmin-packages', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Sysadmin packages that are part of the operation
                ''',
                'sysadmin_packages',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('host-packages', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Host OS packages that are part of the operation
                ''',
                'host_packages',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('complete', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Whether or not the operation has completed.
                ''',
                'complete',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('result', REFERENCE_ENUM_CLASS, 'OpResult', 'op-result',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpResult',
                [], [],
                '''                Whether the operation succeeded or failed, and the error if any. If in progress, this reflects the current state.
                ''',
                'result',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('recover-result', REFERENCE_ENUM_CLASS, 'OpResult', 'op-result',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpResult',
                [], [],
                '''                If a recovery attempt has been completed, an indication of whether the recovery succeeded or failed, and the error if any
                ''',
                'recover_result',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('prepare', REFERENCE_CLASS, 'Prepare', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.Prepare',
                [], [],
                '''                State specific to the prepare phase
                ''',
                'prepare',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activate', REFERENCE_CLASS, 'Activate', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.Activate',
                [], [],
                '''                State specific to the activate phase
                ''',
                'activate',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error', REFERENCE_CLASS, 'Error', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status.Error',
                [], [],
                '''                Details of the first error that was encountered, if there were any.
                ''',
                'error',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'status',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Clients.Client.Response' : _MetaInfoEnum('Response',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients.Client.Response',
        '''Response from this client to most recent notification sent to the client''',
        {
            'notif-resp-no-notif':'notif_resp_no_notif',
            'notif-resp-pending':'notif_resp_pending',
            'notif-resp-ack':'notif_resp_ack',
            'notif-resp-veto':'notif_resp_veto',
            'notif-resp-disconnect':'notif_resp_disconnect',
            'notif-resp-timeout':'notif_resp_timeout',
            'notif-resp-send-error':'notif_resp_send_error',
            'notif-resp-client-error':'notif_resp_client_error',
            'notif-resp-client-abort':'notif_resp_client_abort',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Clients.Client' : {
        'meta_info' : _MetaInfoClass('Issu.Clients.Client', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('name', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Name of the registered feature
                ''',
                'name',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('location', ATTRIBUTE, 'str', 'calvados:location-id',
                None, None,
                [], [b'((([bB][0-9])/(([a-zA-Z]){2}\\d{1,2}))|(([fF][0-7])/(([a-zA-Z]){2}\\d{1,2}))|((0?[0-9]|1[0-5])/((([a-zA-Z]){2,3})?\\d{1,2})))(/[cC][pP][uU]0)?'],
                '''                Node on which the feature process is running
                ''',
                'location',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('registered-for', REFERENCE_LEAFLIST, 'IssuNotif', 'issu-notif',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'IssuNotif',
                [], [],
                '''                Which notifications the feature is registered to receive
                ''',
                'registered_for',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('notif', REFERENCE_ENUM_CLASS, 'IssuNotif', 'issu-notif',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'IssuNotif',
                [], [],
                '''                Type of most recent notification
                ''',
                'notif',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('response', REFERENCE_ENUM_CLASS, 'Response', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients.Client.Response',
                [], [],
                '''                Response from this client to most recent notification sent to the client
                ''',
                'response',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('aborted', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Whether the feature has requested that the current operation be aborted
                ''',
                'aborted',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('abort-reason', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Description of the reason for requesting an abort, if applicable
                ''',
                'abort_reason',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'client',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Clients.AnnouncementStatus' : _MetaInfoEnum('AnnouncementStatus',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients.AnnouncementStatus',
        '''Status of most recent notification sent to clients''',
        {
            'announce-no-notif':'announce_no_notif',
            'announce-in-progress':'announce_in_progress',
            'announce-success':'announce_success',
            'announce-veto':'announce_veto',
            'announce-disconnect':'announce_disconnect',
            'announce-timeout':'announce_timeout',
            'announce-send-error':'announce_send_error',
            'announce-client-error':'announce_client_error',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Clients' : {
        'meta_info' : _MetaInfoClass('Issu.Clients', REFERENCE_CLASS,
            '''Features registered for notifications of ISSU phases''',
            False, 
            [
            _MetaInfoClassMember('announcement', REFERENCE_ENUM_CLASS, 'IssuNotif', 'issu-notif',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'IssuNotif',
                [], [],
                '''                Type of most recent notification sent to clients
                ''',
                'announcement',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('announcement-status', REFERENCE_ENUM_CLASS, 'AnnouncementStatus', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients.AnnouncementStatus',
                [], [],
                '''                Status of most recent notification sent to clients
                ''',
                'announcement_status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('client', REFERENCE_LIST, 'Client', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients.Client',
                [], [],
                '''                ''',
                'client',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'clients',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.OperationStartDetails' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.OperationStartDetails', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('input-package', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Packages used to initiate the operation
                ''',
                'input_package',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('input-operation-id', REFERENCE_LEAFLIST, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Operation IDs used to initiate operation
                ''',
                'input_operation_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'operation-start-details',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory.HistoricalStage' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory.HistoricalStage', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('stage-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer stage index
                ''',
                'stage_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('external-stage', REFERENCE_ENUM_CLASS, 'OpStage', 'op-stage',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
                [], [],
                '''                External stage of operation
                ''',
                'external_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('internal-stage-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Details of the internal stage
                ''',
                'internal_stage_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('status', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Status of the stage
                ''',
                'status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Further error details
                ''',
                'error_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                Start time of stage
                ''',
                'start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('end-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                End time of stage
                ''',
                'end_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('complete', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is the stage complete?
                ''',
                'complete',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'historical-stage',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('historical-stage', REFERENCE_LIST, 'HistoricalStage', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory.HistoricalStage',
                [], [],
                '''                ''',
                'historical_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'prepare-stage-history',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalPrepare' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalPrepare', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('operation-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                ID of prepare operation
                ''',
                'operation_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('complete', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if prepare phase complete
                ''',
                'complete',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('current-stage', REFERENCE_ENUM_CLASS, 'Issu.Internals.StageType', 'stage-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.StageType',
                [], [],
                '''                Current stage of prepare operation, if a stage is in progress
                ''',
                'current_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('host-package', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Host packages to be used in the ISSU
                ''',
                'host_package',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('calvados-package', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Calvados packages to be used in the ISSU
                ''',
                'calvados_package',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('prepare-stage-history', REFERENCE_CLASS, 'PrepareStageHistory', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory',
                [], [],
                '''                ''',
                'prepare_stage_history',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'internal-prepare',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory.HistoricalStage' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory.HistoricalStage', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('stage-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer stage index
                ''',
                'stage_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('external-stage', REFERENCE_ENUM_CLASS, 'OpStage', 'op-stage',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'OpStage',
                [], [],
                '''                External stage of operation
                ''',
                'external_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('internal-stage-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Details of the internal stage
                ''',
                'internal_stage_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('status', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Status of the stage
                ''',
                'status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Further error details
                ''',
                'error_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('start-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                Start time of stage
                ''',
                'start_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('end-time', ATTRIBUTE, 'str', 'ietf-types:date-and-time',
                None, None,
                [], [b'\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(Z|[\\+\\-]\\d{2}:\\d{2})'],
                '''                End time of stage
                ''',
                'end_time',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('complete', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Is the stage complete?
                ''',
                'complete',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'historical-stage',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('historical-stage', REFERENCE_LIST, 'HistoricalStage', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory.HistoricalStage',
                [], [],
                '''                ''',
                'historical_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'activate-stage-history',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.InternalActivate' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.InternalActivate', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('operation-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                ID of prepare operation
                ''',
                'operation_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('complete', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if activate phase complete
                ''',
                'complete',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('current-stage', REFERENCE_ENUM_CLASS, 'Issu.Internals.StageType', 'stage-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.StageType',
                [], [],
                '''                Current stage of activate operation, if a stage is in progress
                ''',
                'current_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('current-phase', REFERENCE_ENUM_CLASS, 'Issu.Internals.PhaseType', 'phase-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.PhaseType',
                [], [],
                '''                Current phase of activate operation, if phase is relevant
                ''',
                'current_phase',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('host-prepared', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Indicates whether any host packages have been prepared
                ''',
                'host_prepared',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('calvados-prepared', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Indicates whether any Calvados packages have been prepared
                ''',
                'calvados_prepared',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('host-node', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Nodes participating in host ISSU
                ''',
                'host_node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('calvados-phase-one-node', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Nodes participating in phase one of Calvados ISSU
                ''',
                'calvados_phase_one_node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('calvados-phase-two-node', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Nodes participating in phase two of Calvados ISSU
                ''',
                'calvados_phase_two_node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('activate-stage-history', REFERENCE_CLASS, 'ActivateStageHistory', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory',
                [], [],
                '''                ''',
                'activate_stage_history',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'internal-activate',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator.Error' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator.Error', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('operation-status', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Overall status of the operation
                ''',
                'operation_status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failure-operation', REFERENCE_ENUM_CLASS, 'Issu.Internals.OpRequestType', 'op-request-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.OpRequestType',
                [], [],
                '''                Operation in progress when first error was encountered
                ''',
                'failure_operation',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failure-external-stage', REFERENCE_ENUM_CLASS, 'Issu.Internals.StageType', 'stage-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.StageType',
                [], [],
                '''                Stage being undertaken when first failure was encountered
                ''',
                'failure_external_stage',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failure-internal-stage-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Description of the internal state when first error encountered
                ''',
                'failure_internal_stage_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                String describing error encountered
                ''',
                'error_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failed-node', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Nodes on which a failure occurred
                ''',
                'failed_node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failed-package', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Packages which caused a failure
                ''',
                'failed_package',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failed-operation-id', REFERENCE_LEAFLIST, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Operation IDs which caused a failure
                ''',
                'failed_operation_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('failed-client', REFERENCE_LEAFLIST, 'str', 'string',
                None, None,
                [], [],
                '''                Registered features which caused a failure
                ''',
                'failed_client',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('recovery-attempted', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if a recovery has been attempted or is currently in progress
                ''',
                'recovery_attempted',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('recovery-status', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Status of the recovery operation
                ''',
                'recovery_status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'error',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Orchestrator' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Orchestrator', REFERENCE_CLASS,
            '''Orchestrator module internal state''',
            False, 
            [
            _MetaInfoClassMember('command', REFERENCE_ENUM_CLASS, 'Issu.Internals.OpRequestType', 'op-request-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.OpRequestType',
                [], [],
                '''                Command issued
                ''',
                'command',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('operation-type', REFERENCE_ENUM_CLASS, 'Issu.Internals.OpRequestType', 'op-request-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.OpRequestType',
                [], [],
                '''                Type of operation: activate or deactivate
                ''',
                'operation_type',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('current-operation', REFERENCE_ENUM_CLASS, 'Issu.Internals.OpRequestType', 'op-request-type',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.OpRequestType',
                [], [],
                '''                Operation being performed
                ''',
                'current_operation',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('issu-completed', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if the overall ISSU operation has been completed, false otherwise
                ''',
                'issu_completed',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('operation-id', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                The ID for the operation
                ''',
                'operation_id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('in-progress', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if an operation is in progress
                ''',
                'in_progress',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('operation-start-details', REFERENCE_CLASS, 'OperationStartDetails', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.OperationStartDetails',
                [], [],
                '''                ''',
                'operation_start_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('internal-prepare', REFERENCE_CLASS, 'InternalPrepare', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalPrepare',
                [], [],
                '''                ''',
                'internal_prepare',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('internal-activate', REFERENCE_CLASS, 'InternalActivate', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.InternalActivate',
                [], [],
                '''                ''',
                'internal_activate',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error', REFERENCE_CLASS, 'Error', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator.Error',
                [], [],
                '''                ''',
                'error',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'orchestrator',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests.Request.Checkpoint.MessageType' : _MetaInfoEnum('MessageType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Checkpoint.MessageType',
        '''Checkpoint request type''',
        {
            'requests-checkpoint-start':'requests_checkpoint_start',
            'requests-checkpoint-end':'requests_checkpoint_end',
            'requests-checkpoint-update':'requests_checkpoint_update',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals.Agents.Requests.Request.Checkpoint' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests.Request.Checkpoint', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('message-type', REFERENCE_ENUM_CLASS, 'MessageType', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Checkpoint.MessageType',
                [], [],
                '''                Checkpoint request type
                ''',
                'message_type',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('data-length', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Length of checkpoint data. 0 for start/end requests
                ''',
                'data_length',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('filename', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Filename of associated checkpoint file
                ''',
                'filename',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'checkpoint',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents.AgentStatus' : _MetaInfoEnum('AgentStatus',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents.AgentStatus',
        '''Enum indicating node status''',
        {
            'agent-response-ok':'agent_response_ok',
            'agent-response-error':'agent_response_error',
            'agent-response-timeout':'agent_response_timeout',
            'agent-response-send-failure':'agent_response_send_failure',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('agent-status', REFERENCE_ENUM_CLASS, 'AgentStatus', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents.AgentStatus',
                [], [],
                '''                Enum indicating node status
                ''',
                'agent_status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('error-details', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Further details of error occuring
                ''',
                'error_details',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'response-contents',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests.Request.Agents_.Agent' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests.Request.Agents_.Agent', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('agent-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer agent index
                ''',
                'agent_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('node', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Node ID
                ''',
                'node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('waiting-for-response', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                Indicates whether this agent has responded
                ''',
                'waiting_for_response',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('response-contents', REFERENCE_CLASS, 'ResponseContents', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents',
                [], [],
                '''                ''',
                'response_contents',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'agent',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests.Request.Agents_' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests.Request.Agents_', REFERENCE_CLASS,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('agent', REFERENCE_LIST, 'Agent', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Agents_.Agent',
                [], [],
                '''                ''',
                'agent',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'agents',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests.Request.RequestType' : _MetaInfoEnum('RequestType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.RequestType',
        '''Type of request''',
        {
            'requests-node-ready':'requests_node_ready',
            'requests-checkpoint':'requests_checkpoint',
            'requests-post-upgrade-cleanup':'requests_post_upgrade_cleanup',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals.Agents.Requests.Request' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests.Request', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('request-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer request index
                ''',
                'request_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('request-type', REFERENCE_ENUM_CLASS, 'RequestType', 'enumeration',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.RequestType',
                [], [],
                '''                Type of request
                ''',
                'request_type',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('checkpoint', REFERENCE_CLASS, 'Checkpoint', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Checkpoint',
                [], [],
                '''                ''',
                'checkpoint',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('requests-sent', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of requests sent. Equal to number of expected responses
                ''',
                'requests_sent',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('responses-received', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of responses received from agents
                ''',
                'responses_received',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('agents', REFERENCE_CLASS, 'Agents_', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request.Agents_',
                [], [],
                '''                ''',
                'agents',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'request',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Requests' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Requests', REFERENCE_CLASS,
            '''Data on requests being processed by Agent module''',
            False, 
            [
            _MetaInfoClassMember('request', REFERENCE_LIST, 'Request', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests.Request',
                [], [],
                '''                ''',
                'request',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'requests',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Inventory.Agent' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Inventory.Agent', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('agent-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer agent index
                ''',
                'agent_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('agent-node', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Agent node ID
                ''',
                'agent_node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('reloaded', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if node has been reloaded. False otherwise
                ''',
                'reloaded',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'agent',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.Inventory' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.Inventory', REFERENCE_CLASS,
            '''Inventory of agents held by Agent module''',
            False, 
            [
            _MetaInfoClassMember('agent', REFERENCE_LIST, 'Agent', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Inventory.Agent',
                [], [],
                '''                ''',
                'agent',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'inventory',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.ReloadTracking.Node' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.ReloadTracking.Node', REFERENCE_LIST,
            ''' ''',
            False, 
            [
            _MetaInfoClassMember('node-index', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Integer node index
                ''',
                'node_index',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('id', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Node ID
                ''',
                'id',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('reloaded', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if node has been reloaded. False otherwise
                ''',
                'reloaded',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'node',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents.ReloadTracking' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents.ReloadTracking', REFERENCE_CLASS,
            '''Reload tracking performed by Agent module''',
            False, 
            [
            _MetaInfoClassMember('in-progress', ATTRIBUTE, 'bool', 'boolean',
                None, None,
                [], [],
                '''                True if reload tracking in progress
                ''',
                'in_progress',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('remaining-nodes-count', ATTRIBUTE, 'int', 'uint32',
                None, None,
                [('0', '4294967295')], [],
                '''                Number of nodes which have not yet reloaded
                ''',
                'remaining_nodes_count',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('node', REFERENCE_LIST, 'Node', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.ReloadTracking.Node',
                [], [],
                '''                ''',
                'node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'reload-tracking',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.Agents' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.Agents', REFERENCE_CLASS,
            '''Agent module internal state''',
            False, 
            [
            _MetaInfoClassMember('requests', REFERENCE_CLASS, 'Requests', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Requests',
                [], [],
                '''                Data on requests being processed by Agent module
                ''',
                'requests',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('inventory', REFERENCE_CLASS, 'Inventory', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.Inventory',
                [], [],
                '''                Inventory of agents held by Agent module
                ''',
                'inventory',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('reload-tracking', REFERENCE_CLASS, 'ReloadTracking', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents.ReloadTracking',
                [], [],
                '''                Reload tracking performed by Agent module
                ''',
                'reload_tracking',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'agents',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.InventoryMonitor.Inventory.Node' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.InventoryMonitor.Inventory.Node', REFERENCE_LIST,
            '''The tree of nodes within the Inventory monitor module, keyed by node ID''',
            False, 
            [
            _MetaInfoClassMember('node', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Node ID
                ''',
                'node',
                'Cisco-IOS-XR-sysadmin-issu', True, is_config=False),
            _MetaInfoClassMember('ip', ATTRIBUTE, 'str', 'string',
                None, None,
                [], [],
                '''                Node IP address
                ''',
                'ip',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'node',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.InventoryMonitor.Inventory' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.InventoryMonitor.Inventory', REFERENCE_CLASS,
            '''Inventory of nodes in the system held by ISSU Director''',
            False, 
            [
            _MetaInfoClassMember('node', REFERENCE_LIST, 'Node', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.InventoryMonitor.Inventory.Node',
                [], [],
                '''                The tree of nodes within the Inventory monitor module, keyed by node ID
                ''',
                'node',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'inventory',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.InventoryMonitor' : {
        'meta_info' : _MetaInfoClass('Issu.Internals.InventoryMonitor', REFERENCE_CLASS,
            '''Inventory monitor module internal state''',
            False, 
            [
            _MetaInfoClassMember('inventory', REFERENCE_CLASS, 'Inventory', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.InventoryMonitor.Inventory',
                [], [],
                '''                Inventory of nodes in the system held by ISSU Director
                ''',
                'inventory',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'inventory-monitor',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu.Internals.OpRequestType' : _MetaInfoEnum('OpRequestType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.OpRequestType',
        '''Enumeration of requests that initiate (part of) an ISSU operation''',
        {
            'operation-request-prepare':'operation_request_prepare',
            'operation-request-activate':'operation_request_activate',
            'operation-request-deactivate':'operation_request_deactivate',
            'operation-request-recover':'operation_request_recover',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals.PhaseType' : _MetaInfoEnum('PhaseType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.PhaseType',
        '''Calvados activate phase''',
        {
            'calvados-activate-phase-one':'calvados_activate_phase_one',
            'calvados-activate-phase-two':'calvados_activate_phase_two',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals.StageType' : _MetaInfoEnum('StageType',
        'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.StageType',
        '''Enumeration of possible internal stages in an operation''',
        {
            'start':'start',
            'end':'end',
            'prepare-inventory-precheck':'prepare_inventory_precheck',
            'prepare-expand-operation-ids':'prepare_expand_operation_ids',
            'prepare-get-metadata':'prepare_get_metadata',
            'prepare-extract-composite':'prepare_extract_composite',
            'prepare-verify-packages':'prepare_verify_packages',
            'prepare-host':'prepare_host',
            'prepare-calvados':'prepare_calvados',
            'prepare-deactivate-verify-packages':'prepare_deactivate_verify_packages',
            'prepare-deactivate-calvados':'prepare_deactivate_calvados',
            'prepare-abort':'prepare_abort',
            'prepare-clean':'prepare_clean',
            'activate-preamble':'activate_preamble',
            'deactivate-preamble':'deactivate_preamble',
            'activate-calvados-preamble':'activate_calvados_preamble',
            'activate-calvados-phase':'activate_calvados_phase',
            'activate-calvados-phase-reload':'activate_calvados_phase_reload',
            'activate-calvados-phase-postamble':'activate_calvados_phase_postamble',
            'activate-calvados-postamble':'activate_calvados_postamble',
            'activate-host':'activate_host',
            'activate-postamble':'activate_postamble',
            'deactivate-calvados':'deactivate_calvados',
            'activate-abort-no-recovery':'activate_abort_no_recovery',
            'activate-abort-unrecoverable':'activate_abort_unrecoverable',
            'activate-error-pause':'activate_error_pause',
            'activate-calvados-recovery':'activate_calvados_recovery',
            'activate-recovery-postamble':'activate_recovery_postamble',
        }, 'Cisco-IOS-XR-sysadmin-issu', _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu']),
    'Issu.Internals' : {
        'meta_info' : _MetaInfoClass('Issu.Internals', REFERENCE_CLASS,
            '''Internal infrastructure state''',
            False, 
            [
            _MetaInfoClassMember('orchestrator', REFERENCE_CLASS, 'Orchestrator', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Orchestrator',
                [], [],
                '''                Orchestrator module internal state
                ''',
                'orchestrator',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('agents', REFERENCE_CLASS, 'Agents', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.Agents',
                [], [],
                '''                Agent module internal state
                ''',
                'agents',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('inventory-monitor', REFERENCE_CLASS, 'InventoryMonitor', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals.InventoryMonitor',
                [], [],
                '''                Inventory monitor module internal state
                ''',
                'inventory_monitor',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'internals',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
    'Issu' : {
        'meta_info' : _MetaInfoClass('Issu', REFERENCE_CLASS,
            '''ISSU operational state''',
            False, 
            [
            _MetaInfoClassMember('status', REFERENCE_CLASS, 'Status', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Status',
                [], [],
                '''                Status of the in-progress or last completed ISSU operation
                ''',
                'status',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('clients', REFERENCE_CLASS, 'Clients', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Clients',
                [], [],
                '''                Features registered for notifications of ISSU phases
                ''',
                'clients',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            _MetaInfoClassMember('internals', REFERENCE_CLASS, 'Internals', '',
                'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu', 'Issu.Internals',
                [], [],
                '''                Internal infrastructure state
                ''',
                'internals',
                'Cisco-IOS-XR-sysadmin-issu', False, is_config=False),
            ],
            'Cisco-IOS-XR-sysadmin-issu',
            'issu',
            _yang_ns.NAMESPACE_LOOKUP['Cisco-IOS-XR-sysadmin-issu'],
            'ydk.models.cisco_ios_xr.Cisco_IOS_XR_sysadmin_issu',
            is_config=False,
        ),
    },
}
_meta_table['Issu.Status.Error.Details']['meta_info'].parent =_meta_table['Issu.Status.Error']['meta_info']
_meta_table['Issu.Status.Prepare']['meta_info'].parent =_meta_table['Issu.Status']['meta_info']
_meta_table['Issu.Status.Activate']['meta_info'].parent =_meta_table['Issu.Status']['meta_info']
_meta_table['Issu.Status.Error']['meta_info'].parent =_meta_table['Issu.Status']['meta_info']
_meta_table['Issu.Clients.Client']['meta_info'].parent =_meta_table['Issu.Clients']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory.HistoricalStage']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalPrepare.PrepareStageHistory']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator.InternalPrepare']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory.HistoricalStage']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalActivate.ActivateStageHistory']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator.InternalActivate']['meta_info']
_meta_table['Issu.Internals.Orchestrator.OperationStartDetails']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalPrepare']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator']['meta_info']
_meta_table['Issu.Internals.Orchestrator.InternalActivate']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator']['meta_info']
_meta_table['Issu.Internals.Orchestrator.Error']['meta_info'].parent =_meta_table['Issu.Internals.Orchestrator']['meta_info']
_meta_table['Issu.Internals.Agents.Requests.Request.Agents_.Agent.ResponseContents']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Requests.Request.Agents_.Agent']['meta_info']
_meta_table['Issu.Internals.Agents.Requests.Request.Agents_.Agent']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Requests.Request.Agents_']['meta_info']
_meta_table['Issu.Internals.Agents.Requests.Request.Checkpoint']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Requests.Request']['meta_info']
_meta_table['Issu.Internals.Agents.Requests.Request.Agents_']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Requests.Request']['meta_info']
_meta_table['Issu.Internals.Agents.Requests.Request']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Requests']['meta_info']
_meta_table['Issu.Internals.Agents.Inventory.Agent']['meta_info'].parent =_meta_table['Issu.Internals.Agents.Inventory']['meta_info']
_meta_table['Issu.Internals.Agents.ReloadTracking.Node']['meta_info'].parent =_meta_table['Issu.Internals.Agents.ReloadTracking']['meta_info']
_meta_table['Issu.Internals.Agents.Requests']['meta_info'].parent =_meta_table['Issu.Internals.Agents']['meta_info']
_meta_table['Issu.Internals.Agents.Inventory']['meta_info'].parent =_meta_table['Issu.Internals.Agents']['meta_info']
_meta_table['Issu.Internals.Agents.ReloadTracking']['meta_info'].parent =_meta_table['Issu.Internals.Agents']['meta_info']
_meta_table['Issu.Internals.InventoryMonitor.Inventory.Node']['meta_info'].parent =_meta_table['Issu.Internals.InventoryMonitor.Inventory']['meta_info']
_meta_table['Issu.Internals.InventoryMonitor.Inventory']['meta_info'].parent =_meta_table['Issu.Internals.InventoryMonitor']['meta_info']
_meta_table['Issu.Internals.Orchestrator']['meta_info'].parent =_meta_table['Issu.Internals']['meta_info']
_meta_table['Issu.Internals.Agents']['meta_info'].parent =_meta_table['Issu.Internals']['meta_info']
_meta_table['Issu.Internals.InventoryMonitor']['meta_info'].parent =_meta_table['Issu.Internals']['meta_info']
_meta_table['Issu.Status']['meta_info'].parent =_meta_table['Issu']['meta_info']
_meta_table['Issu.Clients']['meta_info'].parent =_meta_table['Issu']['meta_info']
_meta_table['Issu.Internals']['meta_info'].parent =_meta_table['Issu']['meta_info']
