""" Cisco_IOS_XR_iedge4710_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR iedge4710 package operational data.

This module contains definitions
for the following management objects\:
  subscriber\: Subscriber operational data
  iedge\-license\-manager\: iedge license manager

Copyright (c) 2013\-2018 by Cisco Systems, Inc.
All rights reserved.

"""
import sys
from collections import OrderedDict

from ydk.types import Entity as _Entity_
from ydk.types import EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class IedgeOperService(Enum):
    """
    IedgeOperService (Enum Class)

    Service types

    .. data:: unknown = 0

    	Unknown Service

    .. data:: profile = 1

    	Profile

    .. data:: template = 2

    	Template

    .. data:: grp_template = 3

    	GRP Template

    .. data:: ppp_template = 4

    	PPP Template

    .. data:: eth_template = 5

    	ETH Template

    .. data:: ip_sub_template = 6

    	IPSub Template

    .. data:: multi_template = 7

    	Multi Template

    .. data:: max_templae = 8

    	MAX Template

    """

    unknown = Enum.YLeaf(0, "unknown")

    profile = Enum.YLeaf(1, "profile")

    template = Enum.YLeaf(2, "template")

    grp_template = Enum.YLeaf(3, "grp-template")

    ppp_template = Enum.YLeaf(4, "ppp-template")

    eth_template = Enum.YLeaf(5, "eth-template")

    ip_sub_template = Enum.YLeaf(6, "ip-sub-template")

    multi_template = Enum.YLeaf(7, "multi-template")

    max_templae = Enum.YLeaf(8, "max-templae")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgeOperService']


class IedgeOperServiceStatus(Enum):
    """
    IedgeOperServiceStatus (Enum Class)

    Subscriber service status

    .. data:: unknown = 0

    	Unknown

    .. data:: error = 1

    	Error

    .. data:: new = 2

    	New

    .. data:: loading = 3

    	Loading

    .. data:: req_association = 4

    	Request Association

    .. data:: associated = 5

    	Associated

    .. data:: req_pd_association = 6

    	Request PD Association

    .. data:: applied = 7

    	Applied

    .. data:: req_unassociation = 8

    	Request Unassociation

    .. data:: req_pd_unassociation = 9

    	Request PD Unassociation

    .. data:: unapplied = 10

    	Unapplied

    .. data:: max = 11

    	Max

    """

    unknown = Enum.YLeaf(0, "unknown")

    error = Enum.YLeaf(1, "error")

    new = Enum.YLeaf(2, "new")

    loading = Enum.YLeaf(3, "loading")

    req_association = Enum.YLeaf(4, "req-association")

    associated = Enum.YLeaf(5, "associated")

    req_pd_association = Enum.YLeaf(6, "req-pd-association")

    applied = Enum.YLeaf(7, "applied")

    req_unassociation = Enum.YLeaf(8, "req-unassociation")

    req_pd_unassociation = Enum.YLeaf(9, "req-pd-unassociation")

    unapplied = Enum.YLeaf(10, "unapplied")

    max = Enum.YLeaf(11, "max")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgeOperServiceStatus']


class IedgeOperSession(Enum):
    """
    IedgeOperSession (Enum Class)

    Subscriber session types

    .. data:: unknown = 0

    	Unknown

    .. data:: pppoe = 1

    	PPPoE/PPP client

    .. data:: ppp = 2

    	PPP serial client

    .. data:: ip_packet_trigger = 3

    	IP subscriber - packet trigger

    .. data:: ip_packet_dhcp_trigger = 4

    	IP subscriber - DHCP trigger

    """

    unknown = Enum.YLeaf(0, "unknown")

    pppoe = Enum.YLeaf(1, "pppoe")

    ppp = Enum.YLeaf(2, "ppp")

    ip_packet_trigger = Enum.YLeaf(3, "ip-packet-trigger")

    ip_packet_dhcp_trigger = Enum.YLeaf(4, "ip-packet-dhcp-trigger")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgeOperSession']


class IedgeOperSessionState(Enum):
    """
    IedgeOperSessionState (Enum Class)

    Subscriber session states

    .. data:: initialize = 0

    	Initialize

    .. data:: connecting = 1

    	Connecting

    .. data:: connected = 2

    	Connected

    .. data:: activated = 3

    	Activated

    .. data:: idle = 4

    	Idle

    .. data:: disconnecting = 5

    	Disconnecting

    .. data:: end = 6

    	End

    """

    initialize = Enum.YLeaf(0, "initialize")

    connecting = Enum.YLeaf(1, "connecting")

    connected = Enum.YLeaf(2, "connected")

    activated = Enum.YLeaf(3, "activated")

    idle = Enum.YLeaf(4, "idle")

    disconnecting = Enum.YLeaf(5, "disconnecting")

    end = Enum.YLeaf(6, "end")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgeOperSessionState']


class IedgePppSub(Enum):
    """
    IedgePppSub (Enum Class)

    PPPoE sub types

    .. data:: pta = 0

    	PPP termination and aggregation

    .. data:: lac = 1

    	L2TP access controller

    """

    pta = Enum.YLeaf(0, "pta")

    lac = Enum.YLeaf(1, "lac")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgePppSub']


class SubscriberAddressFamilyFilterFlag(Enum):
    """
    SubscriberAddressFamilyFilterFlag (Enum Class)

    Subscriber address family filter flag

    .. data:: ipv4_only = 0

    	IPv4 only

    .. data:: ipv6_only = 1

    	IPv6 only

    .. data:: ipv4_all = 2

    	IPv4 all

    .. data:: ipv6_all = 3

    	IPv6 all

    .. data:: dual_all = 4

    	Dual all

    .. data:: dual_part_up = 5

    	Dual part up

    .. data:: dual_up = 6

    	Dual up

    .. data:: lac = 7

    	LAC

    """

    ipv4_only = Enum.YLeaf(0, "ipv4-only")

    ipv6_only = Enum.YLeaf(1, "ipv6-only")

    ipv4_all = Enum.YLeaf(2, "ipv4-all")

    ipv6_all = Enum.YLeaf(3, "ipv6-all")

    dual_all = Enum.YLeaf(4, "dual-all")

    dual_part_up = Enum.YLeaf(5, "dual-part-up")

    dual_up = Enum.YLeaf(6, "dual-up")

    lac = Enum.YLeaf(7, "lac")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['SubscriberAddressFamilyFilterFlag']


class SubscriberAuthenStateFilterFlag(Enum):
    """
    SubscriberAuthenStateFilterFlag (Enum Class)

    Subscriber authen state filter flag

    .. data:: un_authenticated = 0

    	UnAuthenticated

    .. data:: authenticated = 1

    	Authenticated

    """

    un_authenticated = Enum.YLeaf(0, "un-authenticated")

    authenticated = Enum.YLeaf(1, "authenticated")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['SubscriberAuthenStateFilterFlag']


class SubscriberAuthorStateFilterFlag(Enum):
    """
    SubscriberAuthorStateFilterFlag (Enum Class)

    Subscriber author state filter flag

    .. data:: un_authorized = 0

    	UnAuthorized

    .. data:: authorized = 1

    	Authorized

    """

    un_authorized = Enum.YLeaf(0, "un-authorized")

    authorized = Enum.YLeaf(1, "authorized")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['SubscriberAuthorStateFilterFlag']


class SubscriberSrgOperFilterFlag(Enum):
    """
    SubscriberSrgOperFilterFlag (Enum Class)

    Subscriber srg oper filter flag

    .. data:: srg_none = 0

    	SRG Role None

    .. data:: srg_master = 16384

    	SRG Role Master

    .. data:: srg_slave = 65536

    	SRG Role Slave

    .. data:: srg_both = 81920

    	SRG Role Master Slave

    """

    srg_none = Enum.YLeaf(0, "srg-none")

    srg_master = Enum.YLeaf(16384, "srg-master")

    srg_slave = Enum.YLeaf(65536, "srg-slave")

    srg_both = Enum.YLeaf(81920, "srg-both")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['SubscriberSrgOperFilterFlag']


class SubscriberStateFilterFlag(Enum):
    """
    SubscriberStateFilterFlag (Enum Class)

    Subscriber state filter flag

    .. data:: initializing = 0

    	Initializing

    .. data:: connecting = 1

    	Connecting

    .. data:: connected = 2

    	Connected

    .. data:: activated = 3

    	Activated

    .. data:: idle = 4

    	Idle

    .. data:: disconnecting = 5

    	Disconnecting

    .. data:: end = 6

    	End

    """

    initializing = Enum.YLeaf(0, "initializing")

    connecting = Enum.YLeaf(1, "connecting")

    connected = Enum.YLeaf(2, "connected")

    activated = Enum.YLeaf(3, "activated")

    idle = Enum.YLeaf(4, "idle")

    disconnecting = Enum.YLeaf(5, "disconnecting")

    end = Enum.YLeaf(6, "end")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['SubscriberStateFilterFlag']



class Subscriber(_Entity_):
    """
    Subscriber operational data
    
    .. attribute:: manager
    
    	Subscriber manager operational data
    	**type**\:  :py:class:`Manager <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager>`
    
    	**config**\: False
    
    .. attribute:: session
    
    	Subscriber session operational data
    	**type**\:  :py:class:`Session <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session>`
    
    	**config**\: False
    
    

    """

    _prefix = 'iedge4710-oper'
    _revision = '2018-09-20'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(Subscriber, self).__init__()
        self._top_entity = None

        self.yang_name = "subscriber"
        self.yang_parent_name = "Cisco-IOS-XR-iedge4710-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("manager", ("manager", Subscriber.Manager)), ("session", ("session", Subscriber.Session))])
        self._leafs = OrderedDict()

        self.manager = Subscriber.Manager()
        self.manager.parent = self
        self._children_name_map["manager"] = "manager"

        self.session = Subscriber.Session()
        self.session.parent = self
        self._children_name_map["session"] = "session"
        self._segment_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(Subscriber, [], name, value)


    class Manager(_Entity_):
        """
        Subscriber manager operational data
        
        .. attribute:: nodes
        
        	Subscriber manager list of nodes
        	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes>`
        
        	**config**\: False
        
        

        """

        _prefix = 'iedge4710-oper'
        _revision = '2018-09-20'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Subscriber.Manager, self).__init__()

            self.yang_name = "manager"
            self.yang_parent_name = "subscriber"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("nodes", ("nodes", Subscriber.Manager.Nodes))])
            self._leafs = OrderedDict()

            self.nodes = Subscriber.Manager.Nodes()
            self.nodes.parent = self
            self._children_name_map["nodes"] = "nodes"
            self._segment_path = lambda: "manager"
            self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Subscriber.Manager, [], name, value)


        class Nodes(_Entity_):
            """
            Subscriber manager list of nodes
            
            .. attribute:: node
            
            	Subscriber manager operational data for a particular node
            	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node>`
            
            	**config**\: False
            
            

            """

            _prefix = 'iedge4710-oper'
            _revision = '2018-09-20'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Subscriber.Manager.Nodes, self).__init__()

                self.yang_name = "nodes"
                self.yang_parent_name = "manager"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("node", ("node", Subscriber.Manager.Nodes.Node))])
                self._leafs = OrderedDict()

                self.node = YList(self)
                self._segment_path = lambda: "nodes"
                self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/manager/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Subscriber.Manager.Nodes, [], name, value)


            class Node(_Entity_):
                """
                Subscriber manager operational data for a
                particular node
                
                .. attribute:: node_name  (key)
                
                	Node name
                	**type**\: str
                
                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	Subscriber manager statistics
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics>`
                
                	**config**\: False
                
                

                """

                _prefix = 'iedge4710-oper'
                _revision = '2018-09-20'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Subscriber.Manager.Nodes.Node, self).__init__()

                    self.yang_name = "node"
                    self.yang_parent_name = "nodes"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['node_name']
                    self._child_classes = OrderedDict([("statistics", ("statistics", Subscriber.Manager.Nodes.Node.Statistics))])
                    self._leafs = OrderedDict([
                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                    ])
                    self.node_name = None

                    self.statistics = Subscriber.Manager.Nodes.Node.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/manager/nodes/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Subscriber.Manager.Nodes.Node, ['node_name'], name, value)


                class Statistics(_Entity_):
                    """
                    Subscriber manager statistics
                    
                    .. attribute:: aaa
                    
                    	AAA statistics
                    	**type**\:  :py:class:`Aaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa>`
                    
                    	**config**\: False
                    
                    .. attribute:: aggregate_summary
                    
                    	Aggregate summary of statistics
                    	**type**\:  :py:class:`AggregateSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary>`
                    
                    	**config**\: False
                    
                    .. attribute:: disconn_unique
                    
                    	Disconnect Unique Summary statistics
                    	**type**\:  :py:class:`DisconnUnique <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique>`
                    
                    	**config**\: False
                    
                    .. attribute:: srg
                    
                    	Geo Redundancy statistics
                    	**type**\:  :py:class:`Srg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Srg>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Manager.Nodes.Node.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("aaa", ("aaa", Subscriber.Manager.Nodes.Node.Statistics.Aaa)), ("aggregate-summary", ("aggregate_summary", Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary)), ("disconn-unique", ("disconn_unique", Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique)), ("srg", ("srg", Subscriber.Manager.Nodes.Node.Statistics.Srg))])
                        self._leafs = OrderedDict()

                        self.aaa = Subscriber.Manager.Nodes.Node.Statistics.Aaa()
                        self.aaa.parent = self
                        self._children_name_map["aaa"] = "aaa"

                        self.aggregate_summary = Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary()
                        self.aggregate_summary.parent = self
                        self._children_name_map["aggregate_summary"] = "aggregate-summary"

                        self.disconn_unique = Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique()
                        self.disconn_unique.parent = self
                        self._children_name_map["disconn_unique"] = "disconn-unique"

                        self.srg = Subscriber.Manager.Nodes.Node.Statistics.Srg()
                        self.srg.parent = self
                        self._children_name_map["srg"] = "srg"
                        self._segment_path = lambda: "statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics, [], name, value)


                    class Aaa(_Entity_):
                        """
                        AAA statistics
                        
                        .. attribute:: aggregate_accounting
                        
                        	Aggregate accounting statistics
                        	**type**\:  :py:class:`AggregateAccounting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting>`
                        
                        	**config**\: False
                        
                        .. attribute:: authentication
                        
                        	Authentication statistics
                        	**type**\:  :py:class:`Authentication <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication>`
                        
                        	**config**\: False
                        
                        .. attribute:: aggregate_mobility
                        
                        	Aggregate mobility statistics
                        	**type**\:  :py:class:`AggregateMobility <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility>`
                        
                        	**config**\: False
                        
                        .. attribute:: aggregate_authentication
                        
                        	Aggregate authentication statistics
                        	**type**\:  :py:class:`AggregateAuthentication <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication>`
                        
                        	**config**\: False
                        
                        .. attribute:: accounting_stats_all
                        
                        	Display all subscriber management statistics
                        	**type**\:  :py:class:`AccountingStatsAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_of_authorization
                        
                        	Change of authorization (COA) statistics
                        	**type**\:  :py:class:`ChangeOfAuthorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization>`
                        
                        	**config**\: False
                        
                        .. attribute:: authorization
                        
                        	Authorization statistics
                        	**type**\:  :py:class:`Authorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization>`
                        
                        	**config**\: False
                        
                        .. attribute:: aggregate_authorization
                        
                        	Aggregate authorization statistics
                        	**type**\:  :py:class:`AggregateAuthorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization>`
                        
                        	**config**\: False
                        
                        .. attribute:: aggregate_accounting_stats_all
                        
                        	Display all subscriber management total statistics
                        	**type**\:  :py:class:`AggregateAccountingStatsAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll>`
                        
                        	**config**\: False
                        
                        .. attribute:: accounting
                        
                        	Accounting statistics
                        	**type**\:  :py:class:`Accounting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting>`
                        
                        	**config**\: False
                        
                        .. attribute:: mobility
                        
                        	Mobility statistics
                        	**type**\:  :py:class:`Mobility <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility>`
                        
                        	**config**\: False
                        
                        .. attribute:: aggregate_change_of_authorization
                        
                        	Aggregate change of authorization (COA) statistics
                        	**type**\:  :py:class:`AggregateChangeOfAuthorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Manager.Nodes.Node.Statistics.Aaa, self).__init__()

                            self.yang_name = "aaa"
                            self.yang_parent_name = "statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("aggregate-accounting", ("aggregate_accounting", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting)), ("authentication", ("authentication", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication)), ("aggregate-mobility", ("aggregate_mobility", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility)), ("aggregate-authentication", ("aggregate_authentication", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication)), ("accounting-stats-all", ("accounting_stats_all", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll)), ("change-of-authorization", ("change_of_authorization", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization)), ("authorization", ("authorization", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization)), ("aggregate-authorization", ("aggregate_authorization", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization)), ("aggregate-accounting-stats-all", ("aggregate_accounting_stats_all", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll)), ("accounting", ("accounting", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting)), ("mobility", ("mobility", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility)), ("aggregate-change-of-authorization", ("aggregate_change_of_authorization", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization))])
                            self._leafs = OrderedDict()

                            self.aggregate_accounting = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting()
                            self.aggregate_accounting.parent = self
                            self._children_name_map["aggregate_accounting"] = "aggregate-accounting"

                            self.authentication = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication()
                            self.authentication.parent = self
                            self._children_name_map["authentication"] = "authentication"

                            self.aggregate_mobility = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility()
                            self.aggregate_mobility.parent = self
                            self._children_name_map["aggregate_mobility"] = "aggregate-mobility"

                            self.aggregate_authentication = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication()
                            self.aggregate_authentication.parent = self
                            self._children_name_map["aggregate_authentication"] = "aggregate-authentication"

                            self.accounting_stats_all = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll()
                            self.accounting_stats_all.parent = self
                            self._children_name_map["accounting_stats_all"] = "accounting-stats-all"

                            self.change_of_authorization = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization()
                            self.change_of_authorization.parent = self
                            self._children_name_map["change_of_authorization"] = "change-of-authorization"

                            self.authorization = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization()
                            self.authorization.parent = self
                            self._children_name_map["authorization"] = "authorization"

                            self.aggregate_authorization = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization()
                            self.aggregate_authorization.parent = self
                            self._children_name_map["aggregate_authorization"] = "aggregate-authorization"

                            self.aggregate_accounting_stats_all = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll()
                            self.aggregate_accounting_stats_all.parent = self
                            self._children_name_map["aggregate_accounting_stats_all"] = "aggregate-accounting-stats-all"

                            self.accounting = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting()
                            self.accounting.parent = self
                            self._children_name_map["accounting"] = "accounting"

                            self.mobility = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility()
                            self.mobility.parent = self
                            self._children_name_map["mobility"] = "mobility"

                            self.aggregate_change_of_authorization = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization()
                            self.aggregate_change_of_authorization.parent = self
                            self._children_name_map["aggregate_change_of_authorization"] = "aggregate-change-of-authorization"
                            self._segment_path = lambda: "aaa"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa, [], name, value)


                        class AggregateAccounting(_Entity_):
                            """
                            Aggregate accounting statistics
                            
                            .. attribute:: start
                            
                            	Start statistics
                            	**type**\:  :py:class:`Start <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start>`
                            
                            	**config**\: False
                            
                            .. attribute:: stop
                            
                            	Stop statistics
                            	**type**\:  :py:class:`Stop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop>`
                            
                            	**config**\: False
                            
                            .. attribute:: interim
                            
                            	Interim statistics
                            	**type**\:  :py:class:`Interim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim>`
                            
                            	**config**\: False
                            
                            .. attribute:: pass_through
                            
                            	Pass\-through statistics
                            	**type**\:  :py:class:`PassThrough <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough>`
                            
                            	**config**\: False
                            
                            .. attribute:: update
                            
                            	Update statistics
                            	**type**\:  :py:class:`Update <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update>`
                            
                            	**config**\: False
                            
                            .. attribute:: interim_inflight
                            
                            	Interim inflight details
                            	**type**\:  :py:class:`InterimInflight <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight>`
                            
                            	**config**\: False
                            
                            .. attribute:: active_sessions
                            
                            	Active sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: started_sessions
                            
                            	Started sessions
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: stopped_sessions
                            
                            	Stopped sessions
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: policy_plane_errored_requests
                            
                            	Policy plane errored requests
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: policy_plane_unknown_requests
                            
                            	Policy plane unknown requests
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting, self).__init__()

                                self.yang_name = "aggregate-accounting"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("start", ("start", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start)), ("stop", ("stop", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop)), ("interim", ("interim", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim)), ("pass-through", ("pass_through", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough)), ("update", ("update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update)), ("interim-inflight", ("interim_inflight", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight))])
                                self._leafs = OrderedDict([
                                    ('active_sessions', (YLeaf(YType.uint32, 'active-sessions'), ['int'])),
                                    ('started_sessions', (YLeaf(YType.uint64, 'started-sessions'), ['int'])),
                                    ('stopped_sessions', (YLeaf(YType.uint64, 'stopped-sessions'), ['int'])),
                                    ('policy_plane_errored_requests', (YLeaf(YType.uint64, 'policy-plane-errored-requests'), ['int'])),
                                    ('policy_plane_unknown_requests', (YLeaf(YType.uint64, 'policy-plane-unknown-requests'), ['int'])),
                                ])
                                self.active_sessions = None
                                self.started_sessions = None
                                self.stopped_sessions = None
                                self.policy_plane_errored_requests = None
                                self.policy_plane_unknown_requests = None

                                self.start = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start()
                                self.start.parent = self
                                self._children_name_map["start"] = "start"

                                self.stop = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop()
                                self.stop.parent = self
                                self._children_name_map["stop"] = "stop"

                                self.interim = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim()
                                self.interim.parent = self
                                self._children_name_map["interim"] = "interim"

                                self.pass_through = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough()
                                self.pass_through.parent = self
                                self._children_name_map["pass_through"] = "pass-through"

                                self.update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update()
                                self.update.parent = self
                                self._children_name_map["update"] = "update"

                                self.interim_inflight = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight()
                                self.interim_inflight.parent = self
                                self._children_name_map["interim_inflight"] = "interim-inflight"
                                self._segment_path = lambda: "aggregate-accounting"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting, ['active_sessions', 'started_sessions', 'stopped_sessions', 'policy_plane_errored_requests', 'policy_plane_unknown_requests'], name, value)


                            class Start(_Entity_):
                                """
                                Start statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start, self).__init__()

                                    self.yang_name = "start"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "start"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Start']['meta_info']


                            class Stop(_Entity_):
                                """
                                Stop statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop, self).__init__()

                                    self.yang_name = "stop"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "stop"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Stop']['meta_info']


                            class Interim(_Entity_):
                                """
                                Interim statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim, self).__init__()

                                    self.yang_name = "interim"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "interim"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Interim']['meta_info']


                            class PassThrough(_Entity_):
                                """
                                Pass\-through statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough, self).__init__()

                                    self.yang_name = "pass-through"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "pass-through"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.PassThrough']['meta_info']


                            class Update(_Entity_):
                                """
                                Update statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update, self).__init__()

                                    self.yang_name = "update"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "update"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.Update']['meta_info']


                            class InterimInflight(_Entity_):
                                """
                                Interim inflight details
                                
                                .. attribute:: quota_exhausts
                                
                                	Quota exhausts
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: denied_requests
                                
                                	Denied requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Accepted requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: total_quota_of_requests
                                
                                	Total quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remaining_quota_of_requests
                                
                                	Remaining quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: low_water_mark_quota_of_requests
                                
                                	Low water mark quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight, self).__init__()

                                    self.yang_name = "interim-inflight"
                                    self.yang_parent_name = "aggregate-accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('quota_exhausts', (YLeaf(YType.uint32, 'quota-exhausts'), ['int'])),
                                        ('denied_requests', (YLeaf(YType.uint32, 'denied-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint32, 'accepted-requests'), ['int'])),
                                        ('total_quota_of_requests', (YLeaf(YType.uint32, 'total-quota-of-requests'), ['int'])),
                                        ('remaining_quota_of_requests', (YLeaf(YType.uint32, 'remaining-quota-of-requests'), ['int'])),
                                        ('low_water_mark_quota_of_requests', (YLeaf(YType.uint32, 'low-water-mark-quota-of-requests'), ['int'])),
                                    ])
                                    self.quota_exhausts = None
                                    self.denied_requests = None
                                    self.accepted_requests = None
                                    self.total_quota_of_requests = None
                                    self.remaining_quota_of_requests = None
                                    self.low_water_mark_quota_of_requests = None
                                    self._segment_path = lambda: "interim-inflight"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight, ['quota_exhausts', 'denied_requests', 'accepted_requests', 'total_quota_of_requests', 'remaining_quota_of_requests', 'low_water_mark_quota_of_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting.InterimInflight']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccounting']['meta_info']


                        class Authentication(_Entity_):
                            """
                            Authentication statistics
                            
                            .. attribute:: sent_requests
                            
                            	Requests sent to radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: accepted_requests
                            
                            	Request accepted by Radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: successful_requests
                            
                            	Requests which are successful
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: rejected_requests
                            
                            	Requests rejected by radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unreachable_requests
                            
                            	Radius server not available
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: errored_requests
                            
                            	Unexpected errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: terminated_requests
                            
                            	Requests terminated by disconnect
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication, self).__init__()

                                self.yang_name = "authentication"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                    ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                    ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                    ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                    ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                    ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                    ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                ])
                                self.sent_requests = None
                                self.accepted_requests = None
                                self.successful_requests = None
                                self.rejected_requests = None
                                self.unreachable_requests = None
                                self.errored_requests = None
                                self.terminated_requests = None
                                self._segment_path = lambda: "authentication"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authentication']['meta_info']


                        class AggregateMobility(_Entity_):
                            """
                            Aggregate mobility statistics
                            
                            .. attribute:: send_request_successes
                            
                            	Request send success
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: send_request_failures
                            
                            	Request send failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: receive_response_successes
                            
                            	Response receive success
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: receive_response_failures
                            
                            	Response receive failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility, self).__init__()

                                self.yang_name = "aggregate-mobility"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('send_request_successes', (YLeaf(YType.uint64, 'send-request-successes'), ['int'])),
                                    ('send_request_failures', (YLeaf(YType.uint64, 'send-request-failures'), ['int'])),
                                    ('receive_response_successes', (YLeaf(YType.uint64, 'receive-response-successes'), ['int'])),
                                    ('receive_response_failures', (YLeaf(YType.uint64, 'receive-response-failures'), ['int'])),
                                ])
                                self.send_request_successes = None
                                self.send_request_failures = None
                                self.receive_response_successes = None
                                self.receive_response_failures = None
                                self._segment_path = lambda: "aggregate-mobility"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility, ['send_request_successes', 'send_request_failures', 'receive_response_successes', 'receive_response_failures'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateMobility']['meta_info']


                        class AggregateAuthentication(_Entity_):
                            """
                            Aggregate authentication statistics
                            
                            .. attribute:: sent_requests
                            
                            	Requests sent to radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: accepted_requests
                            
                            	Request accepted by Radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: successful_requests
                            
                            	Requests which are successful
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: rejected_requests
                            
                            	Requests rejected by radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unreachable_requests
                            
                            	Radius server not available
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: errored_requests
                            
                            	Unexpected errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: terminated_requests
                            
                            	Requests terminated by disconnect
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication, self).__init__()

                                self.yang_name = "aggregate-authentication"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                    ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                    ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                    ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                    ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                    ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                    ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                ])
                                self.sent_requests = None
                                self.accepted_requests = None
                                self.successful_requests = None
                                self.rejected_requests = None
                                self.unreachable_requests = None
                                self.errored_requests = None
                                self.terminated_requests = None
                                self._segment_path = lambda: "aggregate-authentication"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthentication']['meta_info']


                        class AccountingStatsAll(_Entity_):
                            """
                            Display all subscriber management
                            statistics
                            
                            .. attribute:: accounting_statistics
                            
                            	List of stats for accounting
                            	**type**\:  :py:class:`AccountingStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: authentication_statistics
                            
                            	List of stats for authentication
                            	**type**\:  :py:class:`AuthenticationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: authorization_statistics
                            
                            	List of stats for authorization
                            	**type**\:  :py:class:`AuthorizationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: change_of_authorization_statistics
                            
                            	List of stats for COA
                            	**type**\:  :py:class:`ChangeOfAuthorizationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: mobility_statistics
                            
                            	List of stats for Mobility
                            	**type**\:  :py:class:`MobilityStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll, self).__init__()

                                self.yang_name = "accounting-stats-all"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("accounting-statistics", ("accounting_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics)), ("authentication-statistics", ("authentication_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics)), ("authorization-statistics", ("authorization_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics)), ("change-of-authorization-statistics", ("change_of_authorization_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics)), ("mobility-statistics", ("mobility_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics))])
                                self._leafs = OrderedDict()

                                self.accounting_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics()
                                self.accounting_statistics.parent = self
                                self._children_name_map["accounting_statistics"] = "accounting-statistics"

                                self.authentication_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics()
                                self.authentication_statistics.parent = self
                                self._children_name_map["authentication_statistics"] = "authentication-statistics"

                                self.authorization_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics()
                                self.authorization_statistics.parent = self
                                self._children_name_map["authorization_statistics"] = "authorization-statistics"

                                self.change_of_authorization_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics()
                                self.change_of_authorization_statistics.parent = self
                                self._children_name_map["change_of_authorization_statistics"] = "change-of-authorization-statistics"

                                self.mobility_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics()
                                self.mobility_statistics.parent = self
                                self._children_name_map["mobility_statistics"] = "mobility-statistics"
                                self._segment_path = lambda: "accounting-stats-all"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll, [], name, value)


                            class AccountingStatistics(_Entity_):
                                """
                                List of stats for accounting
                                
                                .. attribute:: start
                                
                                	Start statistics
                                	**type**\:  :py:class:`Start <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start>`
                                
                                	**config**\: False
                                
                                .. attribute:: stop
                                
                                	Stop statistics
                                	**type**\:  :py:class:`Stop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop>`
                                
                                	**config**\: False
                                
                                .. attribute:: interim
                                
                                	Interim statistics
                                	**type**\:  :py:class:`Interim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim>`
                                
                                	**config**\: False
                                
                                .. attribute:: pass_through
                                
                                	Pass\-through statistics
                                	**type**\:  :py:class:`PassThrough <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough>`
                                
                                	**config**\: False
                                
                                .. attribute:: update
                                
                                	Update statistics
                                	**type**\:  :py:class:`Update <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update>`
                                
                                	**config**\: False
                                
                                .. attribute:: interim_inflight
                                
                                	Interim inflight details
                                	**type**\:  :py:class:`InterimInflight <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight>`
                                
                                	**config**\: False
                                
                                .. attribute:: active_sessions
                                
                                	Active sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: started_sessions
                                
                                	Started sessions
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: stopped_sessions
                                
                                	Stopped sessions
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: policy_plane_errored_requests
                                
                                	Policy plane errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: policy_plane_unknown_requests
                                
                                	Policy plane unknown requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics, self).__init__()

                                    self.yang_name = "accounting-statistics"
                                    self.yang_parent_name = "accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("start", ("start", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start)), ("stop", ("stop", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop)), ("interim", ("interim", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim)), ("pass-through", ("pass_through", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough)), ("update", ("update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update)), ("interim-inflight", ("interim_inflight", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight))])
                                    self._leafs = OrderedDict([
                                        ('active_sessions', (YLeaf(YType.uint32, 'active-sessions'), ['int'])),
                                        ('started_sessions', (YLeaf(YType.uint64, 'started-sessions'), ['int'])),
                                        ('stopped_sessions', (YLeaf(YType.uint64, 'stopped-sessions'), ['int'])),
                                        ('policy_plane_errored_requests', (YLeaf(YType.uint64, 'policy-plane-errored-requests'), ['int'])),
                                        ('policy_plane_unknown_requests', (YLeaf(YType.uint64, 'policy-plane-unknown-requests'), ['int'])),
                                    ])
                                    self.active_sessions = None
                                    self.started_sessions = None
                                    self.stopped_sessions = None
                                    self.policy_plane_errored_requests = None
                                    self.policy_plane_unknown_requests = None

                                    self.start = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start()
                                    self.start.parent = self
                                    self._children_name_map["start"] = "start"

                                    self.stop = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop()
                                    self.stop.parent = self
                                    self._children_name_map["stop"] = "stop"

                                    self.interim = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim()
                                    self.interim.parent = self
                                    self._children_name_map["interim"] = "interim"

                                    self.pass_through = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough()
                                    self.pass_through.parent = self
                                    self._children_name_map["pass_through"] = "pass-through"

                                    self.update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update()
                                    self.update.parent = self
                                    self._children_name_map["update"] = "update"

                                    self.interim_inflight = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight()
                                    self.interim_inflight.parent = self
                                    self._children_name_map["interim_inflight"] = "interim-inflight"
                                    self._segment_path = lambda: "accounting-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics, ['active_sessions', 'started_sessions', 'stopped_sessions', 'policy_plane_errored_requests', 'policy_plane_unknown_requests'], name, value)


                                class Start(_Entity_):
                                    """
                                    Start statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start, self).__init__()

                                        self.yang_name = "start"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "start"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Start']['meta_info']


                                class Stop(_Entity_):
                                    """
                                    Stop statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop, self).__init__()

                                        self.yang_name = "stop"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "stop"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Stop']['meta_info']


                                class Interim(_Entity_):
                                    """
                                    Interim statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim, self).__init__()

                                        self.yang_name = "interim"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "interim"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Interim']['meta_info']


                                class PassThrough(_Entity_):
                                    """
                                    Pass\-through statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough, self).__init__()

                                        self.yang_name = "pass-through"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "pass-through"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.PassThrough']['meta_info']


                                class Update(_Entity_):
                                    """
                                    Update statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update, self).__init__()

                                        self.yang_name = "update"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "update"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.Update']['meta_info']


                                class InterimInflight(_Entity_):
                                    """
                                    Interim inflight details
                                    
                                    .. attribute:: quota_exhausts
                                    
                                    	Quota exhausts
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: denied_requests
                                    
                                    	Denied requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: accepted_requests
                                    
                                    	Accepted requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: total_quota_of_requests
                                    
                                    	Total quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: remaining_quota_of_requests
                                    
                                    	Remaining quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: low_water_mark_quota_of_requests
                                    
                                    	Low water mark quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight, self).__init__()

                                        self.yang_name = "interim-inflight"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('quota_exhausts', (YLeaf(YType.uint32, 'quota-exhausts'), ['int'])),
                                            ('denied_requests', (YLeaf(YType.uint32, 'denied-requests'), ['int'])),
                                            ('accepted_requests', (YLeaf(YType.uint32, 'accepted-requests'), ['int'])),
                                            ('total_quota_of_requests', (YLeaf(YType.uint32, 'total-quota-of-requests'), ['int'])),
                                            ('remaining_quota_of_requests', (YLeaf(YType.uint32, 'remaining-quota-of-requests'), ['int'])),
                                            ('low_water_mark_quota_of_requests', (YLeaf(YType.uint32, 'low-water-mark-quota-of-requests'), ['int'])),
                                        ])
                                        self.quota_exhausts = None
                                        self.denied_requests = None
                                        self.accepted_requests = None
                                        self.total_quota_of_requests = None
                                        self.remaining_quota_of_requests = None
                                        self.low_water_mark_quota_of_requests = None
                                        self._segment_path = lambda: "interim-inflight"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight, ['quota_exhausts', 'denied_requests', 'accepted_requests', 'total_quota_of_requests', 'remaining_quota_of_requests', 'low_water_mark_quota_of_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics.InterimInflight']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AccountingStatistics']['meta_info']


                            class AuthenticationStatistics(_Entity_):
                                """
                                List of stats for authentication
                                
                                .. attribute:: sent_requests
                                
                                	Requests sent to radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Request accepted by Radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: successful_requests
                                
                                	Requests which are successful
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: rejected_requests
                                
                                	Requests rejected by radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unreachable_requests
                                
                                	Radius server not available
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Unexpected errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: terminated_requests
                                
                                	Requests terminated by disconnect
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics, self).__init__()

                                    self.yang_name = "authentication-statistics"
                                    self.yang_parent_name = "accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                        ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                        ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                        ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                    ])
                                    self.sent_requests = None
                                    self.accepted_requests = None
                                    self.successful_requests = None
                                    self.rejected_requests = None
                                    self.unreachable_requests = None
                                    self.errored_requests = None
                                    self.terminated_requests = None
                                    self._segment_path = lambda: "authentication-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthenticationStatistics']['meta_info']


                            class AuthorizationStatistics(_Entity_):
                                """
                                List of stats for authorization
                                
                                .. attribute:: sent_requests
                                
                                	Requests sent to radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Request accepted by Radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: successful_requests
                                
                                	Requests which are successful
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: rejected_requests
                                
                                	Requests rejected by radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unreachable_requests
                                
                                	Radius server not available
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Unexpected errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: terminated_requests
                                
                                	Requests terminated by disconnect
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics, self).__init__()

                                    self.yang_name = "authorization-statistics"
                                    self.yang_parent_name = "accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                        ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                        ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                        ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                    ])
                                    self.sent_requests = None
                                    self.accepted_requests = None
                                    self.successful_requests = None
                                    self.rejected_requests = None
                                    self.unreachable_requests = None
                                    self.errored_requests = None
                                    self.terminated_requests = None
                                    self._segment_path = lambda: "authorization-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.AuthorizationStatistics']['meta_info']


                            class ChangeOfAuthorizationStatistics(_Entity_):
                                """
                                List of stats for COA
                                
                                .. attribute:: account_logon
                                
                                	Account logon request statistics
                                	**type**\:  :py:class:`AccountLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon>`
                                
                                	**config**\: False
                                
                                .. attribute:: account_logoff
                                
                                	Account logoff request statistics
                                	**type**\:  :py:class:`AccountLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff>`
                                
                                	**config**\: False
                                
                                .. attribute:: account_update
                                
                                	Account update request statistics
                                	**type**\:  :py:class:`AccountUpdate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_disconnect
                                
                                	Session disconnect request statistics
                                	**type**\:  :py:class:`SessionDisconnect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_logon
                                
                                	Service logon request statistics
                                	**type**\:  :py:class:`SingleServiceLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_logoff
                                
                                	Single Service logoff request statistics
                                	**type**\:  :py:class:`SingleServiceLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_modify
                                
                                	Single Service Modify request statistics
                                	**type**\:  :py:class:`SingleServiceModify <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify>`
                                
                                	**config**\: False
                                
                                .. attribute:: service_multi
                                
                                	MA\-CoA Service request statistics
                                	**type**\:  :py:class:`ServiceMulti <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti>`
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_account_cmd_resps
                                
                                	Responses to unknown account command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_service_cmd_resps
                                
                                	Responses to unknown service command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_cmd_resps
                                
                                	Responses to unknown command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: attr_list_retrieve_failure_resps
                                
                                	Responses to attribute list failure errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: resp_send_failure
                                
                                	Response send failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: internal_err_resps
                                
                                	Responses to internal error
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: service_profile_push_failure_resps
                                
                                	Responses to service profile push failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_cmd_resps
                                
                                	Responses empty (no command) COA request
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_session_found_resps
                                
                                	Responses to COA with unknown session identifier
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_session_peer_resps
                                
                                	Responses to session peer not found error
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics, self).__init__()

                                    self.yang_name = "change-of-authorization-statistics"
                                    self.yang_parent_name = "accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("account-logon", ("account_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon)), ("account-logoff", ("account_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff)), ("account-update", ("account_update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate)), ("session-disconnect", ("session_disconnect", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect)), ("single-service-logon", ("single_service_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon)), ("single-service-logoff", ("single_service_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff)), ("single-service-modify", ("single_service_modify", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify)), ("service-multi", ("service_multi", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti))])
                                    self._leafs = OrderedDict([
                                        ('unknown_account_cmd_resps', (YLeaf(YType.uint64, 'unknown-account-cmd-resps'), ['int'])),
                                        ('unknown_service_cmd_resps', (YLeaf(YType.uint64, 'unknown-service-cmd-resps'), ['int'])),
                                        ('unknown_cmd_resps', (YLeaf(YType.uint64, 'unknown-cmd-resps'), ['int'])),
                                        ('attr_list_retrieve_failure_resps', (YLeaf(YType.uint64, 'attr-list-retrieve-failure-resps'), ['int'])),
                                        ('resp_send_failure', (YLeaf(YType.uint64, 'resp-send-failure'), ['int'])),
                                        ('internal_err_resps', (YLeaf(YType.uint64, 'internal-err-resps'), ['int'])),
                                        ('service_profile_push_failure_resps', (YLeaf(YType.uint64, 'service-profile-push-failure-resps'), ['int'])),
                                        ('no_cmd_resps', (YLeaf(YType.uint64, 'no-cmd-resps'), ['int'])),
                                        ('no_session_found_resps', (YLeaf(YType.uint64, 'no-session-found-resps'), ['int'])),
                                        ('no_session_peer_resps', (YLeaf(YType.uint64, 'no-session-peer-resps'), ['int'])),
                                    ])
                                    self.unknown_account_cmd_resps = None
                                    self.unknown_service_cmd_resps = None
                                    self.unknown_cmd_resps = None
                                    self.attr_list_retrieve_failure_resps = None
                                    self.resp_send_failure = None
                                    self.internal_err_resps = None
                                    self.service_profile_push_failure_resps = None
                                    self.no_cmd_resps = None
                                    self.no_session_found_resps = None
                                    self.no_session_peer_resps = None

                                    self.account_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon()
                                    self.account_logon.parent = self
                                    self._children_name_map["account_logon"] = "account-logon"

                                    self.account_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff()
                                    self.account_logoff.parent = self
                                    self._children_name_map["account_logoff"] = "account-logoff"

                                    self.account_update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate()
                                    self.account_update.parent = self
                                    self._children_name_map["account_update"] = "account-update"

                                    self.session_disconnect = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect()
                                    self.session_disconnect.parent = self
                                    self._children_name_map["session_disconnect"] = "session-disconnect"

                                    self.single_service_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon()
                                    self.single_service_logon.parent = self
                                    self._children_name_map["single_service_logon"] = "single-service-logon"

                                    self.single_service_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff()
                                    self.single_service_logoff.parent = self
                                    self._children_name_map["single_service_logoff"] = "single-service-logoff"

                                    self.single_service_modify = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify()
                                    self.single_service_modify.parent = self
                                    self._children_name_map["single_service_modify"] = "single-service-modify"

                                    self.service_multi = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti()
                                    self.service_multi.parent = self
                                    self._children_name_map["service_multi"] = "service-multi"
                                    self._segment_path = lambda: "change-of-authorization-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics, ['unknown_account_cmd_resps', 'unknown_service_cmd_resps', 'unknown_cmd_resps', 'attr_list_retrieve_failure_resps', 'resp_send_failure', 'internal_err_resps', 'service_profile_push_failure_resps', 'no_cmd_resps', 'no_session_found_resps', 'no_session_peer_resps'], name, value)


                                class AccountLogon(_Entity_):
                                    """
                                    Account logon request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon, self).__init__()

                                        self.yang_name = "account-logon"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-logon"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon']['meta_info']


                                class AccountLogoff(_Entity_):
                                    """
                                    Account logoff request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff, self).__init__()

                                        self.yang_name = "account-logoff"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-logoff"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff']['meta_info']


                                class AccountUpdate(_Entity_):
                                    """
                                    Account update request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate, self).__init__()

                                        self.yang_name = "account-update"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-update"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate']['meta_info']


                                class SessionDisconnect(_Entity_):
                                    """
                                    Session disconnect request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect, self).__init__()

                                        self.yang_name = "session-disconnect"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "session-disconnect"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect']['meta_info']


                                class SingleServiceLogon(_Entity_):
                                    """
                                    Service logon request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon, self).__init__()

                                        self.yang_name = "single-service-logon"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-logon"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon']['meta_info']


                                class SingleServiceLogoff(_Entity_):
                                    """
                                    Single Service logoff request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff, self).__init__()

                                        self.yang_name = "single-service-logoff"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-logoff"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff']['meta_info']


                                class SingleServiceModify(_Entity_):
                                    """
                                    Single Service Modify request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify, self).__init__()

                                        self.yang_name = "single-service-modify"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-modify"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify']['meta_info']


                                class ServiceMulti(_Entity_):
                                    """
                                    MA\-CoA Service request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti, self).__init__()

                                        self.yang_name = "service-multi"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "service-multi"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.ChangeOfAuthorizationStatistics']['meta_info']


                            class MobilityStatistics(_Entity_):
                                """
                                List of stats for Mobility
                                
                                .. attribute:: send_request_successes
                                
                                	Request send success
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: send_request_failures
                                
                                	Request send failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: receive_response_successes
                                
                                	Response receive success
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: receive_response_failures
                                
                                	Response receive failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics, self).__init__()

                                    self.yang_name = "mobility-statistics"
                                    self.yang_parent_name = "accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('send_request_successes', (YLeaf(YType.uint64, 'send-request-successes'), ['int'])),
                                        ('send_request_failures', (YLeaf(YType.uint64, 'send-request-failures'), ['int'])),
                                        ('receive_response_successes', (YLeaf(YType.uint64, 'receive-response-successes'), ['int'])),
                                        ('receive_response_failures', (YLeaf(YType.uint64, 'receive-response-failures'), ['int'])),
                                    ])
                                    self.send_request_successes = None
                                    self.send_request_failures = None
                                    self.receive_response_successes = None
                                    self.receive_response_failures = None
                                    self._segment_path = lambda: "mobility-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics, ['send_request_successes', 'send_request_failures', 'receive_response_successes', 'receive_response_failures'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll.MobilityStatistics']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AccountingStatsAll']['meta_info']


                        class ChangeOfAuthorization(_Entity_):
                            """
                            Change of authorization (COA) statistics
                            
                            .. attribute:: account_logon
                            
                            	Account logon request statistics
                            	**type**\:  :py:class:`AccountLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon>`
                            
                            	**config**\: False
                            
                            .. attribute:: account_logoff
                            
                            	Account logoff request statistics
                            	**type**\:  :py:class:`AccountLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff>`
                            
                            	**config**\: False
                            
                            .. attribute:: account_update
                            
                            	Account update request statistics
                            	**type**\:  :py:class:`AccountUpdate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate>`
                            
                            	**config**\: False
                            
                            .. attribute:: session_disconnect
                            
                            	Session disconnect request statistics
                            	**type**\:  :py:class:`SessionDisconnect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_logon
                            
                            	Service logon request statistics
                            	**type**\:  :py:class:`SingleServiceLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_logoff
                            
                            	Single Service logoff request statistics
                            	**type**\:  :py:class:`SingleServiceLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_modify
                            
                            	Single Service Modify request statistics
                            	**type**\:  :py:class:`SingleServiceModify <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify>`
                            
                            	**config**\: False
                            
                            .. attribute:: service_multi
                            
                            	MA\-CoA Service request statistics
                            	**type**\:  :py:class:`ServiceMulti <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti>`
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_account_cmd_resps
                            
                            	Responses to unknown account command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_service_cmd_resps
                            
                            	Responses to unknown service command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_cmd_resps
                            
                            	Responses to unknown command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: attr_list_retrieve_failure_resps
                            
                            	Responses to attribute list failure errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: resp_send_failure
                            
                            	Response send failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: internal_err_resps
                            
                            	Responses to internal error
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: service_profile_push_failure_resps
                            
                            	Responses to service profile push failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_cmd_resps
                            
                            	Responses empty (no command) COA request
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_session_found_resps
                            
                            	Responses to COA with unknown session identifier
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_session_peer_resps
                            
                            	Responses to session peer not found error
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization, self).__init__()

                                self.yang_name = "change-of-authorization"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("account-logon", ("account_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon)), ("account-logoff", ("account_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff)), ("account-update", ("account_update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate)), ("session-disconnect", ("session_disconnect", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect)), ("single-service-logon", ("single_service_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon)), ("single-service-logoff", ("single_service_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff)), ("single-service-modify", ("single_service_modify", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify)), ("service-multi", ("service_multi", Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti))])
                                self._leafs = OrderedDict([
                                    ('unknown_account_cmd_resps', (YLeaf(YType.uint64, 'unknown-account-cmd-resps'), ['int'])),
                                    ('unknown_service_cmd_resps', (YLeaf(YType.uint64, 'unknown-service-cmd-resps'), ['int'])),
                                    ('unknown_cmd_resps', (YLeaf(YType.uint64, 'unknown-cmd-resps'), ['int'])),
                                    ('attr_list_retrieve_failure_resps', (YLeaf(YType.uint64, 'attr-list-retrieve-failure-resps'), ['int'])),
                                    ('resp_send_failure', (YLeaf(YType.uint64, 'resp-send-failure'), ['int'])),
                                    ('internal_err_resps', (YLeaf(YType.uint64, 'internal-err-resps'), ['int'])),
                                    ('service_profile_push_failure_resps', (YLeaf(YType.uint64, 'service-profile-push-failure-resps'), ['int'])),
                                    ('no_cmd_resps', (YLeaf(YType.uint64, 'no-cmd-resps'), ['int'])),
                                    ('no_session_found_resps', (YLeaf(YType.uint64, 'no-session-found-resps'), ['int'])),
                                    ('no_session_peer_resps', (YLeaf(YType.uint64, 'no-session-peer-resps'), ['int'])),
                                ])
                                self.unknown_account_cmd_resps = None
                                self.unknown_service_cmd_resps = None
                                self.unknown_cmd_resps = None
                                self.attr_list_retrieve_failure_resps = None
                                self.resp_send_failure = None
                                self.internal_err_resps = None
                                self.service_profile_push_failure_resps = None
                                self.no_cmd_resps = None
                                self.no_session_found_resps = None
                                self.no_session_peer_resps = None

                                self.account_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon()
                                self.account_logon.parent = self
                                self._children_name_map["account_logon"] = "account-logon"

                                self.account_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff()
                                self.account_logoff.parent = self
                                self._children_name_map["account_logoff"] = "account-logoff"

                                self.account_update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate()
                                self.account_update.parent = self
                                self._children_name_map["account_update"] = "account-update"

                                self.session_disconnect = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect()
                                self.session_disconnect.parent = self
                                self._children_name_map["session_disconnect"] = "session-disconnect"

                                self.single_service_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon()
                                self.single_service_logon.parent = self
                                self._children_name_map["single_service_logon"] = "single-service-logon"

                                self.single_service_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff()
                                self.single_service_logoff.parent = self
                                self._children_name_map["single_service_logoff"] = "single-service-logoff"

                                self.single_service_modify = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify()
                                self.single_service_modify.parent = self
                                self._children_name_map["single_service_modify"] = "single-service-modify"

                                self.service_multi = Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti()
                                self.service_multi.parent = self
                                self._children_name_map["service_multi"] = "service-multi"
                                self._segment_path = lambda: "change-of-authorization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization, ['unknown_account_cmd_resps', 'unknown_service_cmd_resps', 'unknown_cmd_resps', 'attr_list_retrieve_failure_resps', 'resp_send_failure', 'internal_err_resps', 'service_profile_push_failure_resps', 'no_cmd_resps', 'no_session_found_resps', 'no_session_peer_resps'], name, value)


                            class AccountLogon(_Entity_):
                                """
                                Account logon request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon, self).__init__()

                                    self.yang_name = "account-logon"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-logon"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogon']['meta_info']


                            class AccountLogoff(_Entity_):
                                """
                                Account logoff request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff, self).__init__()

                                    self.yang_name = "account-logoff"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-logoff"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountLogoff']['meta_info']


                            class AccountUpdate(_Entity_):
                                """
                                Account update request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate, self).__init__()

                                    self.yang_name = "account-update"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-update"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.AccountUpdate']['meta_info']


                            class SessionDisconnect(_Entity_):
                                """
                                Session disconnect request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect, self).__init__()

                                    self.yang_name = "session-disconnect"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "session-disconnect"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SessionDisconnect']['meta_info']


                            class SingleServiceLogon(_Entity_):
                                """
                                Service logon request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon, self).__init__()

                                    self.yang_name = "single-service-logon"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-logon"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogon']['meta_info']


                            class SingleServiceLogoff(_Entity_):
                                """
                                Single Service logoff request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff, self).__init__()

                                    self.yang_name = "single-service-logoff"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-logoff"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceLogoff']['meta_info']


                            class SingleServiceModify(_Entity_):
                                """
                                Single Service Modify request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify, self).__init__()

                                    self.yang_name = "single-service-modify"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-modify"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.SingleServiceModify']['meta_info']


                            class ServiceMulti(_Entity_):
                                """
                                MA\-CoA Service request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti, self).__init__()

                                    self.yang_name = "service-multi"
                                    self.yang_parent_name = "change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "service-multi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization.ServiceMulti']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.ChangeOfAuthorization']['meta_info']


                        class Authorization(_Entity_):
                            """
                            Authorization statistics
                            
                            .. attribute:: sent_requests
                            
                            	Requests sent to radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: accepted_requests
                            
                            	Request accepted by Radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: successful_requests
                            
                            	Requests which are successful
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: rejected_requests
                            
                            	Requests rejected by radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unreachable_requests
                            
                            	Radius server not available
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: errored_requests
                            
                            	Unexpected errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: terminated_requests
                            
                            	Requests terminated by disconnect
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization, self).__init__()

                                self.yang_name = "authorization"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                    ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                    ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                    ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                    ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                    ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                    ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                ])
                                self.sent_requests = None
                                self.accepted_requests = None
                                self.successful_requests = None
                                self.rejected_requests = None
                                self.unreachable_requests = None
                                self.errored_requests = None
                                self.terminated_requests = None
                                self._segment_path = lambda: "authorization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Authorization']['meta_info']


                        class AggregateAuthorization(_Entity_):
                            """
                            Aggregate authorization statistics
                            
                            .. attribute:: sent_requests
                            
                            	Requests sent to radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: accepted_requests
                            
                            	Request accepted by Radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: successful_requests
                            
                            	Requests which are successful
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: rejected_requests
                            
                            	Requests rejected by radius server
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unreachable_requests
                            
                            	Radius server not available
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: errored_requests
                            
                            	Unexpected errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: terminated_requests
                            
                            	Requests terminated by disconnect
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization, self).__init__()

                                self.yang_name = "aggregate-authorization"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                    ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                    ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                    ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                    ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                    ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                    ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                ])
                                self.sent_requests = None
                                self.accepted_requests = None
                                self.successful_requests = None
                                self.rejected_requests = None
                                self.unreachable_requests = None
                                self.errored_requests = None
                                self.terminated_requests = None
                                self._segment_path = lambda: "aggregate-authorization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAuthorization']['meta_info']


                        class AggregateAccountingStatsAll(_Entity_):
                            """
                            Display all subscriber management total
                            statistics
                            
                            .. attribute:: accounting_statistics
                            
                            	List of stats for accounting
                            	**type**\:  :py:class:`AccountingStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: authentication_statistics
                            
                            	List of stats for authentication
                            	**type**\:  :py:class:`AuthenticationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: authorization_statistics
                            
                            	List of stats for authorization
                            	**type**\:  :py:class:`AuthorizationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: change_of_authorization_statistics
                            
                            	List of stats for COA
                            	**type**\:  :py:class:`ChangeOfAuthorizationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: mobility_statistics
                            
                            	List of stats for Mobility
                            	**type**\:  :py:class:`MobilityStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll, self).__init__()

                                self.yang_name = "aggregate-accounting-stats-all"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("accounting-statistics", ("accounting_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics)), ("authentication-statistics", ("authentication_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics)), ("authorization-statistics", ("authorization_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics)), ("change-of-authorization-statistics", ("change_of_authorization_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics)), ("mobility-statistics", ("mobility_statistics", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics))])
                                self._leafs = OrderedDict()

                                self.accounting_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics()
                                self.accounting_statistics.parent = self
                                self._children_name_map["accounting_statistics"] = "accounting-statistics"

                                self.authentication_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics()
                                self.authentication_statistics.parent = self
                                self._children_name_map["authentication_statistics"] = "authentication-statistics"

                                self.authorization_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics()
                                self.authorization_statistics.parent = self
                                self._children_name_map["authorization_statistics"] = "authorization-statistics"

                                self.change_of_authorization_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics()
                                self.change_of_authorization_statistics.parent = self
                                self._children_name_map["change_of_authorization_statistics"] = "change-of-authorization-statistics"

                                self.mobility_statistics = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics()
                                self.mobility_statistics.parent = self
                                self._children_name_map["mobility_statistics"] = "mobility-statistics"
                                self._segment_path = lambda: "aggregate-accounting-stats-all"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll, [], name, value)


                            class AccountingStatistics(_Entity_):
                                """
                                List of stats for accounting
                                
                                .. attribute:: start
                                
                                	Start statistics
                                	**type**\:  :py:class:`Start <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start>`
                                
                                	**config**\: False
                                
                                .. attribute:: stop
                                
                                	Stop statistics
                                	**type**\:  :py:class:`Stop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop>`
                                
                                	**config**\: False
                                
                                .. attribute:: interim
                                
                                	Interim statistics
                                	**type**\:  :py:class:`Interim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim>`
                                
                                	**config**\: False
                                
                                .. attribute:: pass_through
                                
                                	Pass\-through statistics
                                	**type**\:  :py:class:`PassThrough <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough>`
                                
                                	**config**\: False
                                
                                .. attribute:: update
                                
                                	Update statistics
                                	**type**\:  :py:class:`Update <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update>`
                                
                                	**config**\: False
                                
                                .. attribute:: interim_inflight
                                
                                	Interim inflight details
                                	**type**\:  :py:class:`InterimInflight <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight>`
                                
                                	**config**\: False
                                
                                .. attribute:: active_sessions
                                
                                	Active sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: started_sessions
                                
                                	Started sessions
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: stopped_sessions
                                
                                	Stopped sessions
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: policy_plane_errored_requests
                                
                                	Policy plane errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: policy_plane_unknown_requests
                                
                                	Policy plane unknown requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics, self).__init__()

                                    self.yang_name = "accounting-statistics"
                                    self.yang_parent_name = "aggregate-accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("start", ("start", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start)), ("stop", ("stop", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop)), ("interim", ("interim", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim)), ("pass-through", ("pass_through", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough)), ("update", ("update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update)), ("interim-inflight", ("interim_inflight", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight))])
                                    self._leafs = OrderedDict([
                                        ('active_sessions', (YLeaf(YType.uint32, 'active-sessions'), ['int'])),
                                        ('started_sessions', (YLeaf(YType.uint64, 'started-sessions'), ['int'])),
                                        ('stopped_sessions', (YLeaf(YType.uint64, 'stopped-sessions'), ['int'])),
                                        ('policy_plane_errored_requests', (YLeaf(YType.uint64, 'policy-plane-errored-requests'), ['int'])),
                                        ('policy_plane_unknown_requests', (YLeaf(YType.uint64, 'policy-plane-unknown-requests'), ['int'])),
                                    ])
                                    self.active_sessions = None
                                    self.started_sessions = None
                                    self.stopped_sessions = None
                                    self.policy_plane_errored_requests = None
                                    self.policy_plane_unknown_requests = None

                                    self.start = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start()
                                    self.start.parent = self
                                    self._children_name_map["start"] = "start"

                                    self.stop = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop()
                                    self.stop.parent = self
                                    self._children_name_map["stop"] = "stop"

                                    self.interim = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim()
                                    self.interim.parent = self
                                    self._children_name_map["interim"] = "interim"

                                    self.pass_through = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough()
                                    self.pass_through.parent = self
                                    self._children_name_map["pass_through"] = "pass-through"

                                    self.update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update()
                                    self.update.parent = self
                                    self._children_name_map["update"] = "update"

                                    self.interim_inflight = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight()
                                    self.interim_inflight.parent = self
                                    self._children_name_map["interim_inflight"] = "interim-inflight"
                                    self._segment_path = lambda: "accounting-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics, ['active_sessions', 'started_sessions', 'stopped_sessions', 'policy_plane_errored_requests', 'policy_plane_unknown_requests'], name, value)


                                class Start(_Entity_):
                                    """
                                    Start statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start, self).__init__()

                                        self.yang_name = "start"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "start"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Start']['meta_info']


                                class Stop(_Entity_):
                                    """
                                    Stop statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop, self).__init__()

                                        self.yang_name = "stop"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "stop"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Stop']['meta_info']


                                class Interim(_Entity_):
                                    """
                                    Interim statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim, self).__init__()

                                        self.yang_name = "interim"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "interim"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Interim']['meta_info']


                                class PassThrough(_Entity_):
                                    """
                                    Pass\-through statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough, self).__init__()

                                        self.yang_name = "pass-through"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "pass-through"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.PassThrough']['meta_info']


                                class Update(_Entity_):
                                    """
                                    Update statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: errored_requests
                                    
                                    	Errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_errored_requests
                                    
                                    	AAA errored requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_sent_requests
                                    
                                    	AAA requests sent
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_succeeded_responses
                                    
                                    	AAA succeeded responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: aaa_failed_responses
                                    
                                    	AAA failed responses
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update, self).__init__()

                                        self.yang_name = "update"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                            ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                            ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                            ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                            ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.errored_requests = None
                                        self.aaa_errored_requests = None
                                        self.aaa_sent_requests = None
                                        self.aaa_succeeded_responses = None
                                        self.aaa_failed_responses = None
                                        self._segment_path = lambda: "update"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.Update']['meta_info']


                                class InterimInflight(_Entity_):
                                    """
                                    Interim inflight details
                                    
                                    .. attribute:: quota_exhausts
                                    
                                    	Quota exhausts
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: denied_requests
                                    
                                    	Denied requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: accepted_requests
                                    
                                    	Accepted requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: total_quota_of_requests
                                    
                                    	Total quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: remaining_quota_of_requests
                                    
                                    	Remaining quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: low_water_mark_quota_of_requests
                                    
                                    	Low water mark quota of requests
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight, self).__init__()

                                        self.yang_name = "interim-inflight"
                                        self.yang_parent_name = "accounting-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('quota_exhausts', (YLeaf(YType.uint32, 'quota-exhausts'), ['int'])),
                                            ('denied_requests', (YLeaf(YType.uint32, 'denied-requests'), ['int'])),
                                            ('accepted_requests', (YLeaf(YType.uint32, 'accepted-requests'), ['int'])),
                                            ('total_quota_of_requests', (YLeaf(YType.uint32, 'total-quota-of-requests'), ['int'])),
                                            ('remaining_quota_of_requests', (YLeaf(YType.uint32, 'remaining-quota-of-requests'), ['int'])),
                                            ('low_water_mark_quota_of_requests', (YLeaf(YType.uint32, 'low-water-mark-quota-of-requests'), ['int'])),
                                        ])
                                        self.quota_exhausts = None
                                        self.denied_requests = None
                                        self.accepted_requests = None
                                        self.total_quota_of_requests = None
                                        self.remaining_quota_of_requests = None
                                        self.low_water_mark_quota_of_requests = None
                                        self._segment_path = lambda: "interim-inflight"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight, ['quota_exhausts', 'denied_requests', 'accepted_requests', 'total_quota_of_requests', 'remaining_quota_of_requests', 'low_water_mark_quota_of_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics.InterimInflight']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AccountingStatistics']['meta_info']


                            class AuthenticationStatistics(_Entity_):
                                """
                                List of stats for authentication
                                
                                .. attribute:: sent_requests
                                
                                	Requests sent to radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Request accepted by Radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: successful_requests
                                
                                	Requests which are successful
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: rejected_requests
                                
                                	Requests rejected by radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unreachable_requests
                                
                                	Radius server not available
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Unexpected errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: terminated_requests
                                
                                	Requests terminated by disconnect
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics, self).__init__()

                                    self.yang_name = "authentication-statistics"
                                    self.yang_parent_name = "aggregate-accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                        ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                        ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                        ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                    ])
                                    self.sent_requests = None
                                    self.accepted_requests = None
                                    self.successful_requests = None
                                    self.rejected_requests = None
                                    self.unreachable_requests = None
                                    self.errored_requests = None
                                    self.terminated_requests = None
                                    self._segment_path = lambda: "authentication-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthenticationStatistics']['meta_info']


                            class AuthorizationStatistics(_Entity_):
                                """
                                List of stats for authorization
                                
                                .. attribute:: sent_requests
                                
                                	Requests sent to radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Request accepted by Radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: successful_requests
                                
                                	Requests which are successful
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: rejected_requests
                                
                                	Requests rejected by radius server
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unreachable_requests
                                
                                	Radius server not available
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Unexpected errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: terminated_requests
                                
                                	Requests terminated by disconnect
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics, self).__init__()

                                    self.yang_name = "authorization-statistics"
                                    self.yang_parent_name = "aggregate-accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sent_requests', (YLeaf(YType.uint64, 'sent-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint64, 'accepted-requests'), ['int'])),
                                        ('successful_requests', (YLeaf(YType.uint64, 'successful-requests'), ['int'])),
                                        ('rejected_requests', (YLeaf(YType.uint64, 'rejected-requests'), ['int'])),
                                        ('unreachable_requests', (YLeaf(YType.uint64, 'unreachable-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('terminated_requests', (YLeaf(YType.uint64, 'terminated-requests'), ['int'])),
                                    ])
                                    self.sent_requests = None
                                    self.accepted_requests = None
                                    self.successful_requests = None
                                    self.rejected_requests = None
                                    self.unreachable_requests = None
                                    self.errored_requests = None
                                    self.terminated_requests = None
                                    self._segment_path = lambda: "authorization-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics, ['sent_requests', 'accepted_requests', 'successful_requests', 'rejected_requests', 'unreachable_requests', 'errored_requests', 'terminated_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.AuthorizationStatistics']['meta_info']


                            class ChangeOfAuthorizationStatistics(_Entity_):
                                """
                                List of stats for COA
                                
                                .. attribute:: account_logon
                                
                                	Account logon request statistics
                                	**type**\:  :py:class:`AccountLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon>`
                                
                                	**config**\: False
                                
                                .. attribute:: account_logoff
                                
                                	Account logoff request statistics
                                	**type**\:  :py:class:`AccountLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff>`
                                
                                	**config**\: False
                                
                                .. attribute:: account_update
                                
                                	Account update request statistics
                                	**type**\:  :py:class:`AccountUpdate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_disconnect
                                
                                	Session disconnect request statistics
                                	**type**\:  :py:class:`SessionDisconnect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_logon
                                
                                	Service logon request statistics
                                	**type**\:  :py:class:`SingleServiceLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_logoff
                                
                                	Single Service logoff request statistics
                                	**type**\:  :py:class:`SingleServiceLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff>`
                                
                                	**config**\: False
                                
                                .. attribute:: single_service_modify
                                
                                	Single Service Modify request statistics
                                	**type**\:  :py:class:`SingleServiceModify <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify>`
                                
                                	**config**\: False
                                
                                .. attribute:: service_multi
                                
                                	MA\-CoA Service request statistics
                                	**type**\:  :py:class:`ServiceMulti <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti>`
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_account_cmd_resps
                                
                                	Responses to unknown account command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_service_cmd_resps
                                
                                	Responses to unknown service command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: unknown_cmd_resps
                                
                                	Responses to unknown command
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: attr_list_retrieve_failure_resps
                                
                                	Responses to attribute list failure errors
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: resp_send_failure
                                
                                	Response send failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: internal_err_resps
                                
                                	Responses to internal error
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: service_profile_push_failure_resps
                                
                                	Responses to service profile push failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_cmd_resps
                                
                                	Responses empty (no command) COA request
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_session_found_resps
                                
                                	Responses to COA with unknown session identifier
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: no_session_peer_resps
                                
                                	Responses to session peer not found error
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics, self).__init__()

                                    self.yang_name = "change-of-authorization-statistics"
                                    self.yang_parent_name = "aggregate-accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("account-logon", ("account_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon)), ("account-logoff", ("account_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff)), ("account-update", ("account_update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate)), ("session-disconnect", ("session_disconnect", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect)), ("single-service-logon", ("single_service_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon)), ("single-service-logoff", ("single_service_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff)), ("single-service-modify", ("single_service_modify", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify)), ("service-multi", ("service_multi", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti))])
                                    self._leafs = OrderedDict([
                                        ('unknown_account_cmd_resps', (YLeaf(YType.uint64, 'unknown-account-cmd-resps'), ['int'])),
                                        ('unknown_service_cmd_resps', (YLeaf(YType.uint64, 'unknown-service-cmd-resps'), ['int'])),
                                        ('unknown_cmd_resps', (YLeaf(YType.uint64, 'unknown-cmd-resps'), ['int'])),
                                        ('attr_list_retrieve_failure_resps', (YLeaf(YType.uint64, 'attr-list-retrieve-failure-resps'), ['int'])),
                                        ('resp_send_failure', (YLeaf(YType.uint64, 'resp-send-failure'), ['int'])),
                                        ('internal_err_resps', (YLeaf(YType.uint64, 'internal-err-resps'), ['int'])),
                                        ('service_profile_push_failure_resps', (YLeaf(YType.uint64, 'service-profile-push-failure-resps'), ['int'])),
                                        ('no_cmd_resps', (YLeaf(YType.uint64, 'no-cmd-resps'), ['int'])),
                                        ('no_session_found_resps', (YLeaf(YType.uint64, 'no-session-found-resps'), ['int'])),
                                        ('no_session_peer_resps', (YLeaf(YType.uint64, 'no-session-peer-resps'), ['int'])),
                                    ])
                                    self.unknown_account_cmd_resps = None
                                    self.unknown_service_cmd_resps = None
                                    self.unknown_cmd_resps = None
                                    self.attr_list_retrieve_failure_resps = None
                                    self.resp_send_failure = None
                                    self.internal_err_resps = None
                                    self.service_profile_push_failure_resps = None
                                    self.no_cmd_resps = None
                                    self.no_session_found_resps = None
                                    self.no_session_peer_resps = None

                                    self.account_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon()
                                    self.account_logon.parent = self
                                    self._children_name_map["account_logon"] = "account-logon"

                                    self.account_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff()
                                    self.account_logoff.parent = self
                                    self._children_name_map["account_logoff"] = "account-logoff"

                                    self.account_update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate()
                                    self.account_update.parent = self
                                    self._children_name_map["account_update"] = "account-update"

                                    self.session_disconnect = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect()
                                    self.session_disconnect.parent = self
                                    self._children_name_map["session_disconnect"] = "session-disconnect"

                                    self.single_service_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon()
                                    self.single_service_logon.parent = self
                                    self._children_name_map["single_service_logon"] = "single-service-logon"

                                    self.single_service_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff()
                                    self.single_service_logoff.parent = self
                                    self._children_name_map["single_service_logoff"] = "single-service-logoff"

                                    self.single_service_modify = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify()
                                    self.single_service_modify.parent = self
                                    self._children_name_map["single_service_modify"] = "single-service-modify"

                                    self.service_multi = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti()
                                    self.service_multi.parent = self
                                    self._children_name_map["service_multi"] = "service-multi"
                                    self._segment_path = lambda: "change-of-authorization-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics, ['unknown_account_cmd_resps', 'unknown_service_cmd_resps', 'unknown_cmd_resps', 'attr_list_retrieve_failure_resps', 'resp_send_failure', 'internal_err_resps', 'service_profile_push_failure_resps', 'no_cmd_resps', 'no_session_found_resps', 'no_session_peer_resps'], name, value)


                                class AccountLogon(_Entity_):
                                    """
                                    Account logon request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon, self).__init__()

                                        self.yang_name = "account-logon"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-logon"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogon']['meta_info']


                                class AccountLogoff(_Entity_):
                                    """
                                    Account logoff request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff, self).__init__()

                                        self.yang_name = "account-logoff"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-logoff"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountLogoff']['meta_info']


                                class AccountUpdate(_Entity_):
                                    """
                                    Account update request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate, self).__init__()

                                        self.yang_name = "account-update"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "account-update"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.AccountUpdate']['meta_info']


                                class SessionDisconnect(_Entity_):
                                    """
                                    Session disconnect request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect, self).__init__()

                                        self.yang_name = "session-disconnect"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "session-disconnect"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SessionDisconnect']['meta_info']


                                class SingleServiceLogon(_Entity_):
                                    """
                                    Service logon request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon, self).__init__()

                                        self.yang_name = "single-service-logon"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-logon"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogon']['meta_info']


                                class SingleServiceLogoff(_Entity_):
                                    """
                                    Single Service logoff request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff, self).__init__()

                                        self.yang_name = "single-service-logoff"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-logoff"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceLogoff']['meta_info']


                                class SingleServiceModify(_Entity_):
                                    """
                                    Single Service Modify request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify, self).__init__()

                                        self.yang_name = "single-service-modify"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "single-service-modify"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.SingleServiceModify']['meta_info']


                                class ServiceMulti(_Entity_):
                                    """
                                    MA\-CoA Service request statistics
                                    
                                    .. attribute:: received_requests
                                    
                                    	Received requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: acknowledged_requests
                                    
                                    	Acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: non_acknowledged_requests
                                    
                                    	Non acknowledged requests
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti, self).__init__()

                                        self.yang_name = "service-multi"
                                        self.yang_parent_name = "change-of-authorization-statistics"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                            ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                            ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                        ])
                                        self.received_requests = None
                                        self.acknowledged_requests = None
                                        self.non_acknowledged_requests = None
                                        self._segment_path = lambda: "service-multi"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics.ServiceMulti']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.ChangeOfAuthorizationStatistics']['meta_info']


                            class MobilityStatistics(_Entity_):
                                """
                                List of stats for Mobility
                                
                                .. attribute:: send_request_successes
                                
                                	Request send success
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: send_request_failures
                                
                                	Request send failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: receive_response_successes
                                
                                	Response receive success
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: receive_response_failures
                                
                                	Response receive failures
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics, self).__init__()

                                    self.yang_name = "mobility-statistics"
                                    self.yang_parent_name = "aggregate-accounting-stats-all"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('send_request_successes', (YLeaf(YType.uint64, 'send-request-successes'), ['int'])),
                                        ('send_request_failures', (YLeaf(YType.uint64, 'send-request-failures'), ['int'])),
                                        ('receive_response_successes', (YLeaf(YType.uint64, 'receive-response-successes'), ['int'])),
                                        ('receive_response_failures', (YLeaf(YType.uint64, 'receive-response-failures'), ['int'])),
                                    ])
                                    self.send_request_successes = None
                                    self.send_request_failures = None
                                    self.receive_response_successes = None
                                    self.receive_response_failures = None
                                    self._segment_path = lambda: "mobility-statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics, ['send_request_successes', 'send_request_failures', 'receive_response_successes', 'receive_response_failures'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll.MobilityStatistics']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateAccountingStatsAll']['meta_info']


                        class Accounting(_Entity_):
                            """
                            Accounting statistics
                            
                            .. attribute:: start
                            
                            	Start statistics
                            	**type**\:  :py:class:`Start <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start>`
                            
                            	**config**\: False
                            
                            .. attribute:: stop
                            
                            	Stop statistics
                            	**type**\:  :py:class:`Stop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop>`
                            
                            	**config**\: False
                            
                            .. attribute:: interim
                            
                            	Interim statistics
                            	**type**\:  :py:class:`Interim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim>`
                            
                            	**config**\: False
                            
                            .. attribute:: pass_through
                            
                            	Pass\-through statistics
                            	**type**\:  :py:class:`PassThrough <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough>`
                            
                            	**config**\: False
                            
                            .. attribute:: update
                            
                            	Update statistics
                            	**type**\:  :py:class:`Update <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update>`
                            
                            	**config**\: False
                            
                            .. attribute:: interim_inflight
                            
                            	Interim inflight details
                            	**type**\:  :py:class:`InterimInflight <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight>`
                            
                            	**config**\: False
                            
                            .. attribute:: active_sessions
                            
                            	Active sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: started_sessions
                            
                            	Started sessions
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: stopped_sessions
                            
                            	Stopped sessions
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: policy_plane_errored_requests
                            
                            	Policy plane errored requests
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: policy_plane_unknown_requests
                            
                            	Policy plane unknown requests
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting, self).__init__()

                                self.yang_name = "accounting"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("start", ("start", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start)), ("stop", ("stop", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop)), ("interim", ("interim", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim)), ("pass-through", ("pass_through", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough)), ("update", ("update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update)), ("interim-inflight", ("interim_inflight", Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight))])
                                self._leafs = OrderedDict([
                                    ('active_sessions', (YLeaf(YType.uint32, 'active-sessions'), ['int'])),
                                    ('started_sessions', (YLeaf(YType.uint64, 'started-sessions'), ['int'])),
                                    ('stopped_sessions', (YLeaf(YType.uint64, 'stopped-sessions'), ['int'])),
                                    ('policy_plane_errored_requests', (YLeaf(YType.uint64, 'policy-plane-errored-requests'), ['int'])),
                                    ('policy_plane_unknown_requests', (YLeaf(YType.uint64, 'policy-plane-unknown-requests'), ['int'])),
                                ])
                                self.active_sessions = None
                                self.started_sessions = None
                                self.stopped_sessions = None
                                self.policy_plane_errored_requests = None
                                self.policy_plane_unknown_requests = None

                                self.start = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start()
                                self.start.parent = self
                                self._children_name_map["start"] = "start"

                                self.stop = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop()
                                self.stop.parent = self
                                self._children_name_map["stop"] = "stop"

                                self.interim = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim()
                                self.interim.parent = self
                                self._children_name_map["interim"] = "interim"

                                self.pass_through = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough()
                                self.pass_through.parent = self
                                self._children_name_map["pass_through"] = "pass-through"

                                self.update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update()
                                self.update.parent = self
                                self._children_name_map["update"] = "update"

                                self.interim_inflight = Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight()
                                self.interim_inflight.parent = self
                                self._children_name_map["interim_inflight"] = "interim-inflight"
                                self._segment_path = lambda: "accounting"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting, ['active_sessions', 'started_sessions', 'stopped_sessions', 'policy_plane_errored_requests', 'policy_plane_unknown_requests'], name, value)


                            class Start(_Entity_):
                                """
                                Start statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start, self).__init__()

                                    self.yang_name = "start"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "start"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Start']['meta_info']


                            class Stop(_Entity_):
                                """
                                Stop statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop, self).__init__()

                                    self.yang_name = "stop"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "stop"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Stop']['meta_info']


                            class Interim(_Entity_):
                                """
                                Interim statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim, self).__init__()

                                    self.yang_name = "interim"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "interim"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Interim']['meta_info']


                            class PassThrough(_Entity_):
                                """
                                Pass\-through statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough, self).__init__()

                                    self.yang_name = "pass-through"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "pass-through"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.PassThrough']['meta_info']


                            class Update(_Entity_):
                                """
                                Update statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: errored_requests
                                
                                	Errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_errored_requests
                                
                                	AAA errored requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_sent_requests
                                
                                	AAA requests sent
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_succeeded_responses
                                
                                	AAA succeeded responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: aaa_failed_responses
                                
                                	AAA failed responses
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update, self).__init__()

                                    self.yang_name = "update"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('errored_requests', (YLeaf(YType.uint64, 'errored-requests'), ['int'])),
                                        ('aaa_errored_requests', (YLeaf(YType.uint64, 'aaa-errored-requests'), ['int'])),
                                        ('aaa_sent_requests', (YLeaf(YType.uint64, 'aaa-sent-requests'), ['int'])),
                                        ('aaa_succeeded_responses', (YLeaf(YType.uint64, 'aaa-succeeded-responses'), ['int'])),
                                        ('aaa_failed_responses', (YLeaf(YType.uint64, 'aaa-failed-responses'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.errored_requests = None
                                    self.aaa_errored_requests = None
                                    self.aaa_sent_requests = None
                                    self.aaa_succeeded_responses = None
                                    self.aaa_failed_responses = None
                                    self._segment_path = lambda: "update"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update, ['received_requests', 'errored_requests', 'aaa_errored_requests', 'aaa_sent_requests', 'aaa_succeeded_responses', 'aaa_failed_responses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.Update']['meta_info']


                            class InterimInflight(_Entity_):
                                """
                                Interim inflight details
                                
                                .. attribute:: quota_exhausts
                                
                                	Quota exhausts
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: denied_requests
                                
                                	Denied requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_requests
                                
                                	Accepted requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: total_quota_of_requests
                                
                                	Total quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remaining_quota_of_requests
                                
                                	Remaining quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: low_water_mark_quota_of_requests
                                
                                	Low water mark quota of requests
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight, self).__init__()

                                    self.yang_name = "interim-inflight"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('quota_exhausts', (YLeaf(YType.uint32, 'quota-exhausts'), ['int'])),
                                        ('denied_requests', (YLeaf(YType.uint32, 'denied-requests'), ['int'])),
                                        ('accepted_requests', (YLeaf(YType.uint32, 'accepted-requests'), ['int'])),
                                        ('total_quota_of_requests', (YLeaf(YType.uint32, 'total-quota-of-requests'), ['int'])),
                                        ('remaining_quota_of_requests', (YLeaf(YType.uint32, 'remaining-quota-of-requests'), ['int'])),
                                        ('low_water_mark_quota_of_requests', (YLeaf(YType.uint32, 'low-water-mark-quota-of-requests'), ['int'])),
                                    ])
                                    self.quota_exhausts = None
                                    self.denied_requests = None
                                    self.accepted_requests = None
                                    self.total_quota_of_requests = None
                                    self.remaining_quota_of_requests = None
                                    self.low_water_mark_quota_of_requests = None
                                    self._segment_path = lambda: "interim-inflight"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight, ['quota_exhausts', 'denied_requests', 'accepted_requests', 'total_quota_of_requests', 'remaining_quota_of_requests', 'low_water_mark_quota_of_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting.InterimInflight']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Accounting']['meta_info']


                        class Mobility(_Entity_):
                            """
                            Mobility statistics
                            
                            .. attribute:: send_request_successes
                            
                            	Request send success
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: send_request_failures
                            
                            	Request send failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: receive_response_successes
                            
                            	Response receive success
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: receive_response_failures
                            
                            	Response receive failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility, self).__init__()

                                self.yang_name = "mobility"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('send_request_successes', (YLeaf(YType.uint64, 'send-request-successes'), ['int'])),
                                    ('send_request_failures', (YLeaf(YType.uint64, 'send-request-failures'), ['int'])),
                                    ('receive_response_successes', (YLeaf(YType.uint64, 'receive-response-successes'), ['int'])),
                                    ('receive_response_failures', (YLeaf(YType.uint64, 'receive-response-failures'), ['int'])),
                                ])
                                self.send_request_successes = None
                                self.send_request_failures = None
                                self.receive_response_successes = None
                                self.receive_response_failures = None
                                self._segment_path = lambda: "mobility"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility, ['send_request_successes', 'send_request_failures', 'receive_response_successes', 'receive_response_failures'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.Mobility']['meta_info']


                        class AggregateChangeOfAuthorization(_Entity_):
                            """
                            Aggregate change of authorization (COA)
                            statistics
                            
                            .. attribute:: account_logon
                            
                            	Account logon request statistics
                            	**type**\:  :py:class:`AccountLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon>`
                            
                            	**config**\: False
                            
                            .. attribute:: account_logoff
                            
                            	Account logoff request statistics
                            	**type**\:  :py:class:`AccountLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff>`
                            
                            	**config**\: False
                            
                            .. attribute:: account_update
                            
                            	Account update request statistics
                            	**type**\:  :py:class:`AccountUpdate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate>`
                            
                            	**config**\: False
                            
                            .. attribute:: session_disconnect
                            
                            	Session disconnect request statistics
                            	**type**\:  :py:class:`SessionDisconnect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_logon
                            
                            	Service logon request statistics
                            	**type**\:  :py:class:`SingleServiceLogon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_logoff
                            
                            	Single Service logoff request statistics
                            	**type**\:  :py:class:`SingleServiceLogoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff>`
                            
                            	**config**\: False
                            
                            .. attribute:: single_service_modify
                            
                            	Single Service Modify request statistics
                            	**type**\:  :py:class:`SingleServiceModify <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify>`
                            
                            	**config**\: False
                            
                            .. attribute:: service_multi
                            
                            	MA\-CoA Service request statistics
                            	**type**\:  :py:class:`ServiceMulti <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti>`
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_account_cmd_resps
                            
                            	Responses to unknown account command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_service_cmd_resps
                            
                            	Responses to unknown service command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: unknown_cmd_resps
                            
                            	Responses to unknown command
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: attr_list_retrieve_failure_resps
                            
                            	Responses to attribute list failure errors
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: resp_send_failure
                            
                            	Response send failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: internal_err_resps
                            
                            	Responses to internal error
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: service_profile_push_failure_resps
                            
                            	Responses to service profile push failures
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_cmd_resps
                            
                            	Responses empty (no command) COA request
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_session_found_resps
                            
                            	Responses to COA with unknown session identifier
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: no_session_peer_resps
                            
                            	Responses to session peer not found error
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization, self).__init__()

                                self.yang_name = "aggregate-change-of-authorization"
                                self.yang_parent_name = "aaa"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("account-logon", ("account_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon)), ("account-logoff", ("account_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff)), ("account-update", ("account_update", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate)), ("session-disconnect", ("session_disconnect", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect)), ("single-service-logon", ("single_service_logon", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon)), ("single-service-logoff", ("single_service_logoff", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff)), ("single-service-modify", ("single_service_modify", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify)), ("service-multi", ("service_multi", Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti))])
                                self._leafs = OrderedDict([
                                    ('unknown_account_cmd_resps', (YLeaf(YType.uint64, 'unknown-account-cmd-resps'), ['int'])),
                                    ('unknown_service_cmd_resps', (YLeaf(YType.uint64, 'unknown-service-cmd-resps'), ['int'])),
                                    ('unknown_cmd_resps', (YLeaf(YType.uint64, 'unknown-cmd-resps'), ['int'])),
                                    ('attr_list_retrieve_failure_resps', (YLeaf(YType.uint64, 'attr-list-retrieve-failure-resps'), ['int'])),
                                    ('resp_send_failure', (YLeaf(YType.uint64, 'resp-send-failure'), ['int'])),
                                    ('internal_err_resps', (YLeaf(YType.uint64, 'internal-err-resps'), ['int'])),
                                    ('service_profile_push_failure_resps', (YLeaf(YType.uint64, 'service-profile-push-failure-resps'), ['int'])),
                                    ('no_cmd_resps', (YLeaf(YType.uint64, 'no-cmd-resps'), ['int'])),
                                    ('no_session_found_resps', (YLeaf(YType.uint64, 'no-session-found-resps'), ['int'])),
                                    ('no_session_peer_resps', (YLeaf(YType.uint64, 'no-session-peer-resps'), ['int'])),
                                ])
                                self.unknown_account_cmd_resps = None
                                self.unknown_service_cmd_resps = None
                                self.unknown_cmd_resps = None
                                self.attr_list_retrieve_failure_resps = None
                                self.resp_send_failure = None
                                self.internal_err_resps = None
                                self.service_profile_push_failure_resps = None
                                self.no_cmd_resps = None
                                self.no_session_found_resps = None
                                self.no_session_peer_resps = None

                                self.account_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon()
                                self.account_logon.parent = self
                                self._children_name_map["account_logon"] = "account-logon"

                                self.account_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff()
                                self.account_logoff.parent = self
                                self._children_name_map["account_logoff"] = "account-logoff"

                                self.account_update = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate()
                                self.account_update.parent = self
                                self._children_name_map["account_update"] = "account-update"

                                self.session_disconnect = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect()
                                self.session_disconnect.parent = self
                                self._children_name_map["session_disconnect"] = "session-disconnect"

                                self.single_service_logon = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon()
                                self.single_service_logon.parent = self
                                self._children_name_map["single_service_logon"] = "single-service-logon"

                                self.single_service_logoff = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff()
                                self.single_service_logoff.parent = self
                                self._children_name_map["single_service_logoff"] = "single-service-logoff"

                                self.single_service_modify = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify()
                                self.single_service_modify.parent = self
                                self._children_name_map["single_service_modify"] = "single-service-modify"

                                self.service_multi = Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti()
                                self.service_multi.parent = self
                                self._children_name_map["service_multi"] = "service-multi"
                                self._segment_path = lambda: "aggregate-change-of-authorization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization, ['unknown_account_cmd_resps', 'unknown_service_cmd_resps', 'unknown_cmd_resps', 'attr_list_retrieve_failure_resps', 'resp_send_failure', 'internal_err_resps', 'service_profile_push_failure_resps', 'no_cmd_resps', 'no_session_found_resps', 'no_session_peer_resps'], name, value)


                            class AccountLogon(_Entity_):
                                """
                                Account logon request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon, self).__init__()

                                    self.yang_name = "account-logon"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-logon"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogon']['meta_info']


                            class AccountLogoff(_Entity_):
                                """
                                Account logoff request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff, self).__init__()

                                    self.yang_name = "account-logoff"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-logoff"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountLogoff']['meta_info']


                            class AccountUpdate(_Entity_):
                                """
                                Account update request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate, self).__init__()

                                    self.yang_name = "account-update"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "account-update"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.AccountUpdate']['meta_info']


                            class SessionDisconnect(_Entity_):
                                """
                                Session disconnect request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect, self).__init__()

                                    self.yang_name = "session-disconnect"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "session-disconnect"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SessionDisconnect']['meta_info']


                            class SingleServiceLogon(_Entity_):
                                """
                                Service logon request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon, self).__init__()

                                    self.yang_name = "single-service-logon"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-logon"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogon']['meta_info']


                            class SingleServiceLogoff(_Entity_):
                                """
                                Single Service logoff request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff, self).__init__()

                                    self.yang_name = "single-service-logoff"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-logoff"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceLogoff']['meta_info']


                            class SingleServiceModify(_Entity_):
                                """
                                Single Service Modify request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify, self).__init__()

                                    self.yang_name = "single-service-modify"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "single-service-modify"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.SingleServiceModify']['meta_info']


                            class ServiceMulti(_Entity_):
                                """
                                MA\-CoA Service request statistics
                                
                                .. attribute:: received_requests
                                
                                	Received requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: acknowledged_requests
                                
                                	Acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                .. attribute:: non_acknowledged_requests
                                
                                	Non acknowledged requests
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti, self).__init__()

                                    self.yang_name = "service-multi"
                                    self.yang_parent_name = "aggregate-change-of-authorization"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('received_requests', (YLeaf(YType.uint64, 'received-requests'), ['int'])),
                                        ('acknowledged_requests', (YLeaf(YType.uint64, 'acknowledged-requests'), ['int'])),
                                        ('non_acknowledged_requests', (YLeaf(YType.uint64, 'non-acknowledged-requests'), ['int'])),
                                    ])
                                    self.received_requests = None
                                    self.acknowledged_requests = None
                                    self.non_acknowledged_requests = None
                                    self._segment_path = lambda: "service-multi"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti, ['received_requests', 'acknowledged_requests', 'non_acknowledged_requests'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization.ServiceMulti']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa.AggregateChangeOfAuthorization']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Aaa']['meta_info']


                    class AggregateSummary(_Entity_):
                        """
                        Aggregate summary of statistics
                        
                        .. attribute:: no_subscriber_control_policy_on_interface
                        
                        	Subscriber control policy not applied on interface
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: no_class_match_in_start_request
                        
                        	No control policy class match during subscriber start
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: nas_port_attribute_format_warnings
                        
                        	NAS port attribute format warnings
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: nas_port_id_attribute_format_warnings
                        
                        	NAS port ID attribute format warnings
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: destination_station_id_attribute_format_warnings
                        
                        	Destination station ID attribute format warnings
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: calling_station_id_attribute_format_warnings
                        
                        	Calling station ID attribute format warnings
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: username_attribute_format_warnings
                        
                        	Username attribute format warnings
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: install_user_profiles
                        
                        	User profiles installed
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: user_profile_install_errors
                        
                        	User profile install errors
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: user_profile_removals
                        
                        	User profile removals
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: user_profile_errors
                        
                        	User profile errors
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_quota_exhausts
                        
                        	Session Disconnect Quota Exhausts
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_no_quota
                        
                        	Session Disconnect Request Queued, no quota
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_quota_avail
                        
                        	Session Disconnect Request Accepted, quota available
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_recon_ip
                        
                        	Session Disconnect Requests not Dequeued, reconciliation in progress
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_none_started
                        
                        	Session Disconnect Requests not Dequeued, no quota
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_quota
                        
                        	Session Disconnect Quota
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_quota_remaining
                        
                        	Session Disconnect Quota Remaining
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sess_disc_q_count
                        
                        	Session Disconnect Requests Queued
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary, self).__init__()

                            self.yang_name = "aggregate-summary"
                            self.yang_parent_name = "statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('no_subscriber_control_policy_on_interface', (YLeaf(YType.uint64, 'no-subscriber-control-policy-on-interface'), ['int'])),
                                ('no_class_match_in_start_request', (YLeaf(YType.uint64, 'no-class-match-in-start-request'), ['int'])),
                                ('nas_port_attribute_format_warnings', (YLeaf(YType.uint64, 'nas-port-attribute-format-warnings'), ['int'])),
                                ('nas_port_id_attribute_format_warnings', (YLeaf(YType.uint64, 'nas-port-id-attribute-format-warnings'), ['int'])),
                                ('destination_station_id_attribute_format_warnings', (YLeaf(YType.uint64, 'destination-station-id-attribute-format-warnings'), ['int'])),
                                ('calling_station_id_attribute_format_warnings', (YLeaf(YType.uint64, 'calling-station-id-attribute-format-warnings'), ['int'])),
                                ('username_attribute_format_warnings', (YLeaf(YType.uint64, 'username-attribute-format-warnings'), ['int'])),
                                ('install_user_profiles', (YLeaf(YType.uint64, 'install-user-profiles'), ['int'])),
                                ('user_profile_install_errors', (YLeaf(YType.uint64, 'user-profile-install-errors'), ['int'])),
                                ('user_profile_removals', (YLeaf(YType.uint64, 'user-profile-removals'), ['int'])),
                                ('user_profile_errors', (YLeaf(YType.uint64, 'user-profile-errors'), ['int'])),
                                ('sess_disc_quota_exhausts', (YLeaf(YType.uint64, 'sess-disc-quota-exhausts'), ['int'])),
                                ('sess_disc_no_quota', (YLeaf(YType.uint64, 'sess-disc-no-quota'), ['int'])),
                                ('sess_disc_quota_avail', (YLeaf(YType.uint64, 'sess-disc-quota-avail'), ['int'])),
                                ('sess_disc_recon_ip', (YLeaf(YType.uint64, 'sess-disc-recon-ip'), ['int'])),
                                ('sess_disc_none_started', (YLeaf(YType.uint64, 'sess-disc-none-started'), ['int'])),
                                ('sess_disc_quota', (YLeaf(YType.uint32, 'sess-disc-quota'), ['int'])),
                                ('sess_disc_quota_remaining', (YLeaf(YType.uint32, 'sess-disc-quota-remaining'), ['int'])),
                                ('sess_disc_q_count', (YLeaf(YType.uint32, 'sess-disc-q-count'), ['int'])),
                            ])
                            self.no_subscriber_control_policy_on_interface = None
                            self.no_class_match_in_start_request = None
                            self.nas_port_attribute_format_warnings = None
                            self.nas_port_id_attribute_format_warnings = None
                            self.destination_station_id_attribute_format_warnings = None
                            self.calling_station_id_attribute_format_warnings = None
                            self.username_attribute_format_warnings = None
                            self.install_user_profiles = None
                            self.user_profile_install_errors = None
                            self.user_profile_removals = None
                            self.user_profile_errors = None
                            self.sess_disc_quota_exhausts = None
                            self.sess_disc_no_quota = None
                            self.sess_disc_quota_avail = None
                            self.sess_disc_recon_ip = None
                            self.sess_disc_none_started = None
                            self.sess_disc_quota = None
                            self.sess_disc_quota_remaining = None
                            self.sess_disc_q_count = None
                            self._segment_path = lambda: "aggregate-summary"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary, ['no_subscriber_control_policy_on_interface', 'no_class_match_in_start_request', 'nas_port_attribute_format_warnings', 'nas_port_id_attribute_format_warnings', 'destination_station_id_attribute_format_warnings', 'calling_station_id_attribute_format_warnings', 'username_attribute_format_warnings', 'install_user_profiles', 'user_profile_install_errors', 'user_profile_removals', 'user_profile_errors', 'sess_disc_quota_exhausts', 'sess_disc_no_quota', 'sess_disc_quota_avail', 'sess_disc_recon_ip', 'sess_disc_none_started', 'sess_disc_quota', 'sess_disc_quota_remaining', 'sess_disc_q_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.AggregateSummary']['meta_info']


                    class DisconnUnique(_Entity_):
                        """
                        Disconnect Unique Summary statistics
                        
                        .. attribute:: history_data
                        
                        	List of disconnect history items
                        	**type**\: list of  		 :py:class:`HistoryData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique.HistoryData>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique, self).__init__()

                            self.yang_name = "disconn-unique"
                            self.yang_parent_name = "statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("history-data", ("history_data", Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique.HistoryData))])
                            self._leafs = OrderedDict()

                            self.history_data = YList(self)
                            self._segment_path = lambda: "disconn-unique"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique, [], name, value)


                        class HistoryData(_Entity_):
                            """
                            List of disconnect history items
                            
                            .. attribute:: disc_reason
                            
                            	Disconnect reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: session_count
                            
                            	Number of sessions that disconnected this way
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: latest_activity
                            
                            	Latest activity
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: if_name
                            
                            	Interface name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique.HistoryData, self).__init__()

                                self.yang_name = "history-data"
                                self.yang_parent_name = "disconn-unique"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('disc_reason', (YLeaf(YType.str, 'disc-reason'), ['str'])),
                                    ('session_count', (YLeaf(YType.uint32, 'session-count'), ['int'])),
                                    ('latest_activity', (YLeaf(YType.uint32, 'latest-activity'), ['int'])),
                                    ('if_name', (YLeaf(YType.str, 'if-name'), ['str'])),
                                ])
                                self.disc_reason = None
                                self.session_count = None
                                self.latest_activity = None
                                self.if_name = None
                                self._segment_path = lambda: "history-data"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique.HistoryData, ['disc_reason', 'session_count', 'latest_activity', 'if_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique.HistoryData']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.DisconnUnique']['meta_info']


                    class Srg(_Entity_):
                        """
                        Geo Redundancy statistics
                        
                        .. attribute:: txlist_send_triggered
                        
                        	Txlist Send Triggered
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_send_failed
                        
                        	Txlist Send Failed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_send_failed_notactive
                        
                        	Txlist send failed due to not active
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: actual_txlist_sent
                        
                        	Txlist Send Success
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: alreadyin_txlist
                        
                        	Element already in Txlist
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_encode
                        
                        	Txlist Encode
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_encode_fail
                        
                        	Txlist encode Failed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: create_update_encode
                        
                        	Txlist Create Update Encode
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: delete_encode
                        
                        	Txlist Delete Encode
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: create_upd_clean_callback
                        
                        	Txlist Create/update clean callback
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: delete_clean_callback
                        
                        	Txlist Delete clean callback
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: slave_recv_entry
                        
                        	Slave Recieved Sync
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: slave_decode_fail
                        
                        	Decode failed on Slave
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: slave_create_update
                        
                        	Create Update received on slave
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: slave_delete
                        
                        	Delete received on slave
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srg_context_malloc
                        
                        	SRG context allocated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srg_context_free
                        
                        	SRG context freed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sod_count
                        
                        	Number of SODs Received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: eod_count
                        
                        	Number of EODs Received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sod_eod_replay_req_count
                        
                        	Number of Replay Requests Within SOD EOD Window
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sod_eod_dirty_mark_count
                        
                        	Number of Sessions Marked as Invalid Within SOD EOD Window
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sod_eod_dirty_delete_count
                        
                        	Number of Sessions Invalid Deletes Within SOD EOD Window
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ack_to_srg
                        
                        	Number of ACKs sent to Srg
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: nack_to_srg
                        
                        	Number of NACKs sent to Srg
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: nack_to_srg_fail_cnt
                        
                        	Number of NACKs Failed to send to Srg
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_remove_all
                        
                        	Number of Txlist remove all calls
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_del_sync
                        
                        	Number for Txlist delete for sync msg
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_del_sync_notlinked
                        
                        	Number of Txlist delete for sync which are not linked
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_del_app
                        
                        	Number of Txlist delete for App msg
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_del_app_notlinked
                        
                        	Number of Txlist delete for App which are not linked
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_clean_invalid_state
                        
                        	Number of Txlist Cleanup called on Invalid subscriber srg state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: txlist_remove_all_internal_error
                        
                        	Number of Internal errors upon Master Txlist remove all call
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_srg_flow_control_enabled
                        
                        	Flag indicating SRG Flow control enabled or not
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: max_inflight_sessoin_count
                        
                        	Maximum no.of inflight sessions allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: flow_control_resume_threshold
                        
                        	Threshold Limit to resume the flow control
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_session_count
                        
                        	No.of Sessions inflight at given time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_add_count
                        
                        	No.of inflight sessions added
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_under_run_count
                        
                        	Inflight Underrun Counter
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_alloc_fails
                        
                        	Memory Alloc Failures for Inflight Entry
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_insert_failures
                        
                        	Inflight Entry Insert Failures
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_deletes
                        
                        	Inflight Deletes Count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_not_found
                        
                        	Inflight Entries not found during delete
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: inflight_delete_failures
                        
                        	Inflight Entry Delete Failures
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_pause_count
                        
                        	Total No.of times Pause is Enabled
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_resume_count
                        
                        	Total No.of times Resume is triggered
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_dont_send_to_txlist
                        
                        	Total No of times Dont send to Txlist
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_srg_txlist_no_add_restore_flag_set
                        
                        	Total No of times restore flag found set
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_srg_not_master
                        
                        	Total No of times SRG Not Master
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_master_eoms_pending
                        
                        	Total No of times Master EOMS Pending
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_master_eoms_pending_cleared
                        
                        	Total No of times Master EOMS Pending Cleared
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_pause_period
                        
                        	Amount of time paused during last flow control window
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: total_pause_time
                        
                        	Total Amount of time paused during all flow control windows
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: last_pause_time
                        
                        	Timestamp of recent Pause Event
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: last_resume_time
                        
                        	Timestamp of recent Resume Event
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Manager.Nodes.Node.Statistics.Srg, self).__init__()

                            self.yang_name = "srg"
                            self.yang_parent_name = "statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('txlist_send_triggered', (YLeaf(YType.uint32, 'txlist-send-triggered'), ['int'])),
                                ('txlist_send_failed', (YLeaf(YType.uint32, 'txlist-send-failed'), ['int'])),
                                ('txlist_send_failed_notactive', (YLeaf(YType.uint32, 'txlist-send-failed-notactive'), ['int'])),
                                ('actual_txlist_sent', (YLeaf(YType.uint32, 'actual-txlist-sent'), ['int'])),
                                ('alreadyin_txlist', (YLeaf(YType.uint32, 'alreadyin-txlist'), ['int'])),
                                ('txlist_encode', (YLeaf(YType.uint32, 'txlist-encode'), ['int'])),
                                ('txlist_encode_fail', (YLeaf(YType.uint32, 'txlist-encode-fail'), ['int'])),
                                ('create_update_encode', (YLeaf(YType.uint32, 'create-update-encode'), ['int'])),
                                ('delete_encode', (YLeaf(YType.uint32, 'delete-encode'), ['int'])),
                                ('create_upd_clean_callback', (YLeaf(YType.uint32, 'create-upd-clean-callback'), ['int'])),
                                ('delete_clean_callback', (YLeaf(YType.uint32, 'delete-clean-callback'), ['int'])),
                                ('slave_recv_entry', (YLeaf(YType.uint32, 'slave-recv-entry'), ['int'])),
                                ('slave_decode_fail', (YLeaf(YType.uint32, 'slave-decode-fail'), ['int'])),
                                ('slave_create_update', (YLeaf(YType.uint32, 'slave-create-update'), ['int'])),
                                ('slave_delete', (YLeaf(YType.uint32, 'slave-delete'), ['int'])),
                                ('srg_context_malloc', (YLeaf(YType.uint32, 'srg-context-malloc'), ['int'])),
                                ('srg_context_free', (YLeaf(YType.uint32, 'srg-context-free'), ['int'])),
                                ('sod_count', (YLeaf(YType.uint32, 'sod-count'), ['int'])),
                                ('eod_count', (YLeaf(YType.uint32, 'eod-count'), ['int'])),
                                ('sod_eod_replay_req_count', (YLeaf(YType.uint32, 'sod-eod-replay-req-count'), ['int'])),
                                ('sod_eod_dirty_mark_count', (YLeaf(YType.uint32, 'sod-eod-dirty-mark-count'), ['int'])),
                                ('sod_eod_dirty_delete_count', (YLeaf(YType.uint32, 'sod-eod-dirty-delete-count'), ['int'])),
                                ('ack_to_srg', (YLeaf(YType.uint32, 'ack-to-srg'), ['int'])),
                                ('nack_to_srg', (YLeaf(YType.uint32, 'nack-to-srg'), ['int'])),
                                ('nack_to_srg_fail_cnt', (YLeaf(YType.uint32, 'nack-to-srg-fail-cnt'), ['int'])),
                                ('txlist_remove_all', (YLeaf(YType.uint32, 'txlist-remove-all'), ['int'])),
                                ('txlist_del_sync', (YLeaf(YType.uint32, 'txlist-del-sync'), ['int'])),
                                ('txlist_del_sync_notlinked', (YLeaf(YType.uint32, 'txlist-del-sync-notlinked'), ['int'])),
                                ('txlist_del_app', (YLeaf(YType.uint32, 'txlist-del-app'), ['int'])),
                                ('txlist_del_app_notlinked', (YLeaf(YType.uint32, 'txlist-del-app-notlinked'), ['int'])),
                                ('txlist_clean_invalid_state', (YLeaf(YType.uint32, 'txlist-clean-invalid-state'), ['int'])),
                                ('txlist_remove_all_internal_error', (YLeaf(YType.uint32, 'txlist-remove-all-internal-error'), ['int'])),
                                ('is_srg_flow_control_enabled', (YLeaf(YType.boolean, 'is-srg-flow-control-enabled'), ['bool'])),
                                ('max_inflight_sessoin_count', (YLeaf(YType.uint32, 'max-inflight-sessoin-count'), ['int'])),
                                ('flow_control_resume_threshold', (YLeaf(YType.uint32, 'flow-control-resume-threshold'), ['int'])),
                                ('inflight_session_count', (YLeaf(YType.uint32, 'inflight-session-count'), ['int'])),
                                ('inflight_add_count', (YLeaf(YType.uint32, 'inflight-add-count'), ['int'])),
                                ('inflight_under_run_count', (YLeaf(YType.uint32, 'inflight-under-run-count'), ['int'])),
                                ('inflight_alloc_fails', (YLeaf(YType.uint32, 'inflight-alloc-fails'), ['int'])),
                                ('inflight_insert_failures', (YLeaf(YType.uint32, 'inflight-insert-failures'), ['int'])),
                                ('inflight_deletes', (YLeaf(YType.uint32, 'inflight-deletes'), ['int'])),
                                ('inflight_not_found', (YLeaf(YType.uint32, 'inflight-not-found'), ['int'])),
                                ('inflight_delete_failures', (YLeaf(YType.uint32, 'inflight-delete-failures'), ['int'])),
                                ('total_pause_count', (YLeaf(YType.uint32, 'total-pause-count'), ['int'])),
                                ('total_resume_count', (YLeaf(YType.uint32, 'total-resume-count'), ['int'])),
                                ('total_dont_send_to_txlist', (YLeaf(YType.uint32, 'total-dont-send-to-txlist'), ['int'])),
                                ('total_srg_txlist_no_add_restore_flag_set', (YLeaf(YType.uint32, 'total-srg-txlist-no-add-restore-flag-set'), ['int'])),
                                ('total_srg_not_master', (YLeaf(YType.uint32, 'total-srg-not-master'), ['int'])),
                                ('total_master_eoms_pending', (YLeaf(YType.uint32, 'total-master-eoms-pending'), ['int'])),
                                ('total_master_eoms_pending_cleared', (YLeaf(YType.uint32, 'total-master-eoms-pending-cleared'), ['int'])),
                                ('last_pause_period', (YLeaf(YType.uint64, 'last-pause-period'), ['int'])),
                                ('total_pause_time', (YLeaf(YType.uint64, 'total-pause-time'), ['int'])),
                                ('last_pause_time', (YLeaf(YType.uint64, 'last-pause-time'), ['int'])),
                                ('last_resume_time', (YLeaf(YType.uint64, 'last-resume-time'), ['int'])),
                            ])
                            self.txlist_send_triggered = None
                            self.txlist_send_failed = None
                            self.txlist_send_failed_notactive = None
                            self.actual_txlist_sent = None
                            self.alreadyin_txlist = None
                            self.txlist_encode = None
                            self.txlist_encode_fail = None
                            self.create_update_encode = None
                            self.delete_encode = None
                            self.create_upd_clean_callback = None
                            self.delete_clean_callback = None
                            self.slave_recv_entry = None
                            self.slave_decode_fail = None
                            self.slave_create_update = None
                            self.slave_delete = None
                            self.srg_context_malloc = None
                            self.srg_context_free = None
                            self.sod_count = None
                            self.eod_count = None
                            self.sod_eod_replay_req_count = None
                            self.sod_eod_dirty_mark_count = None
                            self.sod_eod_dirty_delete_count = None
                            self.ack_to_srg = None
                            self.nack_to_srg = None
                            self.nack_to_srg_fail_cnt = None
                            self.txlist_remove_all = None
                            self.txlist_del_sync = None
                            self.txlist_del_sync_notlinked = None
                            self.txlist_del_app = None
                            self.txlist_del_app_notlinked = None
                            self.txlist_clean_invalid_state = None
                            self.txlist_remove_all_internal_error = None
                            self.is_srg_flow_control_enabled = None
                            self.max_inflight_sessoin_count = None
                            self.flow_control_resume_threshold = None
                            self.inflight_session_count = None
                            self.inflight_add_count = None
                            self.inflight_under_run_count = None
                            self.inflight_alloc_fails = None
                            self.inflight_insert_failures = None
                            self.inflight_deletes = None
                            self.inflight_not_found = None
                            self.inflight_delete_failures = None
                            self.total_pause_count = None
                            self.total_resume_count = None
                            self.total_dont_send_to_txlist = None
                            self.total_srg_txlist_no_add_restore_flag_set = None
                            self.total_srg_not_master = None
                            self.total_master_eoms_pending = None
                            self.total_master_eoms_pending_cleared = None
                            self.last_pause_period = None
                            self.total_pause_time = None
                            self.last_pause_time = None
                            self.last_resume_time = None
                            self._segment_path = lambda: "srg"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Manager.Nodes.Node.Statistics.Srg, ['txlist_send_triggered', 'txlist_send_failed', 'txlist_send_failed_notactive', 'actual_txlist_sent', 'alreadyin_txlist', 'txlist_encode', 'txlist_encode_fail', 'create_update_encode', 'delete_encode', 'create_upd_clean_callback', 'delete_clean_callback', 'slave_recv_entry', 'slave_decode_fail', 'slave_create_update', 'slave_delete', 'srg_context_malloc', 'srg_context_free', 'sod_count', 'eod_count', 'sod_eod_replay_req_count', 'sod_eod_dirty_mark_count', 'sod_eod_dirty_delete_count', 'ack_to_srg', 'nack_to_srg', 'nack_to_srg_fail_cnt', 'txlist_remove_all', 'txlist_del_sync', 'txlist_del_sync_notlinked', 'txlist_del_app', 'txlist_del_app_notlinked', 'txlist_clean_invalid_state', 'txlist_remove_all_internal_error', 'is_srg_flow_control_enabled', 'max_inflight_sessoin_count', 'flow_control_resume_threshold', 'inflight_session_count', 'inflight_add_count', 'inflight_under_run_count', 'inflight_alloc_fails', 'inflight_insert_failures', 'inflight_deletes', 'inflight_not_found', 'inflight_delete_failures', 'total_pause_count', 'total_resume_count', 'total_dont_send_to_txlist', 'total_srg_txlist_no_add_restore_flag_set', 'total_srg_not_master', 'total_master_eoms_pending', 'total_master_eoms_pending_cleared', 'last_pause_period', 'total_pause_time', 'last_pause_time', 'last_resume_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics.Srg']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Manager.Nodes.Node.Statistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                    return meta._meta_table['Subscriber.Manager.Nodes.Node']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                return meta._meta_table['Subscriber.Manager.Nodes']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
            return meta._meta_table['Subscriber.Manager']['meta_info']


    class Session(_Entity_):
        """
        Subscriber session operational data
        
        .. attribute:: nodes
        
        	List of subscriber session supported nodes
        	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes>`
        
        	**config**\: False
        
        

        """

        _prefix = 'iedge4710-oper'
        _revision = '2018-09-20'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Subscriber.Session, self).__init__()

            self.yang_name = "session"
            self.yang_parent_name = "subscriber"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("nodes", ("nodes", Subscriber.Session.Nodes))])
            self._leafs = OrderedDict()

            self.nodes = Subscriber.Session.Nodes()
            self.nodes.parent = self
            self._children_name_map["nodes"] = "nodes"
            self._segment_path = lambda: "session"
            self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Subscriber.Session, [], name, value)


        class Nodes(_Entity_):
            """
            List of subscriber session supported nodes
            
            .. attribute:: node
            
            	Subscriber session operational data for a particular node
            	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node>`
            
            	**config**\: False
            
            

            """

            _prefix = 'iedge4710-oper'
            _revision = '2018-09-20'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Subscriber.Session.Nodes, self).__init__()

                self.yang_name = "nodes"
                self.yang_parent_name = "session"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("node", ("node", Subscriber.Session.Nodes.Node))])
                self._leafs = OrderedDict()

                self.node = YList(self)
                self._segment_path = lambda: "nodes"
                self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/session/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Subscriber.Session.Nodes, [], name, value)


            class Node(_Entity_):
                """
                Subscriber session operational data for a
                particular node
                
                .. attribute:: node_name  (key)
                
                	Node name
                	**type**\: str
                
                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                
                	**config**\: False
                
                .. attribute:: srg_roles
                
                	List of subscriber session supported srg roles
                	**type**\:  :py:class:`SrgRoles <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles>`
                
                	**config**\: False
                
                .. attribute:: author_summaries
                
                	Summary information filtered by authorization state
                	**type**\:  :py:class:`AuthorSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries>`
                
                	**config**\: False
                
                .. attribute:: summary
                
                	Subscriber session summary information
                	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary>`
                
                	**config**\: False
                
                .. attribute:: mac_summaries
                
                	Summary information filtered by MAC address
                	**type**\:  :py:class:`MacSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries>`
                
                	**config**\: False
                
                .. attribute:: interface_summaries
                
                	Summary information filtered by interface
                	**type**\:  :py:class:`InterfaceSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries>`
                
                	**config**\: False
                
                .. attribute:: authentication_summaries
                
                	Summary information filtered by authentication state
                	**type**\:  :py:class:`AuthenticationSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries>`
                
                	**config**\: False
                
                .. attribute:: state_summaries
                
                	Summary information filtered by session state
                	**type**\:  :py:class:`StateSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries>`
                
                	**config**\: False
                
                .. attribute:: ipv4_address_vrf_summaries
                
                	Summary information filtered by IPv4 address and VRF
                	**type**\:  :py:class:`Ipv4AddressVrfSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries>`
                
                	**config**\: False
                
                .. attribute:: address_family_summaries
                
                	Summary information filtered by address family
                	**type**\:  :py:class:`AddressFamilySummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries>`
                
                	**config**\: False
                
                .. attribute:: username_summaries
                
                	Summary information filtered by username
                	**type**\:  :py:class:`UsernameSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries>`
                
                	**config**\: False
                
                .. attribute:: access_interface_summaries
                
                	Summary information filtered by access interface
                	**type**\:  :py:class:`AccessInterfaceSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries>`
                
                	**config**\: False
                
                .. attribute:: ipv4_address_summaries
                
                	Summary information filtered by subscriber IPv4 address
                	**type**\:  :py:class:`Ipv4AddressSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries>`
                
                	**config**\: False
                
                .. attribute:: vrf_summaries
                
                	Summary information filtered by VRF
                	**type**\:  :py:class:`VrfSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries>`
                
                	**config**\: False
                
                .. attribute:: sessions
                
                	IP subscriber sessions
                	**type**\:  :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions>`
                
                	**config**\: False
                
                

                """

                _prefix = 'iedge4710-oper'
                _revision = '2018-09-20'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Subscriber.Session.Nodes.Node, self).__init__()

                    self.yang_name = "node"
                    self.yang_parent_name = "nodes"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['node_name']
                    self._child_classes = OrderedDict([("srg-roles", ("srg_roles", Subscriber.Session.Nodes.Node.SrgRoles)), ("author-summaries", ("author_summaries", Subscriber.Session.Nodes.Node.AuthorSummaries)), ("summary", ("summary", Subscriber.Session.Nodes.Node.Summary)), ("mac-summaries", ("mac_summaries", Subscriber.Session.Nodes.Node.MacSummaries)), ("interface-summaries", ("interface_summaries", Subscriber.Session.Nodes.Node.InterfaceSummaries)), ("authentication-summaries", ("authentication_summaries", Subscriber.Session.Nodes.Node.AuthenticationSummaries)), ("state-summaries", ("state_summaries", Subscriber.Session.Nodes.Node.StateSummaries)), ("ipv4-address-vrf-summaries", ("ipv4_address_vrf_summaries", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries)), ("address-family-summaries", ("address_family_summaries", Subscriber.Session.Nodes.Node.AddressFamilySummaries)), ("username-summaries", ("username_summaries", Subscriber.Session.Nodes.Node.UsernameSummaries)), ("access-interface-summaries", ("access_interface_summaries", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries)), ("ipv4-address-summaries", ("ipv4_address_summaries", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries)), ("vrf-summaries", ("vrf_summaries", Subscriber.Session.Nodes.Node.VrfSummaries)), ("sessions", ("sessions", Subscriber.Session.Nodes.Node.Sessions))])
                    self._leafs = OrderedDict([
                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                    ])
                    self.node_name = None

                    self.srg_roles = Subscriber.Session.Nodes.Node.SrgRoles()
                    self.srg_roles.parent = self
                    self._children_name_map["srg_roles"] = "srg-roles"

                    self.author_summaries = Subscriber.Session.Nodes.Node.AuthorSummaries()
                    self.author_summaries.parent = self
                    self._children_name_map["author_summaries"] = "author-summaries"

                    self.summary = Subscriber.Session.Nodes.Node.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"

                    self.mac_summaries = Subscriber.Session.Nodes.Node.MacSummaries()
                    self.mac_summaries.parent = self
                    self._children_name_map["mac_summaries"] = "mac-summaries"

                    self.interface_summaries = Subscriber.Session.Nodes.Node.InterfaceSummaries()
                    self.interface_summaries.parent = self
                    self._children_name_map["interface_summaries"] = "interface-summaries"

                    self.authentication_summaries = Subscriber.Session.Nodes.Node.AuthenticationSummaries()
                    self.authentication_summaries.parent = self
                    self._children_name_map["authentication_summaries"] = "authentication-summaries"

                    self.state_summaries = Subscriber.Session.Nodes.Node.StateSummaries()
                    self.state_summaries.parent = self
                    self._children_name_map["state_summaries"] = "state-summaries"

                    self.ipv4_address_vrf_summaries = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries()
                    self.ipv4_address_vrf_summaries.parent = self
                    self._children_name_map["ipv4_address_vrf_summaries"] = "ipv4-address-vrf-summaries"

                    self.address_family_summaries = Subscriber.Session.Nodes.Node.AddressFamilySummaries()
                    self.address_family_summaries.parent = self
                    self._children_name_map["address_family_summaries"] = "address-family-summaries"

                    self.username_summaries = Subscriber.Session.Nodes.Node.UsernameSummaries()
                    self.username_summaries.parent = self
                    self._children_name_map["username_summaries"] = "username-summaries"

                    self.access_interface_summaries = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries()
                    self.access_interface_summaries.parent = self
                    self._children_name_map["access_interface_summaries"] = "access-interface-summaries"

                    self.ipv4_address_summaries = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries()
                    self.ipv4_address_summaries.parent = self
                    self._children_name_map["ipv4_address_summaries"] = "ipv4-address-summaries"

                    self.vrf_summaries = Subscriber.Session.Nodes.Node.VrfSummaries()
                    self.vrf_summaries.parent = self
                    self._children_name_map["vrf_summaries"] = "vrf-summaries"

                    self.sessions = Subscriber.Session.Nodes.Node.Sessions()
                    self.sessions.parent = self
                    self._children_name_map["sessions"] = "sessions"
                    self._segment_path = lambda: "node" + "[node-name='" + str(self.node_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:subscriber/session/nodes/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Subscriber.Session.Nodes.Node, ['node_name'], name, value)


                class SrgRoles(_Entity_):
                    """
                    List of subscriber session supported srg
                    roles
                    
                    .. attribute:: srg_role
                    
                    	Subscriber session operational data based on srg role
                    	**type**\: list of  		 :py:class:`SrgRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.SrgRoles, self).__init__()

                        self.yang_name = "srg-roles"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srg-role", ("srg_role", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole))])
                        self._leafs = OrderedDict()

                        self.srg_role = YList(self)
                        self._segment_path = lambda: "srg-roles"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles, [], name, value)


                    class SrgRole(_Entity_):
                        """
                        Subscriber session operational data based on
                        srg role
                        
                        .. attribute:: srg  (key)
                        
                        	Subscriber srg role
                        	**type**\:  :py:class:`SubscriberSrgOperFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberSrgOperFilterFlag>`
                        
                        	**config**\: False
                        
                        .. attribute:: author_summaries
                        
                        	Summary information filtered by authorization state
                        	**type**\:  :py:class:`AuthorSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: username_summaries
                        
                        	Summary information filtered by username
                        	**type**\:  :py:class:`UsernameSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: mac_summaries
                        
                        	Summary information filtered by MAC address
                        	**type**\:  :py:class:`MacSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: interface_summaries
                        
                        	Summary information filtered by interface
                        	**type**\:  :py:class:`InterfaceSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: state_summaries
                        
                        	Summary information filtered by session state
                        	**type**\:  :py:class:`StateSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: authentication_summaries
                        
                        	Summary information filtered by authentication state
                        	**type**\:  :py:class:`AuthenticationSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: subscriber_sessions
                        
                        	IP subscriber sessions
                        	**type**\:  :py:class:`SubscriberSessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions>`
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address_vrf_summaries
                        
                        	Summary information filtered by IPv4 address and VRF
                        	**type**\:  :py:class:`Ipv4AddressVrfSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: srg_summary
                        
                        	Subscriber session summary information
                        	**type**\:  :py:class:`SrgSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary>`
                        
                        	**config**\: False
                        
                        .. attribute:: access_interface_summaries
                        
                        	Summary information filtered by access interface
                        	**type**\:  :py:class:`AccessInterfaceSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_summaries
                        
                        	Summary information filtered by address family
                        	**type**\:  :py:class:`AddressFamilySummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address_summaries
                        
                        	Summary information filtered by subscriber IPv4 address
                        	**type**\:  :py:class:`Ipv4AddressSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries>`
                        
                        	**config**\: False
                        
                        .. attribute:: vrf_summaries
                        
                        	Summary information filtered by VRF
                        	**type**\:  :py:class:`VrfSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole, self).__init__()

                            self.yang_name = "srg-role"
                            self.yang_parent_name = "srg-roles"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['srg']
                            self._child_classes = OrderedDict([("author-summaries", ("author_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries)), ("username-summaries", ("username_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries)), ("mac-summaries", ("mac_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries)), ("interface-summaries", ("interface_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries)), ("state-summaries", ("state_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries)), ("authentication-summaries", ("authentication_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries)), ("subscriber-sessions", ("subscriber_sessions", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions)), ("ipv4-address-vrf-summaries", ("ipv4_address_vrf_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries)), ("srg-summary", ("srg_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary)), ("access-interface-summaries", ("access_interface_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries)), ("address-family-summaries", ("address_family_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries)), ("ipv4-address-summaries", ("ipv4_address_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries)), ("vrf-summaries", ("vrf_summaries", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries))])
                            self._leafs = OrderedDict([
                                ('srg', (YLeaf(YType.enumeration, 'srg'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberSrgOperFilterFlag', '')])),
                            ])
                            self.srg = None

                            self.author_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries()
                            self.author_summaries.parent = self
                            self._children_name_map["author_summaries"] = "author-summaries"

                            self.username_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries()
                            self.username_summaries.parent = self
                            self._children_name_map["username_summaries"] = "username-summaries"

                            self.mac_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries()
                            self.mac_summaries.parent = self
                            self._children_name_map["mac_summaries"] = "mac-summaries"

                            self.interface_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries()
                            self.interface_summaries.parent = self
                            self._children_name_map["interface_summaries"] = "interface-summaries"

                            self.state_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries()
                            self.state_summaries.parent = self
                            self._children_name_map["state_summaries"] = "state-summaries"

                            self.authentication_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries()
                            self.authentication_summaries.parent = self
                            self._children_name_map["authentication_summaries"] = "authentication-summaries"

                            self.subscriber_sessions = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions()
                            self.subscriber_sessions.parent = self
                            self._children_name_map["subscriber_sessions"] = "subscriber-sessions"

                            self.ipv4_address_vrf_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries()
                            self.ipv4_address_vrf_summaries.parent = self
                            self._children_name_map["ipv4_address_vrf_summaries"] = "ipv4-address-vrf-summaries"

                            self.srg_summary = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary()
                            self.srg_summary.parent = self
                            self._children_name_map["srg_summary"] = "srg-summary"

                            self.access_interface_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries()
                            self.access_interface_summaries.parent = self
                            self._children_name_map["access_interface_summaries"] = "access-interface-summaries"

                            self.address_family_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries()
                            self.address_family_summaries.parent = self
                            self._children_name_map["address_family_summaries"] = "address-family-summaries"

                            self.ipv4_address_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries()
                            self.ipv4_address_summaries.parent = self
                            self._children_name_map["ipv4_address_summaries"] = "ipv4-address-summaries"

                            self.vrf_summaries = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries()
                            self.vrf_summaries.parent = self
                            self._children_name_map["vrf_summaries"] = "vrf-summaries"
                            self._segment_path = lambda: "srg-role" + "[srg='" + str(self.srg) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole, ['srg'], name, value)


                        class AuthorSummaries(_Entity_):
                            """
                            Summary information filtered by
                            authorization state
                            
                            .. attribute:: author_summary
                            
                            	authorization summary
                            	**type**\: list of  		 :py:class:`AuthorSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries, self).__init__()

                                self.yang_name = "author-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("author-summary", ("author_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary))])
                                self._leafs = OrderedDict()

                                self.author_summary = YList(self)
                                self._segment_path = lambda: "author-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries, [], name, value)


                            class AuthorSummary(_Entity_):
                                """
                                authorization summary
                                
                                .. attribute:: author_state  (key)
                                
                                	Authorization state
                                	**type**\:  :py:class:`SubscriberAuthorStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAuthorStateFilterFlag>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary, self).__init__()

                                    self.yang_name = "author-summary"
                                    self.yang_parent_name = "author-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['author_state']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('author_state', (YLeaf(YType.enumeration, 'author-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAuthorStateFilterFlag', '')])),
                                    ])
                                    self.author_state = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "author-summary" + "[author-state='" + str(self.author_state) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary, ['author_state'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "author-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "author-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries.AuthorSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthorSummaries']['meta_info']


                        class UsernameSummaries(_Entity_):
                            """
                            Summary information filtered by username
                            
                            .. attribute:: username_summary
                            
                            	Username summary
                            	**type**\: list of  		 :py:class:`UsernameSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries, self).__init__()

                                self.yang_name = "username-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("username-summary", ("username_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary))])
                                self._leafs = OrderedDict()

                                self.username_summary = YList(self)
                                self._segment_path = lambda: "username-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries, [], name, value)


                            class UsernameSummary(_Entity_):
                                """
                                Username summary
                                
                                .. attribute:: username  (key)
                                
                                	Subscriber username
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary, self).__init__()

                                    self.yang_name = "username-summary"
                                    self.yang_parent_name = "username-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['username']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('username', (YLeaf(YType.str, 'username'), ['str'])),
                                    ])
                                    self.username = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "username-summary" + "[username='" + str(self.username) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary, ['username'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "username-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "username-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries.UsernameSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.UsernameSummaries']['meta_info']


                        class MacSummaries(_Entity_):
                            """
                            Summary information filtered by MAC address
                            
                            .. attribute:: mac_summary
                            
                            	MAC address summary
                            	**type**\: list of  		 :py:class:`MacSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries, self).__init__()

                                self.yang_name = "mac-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("mac-summary", ("mac_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary))])
                                self._leafs = OrderedDict()

                                self.mac_summary = YList(self)
                                self._segment_path = lambda: "mac-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries, [], name, value)


                            class MacSummary(_Entity_):
                                """
                                MAC address summary
                                
                                .. attribute:: mac_address  (key)
                                
                                	Subscriber MAC address
                                	**type**\: str
                                
                                	**pattern:** [0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2}){5}
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary, self).__init__()

                                    self.yang_name = "mac-summary"
                                    self.yang_parent_name = "mac-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['mac_address']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('mac_address', (YLeaf(YType.str, 'mac-address'), ['str'])),
                                    ])
                                    self.mac_address = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "mac-summary" + "[mac-address='" + str(self.mac_address) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary, ['mac_address'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "mac-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "mac-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries.MacSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.MacSummaries']['meta_info']


                        class InterfaceSummaries(_Entity_):
                            """
                            Summary information filtered by interface
                            
                            .. attribute:: interface_summary
                            
                            	Interface summary
                            	**type**\: list of  		 :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries, self).__init__()

                                self.yang_name = "interface-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("interface-summary", ("interface_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary))])
                                self._leafs = OrderedDict()

                                self.interface_summary = YList(self)
                                self._segment_path = lambda: "interface-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries, [], name, value)


                            class InterfaceSummary(_Entity_):
                                """
                                Interface summary
                                
                                .. attribute:: interface_name  (key)
                                
                                	Interface name
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary, self).__init__()

                                    self.yang_name = "interface-summary"
                                    self.yang_parent_name = "interface-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['interface_name']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ])
                                    self.interface_name = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "interface-summary" + "[interface-name='" + str(self.interface_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary, ['interface_name'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "interface-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "interface-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries.InterfaceSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.InterfaceSummaries']['meta_info']


                        class StateSummaries(_Entity_):
                            """
                            Summary information filtered by session
                            state
                            
                            .. attribute:: state_summary
                            
                            	State summary
                            	**type**\: list of  		 :py:class:`StateSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries, self).__init__()

                                self.yang_name = "state-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("state-summary", ("state_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary))])
                                self._leafs = OrderedDict()

                                self.state_summary = YList(self)
                                self._segment_path = lambda: "state-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries, [], name, value)


                            class StateSummary(_Entity_):
                                """
                                State summary
                                
                                .. attribute:: state  (key)
                                
                                	Subscriber state
                                	**type**\:  :py:class:`SubscriberStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberStateFilterFlag>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary, self).__init__()

                                    self.yang_name = "state-summary"
                                    self.yang_parent_name = "state-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['state']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberStateFilterFlag', '')])),
                                    ])
                                    self.state = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "state-summary" + "[state='" + str(self.state) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary, ['state'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "state-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "state-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries.StateSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.StateSummaries']['meta_info']


                        class AuthenticationSummaries(_Entity_):
                            """
                            Summary information filtered by
                            authentication state
                            
                            .. attribute:: authentication_summary
                            
                            	authentication summary
                            	**type**\: list of  		 :py:class:`AuthenticationSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries, self).__init__()

                                self.yang_name = "authentication-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("authentication-summary", ("authentication_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary))])
                                self._leafs = OrderedDict()

                                self.authentication_summary = YList(self)
                                self._segment_path = lambda: "authentication-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries, [], name, value)


                            class AuthenticationSummary(_Entity_):
                                """
                                authentication summary
                                
                                .. attribute:: authentication_state  (key)
                                
                                	Authentication state
                                	**type**\:  :py:class:`SubscriberAuthenStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAuthenStateFilterFlag>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary, self).__init__()

                                    self.yang_name = "authentication-summary"
                                    self.yang_parent_name = "authentication-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['authentication_state']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('authentication_state', (YLeaf(YType.enumeration, 'authentication-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAuthenStateFilterFlag', '')])),
                                    ])
                                    self.authentication_state = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "authentication-summary" + "[authentication-state='" + str(self.authentication_state) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary, ['authentication_state'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "authentication-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "authentication-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries.AuthenticationSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AuthenticationSummaries']['meta_info']


                        class SubscriberSessions(_Entity_):
                            """
                            IP subscriber sessions
                            
                            .. attribute:: subscriber_session
                            
                            	Subscriber session information
                            	**type**\: list of  		 :py:class:`SubscriberSession <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions, self).__init__()

                                self.yang_name = "subscriber-sessions"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("subscriber-session", ("subscriber_session", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession))])
                                self._leafs = OrderedDict()

                                self.subscriber_session = YList(self)
                                self._segment_path = lambda: "subscriber-sessions"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions, [], name, value)


                            class SubscriberSession(_Entity_):
                                """
                                Subscriber session information
                                
                                .. attribute:: session_id  (key)
                                
                                	Session ID
                                	**type**\: str
                                
                                	**pattern:** [0\-9a\-fA\-F]{1,8}
                                
                                	**config**\: False
                                
                                .. attribute:: accounting
                                
                                	Accounting information
                                	**type**\:  :py:class:`Accounting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_type
                                
                                	Subscriber session type
                                	**type**\:  :py:class:`IedgeOperSession <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperSession>`
                                
                                	**config**\: False
                                
                                .. attribute:: pppoe_sub_type
                                
                                	PPPoE sub type
                                	**type**\:  :py:class:`IedgePppSub <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgePppSub>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface name
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: vrf_name
                                
                                	VRF name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: circuit_id
                                
                                	Circuit ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: remote_id
                                
                                	Remote ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lns_address
                                
                                	PPPoE LNS address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: lac_address
                                
                                	PPPoE LAC address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_client_authentication_id
                                
                                	PPPoE LAC tunnel client authentication ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_server_authentication_id
                                
                                	PPPoE LAC tunnel server authentication ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: session_ip_address
                                
                                	Session ip address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: session_ipv6_address
                                
                                	Session IPv6 address
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: session_ipv6_prefix
                                
                                	Session IPv6 prefix
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: delegated_ipv6_prefix
                                
                                	Session delegated IPv6 prefix
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_interface_id
                                
                                	IPv6 Interface ID
                                	**type**\: str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                	**config**\: False
                                
                                .. attribute:: mac_address
                                
                                	MAC address
                                	**type**\: str
                                
                                	**pattern:** [0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2}){5}
                                
                                	**config**\: False
                                
                                .. attribute:: account_session_id
                                
                                	Accounting session ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: nas_port
                                
                                	NAS port
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: username
                                
                                	Username
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: clientname
                                
                                	Client Username
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: formattedname
                                
                                	Formatted Username
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: is_session_authentic
                                
                                	If true, session is authentic
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_session_author
                                
                                	If true, session is authorized
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: session_state
                                
                                	Session state
                                	**type**\:  :py:class:`IedgeOperSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_creation_time_epoch
                                
                                	Session creation time in epoch seconds
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: idle_state_change_time
                                
                                	Time when idle state change occurred in DDD MMM DD HH\:MM\:SS YYYY format eg\: Tue Apr 11 21\:30\:47 2011
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: total_session_idle_time
                                
                                	Total session idle time (in seconds)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: access_interface_name
                                
                                	Access interface name associated with the session
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: accounting_stop_fail_rc
                                
                                	Accounting Stop Error Code for Accounting Session
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sub_policy_data
                                
                                	Subscriber control policy applied to this session
                                	**type**\: list of  		 :py:class:`SubPolicyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SubPolicyData>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_service_info
                                
                                	List of subscriber services associated to this session
                                	**type**\: list of  		 :py:class:`SessionServiceInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionServiceInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: session_change_of_authorization
                                
                                	Subscriber change of authorization information
                                	**type**\: list of  		 :py:class:`SessionChangeOfAuthorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionChangeOfAuthorization>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession, self).__init__()

                                    self.yang_name = "subscriber-session"
                                    self.yang_parent_name = "subscriber-sessions"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['session_id']
                                    self._child_classes = OrderedDict([("accounting", ("accounting", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting)), ("sub-policy-data", ("sub_policy_data", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SubPolicyData)), ("session-service-info", ("session_service_info", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionServiceInfo)), ("session-change-of-authorization", ("session_change_of_authorization", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionChangeOfAuthorization))])
                                    self._leafs = OrderedDict([
                                        ('session_id', (YLeaf(YType.str, 'session-id'), ['str'])),
                                        ('session_type', (YLeaf(YType.enumeration, 'session-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperSession', '')])),
                                        ('pppoe_sub_type', (YLeaf(YType.enumeration, 'pppoe-sub-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgePppSub', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                        ('circuit_id', (YLeaf(YType.str, 'circuit-id'), ['str'])),
                                        ('remote_id', (YLeaf(YType.str, 'remote-id'), ['str'])),
                                        ('lns_address', (YLeaf(YType.str, 'lns-address'), ['str'])),
                                        ('lac_address', (YLeaf(YType.str, 'lac-address'), ['str'])),
                                        ('tunnel_client_authentication_id', (YLeaf(YType.str, 'tunnel-client-authentication-id'), ['str'])),
                                        ('tunnel_server_authentication_id', (YLeaf(YType.str, 'tunnel-server-authentication-id'), ['str'])),
                                        ('session_ip_address', (YLeaf(YType.str, 'session-ip-address'), ['str'])),
                                        ('session_ipv6_address', (YLeaf(YType.str, 'session-ipv6-address'), ['str'])),
                                        ('session_ipv6_prefix', (YLeaf(YType.str, 'session-ipv6-prefix'), ['str'])),
                                        ('delegated_ipv6_prefix', (YLeaf(YType.str, 'delegated-ipv6-prefix'), ['str'])),
                                        ('ipv6_interface_id', (YLeaf(YType.str, 'ipv6-interface-id'), ['str'])),
                                        ('mac_address', (YLeaf(YType.str, 'mac-address'), ['str'])),
                                        ('account_session_id', (YLeaf(YType.str, 'account-session-id'), ['str'])),
                                        ('nas_port', (YLeaf(YType.str, 'nas-port'), ['str'])),
                                        ('username', (YLeaf(YType.str, 'username'), ['str'])),
                                        ('clientname', (YLeaf(YType.str, 'clientname'), ['str'])),
                                        ('formattedname', (YLeaf(YType.str, 'formattedname'), ['str'])),
                                        ('is_session_authentic', (YLeaf(YType.boolean, 'is-session-authentic'), ['bool'])),
                                        ('is_session_author', (YLeaf(YType.boolean, 'is-session-author'), ['bool'])),
                                        ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperSessionState', '')])),
                                        ('session_creation_time_epoch', (YLeaf(YType.uint64, 'session-creation-time-epoch'), ['int'])),
                                        ('idle_state_change_time', (YLeaf(YType.str, 'idle-state-change-time'), ['str'])),
                                        ('total_session_idle_time', (YLeaf(YType.uint32, 'total-session-idle-time'), ['int'])),
                                        ('access_interface_name', (YLeaf(YType.str, 'access-interface-name'), ['str'])),
                                        ('accounting_stop_fail_rc', (YLeaf(YType.uint32, 'accounting-stop-fail-rc'), ['int'])),
                                    ])
                                    self.session_id = None
                                    self.session_type = None
                                    self.pppoe_sub_type = None
                                    self.interface_name = None
                                    self.vrf_name = None
                                    self.circuit_id = None
                                    self.remote_id = None
                                    self.lns_address = None
                                    self.lac_address = None
                                    self.tunnel_client_authentication_id = None
                                    self.tunnel_server_authentication_id = None
                                    self.session_ip_address = None
                                    self.session_ipv6_address = None
                                    self.session_ipv6_prefix = None
                                    self.delegated_ipv6_prefix = None
                                    self.ipv6_interface_id = None
                                    self.mac_address = None
                                    self.account_session_id = None
                                    self.nas_port = None
                                    self.username = None
                                    self.clientname = None
                                    self.formattedname = None
                                    self.is_session_authentic = None
                                    self.is_session_author = None
                                    self.session_state = None
                                    self.session_creation_time_epoch = None
                                    self.idle_state_change_time = None
                                    self.total_session_idle_time = None
                                    self.access_interface_name = None
                                    self.accounting_stop_fail_rc = None

                                    self.accounting = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting()
                                    self.accounting.parent = self
                                    self._children_name_map["accounting"] = "accounting"

                                    self.sub_policy_data = YList(self)
                                    self.session_service_info = YList(self)
                                    self.session_change_of_authorization = YList(self)
                                    self._segment_path = lambda: "subscriber-session" + "[session-id='" + str(self.session_id) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession, ['session_id', 'session_type', 'pppoe_sub_type', 'interface_name', 'vrf_name', 'circuit_id', 'remote_id', 'lns_address', 'lac_address', 'tunnel_client_authentication_id', 'tunnel_server_authentication_id', 'session_ip_address', 'session_ipv6_address', 'session_ipv6_prefix', 'delegated_ipv6_prefix', 'ipv6_interface_id', 'mac_address', 'account_session_id', 'nas_port', 'username', 'clientname', 'formattedname', 'is_session_authentic', 'is_session_author', 'session_state', 'session_creation_time_epoch', 'idle_state_change_time', 'total_session_idle_time', 'access_interface_name', 'accounting_stop_fail_rc'], name, value)


                                class Accounting(_Entity_):
                                    """
                                    Accounting information
                                    
                                    .. attribute:: accounting_session
                                    
                                    	Accounting information
                                    	**type**\: list of  		 :py:class:`AccountingSession <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting.AccountingSession>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting, self).__init__()

                                        self.yang_name = "accounting"
                                        self.yang_parent_name = "subscriber-session"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("accounting-session", ("accounting_session", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting.AccountingSession))])
                                        self._leafs = OrderedDict()

                                        self.accounting_session = YList(self)
                                        self._segment_path = lambda: "accounting"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting, [], name, value)


                                    class AccountingSession(_Entity_):
                                        """
                                        Accounting information
                                        
                                        .. attribute:: accounting_state_rc
                                        
                                        	Accounting State Error Code for Accounting Session
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: accounting_stop_state
                                        
                                        	Accounting Stop State
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_context_name
                                        
                                        	Accounting record context name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: method_list_name
                                        
                                        	AAA method list name used to perform accounting
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: account_session_id
                                        
                                        	Accounting session ID
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: accounting_start_time_epoch
                                        
                                        	Accounting start time in epoch\-seconds
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: is_interim_accounting_enabled
                                        
                                        	True if interim accounting is enabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interim_interval
                                        
                                        	Interim accounting interval (in minutes)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: minute
                                        
                                        .. attribute:: last_successful_interim_update_time_epoch
                                        
                                        	Time of last successful interim update in epoch\-seconds 
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: last_unsuccessful_interim_update_time_epoch
                                        
                                        	Time of last unsuccessful interim update in epoch\-seconds 
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: next_interim_update_attempt_time
                                        
                                        	Time of next interim update attempt (in seconds)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: last_interim_update_attempt_time_epoch
                                        
                                        	Time of last interim update attempt in epoch\-seconds
                                        	**type**\: int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**config**\: False
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: sent_interim_updates
                                        
                                        	Number of interim updates sent
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: accepted_interim_updates
                                        
                                        	Number of interim updates accepted
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: rejected_interim_updates
                                        
                                        	Number of interim updates rejected
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: sent_interim_update_failures
                                        
                                        	Number of interim update send failures
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting.AccountingSession, self).__init__()

                                            self.yang_name = "accounting-session"
                                            self.yang_parent_name = "accounting"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('accounting_state_rc', (YLeaf(YType.uint32, 'accounting-state-rc'), ['int'])),
                                                ('accounting_stop_state', (YLeaf(YType.uint32, 'accounting-stop-state'), ['int'])),
                                                ('record_context_name', (YLeaf(YType.str, 'record-context-name'), ['str'])),
                                                ('method_list_name', (YLeaf(YType.str, 'method-list-name'), ['str'])),
                                                ('account_session_id', (YLeaf(YType.str, 'account-session-id'), ['str'])),
                                                ('accounting_start_time_epoch', (YLeaf(YType.uint64, 'accounting-start-time-epoch'), ['int'])),
                                                ('is_interim_accounting_enabled', (YLeaf(YType.boolean, 'is-interim-accounting-enabled'), ['bool'])),
                                                ('interim_interval', (YLeaf(YType.uint32, 'interim-interval'), ['int'])),
                                                ('last_successful_interim_update_time_epoch', (YLeaf(YType.uint64, 'last-successful-interim-update-time-epoch'), ['int'])),
                                                ('last_unsuccessful_interim_update_time_epoch', (YLeaf(YType.uint64, 'last-unsuccessful-interim-update-time-epoch'), ['int'])),
                                                ('next_interim_update_attempt_time', (YLeaf(YType.uint32, 'next-interim-update-attempt-time'), ['int'])),
                                                ('last_interim_update_attempt_time_epoch', (YLeaf(YType.uint64, 'last-interim-update-attempt-time-epoch'), ['int'])),
                                                ('sent_interim_updates', (YLeaf(YType.uint32, 'sent-interim-updates'), ['int'])),
                                                ('accepted_interim_updates', (YLeaf(YType.uint32, 'accepted-interim-updates'), ['int'])),
                                                ('rejected_interim_updates', (YLeaf(YType.uint32, 'rejected-interim-updates'), ['int'])),
                                                ('sent_interim_update_failures', (YLeaf(YType.uint32, 'sent-interim-update-failures'), ['int'])),
                                            ])
                                            self.accounting_state_rc = None
                                            self.accounting_stop_state = None
                                            self.record_context_name = None
                                            self.method_list_name = None
                                            self.account_session_id = None
                                            self.accounting_start_time_epoch = None
                                            self.is_interim_accounting_enabled = None
                                            self.interim_interval = None
                                            self.last_successful_interim_update_time_epoch = None
                                            self.last_unsuccessful_interim_update_time_epoch = None
                                            self.next_interim_update_attempt_time = None
                                            self.last_interim_update_attempt_time_epoch = None
                                            self.sent_interim_updates = None
                                            self.accepted_interim_updates = None
                                            self.rejected_interim_updates = None
                                            self.sent_interim_update_failures = None
                                            self._segment_path = lambda: "accounting-session"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting.AccountingSession, ['accounting_state_rc', 'accounting_stop_state', 'record_context_name', 'method_list_name', 'account_session_id', 'accounting_start_time_epoch', 'is_interim_accounting_enabled', 'interim_interval', 'last_successful_interim_update_time_epoch', 'last_unsuccessful_interim_update_time_epoch', 'next_interim_update_attempt_time', 'last_interim_update_attempt_time_epoch', 'sent_interim_updates', 'accepted_interim_updates', 'rejected_interim_updates', 'sent_interim_update_failures'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting.AccountingSession']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.Accounting']['meta_info']


                                class SubPolicyData(_Entity_):
                                    """
                                    Subscriber control policy applied to this
                                    session
                                    
                                    .. attribute:: policy_epoch
                                    
                                    	Matching event, condition and executed actions
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SubPolicyData, self).__init__()

                                        self.yang_name = "sub-policy-data"
                                        self.yang_parent_name = "subscriber-session"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('policy_epoch', (YLeaf(YType.str, 'policy-epoch'), ['str'])),
                                        ])
                                        self.policy_epoch = None
                                        self._segment_path = lambda: "sub-policy-data"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SubPolicyData, ['policy_epoch'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SubPolicyData']['meta_info']


                                class SessionServiceInfo(_Entity_):
                                    """
                                    List of subscriber services associated to this
                                    session
                                    
                                    .. attribute:: service_name
                                    
                                    	ServiceName
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: service_params
                                    
                                    	ServiceParams
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: service_type
                                    
                                    	ServiceType
                                    	**type**\:  :py:class:`IedgeOperService <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperService>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: service_status
                                    
                                    	ServiceStatus
                                    	**type**\:  :py:class:`IedgeOperServiceStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperServiceStatus>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: service_id
                                    
                                    	ServiceIdentifier
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: service_prepaid
                                    
                                    	ServicePrepaid
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionServiceInfo, self).__init__()

                                        self.yang_name = "session-service-info"
                                        self.yang_parent_name = "subscriber-session"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('service_name', (YLeaf(YType.str, 'service-name'), ['str'])),
                                            ('service_params', (YLeaf(YType.str, 'service-params'), ['str'])),
                                            ('service_type', (YLeaf(YType.enumeration, 'service-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperService', '')])),
                                            ('service_status', (YLeaf(YType.enumeration, 'service-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperServiceStatus', '')])),
                                            ('service_id', (YLeaf(YType.uint32, 'service-id'), ['int'])),
                                            ('service_prepaid', (YLeaf(YType.boolean, 'service-prepaid'), ['bool'])),
                                        ])
                                        self.service_name = None
                                        self.service_params = None
                                        self.service_type = None
                                        self.service_status = None
                                        self.service_id = None
                                        self.service_prepaid = None
                                        self._segment_path = lambda: "session-service-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionServiceInfo, ['service_name', 'service_params', 'service_type', 'service_status', 'service_id', 'service_prepaid'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionServiceInfo']['meta_info']


                                class SessionChangeOfAuthorization(_Entity_):
                                    """
                                    Subscriber change of authorization information
                                    
                                    .. attribute:: request_acked
                                    
                                    	Coa Request Acked
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: request_time_epoch
                                    
                                    	Request time in epoch seconds
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: reply_time_epoch
                                    
                                    	Reply time in epoch seconds
                                    	**type**\: int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**config**\: False
                                    
                                    	**units**\: second
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionChangeOfAuthorization, self).__init__()

                                        self.yang_name = "session-change-of-authorization"
                                        self.yang_parent_name = "subscriber-session"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('request_acked', (YLeaf(YType.boolean, 'request-acked'), ['bool'])),
                                            ('request_time_epoch', (YLeaf(YType.uint64, 'request-time-epoch'), ['int'])),
                                            ('reply_time_epoch', (YLeaf(YType.uint64, 'reply-time-epoch'), ['int'])),
                                        ])
                                        self.request_acked = None
                                        self.request_time_epoch = None
                                        self.reply_time_epoch = None
                                        self._segment_path = lambda: "session-change-of-authorization"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionChangeOfAuthorization, ['request_acked', 'request_time_epoch', 'reply_time_epoch'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession.SessionChangeOfAuthorization']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions.SubscriberSession']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SubscriberSessions']['meta_info']


                        class Ipv4AddressVrfSummaries(_Entity_):
                            """
                            Summary information filtered by IPv4
                            address and VRF
                            
                            .. attribute:: ipv4_address_vrf_summary
                            
                            	IPv4 address and VRF summary
                            	**type**\: list of  		 :py:class:`Ipv4AddressVrfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries, self).__init__()

                                self.yang_name = "ipv4-address-vrf-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-address-vrf-summary", ("ipv4_address_vrf_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary))])
                                self._leafs = OrderedDict()

                                self.ipv4_address_vrf_summary = YList(self)
                                self._segment_path = lambda: "ipv4-address-vrf-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries, [], name, value)


                            class Ipv4AddressVrfSummary(_Entity_):
                                """
                                IPv4 address and VRF summary
                                
                                .. attribute:: vrf_name
                                
                                	VRF name
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                	**config**\: False
                                
                                .. attribute:: address
                                
                                	Subscriber IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary, self).__init__()

                                    self.yang_name = "ipv4-address-vrf-summary"
                                    self.yang_parent_name = "ipv4-address-vrf-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                    ])
                                    self.vrf_name = None
                                    self.address = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "ipv4-address-vrf-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary, ['vrf_name', 'address'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "ipv4-address-vrf-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "ipv4-address-vrf-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressVrfSummaries']['meta_info']


                        class SrgSummary(_Entity_):
                            """
                            Subscriber session summary information
                            
                            .. attribute:: state_xr
                            
                            	State summary
                            	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr>`
                            
                            	**config**\: False
                            
                            .. attribute:: address_family_xr
                            
                            	Address family summary
                            	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary, self).__init__()

                                self.yang_name = "srg-summary"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr))])
                                self._leafs = OrderedDict()

                                self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr()
                                self.state_xr.parent = self
                                self._children_name_map["state_xr"] = "state-xr"

                                self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr()
                                self.address_family_xr.parent = self
                                self._children_name_map["address_family_xr"] = "address-family-xr"
                                self._segment_path = lambda: "srg-summary"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary, [], name, value)


                            class StateXr(_Entity_):
                                """
                                State summary
                                
                                .. attribute:: pppoe
                                
                                	PPPoE summary
                                	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_subscriber_dhcp
                                
                                	IP subscriber DHCP summary
                                	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_subscriber_packet
                                
                                	IP subscriber packet summary
                                	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr, self).__init__()

                                    self.yang_name = "state-xr"
                                    self.yang_parent_name = "srg-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket))])
                                    self._leafs = OrderedDict()

                                    self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe()
                                    self.pppoe.parent = self
                                    self._children_name_map["pppoe"] = "pppoe"

                                    self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp()
                                    self.ip_subscriber_dhcp.parent = self
                                    self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                    self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket()
                                    self.ip_subscriber_packet.parent = self
                                    self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                    self._segment_path = lambda: "state-xr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr, [], name, value)


                                class Pppoe(_Entity_):
                                    """
                                    PPPoE summary
                                    
                                    .. attribute:: initialized_sessions
                                    
                                    	Sessions in initialized state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connecting_sessions
                                    
                                    	Sessions in connecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connected_sessions
                                    
                                    	Sessions in connected state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: activated_sessions
                                    
                                    	Sessions in activated state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: idle_sessions
                                    
                                    	Sessions in idle state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: disconnecting_sessions
                                    
                                    	Sessions in disconnecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_sessions
                                    
                                    	Sessions in end state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe, self).__init__()

                                        self.yang_name = "pppoe"
                                        self.yang_parent_name = "state-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                            ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                            ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                            ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                            ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                            ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                            ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                        ])
                                        self.initialized_sessions = None
                                        self.connecting_sessions = None
                                        self.connected_sessions = None
                                        self.activated_sessions = None
                                        self.idle_sessions = None
                                        self.disconnecting_sessions = None
                                        self.end_sessions = None
                                        self._segment_path = lambda: "pppoe"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.Pppoe']['meta_info']


                                class IpSubscriberDhcp(_Entity_):
                                    """
                                    IP subscriber DHCP summary
                                    
                                    .. attribute:: initialized_sessions
                                    
                                    	Sessions in initialized state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connecting_sessions
                                    
                                    	Sessions in connecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connected_sessions
                                    
                                    	Sessions in connected state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: activated_sessions
                                    
                                    	Sessions in activated state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: idle_sessions
                                    
                                    	Sessions in idle state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: disconnecting_sessions
                                    
                                    	Sessions in disconnecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_sessions
                                    
                                    	Sessions in end state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                        self.yang_name = "ip-subscriber-dhcp"
                                        self.yang_parent_name = "state-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                            ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                            ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                            ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                            ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                            ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                            ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                        ])
                                        self.initialized_sessions = None
                                        self.connecting_sessions = None
                                        self.connected_sessions = None
                                        self.activated_sessions = None
                                        self.idle_sessions = None
                                        self.disconnecting_sessions = None
                                        self.end_sessions = None
                                        self._segment_path = lambda: "ip-subscriber-dhcp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                class IpSubscriberPacket(_Entity_):
                                    """
                                    IP subscriber packet summary
                                    
                                    .. attribute:: initialized_sessions
                                    
                                    	Sessions in initialized state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connecting_sessions
                                    
                                    	Sessions in connecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: connected_sessions
                                    
                                    	Sessions in connected state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: activated_sessions
                                    
                                    	Sessions in activated state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: idle_sessions
                                    
                                    	Sessions in idle state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: disconnecting_sessions
                                    
                                    	Sessions in disconnecting state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_sessions
                                    
                                    	Sessions in end state
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket, self).__init__()

                                        self.yang_name = "ip-subscriber-packet"
                                        self.yang_parent_name = "state-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                            ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                            ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                            ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                            ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                            ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                            ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                        ])
                                        self.initialized_sessions = None
                                        self.connecting_sessions = None
                                        self.connected_sessions = None
                                        self.activated_sessions = None
                                        self.idle_sessions = None
                                        self.disconnecting_sessions = None
                                        self.end_sessions = None
                                        self._segment_path = lambda: "ip-subscriber-packet"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr.IpSubscriberPacket']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.StateXr']['meta_info']


                            class AddressFamilyXr(_Entity_):
                                """
                                Address family summary
                                
                                .. attribute:: pppoe
                                
                                	PPPoE summary
                                	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_subscriber_dhcp
                                
                                	IP subscriber DHCP summary
                                	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_subscriber_packet
                                
                                	IP subscriber packet summary
                                	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr, self).__init__()

                                    self.yang_name = "address-family-xr"
                                    self.yang_parent_name = "srg-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket))])
                                    self._leafs = OrderedDict()

                                    self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe()
                                    self.pppoe.parent = self
                                    self._children_name_map["pppoe"] = "pppoe"

                                    self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp()
                                    self.ip_subscriber_dhcp.parent = self
                                    self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                    self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket()
                                    self.ip_subscriber_packet.parent = self
                                    self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                    self._segment_path = lambda: "address-family-xr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr, [], name, value)


                                class Pppoe(_Entity_):
                                    """
                                    PPPoE summary
                                    
                                    .. attribute:: in_progress_sessions
                                    
                                    	Sessions with undecided address family
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv4_only_sessions
                                    
                                    	IPv4 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_only_sessions
                                    
                                    	IPv6 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_part_up_sessions
                                    
                                    	Dual stack partially up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_up_sessions
                                    
                                    	Dual stack up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lac_sessions
                                    
                                    	LAC sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe, self).__init__()

                                        self.yang_name = "pppoe"
                                        self.yang_parent_name = "address-family-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                            ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                            ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                            ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                            ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                            ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                        ])
                                        self.in_progress_sessions = None
                                        self.ipv4_only_sessions = None
                                        self.ipv6_only_sessions = None
                                        self.dual_part_up_sessions = None
                                        self.dual_up_sessions = None
                                        self.lac_sessions = None
                                        self._segment_path = lambda: "pppoe"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.Pppoe']['meta_info']


                                class IpSubscriberDhcp(_Entity_):
                                    """
                                    IP subscriber DHCP summary
                                    
                                    .. attribute:: in_progress_sessions
                                    
                                    	Sessions with undecided address family
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv4_only_sessions
                                    
                                    	IPv4 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_only_sessions
                                    
                                    	IPv6 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_part_up_sessions
                                    
                                    	Dual stack partially up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_up_sessions
                                    
                                    	Dual stack up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lac_sessions
                                    
                                    	LAC sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                        self.yang_name = "ip-subscriber-dhcp"
                                        self.yang_parent_name = "address-family-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                            ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                            ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                            ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                            ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                            ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                        ])
                                        self.in_progress_sessions = None
                                        self.ipv4_only_sessions = None
                                        self.ipv6_only_sessions = None
                                        self.dual_part_up_sessions = None
                                        self.dual_up_sessions = None
                                        self.lac_sessions = None
                                        self._segment_path = lambda: "ip-subscriber-dhcp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                class IpSubscriberPacket(_Entity_):
                                    """
                                    IP subscriber packet summary
                                    
                                    .. attribute:: in_progress_sessions
                                    
                                    	Sessions with undecided address family
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv4_only_sessions
                                    
                                    	IPv4 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_only_sessions
                                    
                                    	IPv6 only sessions 
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_part_up_sessions
                                    
                                    	Dual stack partially up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dual_up_sessions
                                    
                                    	Dual stack up sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lac_sessions
                                    
                                    	LAC sessions
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                        self.yang_name = "ip-subscriber-packet"
                                        self.yang_parent_name = "address-family-xr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                            ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                            ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                            ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                            ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                            ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                        ])
                                        self.in_progress_sessions = None
                                        self.ipv4_only_sessions = None
                                        self.ipv6_only_sessions = None
                                        self.dual_part_up_sessions = None
                                        self.dual_up_sessions = None
                                        self.lac_sessions = None
                                        self._segment_path = lambda: "ip-subscriber-packet"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary.AddressFamilyXr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.SrgSummary']['meta_info']


                        class AccessInterfaceSummaries(_Entity_):
                            """
                            Summary information filtered by access
                            interface
                            
                            .. attribute:: access_interface_summary
                            
                            	Access interface summary
                            	**type**\: list of  		 :py:class:`AccessInterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries, self).__init__()

                                self.yang_name = "access-interface-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("access-interface-summary", ("access_interface_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary))])
                                self._leafs = OrderedDict()

                                self.access_interface_summary = YList(self)
                                self._segment_path = lambda: "access-interface-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries, [], name, value)


                            class AccessInterfaceSummary(_Entity_):
                                """
                                Access interface summary
                                
                                .. attribute:: interface_name  (key)
                                
                                	Interface name
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary, self).__init__()

                                    self.yang_name = "access-interface-summary"
                                    self.yang_parent_name = "access-interface-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['interface_name']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ])
                                    self.interface_name = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "access-interface-summary" + "[interface-name='" + str(self.interface_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary, ['interface_name'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "access-interface-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "access-interface-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries.AccessInterfaceSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AccessInterfaceSummaries']['meta_info']


                        class AddressFamilySummaries(_Entity_):
                            """
                            Summary information filtered by address
                            family
                            
                            .. attribute:: address_family_summary
                            
                            	Address family summary
                            	**type**\: list of  		 :py:class:`AddressFamilySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries, self).__init__()

                                self.yang_name = "address-family-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("address-family-summary", ("address_family_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary))])
                                self._leafs = OrderedDict()

                                self.address_family_summary = YList(self)
                                self._segment_path = lambda: "address-family-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries, [], name, value)


                            class AddressFamilySummary(_Entity_):
                                """
                                Address family summary
                                
                                .. attribute:: address_family  (key)
                                
                                	Address family
                                	**type**\:  :py:class:`SubscriberAddressFamilyFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAddressFamilyFilterFlag>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary, self).__init__()

                                    self.yang_name = "address-family-summary"
                                    self.yang_parent_name = "address-family-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['address_family']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('address_family', (YLeaf(YType.enumeration, 'address-family'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAddressFamilyFilterFlag', '')])),
                                    ])
                                    self.address_family = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "address-family-summary" + "[address-family='" + str(self.address_family) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary, ['address_family'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "address-family-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "address-family-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries.AddressFamilySummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.AddressFamilySummaries']['meta_info']


                        class Ipv4AddressSummaries(_Entity_):
                            """
                            Summary information filtered by subscriber
                            IPv4 address
                            
                            .. attribute:: ipv4_address_summary
                            
                            	IPv4 address summary
                            	**type**\: list of  		 :py:class:`Ipv4AddressSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries, self).__init__()

                                self.yang_name = "ipv4-address-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-address-summary", ("ipv4_address_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary))])
                                self._leafs = OrderedDict()

                                self.ipv4_address_summary = YList(self)
                                self._segment_path = lambda: "ipv4-address-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries, [], name, value)


                            class Ipv4AddressSummary(_Entity_):
                                """
                                IPv4 address summary
                                
                                .. attribute:: address  (key)
                                
                                	Subscriber IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary, self).__init__()

                                    self.yang_name = "ipv4-address-summary"
                                    self.yang_parent_name = "ipv4-address-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['address']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                    ])
                                    self.address = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "ipv4-address-summary" + "[address='" + str(self.address) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary, ['address'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "ipv4-address-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "ipv4-address-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries.Ipv4AddressSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.Ipv4AddressSummaries']['meta_info']


                        class VrfSummaries(_Entity_):
                            """
                            Summary information filtered by VRF
                            
                            .. attribute:: vrf_summary
                            
                            	VRF summary
                            	**type**\: list of  		 :py:class:`VrfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries, self).__init__()

                                self.yang_name = "vrf-summaries"
                                self.yang_parent_name = "srg-role"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("vrf-summary", ("vrf_summary", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary))])
                                self._leafs = OrderedDict()

                                self.vrf_summary = YList(self)
                                self._segment_path = lambda: "vrf-summaries"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries, [], name, value)


                            class VrfSummary(_Entity_):
                                """
                                VRF summary
                                
                                .. attribute:: vrf_name  (key)
                                
                                	VRF name
                                	**type**\: str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                	**config**\: False
                                
                                .. attribute:: state_xr
                                
                                	State summary
                                	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr>`
                                
                                	**config**\: False
                                
                                .. attribute:: address_family_xr
                                
                                	Address family summary
                                	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary, self).__init__()

                                    self.yang_name = "vrf-summary"
                                    self.yang_parent_name = "vrf-summaries"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = ['vrf_name']
                                    self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr))])
                                    self._leafs = OrderedDict([
                                        ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                    ])
                                    self.vrf_name = None

                                    self.state_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr()
                                    self.state_xr.parent = self
                                    self._children_name_map["state_xr"] = "state-xr"

                                    self.address_family_xr = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr()
                                    self.address_family_xr.parent = self
                                    self._children_name_map["address_family_xr"] = "address-family-xr"
                                    self._segment_path = lambda: "vrf-summary" + "[vrf-name='" + str(self.vrf_name) + "']"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary, ['vrf_name'], name, value)


                                class StateXr(_Entity_):
                                    """
                                    State summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr, self).__init__()

                                        self.yang_name = "state-xr"
                                        self.yang_parent_name = "vrf-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "state-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: initialized_sessions
                                        
                                        	Sessions in initialized state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connecting_sessions
                                        
                                        	Sessions in connecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: connected_sessions
                                        
                                        	Sessions in connected state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: activated_sessions
                                        
                                        	Sessions in activated state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: idle_sessions
                                        
                                        	Sessions in idle state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: disconnecting_sessions
                                        
                                        	Sessions in disconnecting state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_sessions
                                        
                                        	Sessions in end state
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "state-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                                ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                                ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                                ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                                ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                                ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                                ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                            ])
                                            self.initialized_sessions = None
                                            self.connecting_sessions = None
                                            self.connected_sessions = None
                                            self.activated_sessions = None
                                            self.idle_sessions = None
                                            self.disconnecting_sessions = None
                                            self.end_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.StateXr']['meta_info']


                                class AddressFamilyXr(_Entity_):
                                    """
                                    Address family summary
                                    
                                    .. attribute:: pppoe
                                    
                                    	PPPoE summary
                                    	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_dhcp
                                    
                                    	IP subscriber DHCP summary
                                    	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_subscriber_packet
                                    
                                    	IP subscriber packet summary
                                    	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'iedge4710-oper'
                                    _revision = '2018-09-20'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr, self).__init__()

                                        self.yang_name = "address-family-xr"
                                        self.yang_parent_name = "vrf-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket))])
                                        self._leafs = OrderedDict()

                                        self.pppoe = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe()
                                        self.pppoe.parent = self
                                        self._children_name_map["pppoe"] = "pppoe"

                                        self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp()
                                        self.ip_subscriber_dhcp.parent = self
                                        self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                        self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket()
                                        self.ip_subscriber_packet.parent = self
                                        self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                        self._segment_path = lambda: "address-family-xr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr, [], name, value)


                                    class Pppoe(_Entity_):
                                        """
                                        PPPoE summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe, self).__init__()

                                            self.yang_name = "pppoe"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "pppoe"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe']['meta_info']


                                    class IpSubscriberDhcp(_Entity_):
                                        """
                                        IP subscriber DHCP summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                            self.yang_name = "ip-subscriber-dhcp"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-dhcp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                                    class IpSubscriberPacket(_Entity_):
                                        """
                                        IP subscriber packet summary
                                        
                                        .. attribute:: in_progress_sessions
                                        
                                        	Sessions with undecided address family
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv4_only_sessions
                                        
                                        	IPv4 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ipv6_only_sessions
                                        
                                        	IPv6 only sessions 
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_part_up_sessions
                                        
                                        	Dual stack partially up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dual_up_sessions
                                        
                                        	Dual stack up sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lac_sessions
                                        
                                        	LAC sessions
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'iedge4710-oper'
                                        _revision = '2018-09-20'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                            self.yang_name = "ip-subscriber-packet"
                                            self.yang_parent_name = "address-family-xr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                                ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                                ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                                ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                                ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                                ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                            ])
                                            self.in_progress_sessions = None
                                            self.ipv4_only_sessions = None
                                            self.ipv6_only_sessions = None
                                            self.dual_part_up_sessions = None
                                            self.dual_up_sessions = None
                                            self.lac_sessions = None
                                            self._segment_path = lambda: "ip-subscriber-packet"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary.AddressFamilyXr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries.VrfSummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole.VrfSummaries']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles.SrgRole']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.SrgRoles']['meta_info']


                class AuthorSummaries(_Entity_):
                    """
                    Summary information filtered by authorization
                    state
                    
                    .. attribute:: author_summary
                    
                    	authorization summary
                    	**type**\: list of  		 :py:class:`AuthorSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.AuthorSummaries, self).__init__()

                        self.yang_name = "author-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("author-summary", ("author_summary", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary))])
                        self._leafs = OrderedDict()

                        self.author_summary = YList(self)
                        self._segment_path = lambda: "author-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries, [], name, value)


                    class AuthorSummary(_Entity_):
                        """
                        authorization summary
                        
                        .. attribute:: author_state  (key)
                        
                        	Authorization state
                        	**type**\:  :py:class:`SubscriberAuthorStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAuthorStateFilterFlag>`
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary, self).__init__()

                            self.yang_name = "author-summary"
                            self.yang_parent_name = "author-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['author_state']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('author_state', (YLeaf(YType.enumeration, 'author-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAuthorStateFilterFlag', '')])),
                            ])
                            self.author_state = None

                            self.state_xr = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "author-summary" + "[author-state='" + str(self.author_state) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary, ['author_state'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "author-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "author-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries.AuthorSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.AuthorSummaries']['meta_info']


                class Summary(_Entity_):
                    """
                    Subscriber session summary information
                    
                    .. attribute:: state_xr
                    
                    	State summary
                    	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.StateXr>`
                    
                    	**config**\: False
                    
                    .. attribute:: address_family_xr
                    
                    	Address family summary
                    	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.Summary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr))])
                        self._leafs = OrderedDict()

                        self.state_xr = Subscriber.Session.Nodes.Node.Summary.StateXr()
                        self.state_xr.parent = self
                        self._children_name_map["state_xr"] = "state-xr"

                        self.address_family_xr = Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr()
                        self.address_family_xr.parent = self
                        self._children_name_map["address_family_xr"] = "address-family-xr"
                        self._segment_path = lambda: "summary"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.Summary, [], name, value)


                    class StateXr(_Entity_):
                        """
                        State summary
                        
                        .. attribute:: pppoe
                        
                        	PPPoE summary
                        	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe>`
                        
                        	**config**\: False
                        
                        .. attribute:: ip_subscriber_dhcp
                        
                        	IP subscriber DHCP summary
                        	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp>`
                        
                        	**config**\: False
                        
                        .. attribute:: ip_subscriber_packet
                        
                        	IP subscriber packet summary
                        	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.Summary.StateXr, self).__init__()

                            self.yang_name = "state-xr"
                            self.yang_parent_name = "summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket))])
                            self._leafs = OrderedDict()

                            self.pppoe = Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe()
                            self.pppoe.parent = self
                            self._children_name_map["pppoe"] = "pppoe"

                            self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp()
                            self.ip_subscriber_dhcp.parent = self
                            self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                            self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket()
                            self.ip_subscriber_packet.parent = self
                            self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                            self._segment_path = lambda: "state-xr"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.StateXr, [], name, value)


                        class Pppoe(_Entity_):
                            """
                            PPPoE summary
                            
                            .. attribute:: initialized_sessions
                            
                            	Sessions in initialized state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connecting_sessions
                            
                            	Sessions in connecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connected_sessions
                            
                            	Sessions in connected state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: activated_sessions
                            
                            	Sessions in activated state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: idle_sessions
                            
                            	Sessions in idle state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: disconnecting_sessions
                            
                            	Sessions in disconnecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: end_sessions
                            
                            	Sessions in end state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe, self).__init__()

                                self.yang_name = "pppoe"
                                self.yang_parent_name = "state-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                    ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                    ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                    ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                    ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                    ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                    ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                ])
                                self.initialized_sessions = None
                                self.connecting_sessions = None
                                self.connected_sessions = None
                                self.activated_sessions = None
                                self.idle_sessions = None
                                self.disconnecting_sessions = None
                                self.end_sessions = None
                                self._segment_path = lambda: "pppoe"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.StateXr.Pppoe']['meta_info']


                        class IpSubscriberDhcp(_Entity_):
                            """
                            IP subscriber DHCP summary
                            
                            .. attribute:: initialized_sessions
                            
                            	Sessions in initialized state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connecting_sessions
                            
                            	Sessions in connecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connected_sessions
                            
                            	Sessions in connected state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: activated_sessions
                            
                            	Sessions in activated state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: idle_sessions
                            
                            	Sessions in idle state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: disconnecting_sessions
                            
                            	Sessions in disconnecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: end_sessions
                            
                            	Sessions in end state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp, self).__init__()

                                self.yang_name = "ip-subscriber-dhcp"
                                self.yang_parent_name = "state-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                    ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                    ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                    ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                    ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                    ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                    ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                ])
                                self.initialized_sessions = None
                                self.connecting_sessions = None
                                self.connected_sessions = None
                                self.activated_sessions = None
                                self.idle_sessions = None
                                self.disconnecting_sessions = None
                                self.end_sessions = None
                                self._segment_path = lambda: "ip-subscriber-dhcp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberDhcp']['meta_info']


                        class IpSubscriberPacket(_Entity_):
                            """
                            IP subscriber packet summary
                            
                            .. attribute:: initialized_sessions
                            
                            	Sessions in initialized state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connecting_sessions
                            
                            	Sessions in connecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: connected_sessions
                            
                            	Sessions in connected state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: activated_sessions
                            
                            	Sessions in activated state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: idle_sessions
                            
                            	Sessions in idle state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: disconnecting_sessions
                            
                            	Sessions in disconnecting state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: end_sessions
                            
                            	Sessions in end state
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket, self).__init__()

                                self.yang_name = "ip-subscriber-packet"
                                self.yang_parent_name = "state-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                    ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                    ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                    ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                    ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                    ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                    ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                ])
                                self.initialized_sessions = None
                                self.connecting_sessions = None
                                self.connected_sessions = None
                                self.activated_sessions = None
                                self.idle_sessions = None
                                self.disconnecting_sessions = None
                                self.end_sessions = None
                                self._segment_path = lambda: "ip-subscriber-packet"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.StateXr.IpSubscriberPacket']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.StateXr']['meta_info']


                    class AddressFamilyXr(_Entity_):
                        """
                        Address family summary
                        
                        .. attribute:: pppoe
                        
                        	PPPoE summary
                        	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe>`
                        
                        	**config**\: False
                        
                        .. attribute:: ip_subscriber_dhcp
                        
                        	IP subscriber DHCP summary
                        	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp>`
                        
                        	**config**\: False
                        
                        .. attribute:: ip_subscriber_packet
                        
                        	IP subscriber packet summary
                        	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr, self).__init__()

                            self.yang_name = "address-family-xr"
                            self.yang_parent_name = "summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket))])
                            self._leafs = OrderedDict()

                            self.pppoe = Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe()
                            self.pppoe.parent = self
                            self._children_name_map["pppoe"] = "pppoe"

                            self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp()
                            self.ip_subscriber_dhcp.parent = self
                            self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                            self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket()
                            self.ip_subscriber_packet.parent = self
                            self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                            self._segment_path = lambda: "address-family-xr"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr, [], name, value)


                        class Pppoe(_Entity_):
                            """
                            PPPoE summary
                            
                            .. attribute:: in_progress_sessions
                            
                            	Sessions with undecided address family
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_only_sessions
                            
                            	IPv4 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_only_sessions
                            
                            	IPv6 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_part_up_sessions
                            
                            	Dual stack partially up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_up_sessions
                            
                            	Dual stack up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lac_sessions
                            
                            	LAC sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe, self).__init__()

                                self.yang_name = "pppoe"
                                self.yang_parent_name = "address-family-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                    ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                    ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                    ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                    ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                    ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                ])
                                self.in_progress_sessions = None
                                self.ipv4_only_sessions = None
                                self.ipv6_only_sessions = None
                                self.dual_part_up_sessions = None
                                self.dual_up_sessions = None
                                self.lac_sessions = None
                                self._segment_path = lambda: "pppoe"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.Pppoe']['meta_info']


                        class IpSubscriberDhcp(_Entity_):
                            """
                            IP subscriber DHCP summary
                            
                            .. attribute:: in_progress_sessions
                            
                            	Sessions with undecided address family
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_only_sessions
                            
                            	IPv4 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_only_sessions
                            
                            	IPv6 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_part_up_sessions
                            
                            	Dual stack partially up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_up_sessions
                            
                            	Dual stack up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lac_sessions
                            
                            	LAC sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                self.yang_name = "ip-subscriber-dhcp"
                                self.yang_parent_name = "address-family-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                    ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                    ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                    ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                    ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                    ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                ])
                                self.in_progress_sessions = None
                                self.ipv4_only_sessions = None
                                self.ipv6_only_sessions = None
                                self.dual_part_up_sessions = None
                                self.dual_up_sessions = None
                                self.lac_sessions = None
                                self._segment_path = lambda: "ip-subscriber-dhcp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                        class IpSubscriberPacket(_Entity_):
                            """
                            IP subscriber packet summary
                            
                            .. attribute:: in_progress_sessions
                            
                            	Sessions with undecided address family
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_only_sessions
                            
                            	IPv4 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_only_sessions
                            
                            	IPv6 only sessions 
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_part_up_sessions
                            
                            	Dual stack partially up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dual_up_sessions
                            
                            	Dual stack up sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lac_sessions
                            
                            	LAC sessions
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                self.yang_name = "ip-subscriber-packet"
                                self.yang_parent_name = "address-family-xr"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                    ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                    ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                    ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                    ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                    ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                ])
                                self.in_progress_sessions = None
                                self.ipv4_only_sessions = None
                                self.ipv6_only_sessions = None
                                self.dual_part_up_sessions = None
                                self.dual_up_sessions = None
                                self.lac_sessions = None
                                self._segment_path = lambda: "ip-subscriber-packet"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.Summary.AddressFamilyXr']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.Summary']['meta_info']


                class MacSummaries(_Entity_):
                    """
                    Summary information filtered by MAC address
                    
                    .. attribute:: mac_summary
                    
                    	MAC address summary
                    	**type**\: list of  		 :py:class:`MacSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.MacSummaries, self).__init__()

                        self.yang_name = "mac-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("mac-summary", ("mac_summary", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary))])
                        self._leafs = OrderedDict()

                        self.mac_summary = YList(self)
                        self._segment_path = lambda: "mac-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries, [], name, value)


                    class MacSummary(_Entity_):
                        """
                        MAC address summary
                        
                        .. attribute:: mac_address  (key)
                        
                        	Subscriber MAC address
                        	**type**\: str
                        
                        	**pattern:** [0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2}){5}
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary, self).__init__()

                            self.yang_name = "mac-summary"
                            self.yang_parent_name = "mac-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['mac_address']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('mac_address', (YLeaf(YType.str, 'mac-address'), ['str'])),
                            ])
                            self.mac_address = None

                            self.state_xr = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "mac-summary" + "[mac-address='" + str(self.mac_address) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary, ['mac_address'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "mac-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "mac-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries.MacSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.MacSummaries']['meta_info']


                class InterfaceSummaries(_Entity_):
                    """
                    Summary information filtered by interface
                    
                    .. attribute:: interface_summary
                    
                    	Interface summary
                    	**type**\: list of  		 :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.InterfaceSummaries, self).__init__()

                        self.yang_name = "interface-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("interface-summary", ("interface_summary", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary))])
                        self._leafs = OrderedDict()

                        self.interface_summary = YList(self)
                        self._segment_path = lambda: "interface-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries, [], name, value)


                    class InterfaceSummary(_Entity_):
                        """
                        Interface summary
                        
                        .. attribute:: interface_name  (key)
                        
                        	Interface name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary, self).__init__()

                            self.yang_name = "interface-summary"
                            self.yang_parent_name = "interface-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.state_xr = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "interface-summary" + "[interface-name='" + str(self.interface_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary, ['interface_name'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "interface-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "interface-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries.InterfaceSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.InterfaceSummaries']['meta_info']


                class AuthenticationSummaries(_Entity_):
                    """
                    Summary information filtered by
                    authentication state
                    
                    .. attribute:: authentication_summary
                    
                    	authentication summary
                    	**type**\: list of  		 :py:class:`AuthenticationSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.AuthenticationSummaries, self).__init__()

                        self.yang_name = "authentication-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("authentication-summary", ("authentication_summary", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary))])
                        self._leafs = OrderedDict()

                        self.authentication_summary = YList(self)
                        self._segment_path = lambda: "authentication-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries, [], name, value)


                    class AuthenticationSummary(_Entity_):
                        """
                        authentication summary
                        
                        .. attribute:: authentication_state  (key)
                        
                        	Authentication state
                        	**type**\:  :py:class:`SubscriberAuthenStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAuthenStateFilterFlag>`
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary, self).__init__()

                            self.yang_name = "authentication-summary"
                            self.yang_parent_name = "authentication-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['authentication_state']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('authentication_state', (YLeaf(YType.enumeration, 'authentication-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAuthenStateFilterFlag', '')])),
                            ])
                            self.authentication_state = None

                            self.state_xr = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "authentication-summary" + "[authentication-state='" + str(self.authentication_state) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary, ['authentication_state'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "authentication-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "authentication-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries.AuthenticationSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.AuthenticationSummaries']['meta_info']


                class StateSummaries(_Entity_):
                    """
                    Summary information filtered by session state
                    
                    .. attribute:: state_summary
                    
                    	State summary
                    	**type**\: list of  		 :py:class:`StateSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.StateSummaries, self).__init__()

                        self.yang_name = "state-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("state-summary", ("state_summary", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary))])
                        self._leafs = OrderedDict()

                        self.state_summary = YList(self)
                        self._segment_path = lambda: "state-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries, [], name, value)


                    class StateSummary(_Entity_):
                        """
                        State summary
                        
                        .. attribute:: state  (key)
                        
                        	Subscriber state
                        	**type**\:  :py:class:`SubscriberStateFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberStateFilterFlag>`
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary, self).__init__()

                            self.yang_name = "state-summary"
                            self.yang_parent_name = "state-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['state']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberStateFilterFlag', '')])),
                            ])
                            self.state = None

                            self.state_xr = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "state-summary" + "[state='" + str(self.state) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary, ['state'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "state-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "state-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries.StateSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.StateSummaries']['meta_info']


                class Ipv4AddressVrfSummaries(_Entity_):
                    """
                    Summary information filtered by IPv4 address
                    and VRF
                    
                    .. attribute:: ipv4_address_vrf_summary
                    
                    	IPv4 address and VRF summary
                    	**type**\: list of  		 :py:class:`Ipv4AddressVrfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries, self).__init__()

                        self.yang_name = "ipv4-address-vrf-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipv4-address-vrf-summary", ("ipv4_address_vrf_summary", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary))])
                        self._leafs = OrderedDict()

                        self.ipv4_address_vrf_summary = YList(self)
                        self._segment_path = lambda: "ipv4-address-vrf-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries, [], name, value)


                    class Ipv4AddressVrfSummary(_Entity_):
                        """
                        IPv4 address and VRF summary
                        
                        .. attribute:: vrf_name
                        
                        	VRF name
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        	**config**\: False
                        
                        .. attribute:: address
                        
                        	Subscriber IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary, self).__init__()

                            self.yang_name = "ipv4-address-vrf-summary"
                            self.yang_parent_name = "ipv4-address-vrf-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                            ])
                            self.vrf_name = None
                            self.address = None

                            self.state_xr = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "ipv4-address-vrf-summary"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary, ['vrf_name', 'address'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "ipv4-address-vrf-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "ipv4-address-vrf-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries.Ipv4AddressVrfSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressVrfSummaries']['meta_info']


                class AddressFamilySummaries(_Entity_):
                    """
                    Summary information filtered by address
                    family
                    
                    .. attribute:: address_family_summary
                    
                    	Address family summary
                    	**type**\: list of  		 :py:class:`AddressFamilySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.AddressFamilySummaries, self).__init__()

                        self.yang_name = "address-family-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("address-family-summary", ("address_family_summary", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary))])
                        self._leafs = OrderedDict()

                        self.address_family_summary = YList(self)
                        self._segment_path = lambda: "address-family-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries, [], name, value)


                    class AddressFamilySummary(_Entity_):
                        """
                        Address family summary
                        
                        .. attribute:: address_family  (key)
                        
                        	Address family
                        	**type**\:  :py:class:`SubscriberAddressFamilyFilterFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.SubscriberAddressFamilyFilterFlag>`
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary, self).__init__()

                            self.yang_name = "address-family-summary"
                            self.yang_parent_name = "address-family-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['address_family']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('address_family', (YLeaf(YType.enumeration, 'address-family'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'SubscriberAddressFamilyFilterFlag', '')])),
                            ])
                            self.address_family = None

                            self.state_xr = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "address-family-summary" + "[address-family='" + str(self.address_family) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary, ['address_family'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "address-family-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "address-family-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries.AddressFamilySummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.AddressFamilySummaries']['meta_info']


                class UsernameSummaries(_Entity_):
                    """
                    Summary information filtered by username
                    
                    .. attribute:: username_summary
                    
                    	Username summary
                    	**type**\: list of  		 :py:class:`UsernameSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.UsernameSummaries, self).__init__()

                        self.yang_name = "username-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("username-summary", ("username_summary", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary))])
                        self._leafs = OrderedDict()

                        self.username_summary = YList(self)
                        self._segment_path = lambda: "username-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries, [], name, value)


                    class UsernameSummary(_Entity_):
                        """
                        Username summary
                        
                        .. attribute:: username  (key)
                        
                        	Subscriber username
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary, self).__init__()

                            self.yang_name = "username-summary"
                            self.yang_parent_name = "username-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['username']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('username', (YLeaf(YType.str, 'username'), ['str'])),
                            ])
                            self.username = None

                            self.state_xr = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "username-summary" + "[username='" + str(self.username) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary, ['username'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "username-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "username-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries.UsernameSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.UsernameSummaries']['meta_info']


                class AccessInterfaceSummaries(_Entity_):
                    """
                    Summary information filtered by access
                    interface
                    
                    .. attribute:: access_interface_summary
                    
                    	Access interface summary
                    	**type**\: list of  		 :py:class:`AccessInterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries, self).__init__()

                        self.yang_name = "access-interface-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("access-interface-summary", ("access_interface_summary", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary))])
                        self._leafs = OrderedDict()

                        self.access_interface_summary = YList(self)
                        self._segment_path = lambda: "access-interface-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries, [], name, value)


                    class AccessInterfaceSummary(_Entity_):
                        """
                        Access interface summary
                        
                        .. attribute:: interface_name  (key)
                        
                        	Interface name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary, self).__init__()

                            self.yang_name = "access-interface-summary"
                            self.yang_parent_name = "access-interface-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                            ])
                            self.interface_name = None

                            self.state_xr = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "access-interface-summary" + "[interface-name='" + str(self.interface_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary, ['interface_name'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "access-interface-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "access-interface-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries.AccessInterfaceSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.AccessInterfaceSummaries']['meta_info']


                class Ipv4AddressSummaries(_Entity_):
                    """
                    Summary information filtered by subscriber
                    IPv4 address
                    
                    .. attribute:: ipv4_address_summary
                    
                    	IPv4 address summary
                    	**type**\: list of  		 :py:class:`Ipv4AddressSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries, self).__init__()

                        self.yang_name = "ipv4-address-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipv4-address-summary", ("ipv4_address_summary", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary))])
                        self._leafs = OrderedDict()

                        self.ipv4_address_summary = YList(self)
                        self._segment_path = lambda: "ipv4-address-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries, [], name, value)


                    class Ipv4AddressSummary(_Entity_):
                        """
                        IPv4 address summary
                        
                        .. attribute:: address  (key)
                        
                        	Subscriber IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary, self).__init__()

                            self.yang_name = "ipv4-address-summary"
                            self.yang_parent_name = "ipv4-address-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['address']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                            ])
                            self.address = None

                            self.state_xr = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "ipv4-address-summary" + "[address='" + str(self.address) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary, ['address'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "ipv4-address-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "ipv4-address-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries.Ipv4AddressSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.Ipv4AddressSummaries']['meta_info']


                class VrfSummaries(_Entity_):
                    """
                    Summary information filtered by VRF
                    
                    .. attribute:: vrf_summary
                    
                    	VRF summary
                    	**type**\: list of  		 :py:class:`VrfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.VrfSummaries, self).__init__()

                        self.yang_name = "vrf-summaries"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("vrf-summary", ("vrf_summary", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary))])
                        self._leafs = OrderedDict()

                        self.vrf_summary = YList(self)
                        self._segment_path = lambda: "vrf-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries, [], name, value)


                    class VrfSummary(_Entity_):
                        """
                        VRF summary
                        
                        .. attribute:: vrf_name  (key)
                        
                        	VRF name
                        	**type**\: str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        	**config**\: False
                        
                        .. attribute:: state_xr
                        
                        	State summary
                        	**type**\:  :py:class:`StateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr>`
                        
                        	**config**\: False
                        
                        .. attribute:: address_family_xr
                        
                        	Address family summary
                        	**type**\:  :py:class:`AddressFamilyXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary, self).__init__()

                            self.yang_name = "vrf-summary"
                            self.yang_parent_name = "vrf-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['vrf_name']
                            self._child_classes = OrderedDict([("state-xr", ("state_xr", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr)), ("address-family-xr", ("address_family_xr", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr))])
                            self._leafs = OrderedDict([
                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                            ])
                            self.vrf_name = None

                            self.state_xr = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr()
                            self.state_xr.parent = self
                            self._children_name_map["state_xr"] = "state-xr"

                            self.address_family_xr = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr()
                            self.address_family_xr.parent = self
                            self._children_name_map["address_family_xr"] = "address-family-xr"
                            self._segment_path = lambda: "vrf-summary" + "[vrf-name='" + str(self.vrf_name) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary, ['vrf_name'], name, value)


                        class StateXr(_Entity_):
                            """
                            State summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr, self).__init__()

                                self.yang_name = "state-xr"
                                self.yang_parent_name = "vrf-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "state-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: initialized_sessions
                                
                                	Sessions in initialized state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connecting_sessions
                                
                                	Sessions in connecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: connected_sessions
                                
                                	Sessions in connected state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: activated_sessions
                                
                                	Sessions in activated state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: idle_sessions
                                
                                	Sessions in idle state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: disconnecting_sessions
                                
                                	Sessions in disconnecting state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: end_sessions
                                
                                	Sessions in end state
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "state-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('initialized_sessions', (YLeaf(YType.uint32, 'initialized-sessions'), ['int'])),
                                        ('connecting_sessions', (YLeaf(YType.uint32, 'connecting-sessions'), ['int'])),
                                        ('connected_sessions', (YLeaf(YType.uint32, 'connected-sessions'), ['int'])),
                                        ('activated_sessions', (YLeaf(YType.uint32, 'activated-sessions'), ['int'])),
                                        ('idle_sessions', (YLeaf(YType.uint32, 'idle-sessions'), ['int'])),
                                        ('disconnecting_sessions', (YLeaf(YType.uint32, 'disconnecting-sessions'), ['int'])),
                                        ('end_sessions', (YLeaf(YType.uint32, 'end-sessions'), ['int'])),
                                    ])
                                    self.initialized_sessions = None
                                    self.connecting_sessions = None
                                    self.connected_sessions = None
                                    self.activated_sessions = None
                                    self.idle_sessions = None
                                    self.disconnecting_sessions = None
                                    self.end_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket, ['initialized_sessions', 'connecting_sessions', 'connected_sessions', 'activated_sessions', 'idle_sessions', 'disconnecting_sessions', 'end_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.StateXr']['meta_info']


                        class AddressFamilyXr(_Entity_):
                            """
                            Address family summary
                            
                            .. attribute:: pppoe
                            
                            	PPPoE summary
                            	**type**\:  :py:class:`Pppoe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_dhcp
                            
                            	IP subscriber DHCP summary
                            	**type**\:  :py:class:`IpSubscriberDhcp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp>`
                            
                            	**config**\: False
                            
                            .. attribute:: ip_subscriber_packet
                            
                            	IP subscriber packet summary
                            	**type**\:  :py:class:`IpSubscriberPacket <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr, self).__init__()

                                self.yang_name = "address-family-xr"
                                self.yang_parent_name = "vrf-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("pppoe", ("pppoe", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe)), ("ip-subscriber-dhcp", ("ip_subscriber_dhcp", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp)), ("ip-subscriber-packet", ("ip_subscriber_packet", Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket))])
                                self._leafs = OrderedDict()

                                self.pppoe = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe()
                                self.pppoe.parent = self
                                self._children_name_map["pppoe"] = "pppoe"

                                self.ip_subscriber_dhcp = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp()
                                self.ip_subscriber_dhcp.parent = self
                                self._children_name_map["ip_subscriber_dhcp"] = "ip-subscriber-dhcp"

                                self.ip_subscriber_packet = Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket()
                                self.ip_subscriber_packet.parent = self
                                self._children_name_map["ip_subscriber_packet"] = "ip-subscriber-packet"
                                self._segment_path = lambda: "address-family-xr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr, [], name, value)


                            class Pppoe(_Entity_):
                                """
                                PPPoE summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe, self).__init__()

                                    self.yang_name = "pppoe"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "pppoe"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.Pppoe']['meta_info']


                            class IpSubscriberDhcp(_Entity_):
                                """
                                IP subscriber DHCP summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp, self).__init__()

                                    self.yang_name = "ip-subscriber-dhcp"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-dhcp"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberDhcp']['meta_info']


                            class IpSubscriberPacket(_Entity_):
                                """
                                IP subscriber packet summary
                                
                                .. attribute:: in_progress_sessions
                                
                                	Sessions with undecided address family
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_only_sessions
                                
                                	IPv4 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_only_sessions
                                
                                	IPv6 only sessions 
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_part_up_sessions
                                
                                	Dual stack partially up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: dual_up_sessions
                                
                                	Dual stack up sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: lac_sessions
                                
                                	LAC sessions
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket, self).__init__()

                                    self.yang_name = "ip-subscriber-packet"
                                    self.yang_parent_name = "address-family-xr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('in_progress_sessions', (YLeaf(YType.uint32, 'in-progress-sessions'), ['int'])),
                                        ('ipv4_only_sessions', (YLeaf(YType.uint32, 'ipv4-only-sessions'), ['int'])),
                                        ('ipv6_only_sessions', (YLeaf(YType.uint32, 'ipv6-only-sessions'), ['int'])),
                                        ('dual_part_up_sessions', (YLeaf(YType.uint32, 'dual-part-up-sessions'), ['int'])),
                                        ('dual_up_sessions', (YLeaf(YType.uint32, 'dual-up-sessions'), ['int'])),
                                        ('lac_sessions', (YLeaf(YType.uint32, 'lac-sessions'), ['int'])),
                                    ])
                                    self.in_progress_sessions = None
                                    self.ipv4_only_sessions = None
                                    self.ipv6_only_sessions = None
                                    self.dual_part_up_sessions = None
                                    self.dual_up_sessions = None
                                    self.lac_sessions = None
                                    self._segment_path = lambda: "ip-subscriber-packet"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket, ['in_progress_sessions', 'ipv4_only_sessions', 'ipv6_only_sessions', 'dual_part_up_sessions', 'dual_up_sessions', 'lac_sessions'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr.IpSubscriberPacket']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary.AddressFamilyXr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries.VrfSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.VrfSummaries']['meta_info']


                class Sessions(_Entity_):
                    """
                    IP subscriber sessions
                    
                    .. attribute:: session
                    
                    	Subscriber session information
                    	**type**\: list of  		 :py:class:`Session_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'iedge4710-oper'
                    _revision = '2018-09-20'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Subscriber.Session.Nodes.Node.Sessions, self).__init__()

                        self.yang_name = "sessions"
                        self.yang_parent_name = "node"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("session", ("session", Subscriber.Session.Nodes.Node.Sessions.Session_))])
                        self._leafs = OrderedDict()

                        self.session = YList(self)
                        self._segment_path = lambda: "sessions"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions, [], name, value)


                    class Session_(_Entity_):
                        """
                        Subscriber session information
                        
                        .. attribute:: session_id  (key)
                        
                        	Session ID
                        	**type**\: str
                        
                        	**pattern:** [0\-9a\-fA\-F]{1,8}
                        
                        	**config**\: False
                        
                        .. attribute:: accounting
                        
                        	Accounting information
                        	**type**\:  :py:class:`Accounting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting>`
                        
                        	**config**\: False
                        
                        .. attribute:: session_type
                        
                        	Subscriber session type
                        	**type**\:  :py:class:`IedgeOperSession <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperSession>`
                        
                        	**config**\: False
                        
                        .. attribute:: pppoe_sub_type
                        
                        	PPPoE sub type
                        	**type**\:  :py:class:`IedgePppSub <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgePppSub>`
                        
                        	**config**\: False
                        
                        .. attribute:: interface_name
                        
                        	Interface name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: vrf_name
                        
                        	VRF name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: circuit_id
                        
                        	Circuit ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: remote_id
                        
                        	Remote ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lns_address
                        
                        	PPPoE LNS address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: lac_address
                        
                        	PPPoE LAC address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_client_authentication_id
                        
                        	PPPoE LAC tunnel client authentication ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_server_authentication_id
                        
                        	PPPoE LAC tunnel server authentication ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: session_ip_address
                        
                        	Session ip address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: session_ipv6_address
                        
                        	Session IPv6 address
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: session_ipv6_prefix
                        
                        	Session IPv6 prefix
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: delegated_ipv6_prefix
                        
                        	Session delegated IPv6 prefix
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ipv6_interface_id
                        
                        	IPv6 Interface ID
                        	**type**\: str
                        
                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                        
                        	**config**\: False
                        
                        .. attribute:: mac_address
                        
                        	MAC address
                        	**type**\: str
                        
                        	**pattern:** [0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2}){5}
                        
                        	**config**\: False
                        
                        .. attribute:: account_session_id
                        
                        	Accounting session ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: nas_port
                        
                        	NAS port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: username
                        
                        	Username
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: clientname
                        
                        	Client Username
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: formattedname
                        
                        	Formatted Username
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_session_authentic
                        
                        	If true, session is authentic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_session_author
                        
                        	If true, session is authorized
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: session_state
                        
                        	Session state
                        	**type**\:  :py:class:`IedgeOperSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperSessionState>`
                        
                        	**config**\: False
                        
                        .. attribute:: session_creation_time_epoch
                        
                        	Session creation time in epoch seconds
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: idle_state_change_time
                        
                        	Time when idle state change occurred in DDD MMM DD HH\:MM\:SS YYYY format eg\: Tue Apr 11 21\:30\:47 2011
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: total_session_idle_time
                        
                        	Total session idle time (in seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: access_interface_name
                        
                        	Access interface name associated with the session
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: accounting_stop_fail_rc
                        
                        	Accounting Stop Error Code for Accounting Session
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: sub_policy_data
                        
                        	Subscriber control policy applied to this session
                        	**type**\: list of  		 :py:class:`SubPolicyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_.SubPolicyData>`
                        
                        	**config**\: False
                        
                        .. attribute:: session_service_info
                        
                        	List of subscriber services associated to this session
                        	**type**\: list of  		 :py:class:`SessionServiceInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_.SessionServiceInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: session_change_of_authorization
                        
                        	Subscriber change of authorization information
                        	**type**\: list of  		 :py:class:`SessionChangeOfAuthorization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_.SessionChangeOfAuthorization>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'iedge4710-oper'
                        _revision = '2018-09-20'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Subscriber.Session.Nodes.Node.Sessions.Session_, self).__init__()

                            self.yang_name = "session"
                            self.yang_parent_name = "sessions"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['session_id']
                            self._child_classes = OrderedDict([("accounting", ("accounting", Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting)), ("sub-policy-data", ("sub_policy_data", Subscriber.Session.Nodes.Node.Sessions.Session_.SubPolicyData)), ("session-service-info", ("session_service_info", Subscriber.Session.Nodes.Node.Sessions.Session_.SessionServiceInfo)), ("session-change-of-authorization", ("session_change_of_authorization", Subscriber.Session.Nodes.Node.Sessions.Session_.SessionChangeOfAuthorization))])
                            self._leafs = OrderedDict([
                                ('session_id', (YLeaf(YType.str, 'session-id'), ['str'])),
                                ('session_type', (YLeaf(YType.enumeration, 'session-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperSession', '')])),
                                ('pppoe_sub_type', (YLeaf(YType.enumeration, 'pppoe-sub-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgePppSub', '')])),
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                ('vrf_name', (YLeaf(YType.str, 'vrf-name'), ['str'])),
                                ('circuit_id', (YLeaf(YType.str, 'circuit-id'), ['str'])),
                                ('remote_id', (YLeaf(YType.str, 'remote-id'), ['str'])),
                                ('lns_address', (YLeaf(YType.str, 'lns-address'), ['str'])),
                                ('lac_address', (YLeaf(YType.str, 'lac-address'), ['str'])),
                                ('tunnel_client_authentication_id', (YLeaf(YType.str, 'tunnel-client-authentication-id'), ['str'])),
                                ('tunnel_server_authentication_id', (YLeaf(YType.str, 'tunnel-server-authentication-id'), ['str'])),
                                ('session_ip_address', (YLeaf(YType.str, 'session-ip-address'), ['str'])),
                                ('session_ipv6_address', (YLeaf(YType.str, 'session-ipv6-address'), ['str'])),
                                ('session_ipv6_prefix', (YLeaf(YType.str, 'session-ipv6-prefix'), ['str'])),
                                ('delegated_ipv6_prefix', (YLeaf(YType.str, 'delegated-ipv6-prefix'), ['str'])),
                                ('ipv6_interface_id', (YLeaf(YType.str, 'ipv6-interface-id'), ['str'])),
                                ('mac_address', (YLeaf(YType.str, 'mac-address'), ['str'])),
                                ('account_session_id', (YLeaf(YType.str, 'account-session-id'), ['str'])),
                                ('nas_port', (YLeaf(YType.str, 'nas-port'), ['str'])),
                                ('username', (YLeaf(YType.str, 'username'), ['str'])),
                                ('clientname', (YLeaf(YType.str, 'clientname'), ['str'])),
                                ('formattedname', (YLeaf(YType.str, 'formattedname'), ['str'])),
                                ('is_session_authentic', (YLeaf(YType.boolean, 'is-session-authentic'), ['bool'])),
                                ('is_session_author', (YLeaf(YType.boolean, 'is-session-author'), ['bool'])),
                                ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperSessionState', '')])),
                                ('session_creation_time_epoch', (YLeaf(YType.uint64, 'session-creation-time-epoch'), ['int'])),
                                ('idle_state_change_time', (YLeaf(YType.str, 'idle-state-change-time'), ['str'])),
                                ('total_session_idle_time', (YLeaf(YType.uint32, 'total-session-idle-time'), ['int'])),
                                ('access_interface_name', (YLeaf(YType.str, 'access-interface-name'), ['str'])),
                                ('accounting_stop_fail_rc', (YLeaf(YType.uint32, 'accounting-stop-fail-rc'), ['int'])),
                            ])
                            self.session_id = None
                            self.session_type = None
                            self.pppoe_sub_type = None
                            self.interface_name = None
                            self.vrf_name = None
                            self.circuit_id = None
                            self.remote_id = None
                            self.lns_address = None
                            self.lac_address = None
                            self.tunnel_client_authentication_id = None
                            self.tunnel_server_authentication_id = None
                            self.session_ip_address = None
                            self.session_ipv6_address = None
                            self.session_ipv6_prefix = None
                            self.delegated_ipv6_prefix = None
                            self.ipv6_interface_id = None
                            self.mac_address = None
                            self.account_session_id = None
                            self.nas_port = None
                            self.username = None
                            self.clientname = None
                            self.formattedname = None
                            self.is_session_authentic = None
                            self.is_session_author = None
                            self.session_state = None
                            self.session_creation_time_epoch = None
                            self.idle_state_change_time = None
                            self.total_session_idle_time = None
                            self.access_interface_name = None
                            self.accounting_stop_fail_rc = None

                            self.accounting = Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting()
                            self.accounting.parent = self
                            self._children_name_map["accounting"] = "accounting"

                            self.sub_policy_data = YList(self)
                            self.session_service_info = YList(self)
                            self.session_change_of_authorization = YList(self)
                            self._segment_path = lambda: "session" + "[session-id='" + str(self.session_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_, ['session_id', 'session_type', 'pppoe_sub_type', 'interface_name', 'vrf_name', 'circuit_id', 'remote_id', 'lns_address', 'lac_address', 'tunnel_client_authentication_id', 'tunnel_server_authentication_id', 'session_ip_address', 'session_ipv6_address', 'session_ipv6_prefix', 'delegated_ipv6_prefix', 'ipv6_interface_id', 'mac_address', 'account_session_id', 'nas_port', 'username', 'clientname', 'formattedname', 'is_session_authentic', 'is_session_author', 'session_state', 'session_creation_time_epoch', 'idle_state_change_time', 'total_session_idle_time', 'access_interface_name', 'accounting_stop_fail_rc'], name, value)


                        class Accounting(_Entity_):
                            """
                            Accounting information
                            
                            .. attribute:: accounting_session
                            
                            	Accounting information
                            	**type**\: list of  		 :py:class:`AccountingSession <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting.AccountingSession>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting, self).__init__()

                                self.yang_name = "accounting"
                                self.yang_parent_name = "session"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("accounting-session", ("accounting_session", Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting.AccountingSession))])
                                self._leafs = OrderedDict()

                                self.accounting_session = YList(self)
                                self._segment_path = lambda: "accounting"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting, [], name, value)


                            class AccountingSession(_Entity_):
                                """
                                Accounting information
                                
                                .. attribute:: accounting_state_rc
                                
                                	Accounting State Error Code for Accounting Session
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: accounting_stop_state
                                
                                	Accounting Stop State
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: record_context_name
                                
                                	Accounting record context name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: method_list_name
                                
                                	AAA method list name used to perform accounting
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: account_session_id
                                
                                	Accounting session ID
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: accounting_start_time_epoch
                                
                                	Accounting start time in epoch\-seconds
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: is_interim_accounting_enabled
                                
                                	True if interim accounting is enabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: interim_interval
                                
                                	Interim accounting interval (in minutes)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: minute
                                
                                .. attribute:: last_successful_interim_update_time_epoch
                                
                                	Time of last successful interim update in epoch\-seconds 
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: last_unsuccessful_interim_update_time_epoch
                                
                                	Time of last unsuccessful interim update in epoch\-seconds 
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: next_interim_update_attempt_time
                                
                                	Time of next interim update attempt (in seconds)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: last_interim_update_attempt_time_epoch
                                
                                	Time of last interim update attempt in epoch\-seconds
                                	**type**\: int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: sent_interim_updates
                                
                                	Number of interim updates sent
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: accepted_interim_updates
                                
                                	Number of interim updates accepted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rejected_interim_updates
                                
                                	Number of interim updates rejected
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sent_interim_update_failures
                                
                                	Number of interim update send failures
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'iedge4710-oper'
                                _revision = '2018-09-20'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting.AccountingSession, self).__init__()

                                    self.yang_name = "accounting-session"
                                    self.yang_parent_name = "accounting"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('accounting_state_rc', (YLeaf(YType.uint32, 'accounting-state-rc'), ['int'])),
                                        ('accounting_stop_state', (YLeaf(YType.uint32, 'accounting-stop-state'), ['int'])),
                                        ('record_context_name', (YLeaf(YType.str, 'record-context-name'), ['str'])),
                                        ('method_list_name', (YLeaf(YType.str, 'method-list-name'), ['str'])),
                                        ('account_session_id', (YLeaf(YType.str, 'account-session-id'), ['str'])),
                                        ('accounting_start_time_epoch', (YLeaf(YType.uint64, 'accounting-start-time-epoch'), ['int'])),
                                        ('is_interim_accounting_enabled', (YLeaf(YType.boolean, 'is-interim-accounting-enabled'), ['bool'])),
                                        ('interim_interval', (YLeaf(YType.uint32, 'interim-interval'), ['int'])),
                                        ('last_successful_interim_update_time_epoch', (YLeaf(YType.uint64, 'last-successful-interim-update-time-epoch'), ['int'])),
                                        ('last_unsuccessful_interim_update_time_epoch', (YLeaf(YType.uint64, 'last-unsuccessful-interim-update-time-epoch'), ['int'])),
                                        ('next_interim_update_attempt_time', (YLeaf(YType.uint32, 'next-interim-update-attempt-time'), ['int'])),
                                        ('last_interim_update_attempt_time_epoch', (YLeaf(YType.uint64, 'last-interim-update-attempt-time-epoch'), ['int'])),
                                        ('sent_interim_updates', (YLeaf(YType.uint32, 'sent-interim-updates'), ['int'])),
                                        ('accepted_interim_updates', (YLeaf(YType.uint32, 'accepted-interim-updates'), ['int'])),
                                        ('rejected_interim_updates', (YLeaf(YType.uint32, 'rejected-interim-updates'), ['int'])),
                                        ('sent_interim_update_failures', (YLeaf(YType.uint32, 'sent-interim-update-failures'), ['int'])),
                                    ])
                                    self.accounting_state_rc = None
                                    self.accounting_stop_state = None
                                    self.record_context_name = None
                                    self.method_list_name = None
                                    self.account_session_id = None
                                    self.accounting_start_time_epoch = None
                                    self.is_interim_accounting_enabled = None
                                    self.interim_interval = None
                                    self.last_successful_interim_update_time_epoch = None
                                    self.last_unsuccessful_interim_update_time_epoch = None
                                    self.next_interim_update_attempt_time = None
                                    self.last_interim_update_attempt_time_epoch = None
                                    self.sent_interim_updates = None
                                    self.accepted_interim_updates = None
                                    self.rejected_interim_updates = None
                                    self.sent_interim_update_failures = None
                                    self._segment_path = lambda: "accounting-session"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting.AccountingSession, ['accounting_state_rc', 'accounting_stop_state', 'record_context_name', 'method_list_name', 'account_session_id', 'accounting_start_time_epoch', 'is_interim_accounting_enabled', 'interim_interval', 'last_successful_interim_update_time_epoch', 'last_unsuccessful_interim_update_time_epoch', 'next_interim_update_attempt_time', 'last_interim_update_attempt_time_epoch', 'sent_interim_updates', 'accepted_interim_updates', 'rejected_interim_updates', 'sent_interim_update_failures'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                    return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting.AccountingSession']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_.Accounting']['meta_info']


                        class SubPolicyData(_Entity_):
                            """
                            Subscriber control policy applied to this
                            session
                            
                            .. attribute:: policy_epoch
                            
                            	Matching event, condition and executed actions
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Sessions.Session_.SubPolicyData, self).__init__()

                                self.yang_name = "sub-policy-data"
                                self.yang_parent_name = "session"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('policy_epoch', (YLeaf(YType.str, 'policy-epoch'), ['str'])),
                                ])
                                self.policy_epoch = None
                                self._segment_path = lambda: "sub-policy-data"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_.SubPolicyData, ['policy_epoch'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_.SubPolicyData']['meta_info']


                        class SessionServiceInfo(_Entity_):
                            """
                            List of subscriber services associated to this
                            session
                            
                            .. attribute:: service_name
                            
                            	ServiceName
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: service_params
                            
                            	ServiceParams
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: service_type
                            
                            	ServiceType
                            	**type**\:  :py:class:`IedgeOperService <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperService>`
                            
                            	**config**\: False
                            
                            .. attribute:: service_status
                            
                            	ServiceStatus
                            	**type**\:  :py:class:`IedgeOperServiceStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeOperServiceStatus>`
                            
                            	**config**\: False
                            
                            .. attribute:: service_id
                            
                            	ServiceIdentifier
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: service_prepaid
                            
                            	ServicePrepaid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Sessions.Session_.SessionServiceInfo, self).__init__()

                                self.yang_name = "session-service-info"
                                self.yang_parent_name = "session"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('service_name', (YLeaf(YType.str, 'service-name'), ['str'])),
                                    ('service_params', (YLeaf(YType.str, 'service-params'), ['str'])),
                                    ('service_type', (YLeaf(YType.enumeration, 'service-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperService', '')])),
                                    ('service_status', (YLeaf(YType.enumeration, 'service-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper', 'IedgeOperServiceStatus', '')])),
                                    ('service_id', (YLeaf(YType.uint32, 'service-id'), ['int'])),
                                    ('service_prepaid', (YLeaf(YType.boolean, 'service-prepaid'), ['bool'])),
                                ])
                                self.service_name = None
                                self.service_params = None
                                self.service_type = None
                                self.service_status = None
                                self.service_id = None
                                self.service_prepaid = None
                                self._segment_path = lambda: "session-service-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_.SessionServiceInfo, ['service_name', 'service_params', 'service_type', 'service_status', 'service_id', 'service_prepaid'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_.SessionServiceInfo']['meta_info']


                        class SessionChangeOfAuthorization(_Entity_):
                            """
                            Subscriber change of authorization information
                            
                            .. attribute:: request_acked
                            
                            	Coa Request Acked
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: request_time_epoch
                            
                            	Request time in epoch seconds
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: reply_time_epoch
                            
                            	Reply time in epoch seconds
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'iedge4710-oper'
                            _revision = '2018-09-20'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Subscriber.Session.Nodes.Node.Sessions.Session_.SessionChangeOfAuthorization, self).__init__()

                                self.yang_name = "session-change-of-authorization"
                                self.yang_parent_name = "session"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('request_acked', (YLeaf(YType.boolean, 'request-acked'), ['bool'])),
                                    ('request_time_epoch', (YLeaf(YType.uint64, 'request-time-epoch'), ['int'])),
                                    ('reply_time_epoch', (YLeaf(YType.uint64, 'reply-time-epoch'), ['int'])),
                                ])
                                self.request_acked = None
                                self.request_time_epoch = None
                                self.reply_time_epoch = None
                                self._segment_path = lambda: "session-change-of-authorization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Subscriber.Session.Nodes.Node.Sessions.Session_.SessionChangeOfAuthorization, ['request_acked', 'request_time_epoch', 'reply_time_epoch'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                                return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_.SessionChangeOfAuthorization']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                            return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions.Session_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                        return meta._meta_table['Subscriber.Session.Nodes.Node.Sessions']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                    return meta._meta_table['Subscriber.Session.Nodes.Node']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                return meta._meta_table['Subscriber.Session.Nodes']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
            return meta._meta_table['Subscriber.Session']['meta_info']

    def clone_ptr(self):
        self._top_entity = Subscriber()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['Subscriber']['meta_info']


class IedgeLicenseManager(_Entity_):
    """
    iedge license manager
    
    .. attribute:: nodes
    
    	Session License Manager operational data for a location
    	**type**\:  :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeLicenseManager.Nodes>`
    
    	**config**\: False
    
    

    """

    _prefix = 'iedge4710-oper'
    _revision = '2018-09-20'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(IedgeLicenseManager, self).__init__()
        self._top_entity = None

        self.yang_name = "iedge-license-manager"
        self.yang_parent_name = "Cisco-IOS-XR-iedge4710-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("nodes", ("nodes", IedgeLicenseManager.Nodes))])
        self._leafs = OrderedDict()

        self.nodes = IedgeLicenseManager.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._segment_path = lambda: "Cisco-IOS-XR-iedge4710-oper:iedge-license-manager"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(IedgeLicenseManager, [], name, value)


    class Nodes(_Entity_):
        """
        Session License Manager operational data for a
        location
        
        .. attribute:: node
        
        	Location. For example, 0/1/CPU0
        	**type**\: list of  		 :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeLicenseManager.Nodes.Node>`
        
        	**config**\: False
        
        

        """

        _prefix = 'iedge4710-oper'
        _revision = '2018-09-20'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(IedgeLicenseManager.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "iedge-license-manager"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("node", ("node", IedgeLicenseManager.Nodes.Node))])
            self._leafs = OrderedDict()

            self.node = YList(self)
            self._segment_path = lambda: "nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:iedge-license-manager/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(IedgeLicenseManager.Nodes, [], name, value)


        class Node(_Entity_):
            """
            Location. For example, 0/1/CPU0
            
            .. attribute:: nodeid  (key)
            
            	The node id to filter on. For example, 0/1/CPU0
            	**type**\: str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            	**config**\: False
            
            .. attribute:: iedge_license_manager_summary
            
            	Display Session License Manager summary data
            	**type**\:  :py:class:`IedgeLicenseManagerSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_iedge4710_oper.IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary>`
            
            	**config**\: False
            
            

            """

            _prefix = 'iedge4710-oper'
            _revision = '2018-09-20'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(IedgeLicenseManager.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['nodeid']
                self._child_classes = OrderedDict([("iedge-license-manager-summary", ("iedge_license_manager_summary", IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary))])
                self._leafs = OrderedDict([
                    ('nodeid', (YLeaf(YType.str, 'nodeid'), ['str'])),
                ])
                self.nodeid = None

                self.iedge_license_manager_summary = IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary()
                self.iedge_license_manager_summary.parent = self
                self._children_name_map["iedge_license_manager_summary"] = "iedge-license-manager-summary"
                self._segment_path = lambda: "node" + "[nodeid='" + str(self.nodeid) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-iedge4710-oper:iedge-license-manager/nodes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(IedgeLicenseManager.Nodes.Node, ['nodeid'], name, value)


            class IedgeLicenseManagerSummary(_Entity_):
                """
                Display Session License Manager summary data
                
                .. attribute:: session_limit
                
                	configured session limit
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_threshold
                
                	configured session threshold
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_license_count
                
                	number of license
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_count
                
                	number of sessions
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'iedge4710-oper'
                _revision = '2018-09-20'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary, self).__init__()

                    self.yang_name = "iedge-license-manager-summary"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_limit', (YLeaf(YType.uint32, 'session-limit'), ['int'])),
                        ('session_threshold', (YLeaf(YType.uint32, 'session-threshold'), ['int'])),
                        ('session_license_count', (YLeaf(YType.uint32, 'session-license-count'), ['int'])),
                        ('session_count', (YLeaf(YType.uint32, 'session-count'), ['int'])),
                    ])
                    self.session_limit = None
                    self.session_threshold = None
                    self.session_license_count = None
                    self.session_count = None
                    self._segment_path = lambda: "iedge-license-manager-summary"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary, ['session_limit', 'session_threshold', 'session_license_count', 'session_count'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                    return meta._meta_table['IedgeLicenseManager.Nodes.Node.IedgeLicenseManagerSummary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
                return meta._meta_table['IedgeLicenseManager.Nodes.Node']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
            return meta._meta_table['IedgeLicenseManager.Nodes']['meta_info']

    def clone_ptr(self):
        self._top_entity = IedgeLicenseManager()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_iedge4710_oper as meta
        return meta._meta_table['IedgeLicenseManager']['meta_info']


