""" Cisco_IOS_XR_infra_rcmd_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR infra\-rcmd package operational data.

This module contains definitions
for the following management objects\:
  rcmd\: Show command for Route Convergence Monitoring &
    Diagnostics

Copyright (c) 2013\-2018 by Cisco Systems, Inc.
All rights reserved.

"""
import sys
from collections import OrderedDict

from ydk.types import Entity as _Entity_
from ydk.types import EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class RcmdBagEnableDisable(Enum):
    """
    RcmdBagEnableDisable (Enum Class)

    status enum

    .. data:: disable = 0

    	Disabled

    .. data:: enable = 1

    	Enabled

    """

    disable = Enum.YLeaf(0, "disable")

    enable = Enum.YLeaf(1, "enable")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdBagEnableDisable']


class RcmdBagEnblDsbl(Enum):
    """
    RcmdBagEnblDsbl (Enum Class)

    status enum

    .. data:: dsbl = 0

    	Disabled

    .. data:: enbl = 1

    	Enabled

    """

    dsbl = Enum.YLeaf(0, "dsbl")

    enbl = Enum.YLeaf(1, "enbl")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdBagEnblDsbl']


class RcmdBoolYesNo(Enum):
    """
    RcmdBoolYesNo (Enum Class)

    Boolean enum

    .. data:: no = 0

    	No

    .. data:: yes = 1

    	Yes

    """

    no = Enum.YLeaf(0, "no")

    yes = Enum.YLeaf(1, "yes")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdBoolYesNo']


class RcmdChange(Enum):
    """
    RcmdChange (Enum Class)

    Type of change

    .. data:: none = 0

    	Invalid

    .. data:: add = 1

    	Added

    .. data:: delete = 2

    	Deleted

    .. data:: modify = 3

    	Modified

    .. data:: no_change = 4

    	No Change

    """

    none = Enum.YLeaf(0, "none")

    add = Enum.YLeaf(1, "add")

    delete = Enum.YLeaf(2, "delete")

    modify = Enum.YLeaf(3, "modify")

    no_change = Enum.YLeaf(4, "no-change")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdChange']


class RcmdIsisLvl(Enum):
    """
    RcmdIsisLvl (Enum Class)

    Type of an ISIS Level

    .. data:: l1 = 0

    	Level 1

    .. data:: l2 = 1

    	Level 2

    """

    l1 = Enum.YLeaf(0, "l1")

    l2 = Enum.YLeaf(1, "l2")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdIsisLvl']


class RcmdIsisSpf(Enum):
    """
    RcmdIsisSpf (Enum Class)

    Type of an ISIS SPF run

    .. data:: full = 0

    	Full

    .. data:: incremental = 1

    	Incremental

    .. data:: next_hop = 2

    	Next hop calculation

    .. data:: partial_route = 3

    	Partial route calculation

    """

    full = Enum.YLeaf(0, "full")

    incremental = Enum.YLeaf(1, "incremental")

    next_hop = Enum.YLeaf(2, "next-hop")

    partial_route = Enum.YLeaf(3, "partial-route")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdIsisSpf']


class RcmdLdpEvent(Enum):
    """
    RcmdLdpEvent (Enum Class)

    Type of LDP Event

    .. data:: neighbor = 1

    	Neighbor Event

    .. data:: adjacency = 2

    	Adjacency Event

    """

    neighbor = Enum.YLeaf(1, "neighbor")

    adjacency = Enum.YLeaf(2, "adjacency")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdLdpEvent']


class RcmdLinecardSpeed(Enum):
    """
    RcmdLinecardSpeed (Enum Class)

    Comparative speed of programming on linecard

    .. data:: other = 0

    	Other linecard

    .. data:: fastest = 1

    	Fastest linecard

    .. data:: slowest = 2

    	Slowest linecard

    """

    other = Enum.YLeaf(0, "other")

    fastest = Enum.YLeaf(1, "fastest")

    slowest = Enum.YLeaf(2, "slowest")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdLinecardSpeed']


class RcmdLsChange(Enum):
    """
    RcmdLsChange (Enum Class)

    Type of change

    .. data:: new = 0

    	Added

    .. data:: delete = 1

    	Deleted

    .. data:: modify = 2

    	Modified

    .. data:: noop = 3

    	No operation

    """

    new = Enum.YLeaf(0, "new")

    delete = Enum.YLeaf(1, "delete")

    modify = Enum.YLeaf(2, "modify")

    noop = Enum.YLeaf(3, "noop")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdLsChange']


class RcmdLsa(Enum):
    """
    RcmdLsa (Enum Class)

    Type of LSA

    .. data:: unknown = 0

    	Invalid LSA

    .. data:: router = 1

    	Router LSA

    .. data:: network = 2

    	Network LSA

    .. data:: summary = 3

    	Summary LSA

    .. data:: asbr = 4

    	ASBR LSA

    .. data:: external = 5

    	External LSA

    .. data:: multicast = 6

    	Multicast LSA

    .. data:: nssa = 7

    	NSSA LSA

    """

    unknown = Enum.YLeaf(0, "unknown")

    router = Enum.YLeaf(1, "router")

    network = Enum.YLeaf(2, "network")

    summary = Enum.YLeaf(3, "summary")

    asbr = Enum.YLeaf(4, "asbr")

    external = Enum.YLeaf(5, "external")

    multicast = Enum.YLeaf(6, "multicast")

    nssa = Enum.YLeaf(7, "nssa")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdLsa']


class RcmdPriorityLevel(Enum):
    """
    RcmdPriorityLevel (Enum Class)

    Level of priority

    .. data:: critical = 0

    	Critical

    .. data:: high = 1

    	High

    .. data:: medium = 2

    	Medium

    .. data:: low = 3

    	Low

    """

    critical = Enum.YLeaf(0, "critical")

    high = Enum.YLeaf(1, "high")

    medium = Enum.YLeaf(2, "medium")

    low = Enum.YLeaf(3, "low")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdPriorityLevel']


class RcmdProtocolId(Enum):
    """
    RcmdProtocolId (Enum Class)

    Protocol Info

    .. data:: ospf = 0

    	OSPF protocol

    .. data:: isis = 1

    	ISIS Prrotocol

    .. data:: na = 2

    	Max NA

    """

    ospf = Enum.YLeaf(0, "ospf")

    isis = Enum.YLeaf(1, "isis")

    na = Enum.YLeaf(2, "na")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdProtocolId']


class RcmdShowCompId(Enum):
    """
    RcmdShowCompId (Enum Class)

    Component Info

    .. data:: ospf = 0

    	OSPF component

    .. data:: isis = 1

    	ISIS component

    .. data:: un_known = 2

    	Max NA

    """

    ospf = Enum.YLeaf(0, "ospf")

    isis = Enum.YLeaf(1, "isis")

    un_known = Enum.YLeaf(2, "un-known")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowCompId']


class RcmdShowInstState(Enum):
    """
    RcmdShowInstState (Enum Class)

    instance state

    .. data:: unknown = 0

    	Unknown state

    .. data:: active = 1

    	Active state

    .. data:: in_active = 2

    	InActive state

    .. data:: na = 3

    	Max state

    """

    unknown = Enum.YLeaf(0, "unknown")

    active = Enum.YLeaf(1, "active")

    in_active = Enum.YLeaf(2, "in-active")

    na = Enum.YLeaf(3, "na")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowInstState']


class RcmdShowIntfEvent(Enum):
    """
    RcmdShowIntfEvent (Enum Class)

    Rcmd show intf event

    .. data:: create = 1

    	Create

    .. data:: delete = 2

    	Delete

    .. data:: link_up = 3

    	LinkUp

    .. data:: link_down = 4

    	LinkDown

    .. data:: primary_address = 5

    	PrimaryAddress

    .. data:: secondary_address = 6

    	SecondaryAddress

    .. data:: ipv6_link_local_address = 7

    	Ipv6LinkLocalAddress

    .. data:: ipv6_global_address = 8

    	Ipv6GlobalAddress

    .. data:: mtu = 9

    	MTU

    .. data:: band_width = 10

    	BandWidth

    .. data:: ldp_sync = 11

    	LDPSync

    .. data:: forward_reference = 12

    	ForwardReference

    .. data:: ldp_no_sync = 13

    	LDPNoSync

    """

    create = Enum.YLeaf(1, "create")

    delete = Enum.YLeaf(2, "delete")

    link_up = Enum.YLeaf(3, "link-up")

    link_down = Enum.YLeaf(4, "link-down")

    primary_address = Enum.YLeaf(5, "primary-address")

    secondary_address = Enum.YLeaf(6, "secondary-address")

    ipv6_link_local_address = Enum.YLeaf(7, "ipv6-link-local-address")

    ipv6_global_address = Enum.YLeaf(8, "ipv6-global-address")

    mtu = Enum.YLeaf(9, "mtu")

    band_width = Enum.YLeaf(10, "band-width")

    ldp_sync = Enum.YLeaf(11, "ldp-sync")

    forward_reference = Enum.YLeaf(12, "forward-reference")

    ldp_no_sync = Enum.YLeaf(13, "ldp-no-sync")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowIntfEvent']


class RcmdShowIpfrrLfa(Enum):
    """
    RcmdShowIpfrrLfa (Enum Class)

    IP Frr LFA Types

    .. data:: none = 0

    	No IP Frr LFA Type 

    .. data:: local = 1

    	IP Frr Local LFA

    .. data:: remote = 2

    	IP Frr Remote LFA

    """

    none = Enum.YLeaf(0, "none")

    local = Enum.YLeaf(1, "local")

    remote = Enum.YLeaf(2, "remote")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowIpfrrLfa']


class RcmdShowLdpConvState(Enum):
    """
    RcmdShowLdpConvState (Enum Class)

    LDP Convergence States

    .. data:: not_full = 0

    	Not Fully Covered

    .. data:: fully_covered = 1

    	Fully Covered

    .. data:: coverage_above_threshold = 2

    	Backup Coverage Above Threshold

    .. data:: coverage_below_threshold = 3

    	Backup Coverage Below Threshold

    .. data:: coverage_flapping = 4

    	Backup Coverage is Flappping

    """

    not_full = Enum.YLeaf(0, "not-full")

    fully_covered = Enum.YLeaf(1, "fully-covered")

    coverage_above_threshold = Enum.YLeaf(2, "coverage-above-threshold")

    coverage_below_threshold = Enum.YLeaf(3, "coverage-below-threshold")

    coverage_flapping = Enum.YLeaf(4, "coverage-flapping")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowLdpConvState']


class RcmdShowLdpNeighbourStatus(Enum):
    """
    RcmdShowLdpNeighbourStatus (Enum Class)

    LDP Adjacency Session Status

    .. data:: down = 0

    	Down State

    .. data:: up = 1

    	Up State

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowLdpNeighbourStatus']


class RcmdShowLdpSessionState(Enum):
    """
    RcmdShowLdpSessionState (Enum Class)

    LDP Session State

    .. data:: gr_down = 0

    	GR Down State

    .. data:: gr_converging = 1

    	GR Converging State

    .. data:: establishing = 2

    	Establishing State

    .. data:: converging = 3

    	Converging State

    .. data:: converged = 4

    	Converged State

    .. data:: retrying = 5

    	Retrying State

    .. data:: total = 6

    	Cumulative Coverage for all the States

    """

    gr_down = Enum.YLeaf(0, "gr-down")

    gr_converging = Enum.YLeaf(1, "gr-converging")

    establishing = Enum.YLeaf(2, "establishing")

    converging = Enum.YLeaf(3, "converging")

    converged = Enum.YLeaf(4, "converged")

    retrying = Enum.YLeaf(5, "retrying")

    total = Enum.YLeaf(6, "total")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowLdpSessionState']


class RcmdShowMem(Enum):
    """
    RcmdShowMem (Enum Class)

    RCMD Memory Manager type

    .. data:: standard = 0

    	Standard type

    .. data:: chunk = 1

    	Chunk type

    .. data:: edm = 2

    	EDM type

    .. data:: string = 3

    	String type

    .. data:: static = 4

    	Static type

    .. data:: unknown = 5

    	Unknown type

    """

    standard = Enum.YLeaf(0, "standard")

    chunk = Enum.YLeaf(1, "chunk")

    edm = Enum.YLeaf(2, "edm")

    string = Enum.YLeaf(3, "string")

    static = Enum.YLeaf(4, "static")

    unknown = Enum.YLeaf(5, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowMem']


class RcmdShowNode(Enum):
    """
    RcmdShowNode (Enum Class)

    Type of Node

    .. data:: unknown = 0

    	Unknown Type

    .. data:: lc = 1

    	LC Type

    .. data:: rp = 2

    	RP Type

    """

    unknown = Enum.YLeaf(0, "unknown")

    lc = Enum.YLeaf(1, "lc")

    rp = Enum.YLeaf(2, "rp")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowNode']


class RcmdShowPrcsState(Enum):
    """
    RcmdShowPrcsState (Enum Class)

    Post Processing Info

    .. data:: success = 0

    	Success

    .. data:: cpu = 1

    	Cpu overload

    .. data:: memory = 2

    	Memory overload

    """

    success = Enum.YLeaf(0, "success")

    cpu = Enum.YLeaf(1, "cpu")

    memory = Enum.YLeaf(2, "memory")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowPrcsState']


class RcmdShowRoute(Enum):
    """
    RcmdShowRoute (Enum Class)

    Route Types

    .. data:: ospf = 0

    	OSPF route init

    .. data:: intra = 1

    	OSPF Intra route

    .. data:: inter = 2

    	OSPF Inter route

    .. data:: ext_1 = 3

    	OSPF External Type-1 Route

    .. data:: ext_2 = 4

    	OSPF External Type-2 Route

    .. data:: nssa_1 = 5

    	OSPF NSSA Type-1 Route

    .. data:: nssa_2 = 6

    	OSPF NSSA Type-2 Route

    .. data:: isis = 7

    	ISIS route init

    .. data:: l1_summary = 8

    	ISIS L1 Summary

    .. data:: l1 = 9

    	ISIS L1

    .. data:: l2_summary = 10

    	ISIS L2 Summary

    .. data:: l2 = 11

    	ISIS L2

    .. data:: inter_area_summary = 12

    	ISIS Inter Area Summary

    .. data:: inter_area = 13

    	ISIS Inter Area

    .. data:: default_attached = 14

    	ISIS Default Route Attached

    """

    ospf = Enum.YLeaf(0, "ospf")

    intra = Enum.YLeaf(1, "intra")

    inter = Enum.YLeaf(2, "inter")

    ext_1 = Enum.YLeaf(3, "ext-1")

    ext_2 = Enum.YLeaf(4, "ext-2")

    nssa_1 = Enum.YLeaf(5, "nssa-1")

    nssa_2 = Enum.YLeaf(6, "nssa-2")

    isis = Enum.YLeaf(7, "isis")

    l1_summary = Enum.YLeaf(8, "l1-summary")

    l1 = Enum.YLeaf(9, "l1")

    l2_summary = Enum.YLeaf(10, "l2-summary")

    l2 = Enum.YLeaf(11, "l2")

    inter_area_summary = Enum.YLeaf(12, "inter-area-summary")

    inter_area = Enum.YLeaf(13, "inter-area")

    default_attached = Enum.YLeaf(14, "default-attached")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowRoute']


class RcmdShowRoutePathChange(Enum):
    """
    RcmdShowRoutePathChange (Enum Class)

    Type of route change

    .. data:: primary = 0

    	Primary path is changed

    .. data:: backup = 1

    	Backup path is changed

    """

    primary = Enum.YLeaf(0, "primary")

    backup = Enum.YLeaf(1, "backup")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdShowRoutePathChange']


class RcmdSpfState(Enum):
    """
    RcmdSpfState (Enum Class)

    Type of an ISIS Level

    .. data:: complete = 0

    	Complete

    .. data:: in_complete = 1

    	InComplete

    .. data:: collecting = 2

    	Collecting data

    .. data:: no_route_change = 3

    	No Route Change

    """

    complete = Enum.YLeaf(0, "complete")

    in_complete = Enum.YLeaf(1, "in-complete")

    collecting = Enum.YLeaf(2, "collecting")

    no_route_change = Enum.YLeaf(3, "no-route-change")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['RcmdSpfState']



class Rcmd(_Entity_):
    """
    Show command for Route Convergence Monitoring &
    Diagnostics
    
    .. attribute:: ospf
    
    	Operational data for OSPF
    	**type**\:  :py:class:`Ospf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf>`
    
    	**config**\: False
    
    .. attribute:: server
    
    	Server Info
    	**type**\:  :py:class:`Server <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server>`
    
    	**config**\: False
    
    .. attribute:: node
    
    	Node Info
    	**type**\:  :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Node>`
    
    	**config**\: False
    
    .. attribute:: isis
    
    	Operational data for ISIS
    	**type**\:  :py:class:`Isis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis>`
    
    	**config**\: False
    
    .. attribute:: memory
    
    	Memory Info
    	**type**\:  :py:class:`Memory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Memory>`
    
    	**config**\: False
    
    .. attribute:: ldp
    
    	LDP data
    	**type**\:  :py:class:`Ldp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp>`
    
    	**config**\: False
    
    .. attribute:: intf
    
    	Interface data
    	**type**\:  :py:class:`Intf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Intf>`
    
    	**config**\: False
    
    .. attribute:: process
    
    	Process information
    	**type**\:  :py:class:`Process <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process>`
    
    	**config**\: False
    
    

    """

    _prefix = 'infra-rcmd-oper'
    _revision = '2015-11-09'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(Rcmd, self).__init__()
        self._top_entity = None

        self.yang_name = "rcmd"
        self.yang_parent_name = "Cisco-IOS-XR-infra-rcmd-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("ospf", ("ospf", Rcmd.Ospf)), ("server", ("server", Rcmd.Server)), ("node", ("node", Rcmd.Node)), ("isis", ("isis", Rcmd.Isis)), ("memory", ("memory", Rcmd.Memory)), ("ldp", ("ldp", Rcmd.Ldp)), ("intf", ("intf", Rcmd.Intf)), ("process", ("process", Rcmd.Process))])
        self._leafs = OrderedDict()

        self.ospf = Rcmd.Ospf()
        self.ospf.parent = self
        self._children_name_map["ospf"] = "ospf"

        self.server = Rcmd.Server()
        self.server.parent = self
        self._children_name_map["server"] = "server"

        self.node = Rcmd.Node()
        self.node.parent = self
        self._children_name_map["node"] = "node"

        self.isis = Rcmd.Isis()
        self.isis.parent = self
        self._children_name_map["isis"] = "isis"

        self.memory = Rcmd.Memory()
        self.memory.parent = self
        self._children_name_map["memory"] = "memory"

        self.ldp = Rcmd.Ldp()
        self.ldp.parent = self
        self._children_name_map["ldp"] = "ldp"

        self.intf = Rcmd.Intf()
        self.intf.parent = self
        self._children_name_map["intf"] = "intf"

        self.process = Rcmd.Process()
        self.process.parent = self
        self._children_name_map["process"] = "process"
        self._segment_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(Rcmd, [], name, value)


    class Ospf(_Entity_):
        """
        Operational data for OSPF
        
        .. attribute:: instances
        
        	Operational data
        	**type**\:  :py:class:`Instances <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Ospf, self).__init__()

            self.yang_name = "ospf"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("instances", ("instances", Rcmd.Ospf.Instances))])
            self._leafs = OrderedDict()

            self.instances = Rcmd.Ospf.Instances()
            self.instances.parent = self
            self._children_name_map["instances"] = "instances"
            self._segment_path = lambda: "ospf"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Ospf, [], name, value)


        class Instances(_Entity_):
            """
            Operational data
            
            .. attribute:: instance
            
            	Operational data for a particular instance
            	**type**\: list of  		 :py:class:`Instance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Ospf.Instances, self).__init__()

                self.yang_name = "instances"
                self.yang_parent_name = "ospf"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("instance", ("instance", Rcmd.Ospf.Instances.Instance))])
                self._leafs = OrderedDict()

                self.instance = YList(self)
                self._segment_path = lambda: "instances"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ospf/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Ospf.Instances, [], name, value)


            class Instance(_Entity_):
                """
                Operational data for a particular instance
                
                .. attribute:: instance_name  (key)
                
                	Operational data for a particular instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_summaries
                
                	OSPF IP\-FRR events summary data
                	**type**\:  :py:class:`IpfrrEventSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_statistics
                
                	OSPF Prefix events summary data
                	**type**\:  :py:class:`PrefixEventStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventStatistics>`
                
                	**config**\: False
                
                .. attribute:: spf_run_summaries
                
                	OSPF SPF run summary data
                	**type**\:  :py:class:`SpfRunSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries>`
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_offlines
                
                	OSPF IP\-FRR Event offline data
                	**type**\:  :py:class:`IpfrrEventOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines>`
                
                	**config**\: False
                
                .. attribute:: spf_run_offlines
                
                	OSPF SPF run offline data
                	**type**\:  :py:class:`SpfRunOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines>`
                
                	**config**\: False
                
                .. attribute:: summary_external_event_summaries
                
                	OSPF Summary\-External Prefix events summary data
                	**type**\:  :py:class:`SummaryExternalEventSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_summaries
                
                	OSPF Prefix events summary data
                	**type**\:  :py:class:`PrefixEventSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries>`
                
                	**config**\: False
                
                .. attribute:: summary_external_event_offlines
                
                	OSPF Summary\-External Prefix events offline data
                	**type**\:  :py:class:`SummaryExternalEventOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_offlines
                
                	OSPF Prefix events offline data
                	**type**\:  :py:class:`PrefixEventOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines>`
                
                	**config**\: False
                
                .. attribute:: summary_external_event_statistics
                
                	Summary\-External prefix monitoring statistics
                	**type**\:  :py:class:`SummaryExternalEventStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Ospf.Instances.Instance, self).__init__()

                    self.yang_name = "instance"
                    self.yang_parent_name = "instances"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['instance_name']
                    self._child_classes = OrderedDict([("ipfrr-event-summaries", ("ipfrr_event_summaries", Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries)), ("prefix-event-statistics", ("prefix_event_statistics", Rcmd.Ospf.Instances.Instance.PrefixEventStatistics)), ("spf-run-summaries", ("spf_run_summaries", Rcmd.Ospf.Instances.Instance.SpfRunSummaries)), ("ipfrr-event-offlines", ("ipfrr_event_offlines", Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines)), ("spf-run-offlines", ("spf_run_offlines", Rcmd.Ospf.Instances.Instance.SpfRunOfflines)), ("summary-external-event-summaries", ("summary_external_event_summaries", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries)), ("prefix-event-summaries", ("prefix_event_summaries", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries)), ("summary-external-event-offlines", ("summary_external_event_offlines", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines)), ("prefix-event-offlines", ("prefix_event_offlines", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines)), ("summary-external-event-statistics", ("summary_external_event_statistics", Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics))])
                    self._leafs = OrderedDict([
                        ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ])
                    self.instance_name = None

                    self.ipfrr_event_summaries = Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries()
                    self.ipfrr_event_summaries.parent = self
                    self._children_name_map["ipfrr_event_summaries"] = "ipfrr-event-summaries"

                    self.prefix_event_statistics = Rcmd.Ospf.Instances.Instance.PrefixEventStatistics()
                    self.prefix_event_statistics.parent = self
                    self._children_name_map["prefix_event_statistics"] = "prefix-event-statistics"

                    self.spf_run_summaries = Rcmd.Ospf.Instances.Instance.SpfRunSummaries()
                    self.spf_run_summaries.parent = self
                    self._children_name_map["spf_run_summaries"] = "spf-run-summaries"

                    self.ipfrr_event_offlines = Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines()
                    self.ipfrr_event_offlines.parent = self
                    self._children_name_map["ipfrr_event_offlines"] = "ipfrr-event-offlines"

                    self.spf_run_offlines = Rcmd.Ospf.Instances.Instance.SpfRunOfflines()
                    self.spf_run_offlines.parent = self
                    self._children_name_map["spf_run_offlines"] = "spf-run-offlines"

                    self.summary_external_event_summaries = Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries()
                    self.summary_external_event_summaries.parent = self
                    self._children_name_map["summary_external_event_summaries"] = "summary-external-event-summaries"

                    self.prefix_event_summaries = Rcmd.Ospf.Instances.Instance.PrefixEventSummaries()
                    self.prefix_event_summaries.parent = self
                    self._children_name_map["prefix_event_summaries"] = "prefix-event-summaries"

                    self.summary_external_event_offlines = Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines()
                    self.summary_external_event_offlines.parent = self
                    self._children_name_map["summary_external_event_offlines"] = "summary-external-event-offlines"

                    self.prefix_event_offlines = Rcmd.Ospf.Instances.Instance.PrefixEventOfflines()
                    self.prefix_event_offlines.parent = self
                    self._children_name_map["prefix_event_offlines"] = "prefix-event-offlines"

                    self.summary_external_event_statistics = Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics()
                    self.summary_external_event_statistics.parent = self
                    self._children_name_map["summary_external_event_statistics"] = "summary-external-event-statistics"
                    self._segment_path = lambda: "instance" + "[instance-name='" + str(self.instance_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ospf/instances/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Ospf.Instances.Instance, ['instance_name'], name, value)


                class IpfrrEventSummaries(_Entity_):
                    """
                    OSPF IP\-FRR events summary data
                    
                    .. attribute:: ipfrr_event_summary
                    
                    	IP\-FRR Event data
                    	**type**\: list of  		 :py:class:`IpfrrEventSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries, self).__init__()

                        self.yang_name = "ipfrr-event-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipfrr-event-summary", ("ipfrr_event_summary", Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary))])
                        self._leafs = OrderedDict()

                        self.ipfrr_event_summary = YList(self)
                        self._segment_path = lambda: "ipfrr-event-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries, [], name, value)


                    class IpfrrEventSummary(_Entity_):
                        """
                        IP\-FRR Event data
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific IP\-FRR Event
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: event_id_xr
                        
                        	IP\-Frr Event ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Trigger time  (eg\: Apr 24 13\:16\:04.961)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_spf_run
                        
                        	IP\-Frr Triggered reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Waiting Time (in milliseconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: start_time_offset
                        
                        	Start Time offset from trigger time (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: duration
                        
                        	Duration for the calculation (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: completed_spf_run
                        
                        	IP\-Frr Completed reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_routes
                        
                        	Cumulative Number of Routes for all priorities
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fully_protected_routes
                        
                        	Cumulative Number of Fully Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: partially_protected_routes
                        
                        	Cumulative Number of Partially Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: coverage
                        
                        	Coverage in percentage for all priorities
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: percentage
                        
                        .. attribute:: ipfrr_statistic
                        
                        	IP\-Frr Statistics categorized by priority
                        	**type**\: list of  		 :py:class:`IpfrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_node
                        
                        	Remote Node Information
                        	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary, self).__init__()

                            self.yang_name = "ipfrr-event-summary"
                            self.yang_parent_name = "ipfrr-event-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ipfrr-statistic", ("ipfrr_statistic", Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic)), ("remote-node", ("remote_node", Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                ('trigger_spf_run', (YLeaf(YType.uint32, 'trigger-spf-run'), ['int'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('start_time_offset', (YLeaf(YType.str, 'start-time-offset'), ['str'])),
                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ('completed_spf_run', (YLeaf(YType.uint32, 'completed-spf-run'), ['int'])),
                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                            ])
                            self.event_id = None
                            self.event_id_xr = None
                            self.trigger_time = None
                            self.trigger_spf_run = None
                            self.wait_time = None
                            self.start_time_offset = None
                            self.duration = None
                            self.completed_spf_run = None
                            self.total_routes = None
                            self.fully_protected_routes = None
                            self.partially_protected_routes = None
                            self.coverage = None

                            self.ipfrr_statistic = YList(self)
                            self.remote_node = YList(self)
                            self._segment_path = lambda: "ipfrr-event-summary" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary, ['event_id', 'event_id_xr', 'trigger_time', 'trigger_spf_run', 'wait_time', 'start_time_offset', 'duration', 'completed_spf_run', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)


                        class IpfrrStatistic(_Entity_):
                            """
                            IP\-Frr Statistics categorized by priority
                            
                            .. attribute:: priority
                            
                            	Priority
                            	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                            
                            	**config**\: False
                            
                            .. attribute:: total_routes
                            
                            	Total Number of Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fully_protected_routes
                            
                            	Fully Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: partially_protected_routes
                            
                            	Partially Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: coverage
                            
                            	Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: local_lfa_coverage
                            
                            	Local LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: remote_lfa_coverage
                            
                            	Remote LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: below_threshold
                            
                            	Covearge is below Configured Threshold
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic, self).__init__()

                                self.yang_name = "ipfrr-statistic"
                                self.yang_parent_name = "ipfrr-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                    ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                    ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                    ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                    ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                    ('local_lfa_coverage', (YLeaf(YType.str, 'local-lfa-coverage'), ['str'])),
                                    ('remote_lfa_coverage', (YLeaf(YType.str, 'remote-lfa-coverage'), ['str'])),
                                    ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                                ])
                                self.priority = None
                                self.total_routes = None
                                self.fully_protected_routes = None
                                self.partially_protected_routes = None
                                self.coverage = None
                                self.local_lfa_coverage = None
                                self.remote_lfa_coverage = None
                                self.below_threshold = None
                                self._segment_path = lambda: "ipfrr-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic, ['priority', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage', 'local_lfa_coverage', 'remote_lfa_coverage', 'below_threshold'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic']['meta_info']


                        class RemoteNode(_Entity_):
                            """
                            Remote Node Information
                            
                            .. attribute:: remote_node_id
                            
                            	Remote\-LFA Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_count
                            
                            	Number of paths protected by this Remote Node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: in_use_time
                            
                            	Inuse time of the Remote Node (eg\: Apr 24 13\:16 \:04.961)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: primary_path
                            
                            	Protected Primary Paths
                            	**type**\: list of  		 :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode, self).__init__()

                                self.yang_name = "remote-node"
                                self.yang_parent_name = "ipfrr-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-path", ("primary_path", Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath))])
                                self._leafs = OrderedDict([
                                    ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                                    ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                                ])
                                self.remote_node_id = None
                                self.interface_name = None
                                self.neighbour_address = None
                                self.path_count = None
                                self.in_use_time = None

                                self.primary_path = YList(self)
                                self._segment_path = lambda: "remote-node"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode, ['remote_node_id', 'interface_name', 'neighbour_address', 'path_count', 'in_use_time'], name, value)


                            class PrimaryPath(_Entity_):
                                """
                                Protected Primary Paths
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath, self).__init__()

                                    self.yang_name = "primary-path"
                                    self.yang_parent_name = "remote-node"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ])
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self._segment_path = lambda: "primary-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath, ['interface_name', 'neighbour_address'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventSummaries']['meta_info']


                class PrefixEventStatistics(_Entity_):
                    """
                    OSPF Prefix events summary data
                    
                    .. attribute:: prefix_event_statistic
                    
                    	Prefix Event statistics
                    	**type**\: list of  		 :py:class:`PrefixEventStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.PrefixEventStatistics, self).__init__()

                        self.yang_name = "prefix-event-statistics"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-statistic", ("prefix_event_statistic", Rcmd.Ospf.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic))])
                        self._leafs = OrderedDict()

                        self.prefix_event_statistic = YList(self)
                        self._segment_path = lambda: "prefix-event-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventStatistics, [], name, value)


                    class PrefixEventStatistic(_Entity_):
                        """
                        Prefix Event statistics
                        
                        .. attribute:: prefix_info  (key)
                        
                        	Events with Prefix
                        	**type**\: union of the below types:
                        
                        		**type**\: str
                        
                        			**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                        
                        		**type**\: str
                        
                        			**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_event_time
                        
                        	Last event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: last_priority
                        
                        	Last event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_route_type
                        
                        	Last event Route Type
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_change_type
                        
                        	Last event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_cost
                        
                        	Last Known Cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: critical_priority
                        
                        	No. of times processed under Critical Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_priority
                        
                        	No. of times processed under High Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: medium_priority
                        
                        	No. of times processed under Medium Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: low_priority
                        
                        	No. of times processed under Low Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: add_count
                        
                        	No. of times route gets Added
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: modify_count
                        
                        	No. of times route gets Deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: delete_count
                        
                        	No. of times route gets Deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceed_count
                        
                        	No. of times threshold got exceeded
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic, self).__init__()

                            self.yang_name = "prefix-event-statistic"
                            self.yang_parent_name = "prefix-event-statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['prefix_info']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('prefix_info', (YLeaf(YType.str, 'prefix-info'), ['str','str'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('last_event_time', (YLeaf(YType.str, 'last-event-time'), ['str'])),
                                ('last_priority', (YLeaf(YType.enumeration, 'last-priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('last_route_type', (YLeaf(YType.enumeration, 'last-route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('last_change_type', (YLeaf(YType.enumeration, 'last-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('last_cost', (YLeaf(YType.uint32, 'last-cost'), ['int'])),
                                ('critical_priority', (YLeaf(YType.uint32, 'critical-priority'), ['int'])),
                                ('high_priority', (YLeaf(YType.uint32, 'high-priority'), ['int'])),
                                ('medium_priority', (YLeaf(YType.uint32, 'medium-priority'), ['int'])),
                                ('low_priority', (YLeaf(YType.uint32, 'low-priority'), ['int'])),
                                ('add_count', (YLeaf(YType.uint32, 'add-count'), ['int'])),
                                ('modify_count', (YLeaf(YType.uint32, 'modify-count'), ['int'])),
                                ('delete_count', (YLeaf(YType.uint32, 'delete-count'), ['int'])),
                                ('threshold_exceed_count', (YLeaf(YType.uint32, 'threshold-exceed-count'), ['int'])),
                            ])
                            self.prefix_info = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.last_event_time = None
                            self.last_priority = None
                            self.last_route_type = None
                            self.last_change_type = None
                            self.last_cost = None
                            self.critical_priority = None
                            self.high_priority = None
                            self.medium_priority = None
                            self.low_priority = None
                            self.add_count = None
                            self.modify_count = None
                            self.delete_count = None
                            self.threshold_exceed_count = None
                            self._segment_path = lambda: "prefix-event-statistic" + "[prefix-info='" + str(self.prefix_info) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic, ['prefix_info', 'prefix', 'prefix_lenth', 'last_event_time', 'last_priority', 'last_route_type', 'last_change_type', 'last_cost', 'critical_priority', 'high_priority', 'medium_priority', 'low_priority', 'add_count', 'modify_count', 'delete_count', 'threshold_exceed_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventStatistics']['meta_info']


                class SpfRunSummaries(_Entity_):
                    """
                    OSPF SPF run summary data
                    
                    .. attribute:: spf_run_summary
                    
                    	SPF Event data
                    	**type**\: list of  		 :py:class:`SpfRunSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries, self).__init__()

                        self.yang_name = "spf-run-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("spf-run-summary", ("spf_run_summary", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary))])
                        self._leafs = OrderedDict()

                        self.spf_run_summary = YList(self)
                        self._segment_path = lambda: "spf-run-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries, [], name, value)


                    class SpfRunSummary(_Entity_):
                        """
                        SPF Event data
                        
                        .. attribute:: spf_run_number  (key)
                        
                        	Specific SPF run
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_summary
                        
                        	SPF summary information
                        	**type**\:  :py:class:`SpfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary>`
                        
                        	**config**\: False
                        
                        .. attribute:: dijkstra_run
                        
                        	List of Dijkstra runs
                        	**type**\: list of  		 :py:class:`DijkstraRun <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun>`
                        
                        	**config**\: False
                        
                        .. attribute:: inter_area_and_external
                        
                        	Inter\-area & external calculation information
                        	**type**\: list of  		 :py:class:`InterAreaAndExternal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary, self).__init__()

                            self.yang_name = "spf-run-summary"
                            self.yang_parent_name = "spf-run-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['spf_run_number']
                            self._child_classes = OrderedDict([("spf-summary", ("spf_summary", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary)), ("dijkstra-run", ("dijkstra_run", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun)), ("inter-area-and-external", ("inter_area_and_external", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal))])
                            self._leafs = OrderedDict([
                                ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                            ])
                            self.spf_run_number = None

                            self.spf_summary = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary()
                            self.spf_summary.parent = self
                            self._children_name_map["spf_summary"] = "spf-summary"

                            self.dijkstra_run = YList(self)
                            self.inter_area_and_external = YList(self)
                            self._segment_path = lambda: "spf-run-summary" + "[spf-run-number='" + str(self.spf_run_number) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary, ['spf_run_number'], name, value)


                        class SpfSummary(_Entity_):
                            """
                            SPF summary information
                            
                            .. attribute:: state
                            
                            	SPF state
                            	**type**\:  :py:class:`RcmdSpfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdSpfState>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_data_complete
                            
                            	Whether the event has all information
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: start_time
                            
                            	Start time (offset from event trigger time in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of complete SPF calculation (in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: total_dijkstra_runs
                            
                            	Total number of Dijkstra runs
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_inter_area_and_external_batches
                            
                            	Total number of inter\-area/external computation batches
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_type12lsa_changes
                            
                            	Total number of Type 1/2 LSA changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_type357lsa_changes
                            
                            	Total number of Type 3/5/7 LSA changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: priority_summary
                            
                            	Convergence information summary on per\-priority basis
                            	**type**\: list of  		 :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary, self).__init__()

                                self.yang_name = "spf-summary"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary))])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdSpfState', '')])),
                                    ('is_data_complete', (YLeaf(YType.boolean, 'is-data-complete'), ['bool'])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                    ('total_dijkstra_runs', (YLeaf(YType.uint16, 'total-dijkstra-runs'), ['int'])),
                                    ('total_inter_area_and_external_batches', (YLeaf(YType.uint16, 'total-inter-area-and-external-batches'), ['int'])),
                                    ('total_type12lsa_changes', (YLeaf(YType.uint16, 'total-type12lsa-changes'), ['int'])),
                                    ('total_type357lsa_changes', (YLeaf(YType.uint16, 'total-type357lsa-changes'), ['int'])),
                                ])
                                self.state = None
                                self.is_data_complete = None
                                self.threshold_exceeded = None
                                self.trigger_time = None
                                self.start_time = None
                                self.duration = None
                                self.total_dijkstra_runs = None
                                self.total_inter_area_and_external_batches = None
                                self.total_type12lsa_changes = None
                                self.total_type357lsa_changes = None

                                self.priority_summary = YList(self)
                                self._segment_path = lambda: "spf-summary"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary, ['state', 'is_data_complete', 'threshold_exceeded', 'trigger_time', 'start_time', 'duration', 'total_dijkstra_runs', 'total_inter_area_and_external_batches', 'total_type12lsa_changes', 'total_type357lsa_changes'], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Convergence information summary on per\-priority
                                basis
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "spf-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary']['meta_info']


                        class DijkstraRun(_Entity_):
                            """
                            List of Dijkstra runs
                            
                            .. attribute:: dijkstra_run_number
                            
                            	Area Dijkstra run number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: area_id
                            
                            	Area ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: start_time
                            
                            	Start time (offset from event trigger time in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: wait_time
                            
                            	Wait time (offset from event trigger time in ss .msec)
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of Dijktra calculation (in ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_lsa
                            
                            	LSA that triggered the Dijkstra run
                            	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.TriggerLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: priority
                            
                            	Convergence information on per\-priority basis
                            	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_processed
                            
                            	List of type 1/2 LSA changes processed
                            	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.LsaProcessed>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun, self).__init__()

                                self.yang_name = "dijkstra-run"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.TriggerLsa)), ("priority", ("priority", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.LsaProcessed))])
                                self._leafs = OrderedDict([
                                    ('dijkstra_run_number', (YLeaf(YType.uint32, 'dijkstra-run-number'), ['int'])),
                                    ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                    ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ])
                                self.dijkstra_run_number = None
                                self.area_id = None
                                self.threshold_exceeded = None
                                self.trigger_time = None
                                self.start_time = None
                                self.wait_time = None
                                self.duration = None

                                self.trigger_lsa = YList(self)
                                self.priority = YList(self)
                                self.lsa_processed = YList(self)
                                self._segment_path = lambda: "dijkstra-run"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun, ['dijkstra_run_number', 'area_id', 'threshold_exceeded', 'trigger_time', 'start_time', 'wait_time', 'duration'], name, value)


                            class TriggerLsa(_Entity_):
                                """
                                LSA that triggered the Dijkstra run
                                
                                .. attribute:: lsa_id
                                
                                	LSA ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sequence_number
                                
                                	Sequence Number
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsa_type
                                
                                	LSA type
                                	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                                
                                	**config**\: False
                                
                                .. attribute:: origin_router_id
                                
                                	Originating Router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Add, Delete, Modify
                                	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: reception_time
                                
                                	Reception Time on router (in hh\:mm\:ss.msec)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.TriggerLsa, self).__init__()

                                    self.yang_name = "trigger-lsa"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                        ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                        ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                        ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                        ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ])
                                    self.lsa_id = None
                                    self.sequence_number = None
                                    self.lsa_type = None
                                    self.origin_router_id = None
                                    self.change_type = None
                                    self.reception_time = None
                                    self._segment_path = lambda: "trigger-lsa"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.TriggerLsa']['meta_info']


                            class Priority(_Entity_):
                                """
                                Convergence information on per\-priority basis
                                
                                .. attribute:: priority_summary
                                
                                	Summary of the priority
                                	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary>`
                                
                                	**config**\: False
                                
                                .. attribute:: convergence_timeline
                                
                                	Convergence timeline details
                                	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_added
                                
                                	List of Leaf Networks Added
                                	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksAdded>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_deleted
                                
                                	List of Leaf Networks Deleted
                                	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksDeleted>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority, self).__init__()

                                    self.yang_name = "priority"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksDeleted))])
                                    self._leafs = OrderedDict()

                                    self.priority_summary = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary()
                                    self.priority_summary.parent = self
                                    self._children_name_map["priority_summary"] = "priority-summary"

                                    self.convergence_timeline = YList(self)
                                    self.leaf_networks_added = YList(self)
                                    self.leaf_networks_deleted = YList(self)
                                    self._segment_path = lambda: "priority"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority, [], name, value)


                                class PrioritySummary(_Entity_):
                                    """
                                    Summary of the priority
                                    
                                    .. attribute:: route_statistics
                                    
                                    	Route statistics
                                    	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_convergence_time
                                    
                                    	Convergence time for IP route programming
                                    	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mpls_convergence_time
                                    
                                    	Convergence time for MPLS label programming
                                    	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: level
                                    
                                    	Critical, High, Medium or Low
                                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_exceeded
                                    
                                    	Threshold exceeded
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_statistic
                                    
                                    	Fast Re\-Route Statistics
                                    	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.FrrStatistic>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary, self).__init__()

                                        self.yang_name = "priority-summary"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.FrrStatistic))])
                                        self._leafs = OrderedDict([
                                            ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                            ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                        ])
                                        self.level = None
                                        self.threshold_exceeded = None

                                        self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics()
                                        self.route_statistics.parent = self
                                        self._children_name_map["route_statistics"] = "route-statistics"

                                        self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime()
                                        self.ip_convergence_time.parent = self
                                        self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                        self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime()
                                        self.mpls_convergence_time.parent = self
                                        self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                        self.frr_statistic = YList(self)
                                        self._segment_path = lambda: "priority-summary"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                    class RouteStatistics(_Entity_):
                                        """
                                        Route statistics
                                        
                                        .. attribute:: adds
                                        
                                        	Added
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: deletes
                                        
                                        	Deleted
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: modifies
                                        
                                        	Modified
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: reachables
                                        
                                        	Reachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreachables
                                        
                                        	Unreachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: touches
                                        
                                        	Touched
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                            self.yang_name = "route-statistics"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                                ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                                ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                                ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                                ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                                ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                            ])
                                            self.adds = None
                                            self.deletes = None
                                            self.modifies = None
                                            self.reachables = None
                                            self.unreachables = None
                                            self.touches = None
                                            self._segment_path = lambda: "route-statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                    class IpConvergenceTime(_Entity_):
                                        """
                                        Convergence time for IP route programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                            self.yang_name = "ip-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "ip-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                    class MplsConvergenceTime(_Entity_):
                                        """
                                        Convergence time for MPLS label programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                            self.yang_name = "mpls-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "mpls-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']


                                    class FrrStatistic(_Entity_):
                                        """
                                        Fast Re\-Route Statistics
                                        
                                        .. attribute:: total_routes
                                        
                                        	Total Number of Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fully_protected_routes
                                        
                                        	Fully Protected Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: partially_protected_routes
                                        
                                        	Partially Protected Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: coverage
                                        
                                        	Coverage in percentage
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: percentage
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.FrrStatistic, self).__init__()

                                            self.yang_name = "frr-statistic"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                            ])
                                            self.total_routes = None
                                            self.fully_protected_routes = None
                                            self.partially_protected_routes = None
                                            self.coverage = None
                                            self._segment_path = lambda: "frr-statistic"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary.FrrStatistic']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.PrioritySummary']['meta_info']


                                class ConvergenceTimeline(_Entity_):
                                    """
                                    Convergence timeline details
                                    
                                    .. attribute:: route_origin
                                    
                                    	Route origin (routing protocol)
                                    	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_enter
                                    
                                    	Entry point of IPv4 RIB
                                    	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_exit
                                    
                                    	Exit point from IPv4 RIB to FIBs
                                    	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_redistribute
                                    
                                    	Route Redistribute point from IPv4 RIB to LDP
                                    	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_enter
                                    
                                    	Entry point of LDP
                                    	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_exit
                                    
                                    	Exit point of LDP to LSD
                                    	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_enter
                                    
                                    	Entry point of LSD
                                    	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_exit
                                    
                                    	Exit point of LSD to FIBs
                                    	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_ip
                                    
                                    	List of Linecards' completion point for IP routes
                                    	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_mpls
                                    
                                    	List of Linecards' completion point for MPLS labels
                                    	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline, self).__init__()

                                        self.yang_name = "convergence-timeline"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls))])
                                        self._leafs = OrderedDict()

                                        self.route_origin = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin()
                                        self.route_origin.parent = self
                                        self._children_name_map["route_origin"] = "route-origin"

                                        self.ri_bv4_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter()
                                        self.ri_bv4_enter.parent = self
                                        self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                        self.ri_bv4_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit()
                                        self.ri_bv4_exit.parent = self
                                        self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                        self.ri_bv4_redistribute = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                        self.ri_bv4_redistribute.parent = self
                                        self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                        self.ldp_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter()
                                        self.ldp_enter.parent = self
                                        self._children_name_map["ldp_enter"] = "ldp-enter"

                                        self.ldp_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit()
                                        self.ldp_exit.parent = self
                                        self._children_name_map["ldp_exit"] = "ldp-exit"

                                        self.lsd_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter()
                                        self.lsd_enter.parent = self
                                        self._children_name_map["lsd_enter"] = "lsd-enter"

                                        self.lsd_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit()
                                        self.lsd_exit.parent = self
                                        self._children_name_map["lsd_exit"] = "lsd-exit"

                                        self.lc_ip = YList(self)
                                        self.lc_mpls = YList(self)
                                        self._segment_path = lambda: "convergence-timeline"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline, [], name, value)


                                    class RouteOrigin(_Entity_):
                                        """
                                        Route origin (routing protocol)
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                            self.yang_name = "route-origin"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "route-origin"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                    class RiBv4Enter(_Entity_):
                                        """
                                        Entry point of IPv4 RIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                            self.yang_name = "ri-bv4-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                    class RiBv4Exit(_Entity_):
                                        """
                                        Exit point from IPv4 RIB to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                            self.yang_name = "ri-bv4-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                    class RiBv4Redistribute(_Entity_):
                                        """
                                        Route Redistribute point from IPv4 RIB to LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                            self.yang_name = "ri-bv4-redistribute"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-redistribute"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                    class LdpEnter(_Entity_):
                                        """
                                        Entry point of LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                            self.yang_name = "ldp-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                    class LdpExit(_Entity_):
                                        """
                                        Exit point of LDP to LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                            self.yang_name = "ldp-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                    class LsdEnter(_Entity_):
                                        """
                                        Entry point of LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                            self.yang_name = "lsd-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                    class LsdExit(_Entity_):
                                        """
                                        Exit point of LSD to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                            self.yang_name = "lsd-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                    class LcIp(_Entity_):
                                        """
                                        List of Linecards' completion point for IP
                                        routes
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                            self.yang_name = "lc-ip"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-ip"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-ip"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                    class LcMpls(_Entity_):
                                        """
                                        List of Linecards' completion point for MPLS
                                        labels
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                            self.yang_name = "lc-mpls"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-mpls"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-mpls"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.ConvergenceTimeline']['meta_info']


                                class LeafNetworksAdded(_Entity_):
                                    """
                                    List of Leaf Networks Added
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksAdded, self).__init__()

                                        self.yang_name = "leaf-networks-added"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-added"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksAdded']['meta_info']


                                class LeafNetworksDeleted(_Entity_):
                                    """
                                    List of Leaf Networks Deleted
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksDeleted, self).__init__()

                                        self.yang_name = "leaf-networks-deleted"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-deleted"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority.LeafNetworksDeleted']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.Priority']['meta_info']


                            class LsaProcessed(_Entity_):
                                """
                                List of type 1/2 LSA changes processed
                                
                                .. attribute:: lsa_id
                                
                                	LSA ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sequence_number
                                
                                	Sequence Number
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsa_type
                                
                                	LSA type
                                	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                                
                                	**config**\: False
                                
                                .. attribute:: origin_router_id
                                
                                	Originating Router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Add, Delete, Modify
                                	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: reception_time
                                
                                	Reception Time on router (in hh\:mm\:ss.msec)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.LsaProcessed, self).__init__()

                                    self.yang_name = "lsa-processed"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                        ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                        ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                        ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                        ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ])
                                    self.lsa_id = None
                                    self.sequence_number = None
                                    self.lsa_type = None
                                    self.origin_router_id = None
                                    self.change_type = None
                                    self.reception_time = None
                                    self._segment_path = lambda: "lsa-processed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun.LsaProcessed']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.DijkstraRun']['meta_info']


                        class InterAreaAndExternal(_Entity_):
                            """
                            Inter\-area & external calculation information
                            
                            .. attribute:: priority
                            
                            	Convergence information on a per\-priority basis
                            	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal, self).__init__()

                                self.yang_name = "inter-area-and-external"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority", ("priority", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority))])
                                self._leafs = OrderedDict()

                                self.priority = YList(self)
                                self._segment_path = lambda: "inter-area-and-external"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal, [], name, value)


                            class Priority(_Entity_):
                                """
                                Convergence information on a per\-priority basis
                                
                                .. attribute:: priority_summary
                                
                                	Summary of the priority
                                	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary>`
                                
                                	**config**\: False
                                
                                .. attribute:: convergence_timeline
                                
                                	Convergence timeline details
                                	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_added
                                
                                	List of Leaf Networks Added
                                	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksAdded>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_deleted
                                
                                	List of Leaf Networks Deleted
                                	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksDeleted>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority, self).__init__()

                                    self.yang_name = "priority"
                                    self.yang_parent_name = "inter-area-and-external"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksDeleted))])
                                    self._leafs = OrderedDict()

                                    self.priority_summary = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary()
                                    self.priority_summary.parent = self
                                    self._children_name_map["priority_summary"] = "priority-summary"

                                    self.convergence_timeline = YList(self)
                                    self.leaf_networks_added = YList(self)
                                    self.leaf_networks_deleted = YList(self)
                                    self._segment_path = lambda: "priority"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority, [], name, value)


                                class PrioritySummary(_Entity_):
                                    """
                                    Summary of the priority
                                    
                                    .. attribute:: route_statistics
                                    
                                    	Route statistics
                                    	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_convergence_time
                                    
                                    	Convergence time for IP route programming
                                    	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mpls_convergence_time
                                    
                                    	Convergence time for MPLS label programming
                                    	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: level
                                    
                                    	Critical, High, Medium or Low
                                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_exceeded
                                    
                                    	Threshold exceeded
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type3ls_as
                                    
                                    	Number of Type 3 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type4ls_as
                                    
                                    	Number of Type 4 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type57ls_as
                                    
                                    	Number of Type 5/7 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary, self).__init__()

                                        self.yang_name = "priority-summary"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime))])
                                        self._leafs = OrderedDict([
                                            ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                            ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                            ('type3ls_as', (YLeaf(YType.uint32, 'type3ls-as'), ['int'])),
                                            ('type4ls_as', (YLeaf(YType.uint32, 'type4ls-as'), ['int'])),
                                            ('type57ls_as', (YLeaf(YType.uint32, 'type57ls-as'), ['int'])),
                                        ])
                                        self.level = None
                                        self.threshold_exceeded = None
                                        self.type3ls_as = None
                                        self.type4ls_as = None
                                        self.type57ls_as = None

                                        self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics()
                                        self.route_statistics.parent = self
                                        self._children_name_map["route_statistics"] = "route-statistics"

                                        self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime()
                                        self.ip_convergence_time.parent = self
                                        self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                        self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime()
                                        self.mpls_convergence_time.parent = self
                                        self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"
                                        self._segment_path = lambda: "priority-summary"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary, ['level', 'threshold_exceeded', 'type3ls_as', 'type4ls_as', 'type57ls_as'], name, value)


                                    class RouteStatistics(_Entity_):
                                        """
                                        Route statistics
                                        
                                        .. attribute:: adds
                                        
                                        	Added
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: deletes
                                        
                                        	Deleted
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: modifies
                                        
                                        	Modified
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: reachables
                                        
                                        	Reachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreachables
                                        
                                        	Unreachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: touches
                                        
                                        	Touched
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                            self.yang_name = "route-statistics"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                                ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                                ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                                ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                                ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                                ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                            ])
                                            self.adds = None
                                            self.deletes = None
                                            self.modifies = None
                                            self.reachables = None
                                            self.unreachables = None
                                            self.touches = None
                                            self._segment_path = lambda: "route-statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                    class IpConvergenceTime(_Entity_):
                                        """
                                        Convergence time for IP route programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                            self.yang_name = "ip-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "ip-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                    class MplsConvergenceTime(_Entity_):
                                        """
                                        Convergence time for MPLS label programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                            self.yang_name = "mpls-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "mpls-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.PrioritySummary']['meta_info']


                                class ConvergenceTimeline(_Entity_):
                                    """
                                    Convergence timeline details
                                    
                                    .. attribute:: route_origin
                                    
                                    	Route origin (routing protocol)
                                    	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_enter
                                    
                                    	Entry point of IPv4 RIB
                                    	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_exit
                                    
                                    	Exit point from IPv4 RIB to FIBs
                                    	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_redistribute
                                    
                                    	Route Redistribute point from IPv4 RIB to LDP
                                    	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_enter
                                    
                                    	Entry point of LDP
                                    	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_exit
                                    
                                    	Exit point of LDP to LSD
                                    	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_enter
                                    
                                    	Entry point of LSD
                                    	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_exit
                                    
                                    	Exit point of LSD to FIBs
                                    	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_ip
                                    
                                    	List of Linecards' completion point for IP routes
                                    	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_mpls
                                    
                                    	List of Linecards' completion point for MPLS labels
                                    	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline, self).__init__()

                                        self.yang_name = "convergence-timeline"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls))])
                                        self._leafs = OrderedDict()

                                        self.route_origin = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin()
                                        self.route_origin.parent = self
                                        self._children_name_map["route_origin"] = "route-origin"

                                        self.ri_bv4_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter()
                                        self.ri_bv4_enter.parent = self
                                        self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                        self.ri_bv4_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit()
                                        self.ri_bv4_exit.parent = self
                                        self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                        self.ri_bv4_redistribute = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                        self.ri_bv4_redistribute.parent = self
                                        self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                        self.ldp_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter()
                                        self.ldp_enter.parent = self
                                        self._children_name_map["ldp_enter"] = "ldp-enter"

                                        self.ldp_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit()
                                        self.ldp_exit.parent = self
                                        self._children_name_map["ldp_exit"] = "ldp-exit"

                                        self.lsd_enter = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter()
                                        self.lsd_enter.parent = self
                                        self._children_name_map["lsd_enter"] = "lsd-enter"

                                        self.lsd_exit = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit()
                                        self.lsd_exit.parent = self
                                        self._children_name_map["lsd_exit"] = "lsd-exit"

                                        self.lc_ip = YList(self)
                                        self.lc_mpls = YList(self)
                                        self._segment_path = lambda: "convergence-timeline"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline, [], name, value)


                                    class RouteOrigin(_Entity_):
                                        """
                                        Route origin (routing protocol)
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                            self.yang_name = "route-origin"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "route-origin"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                    class RiBv4Enter(_Entity_):
                                        """
                                        Entry point of IPv4 RIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                            self.yang_name = "ri-bv4-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                    class RiBv4Exit(_Entity_):
                                        """
                                        Exit point from IPv4 RIB to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                            self.yang_name = "ri-bv4-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                    class RiBv4Redistribute(_Entity_):
                                        """
                                        Route Redistribute point from IPv4 RIB to LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                            self.yang_name = "ri-bv4-redistribute"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-redistribute"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                    class LdpEnter(_Entity_):
                                        """
                                        Entry point of LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                            self.yang_name = "ldp-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                    class LdpExit(_Entity_):
                                        """
                                        Exit point of LDP to LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                            self.yang_name = "ldp-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                    class LsdEnter(_Entity_):
                                        """
                                        Entry point of LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                            self.yang_name = "lsd-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                    class LsdExit(_Entity_):
                                        """
                                        Exit point of LSD to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                            self.yang_name = "lsd-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                    class LcIp(_Entity_):
                                        """
                                        List of Linecards' completion point for IP
                                        routes
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                            self.yang_name = "lc-ip"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-ip"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-ip"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                    class LcMpls(_Entity_):
                                        """
                                        List of Linecards' completion point for MPLS
                                        labels
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                            self.yang_name = "lc-mpls"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-mpls"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-mpls"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.ConvergenceTimeline']['meta_info']


                                class LeafNetworksAdded(_Entity_):
                                    """
                                    List of Leaf Networks Added
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksAdded, self).__init__()

                                        self.yang_name = "leaf-networks-added"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-added"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksAdded']['meta_info']


                                class LeafNetworksDeleted(_Entity_):
                                    """
                                    List of Leaf Networks Deleted
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksDeleted, self).__init__()

                                        self.yang_name = "leaf-networks-deleted"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-deleted"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority.LeafNetworksDeleted']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal.Priority']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary.InterAreaAndExternal']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries.SpfRunSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunSummaries']['meta_info']


                class IpfrrEventOfflines(_Entity_):
                    """
                    OSPF IP\-FRR Event offline data
                    
                    .. attribute:: ipfrr_event_offline
                    
                    	Offline operational data for particular OSPF IP\-FRR Event
                    	**type**\: list of  		 :py:class:`IpfrrEventOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines, self).__init__()

                        self.yang_name = "ipfrr-event-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipfrr-event-offline", ("ipfrr_event_offline", Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline))])
                        self._leafs = OrderedDict()

                        self.ipfrr_event_offline = YList(self)
                        self._segment_path = lambda: "ipfrr-event-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines, [], name, value)


                    class IpfrrEventOffline(_Entity_):
                        """
                        Offline operational data for particular OSPF
                        IP\-FRR Event
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific IP\-FRR Event
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: event_id_xr
                        
                        	IP\-Frr Event ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Trigger time  (eg\: Apr 24 13\:16\:04.961)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_spf_run
                        
                        	IP\-Frr Triggered reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Waiting Time (in milliseconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: start_time_offset
                        
                        	Start Time offset from trigger time (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: duration
                        
                        	Duration for the calculation (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: completed_spf_run
                        
                        	IP\-Frr Completed reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_routes
                        
                        	Cumulative Number of Routes for all priorities
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fully_protected_routes
                        
                        	Cumulative Number of Fully Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: partially_protected_routes
                        
                        	Cumulative Number of Partially Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: coverage
                        
                        	Coverage in percentage for all priorities
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: percentage
                        
                        .. attribute:: ipfrr_statistic
                        
                        	IP\-Frr Statistics categorized by priority
                        	**type**\: list of  		 :py:class:`IpfrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_node
                        
                        	Remote Node Information
                        	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline, self).__init__()

                            self.yang_name = "ipfrr-event-offline"
                            self.yang_parent_name = "ipfrr-event-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ipfrr-statistic", ("ipfrr_statistic", Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic)), ("remote-node", ("remote_node", Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                ('trigger_spf_run', (YLeaf(YType.uint32, 'trigger-spf-run'), ['int'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('start_time_offset', (YLeaf(YType.str, 'start-time-offset'), ['str'])),
                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ('completed_spf_run', (YLeaf(YType.uint32, 'completed-spf-run'), ['int'])),
                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                            ])
                            self.event_id = None
                            self.event_id_xr = None
                            self.trigger_time = None
                            self.trigger_spf_run = None
                            self.wait_time = None
                            self.start_time_offset = None
                            self.duration = None
                            self.completed_spf_run = None
                            self.total_routes = None
                            self.fully_protected_routes = None
                            self.partially_protected_routes = None
                            self.coverage = None

                            self.ipfrr_statistic = YList(self)
                            self.remote_node = YList(self)
                            self._segment_path = lambda: "ipfrr-event-offline" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline, ['event_id', 'event_id_xr', 'trigger_time', 'trigger_spf_run', 'wait_time', 'start_time_offset', 'duration', 'completed_spf_run', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)


                        class IpfrrStatistic(_Entity_):
                            """
                            IP\-Frr Statistics categorized by priority
                            
                            .. attribute:: priority
                            
                            	Priority
                            	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                            
                            	**config**\: False
                            
                            .. attribute:: total_routes
                            
                            	Total Number of Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fully_protected_routes
                            
                            	Fully Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: partially_protected_routes
                            
                            	Partially Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: coverage
                            
                            	Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: local_lfa_coverage
                            
                            	Local LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: remote_lfa_coverage
                            
                            	Remote LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: below_threshold
                            
                            	Covearge is below Configured Threshold
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic, self).__init__()

                                self.yang_name = "ipfrr-statistic"
                                self.yang_parent_name = "ipfrr-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                    ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                    ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                    ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                    ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                    ('local_lfa_coverage', (YLeaf(YType.str, 'local-lfa-coverage'), ['str'])),
                                    ('remote_lfa_coverage', (YLeaf(YType.str, 'remote-lfa-coverage'), ['str'])),
                                    ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                                ])
                                self.priority = None
                                self.total_routes = None
                                self.fully_protected_routes = None
                                self.partially_protected_routes = None
                                self.coverage = None
                                self.local_lfa_coverage = None
                                self.remote_lfa_coverage = None
                                self.below_threshold = None
                                self._segment_path = lambda: "ipfrr-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic, ['priority', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage', 'local_lfa_coverage', 'remote_lfa_coverage', 'below_threshold'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic']['meta_info']


                        class RemoteNode(_Entity_):
                            """
                            Remote Node Information
                            
                            .. attribute:: remote_node_id
                            
                            	Remote\-LFA Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_count
                            
                            	Number of paths protected by this Remote Node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: in_use_time
                            
                            	Inuse time of the Remote Node (eg\: Apr 24 13\:16 \:04.961)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: primary_path
                            
                            	Protected Primary Paths
                            	**type**\: list of  		 :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode, self).__init__()

                                self.yang_name = "remote-node"
                                self.yang_parent_name = "ipfrr-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-path", ("primary_path", Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath))])
                                self._leafs = OrderedDict([
                                    ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                                    ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                                ])
                                self.remote_node_id = None
                                self.interface_name = None
                                self.neighbour_address = None
                                self.path_count = None
                                self.in_use_time = None

                                self.primary_path = YList(self)
                                self._segment_path = lambda: "remote-node"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode, ['remote_node_id', 'interface_name', 'neighbour_address', 'path_count', 'in_use_time'], name, value)


                            class PrimaryPath(_Entity_):
                                """
                                Protected Primary Paths
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath, self).__init__()

                                    self.yang_name = "primary-path"
                                    self.yang_parent_name = "remote-node"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ])
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self._segment_path = lambda: "primary-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath, ['interface_name', 'neighbour_address'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.IpfrrEventOfflines']['meta_info']


                class SpfRunOfflines(_Entity_):
                    """
                    OSPF SPF run offline data
                    
                    .. attribute:: spf_run_offline
                    
                    	Offline operational data for particular OSPF SPF run
                    	**type**\: list of  		 :py:class:`SpfRunOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines, self).__init__()

                        self.yang_name = "spf-run-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("spf-run-offline", ("spf_run_offline", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline))])
                        self._leafs = OrderedDict()

                        self.spf_run_offline = YList(self)
                        self._segment_path = lambda: "spf-run-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines, [], name, value)


                    class SpfRunOffline(_Entity_):
                        """
                        Offline operational data for particular OSPF
                        SPF run
                        
                        .. attribute:: spf_run_number  (key)
                        
                        	Specific SPF run
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_summary
                        
                        	SPF summary information
                        	**type**\:  :py:class:`SpfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary>`
                        
                        	**config**\: False
                        
                        .. attribute:: dijkstra_run
                        
                        	List of Dijkstra runs
                        	**type**\: list of  		 :py:class:`DijkstraRun <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun>`
                        
                        	**config**\: False
                        
                        .. attribute:: inter_area_and_external
                        
                        	Inter\-area & external calculation information
                        	**type**\: list of  		 :py:class:`InterAreaAndExternal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline, self).__init__()

                            self.yang_name = "spf-run-offline"
                            self.yang_parent_name = "spf-run-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['spf_run_number']
                            self._child_classes = OrderedDict([("spf-summary", ("spf_summary", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary)), ("dijkstra-run", ("dijkstra_run", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun)), ("inter-area-and-external", ("inter_area_and_external", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal))])
                            self._leafs = OrderedDict([
                                ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                            ])
                            self.spf_run_number = None

                            self.spf_summary = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary()
                            self.spf_summary.parent = self
                            self._children_name_map["spf_summary"] = "spf-summary"

                            self.dijkstra_run = YList(self)
                            self.inter_area_and_external = YList(self)
                            self._segment_path = lambda: "spf-run-offline" + "[spf-run-number='" + str(self.spf_run_number) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline, ['spf_run_number'], name, value)


                        class SpfSummary(_Entity_):
                            """
                            SPF summary information
                            
                            .. attribute:: state
                            
                            	SPF state
                            	**type**\:  :py:class:`RcmdSpfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdSpfState>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_data_complete
                            
                            	Whether the event has all information
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: start_time
                            
                            	Start time (offset from event trigger time in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of complete SPF calculation (in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: total_dijkstra_runs
                            
                            	Total number of Dijkstra runs
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_inter_area_and_external_batches
                            
                            	Total number of inter\-area/external computation batches
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_type12lsa_changes
                            
                            	Total number of Type 1/2 LSA changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: total_type357lsa_changes
                            
                            	Total number of Type 3/5/7 LSA changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: priority_summary
                            
                            	Convergence information summary on per\-priority basis
                            	**type**\: list of  		 :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary, self).__init__()

                                self.yang_name = "spf-summary"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary))])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdSpfState', '')])),
                                    ('is_data_complete', (YLeaf(YType.boolean, 'is-data-complete'), ['bool'])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                    ('total_dijkstra_runs', (YLeaf(YType.uint16, 'total-dijkstra-runs'), ['int'])),
                                    ('total_inter_area_and_external_batches', (YLeaf(YType.uint16, 'total-inter-area-and-external-batches'), ['int'])),
                                    ('total_type12lsa_changes', (YLeaf(YType.uint16, 'total-type12lsa-changes'), ['int'])),
                                    ('total_type357lsa_changes', (YLeaf(YType.uint16, 'total-type357lsa-changes'), ['int'])),
                                ])
                                self.state = None
                                self.is_data_complete = None
                                self.threshold_exceeded = None
                                self.trigger_time = None
                                self.start_time = None
                                self.duration = None
                                self.total_dijkstra_runs = None
                                self.total_inter_area_and_external_batches = None
                                self.total_type12lsa_changes = None
                                self.total_type357lsa_changes = None

                                self.priority_summary = YList(self)
                                self._segment_path = lambda: "spf-summary"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary, ['state', 'is_data_complete', 'threshold_exceeded', 'trigger_time', 'start_time', 'duration', 'total_dijkstra_runs', 'total_inter_area_and_external_batches', 'total_type12lsa_changes', 'total_type357lsa_changes'], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Convergence information summary on per\-priority
                                basis
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "spf-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary']['meta_info']


                        class DijkstraRun(_Entity_):
                            """
                            List of Dijkstra runs
                            
                            .. attribute:: dijkstra_run_number
                            
                            	Area Dijkstra run number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: area_id
                            
                            	Area ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: start_time
                            
                            	Start time (offset from event trigger time in ss .msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: wait_time
                            
                            	Wait time (offset from event trigger time in ss .msec)
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of Dijktra calculation (in ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_lsa
                            
                            	LSA that triggered the Dijkstra run
                            	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.TriggerLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: priority
                            
                            	Convergence information on per\-priority basis
                            	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_processed
                            
                            	List of type 1/2 LSA changes processed
                            	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.LsaProcessed>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun, self).__init__()

                                self.yang_name = "dijkstra-run"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.TriggerLsa)), ("priority", ("priority", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.LsaProcessed))])
                                self._leafs = OrderedDict([
                                    ('dijkstra_run_number', (YLeaf(YType.uint32, 'dijkstra-run-number'), ['int'])),
                                    ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                    ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ])
                                self.dijkstra_run_number = None
                                self.area_id = None
                                self.threshold_exceeded = None
                                self.trigger_time = None
                                self.start_time = None
                                self.wait_time = None
                                self.duration = None

                                self.trigger_lsa = YList(self)
                                self.priority = YList(self)
                                self.lsa_processed = YList(self)
                                self._segment_path = lambda: "dijkstra-run"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun, ['dijkstra_run_number', 'area_id', 'threshold_exceeded', 'trigger_time', 'start_time', 'wait_time', 'duration'], name, value)


                            class TriggerLsa(_Entity_):
                                """
                                LSA that triggered the Dijkstra run
                                
                                .. attribute:: lsa_id
                                
                                	LSA ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sequence_number
                                
                                	Sequence Number
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsa_type
                                
                                	LSA type
                                	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                                
                                	**config**\: False
                                
                                .. attribute:: origin_router_id
                                
                                	Originating Router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Add, Delete, Modify
                                	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: reception_time
                                
                                	Reception Time on router (in hh\:mm\:ss.msec)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.TriggerLsa, self).__init__()

                                    self.yang_name = "trigger-lsa"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                        ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                        ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                        ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                        ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ])
                                    self.lsa_id = None
                                    self.sequence_number = None
                                    self.lsa_type = None
                                    self.origin_router_id = None
                                    self.change_type = None
                                    self.reception_time = None
                                    self._segment_path = lambda: "trigger-lsa"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.TriggerLsa']['meta_info']


                            class Priority(_Entity_):
                                """
                                Convergence information on per\-priority basis
                                
                                .. attribute:: priority_summary
                                
                                	Summary of the priority
                                	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary>`
                                
                                	**config**\: False
                                
                                .. attribute:: convergence_timeline
                                
                                	Convergence timeline details
                                	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_added
                                
                                	List of Leaf Networks Added
                                	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksAdded>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_deleted
                                
                                	List of Leaf Networks Deleted
                                	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksDeleted>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority, self).__init__()

                                    self.yang_name = "priority"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksDeleted))])
                                    self._leafs = OrderedDict()

                                    self.priority_summary = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary()
                                    self.priority_summary.parent = self
                                    self._children_name_map["priority_summary"] = "priority-summary"

                                    self.convergence_timeline = YList(self)
                                    self.leaf_networks_added = YList(self)
                                    self.leaf_networks_deleted = YList(self)
                                    self._segment_path = lambda: "priority"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority, [], name, value)


                                class PrioritySummary(_Entity_):
                                    """
                                    Summary of the priority
                                    
                                    .. attribute:: route_statistics
                                    
                                    	Route statistics
                                    	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_convergence_time
                                    
                                    	Convergence time for IP route programming
                                    	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mpls_convergence_time
                                    
                                    	Convergence time for MPLS label programming
                                    	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: level
                                    
                                    	Critical, High, Medium or Low
                                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_exceeded
                                    
                                    	Threshold exceeded
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_statistic
                                    
                                    	Fast Re\-Route Statistics
                                    	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.FrrStatistic>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary, self).__init__()

                                        self.yang_name = "priority-summary"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.FrrStatistic))])
                                        self._leafs = OrderedDict([
                                            ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                            ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                        ])
                                        self.level = None
                                        self.threshold_exceeded = None

                                        self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics()
                                        self.route_statistics.parent = self
                                        self._children_name_map["route_statistics"] = "route-statistics"

                                        self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime()
                                        self.ip_convergence_time.parent = self
                                        self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                        self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime()
                                        self.mpls_convergence_time.parent = self
                                        self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                        self.frr_statistic = YList(self)
                                        self._segment_path = lambda: "priority-summary"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                    class RouteStatistics(_Entity_):
                                        """
                                        Route statistics
                                        
                                        .. attribute:: adds
                                        
                                        	Added
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: deletes
                                        
                                        	Deleted
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: modifies
                                        
                                        	Modified
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: reachables
                                        
                                        	Reachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreachables
                                        
                                        	Unreachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: touches
                                        
                                        	Touched
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                            self.yang_name = "route-statistics"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                                ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                                ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                                ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                                ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                                ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                            ])
                                            self.adds = None
                                            self.deletes = None
                                            self.modifies = None
                                            self.reachables = None
                                            self.unreachables = None
                                            self.touches = None
                                            self._segment_path = lambda: "route-statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                    class IpConvergenceTime(_Entity_):
                                        """
                                        Convergence time for IP route programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                            self.yang_name = "ip-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "ip-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                    class MplsConvergenceTime(_Entity_):
                                        """
                                        Convergence time for MPLS label programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                            self.yang_name = "mpls-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "mpls-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']


                                    class FrrStatistic(_Entity_):
                                        """
                                        Fast Re\-Route Statistics
                                        
                                        .. attribute:: total_routes
                                        
                                        	Total Number of Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fully_protected_routes
                                        
                                        	Fully Protected Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: partially_protected_routes
                                        
                                        	Partially Protected Routes
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: coverage
                                        
                                        	Coverage in percentage
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: percentage
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.FrrStatistic, self).__init__()

                                            self.yang_name = "frr-statistic"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                            ])
                                            self.total_routes = None
                                            self.fully_protected_routes = None
                                            self.partially_protected_routes = None
                                            self.coverage = None
                                            self._segment_path = lambda: "frr-statistic"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary.FrrStatistic']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.PrioritySummary']['meta_info']


                                class ConvergenceTimeline(_Entity_):
                                    """
                                    Convergence timeline details
                                    
                                    .. attribute:: route_origin
                                    
                                    	Route origin (routing protocol)
                                    	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_enter
                                    
                                    	Entry point of IPv4 RIB
                                    	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_exit
                                    
                                    	Exit point from IPv4 RIB to FIBs
                                    	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_redistribute
                                    
                                    	Route Redistribute point from IPv4 RIB to LDP
                                    	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_enter
                                    
                                    	Entry point of LDP
                                    	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_exit
                                    
                                    	Exit point of LDP to LSD
                                    	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_enter
                                    
                                    	Entry point of LSD
                                    	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_exit
                                    
                                    	Exit point of LSD to FIBs
                                    	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_ip
                                    
                                    	List of Linecards' completion point for IP routes
                                    	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_mpls
                                    
                                    	List of Linecards' completion point for MPLS labels
                                    	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline, self).__init__()

                                        self.yang_name = "convergence-timeline"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls))])
                                        self._leafs = OrderedDict()

                                        self.route_origin = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin()
                                        self.route_origin.parent = self
                                        self._children_name_map["route_origin"] = "route-origin"

                                        self.ri_bv4_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter()
                                        self.ri_bv4_enter.parent = self
                                        self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                        self.ri_bv4_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit()
                                        self.ri_bv4_exit.parent = self
                                        self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                        self.ri_bv4_redistribute = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                        self.ri_bv4_redistribute.parent = self
                                        self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                        self.ldp_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter()
                                        self.ldp_enter.parent = self
                                        self._children_name_map["ldp_enter"] = "ldp-enter"

                                        self.ldp_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit()
                                        self.ldp_exit.parent = self
                                        self._children_name_map["ldp_exit"] = "ldp-exit"

                                        self.lsd_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter()
                                        self.lsd_enter.parent = self
                                        self._children_name_map["lsd_enter"] = "lsd-enter"

                                        self.lsd_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit()
                                        self.lsd_exit.parent = self
                                        self._children_name_map["lsd_exit"] = "lsd-exit"

                                        self.lc_ip = YList(self)
                                        self.lc_mpls = YList(self)
                                        self._segment_path = lambda: "convergence-timeline"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline, [], name, value)


                                    class RouteOrigin(_Entity_):
                                        """
                                        Route origin (routing protocol)
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                            self.yang_name = "route-origin"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "route-origin"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                    class RiBv4Enter(_Entity_):
                                        """
                                        Entry point of IPv4 RIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                            self.yang_name = "ri-bv4-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                    class RiBv4Exit(_Entity_):
                                        """
                                        Exit point from IPv4 RIB to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                            self.yang_name = "ri-bv4-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                    class RiBv4Redistribute(_Entity_):
                                        """
                                        Route Redistribute point from IPv4 RIB to LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                            self.yang_name = "ri-bv4-redistribute"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-redistribute"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                    class LdpEnter(_Entity_):
                                        """
                                        Entry point of LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                            self.yang_name = "ldp-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                    class LdpExit(_Entity_):
                                        """
                                        Exit point of LDP to LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                            self.yang_name = "ldp-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                    class LsdEnter(_Entity_):
                                        """
                                        Entry point of LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                            self.yang_name = "lsd-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                    class LsdExit(_Entity_):
                                        """
                                        Exit point of LSD to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                            self.yang_name = "lsd-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                    class LcIp(_Entity_):
                                        """
                                        List of Linecards' completion point for IP
                                        routes
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                            self.yang_name = "lc-ip"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-ip"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-ip"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                    class LcMpls(_Entity_):
                                        """
                                        List of Linecards' completion point for MPLS
                                        labels
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                            self.yang_name = "lc-mpls"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-mpls"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-mpls"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.ConvergenceTimeline']['meta_info']


                                class LeafNetworksAdded(_Entity_):
                                    """
                                    List of Leaf Networks Added
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksAdded, self).__init__()

                                        self.yang_name = "leaf-networks-added"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-added"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksAdded']['meta_info']


                                class LeafNetworksDeleted(_Entity_):
                                    """
                                    List of Leaf Networks Deleted
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksDeleted, self).__init__()

                                        self.yang_name = "leaf-networks-deleted"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-deleted"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority.LeafNetworksDeleted']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.Priority']['meta_info']


                            class LsaProcessed(_Entity_):
                                """
                                List of type 1/2 LSA changes processed
                                
                                .. attribute:: lsa_id
                                
                                	LSA ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sequence_number
                                
                                	Sequence Number
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsa_type
                                
                                	LSA type
                                	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                                
                                	**config**\: False
                                
                                .. attribute:: origin_router_id
                                
                                	Originating Router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Add, Delete, Modify
                                	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: reception_time
                                
                                	Reception Time on router (in hh\:mm\:ss.msec)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.LsaProcessed, self).__init__()

                                    self.yang_name = "lsa-processed"
                                    self.yang_parent_name = "dijkstra-run"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                        ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                        ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                        ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                        ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ])
                                    self.lsa_id = None
                                    self.sequence_number = None
                                    self.lsa_type = None
                                    self.origin_router_id = None
                                    self.change_type = None
                                    self.reception_time = None
                                    self._segment_path = lambda: "lsa-processed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun.LsaProcessed']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.DijkstraRun']['meta_info']


                        class InterAreaAndExternal(_Entity_):
                            """
                            Inter\-area & external calculation information
                            
                            .. attribute:: priority
                            
                            	Convergence information on a per\-priority basis
                            	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal, self).__init__()

                                self.yang_name = "inter-area-and-external"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority", ("priority", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority))])
                                self._leafs = OrderedDict()

                                self.priority = YList(self)
                                self._segment_path = lambda: "inter-area-and-external"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal, [], name, value)


                            class Priority(_Entity_):
                                """
                                Convergence information on a per\-priority basis
                                
                                .. attribute:: priority_summary
                                
                                	Summary of the priority
                                	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary>`
                                
                                	**config**\: False
                                
                                .. attribute:: convergence_timeline
                                
                                	Convergence timeline details
                                	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_added
                                
                                	List of Leaf Networks Added
                                	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksAdded>`
                                
                                	**config**\: False
                                
                                .. attribute:: leaf_networks_deleted
                                
                                	List of Leaf Networks Deleted
                                	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksDeleted>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority, self).__init__()

                                    self.yang_name = "priority"
                                    self.yang_parent_name = "inter-area-and-external"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksDeleted))])
                                    self._leafs = OrderedDict()

                                    self.priority_summary = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary()
                                    self.priority_summary.parent = self
                                    self._children_name_map["priority_summary"] = "priority-summary"

                                    self.convergence_timeline = YList(self)
                                    self.leaf_networks_added = YList(self)
                                    self.leaf_networks_deleted = YList(self)
                                    self._segment_path = lambda: "priority"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority, [], name, value)


                                class PrioritySummary(_Entity_):
                                    """
                                    Summary of the priority
                                    
                                    .. attribute:: route_statistics
                                    
                                    	Route statistics
                                    	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ip_convergence_time
                                    
                                    	Convergence time for IP route programming
                                    	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mpls_convergence_time
                                    
                                    	Convergence time for MPLS label programming
                                    	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: level
                                    
                                    	Critical, High, Medium or Low
                                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: threshold_exceeded
                                    
                                    	Threshold exceeded
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type3ls_as
                                    
                                    	Number of Type 3 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type4ls_as
                                    
                                    	Number of Type 4 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type57ls_as
                                    
                                    	Number of Type 5/7 LSA
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary, self).__init__()

                                        self.yang_name = "priority-summary"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime))])
                                        self._leafs = OrderedDict([
                                            ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                            ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                            ('type3ls_as', (YLeaf(YType.uint32, 'type3ls-as'), ['int'])),
                                            ('type4ls_as', (YLeaf(YType.uint32, 'type4ls-as'), ['int'])),
                                            ('type57ls_as', (YLeaf(YType.uint32, 'type57ls-as'), ['int'])),
                                        ])
                                        self.level = None
                                        self.threshold_exceeded = None
                                        self.type3ls_as = None
                                        self.type4ls_as = None
                                        self.type57ls_as = None

                                        self.route_statistics = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics()
                                        self.route_statistics.parent = self
                                        self._children_name_map["route_statistics"] = "route-statistics"

                                        self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime()
                                        self.ip_convergence_time.parent = self
                                        self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                        self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime()
                                        self.mpls_convergence_time.parent = self
                                        self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"
                                        self._segment_path = lambda: "priority-summary"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary, ['level', 'threshold_exceeded', 'type3ls_as', 'type4ls_as', 'type57ls_as'], name, value)


                                    class RouteStatistics(_Entity_):
                                        """
                                        Route statistics
                                        
                                        .. attribute:: adds
                                        
                                        	Added
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: deletes
                                        
                                        	Deleted
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: modifies
                                        
                                        	Modified
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: reachables
                                        
                                        	Reachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreachables
                                        
                                        	Unreachable
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: touches
                                        
                                        	Touched
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                            self.yang_name = "route-statistics"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                                ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                                ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                                ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                                ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                                ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                            ])
                                            self.adds = None
                                            self.deletes = None
                                            self.modifies = None
                                            self.reachables = None
                                            self.unreachables = None
                                            self.touches = None
                                            self._segment_path = lambda: "route-statistics"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                    class IpConvergenceTime(_Entity_):
                                        """
                                        Convergence time for IP route programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                            self.yang_name = "ip-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "ip-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                    class MplsConvergenceTime(_Entity_):
                                        """
                                        Convergence time for MPLS label programming
                                        
                                        .. attribute:: minimum_time
                                        
                                        	Minimum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: maximum_time
                                        
                                        	Maximum time(in seconds.milliseconds)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        	**units**\: millisecond
                                        
                                        .. attribute:: slowest_node_name
                                        
                                        	Linecard node name which took the maximum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fastest_node_name
                                        
                                        	Linecard node name which took the minimum time
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                            self.yang_name = "mpls-convergence-time"
                                            self.yang_parent_name = "priority-summary"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                                ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                                ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                                ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                            ])
                                            self.minimum_time = None
                                            self.maximum_time = None
                                            self.slowest_node_name = None
                                            self.fastest_node_name = None
                                            self._segment_path = lambda: "mpls-convergence-time"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.PrioritySummary']['meta_info']


                                class ConvergenceTimeline(_Entity_):
                                    """
                                    Convergence timeline details
                                    
                                    .. attribute:: route_origin
                                    
                                    	Route origin (routing protocol)
                                    	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_enter
                                    
                                    	Entry point of IPv4 RIB
                                    	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_exit
                                    
                                    	Exit point from IPv4 RIB to FIBs
                                    	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ri_bv4_redistribute
                                    
                                    	Route Redistribute point from IPv4 RIB to LDP
                                    	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_enter
                                    
                                    	Entry point of LDP
                                    	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ldp_exit
                                    
                                    	Exit point of LDP to LSD
                                    	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_enter
                                    
                                    	Entry point of LSD
                                    	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsd_exit
                                    
                                    	Exit point of LSD to FIBs
                                    	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_ip
                                    
                                    	List of Linecards' completion point for IP routes
                                    	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lc_mpls
                                    
                                    	List of Linecards' completion point for MPLS labels
                                    	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline, self).__init__()

                                        self.yang_name = "convergence-timeline"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls))])
                                        self._leafs = OrderedDict()

                                        self.route_origin = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin()
                                        self.route_origin.parent = self
                                        self._children_name_map["route_origin"] = "route-origin"

                                        self.ri_bv4_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter()
                                        self.ri_bv4_enter.parent = self
                                        self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                        self.ri_bv4_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit()
                                        self.ri_bv4_exit.parent = self
                                        self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                        self.ri_bv4_redistribute = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                        self.ri_bv4_redistribute.parent = self
                                        self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                        self.ldp_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter()
                                        self.ldp_enter.parent = self
                                        self._children_name_map["ldp_enter"] = "ldp-enter"

                                        self.ldp_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit()
                                        self.ldp_exit.parent = self
                                        self._children_name_map["ldp_exit"] = "ldp-exit"

                                        self.lsd_enter = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter()
                                        self.lsd_enter.parent = self
                                        self._children_name_map["lsd_enter"] = "lsd-enter"

                                        self.lsd_exit = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit()
                                        self.lsd_exit.parent = self
                                        self._children_name_map["lsd_exit"] = "lsd-exit"

                                        self.lc_ip = YList(self)
                                        self.lc_mpls = YList(self)
                                        self._segment_path = lambda: "convergence-timeline"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline, [], name, value)


                                    class RouteOrigin(_Entity_):
                                        """
                                        Route origin (routing protocol)
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                            self.yang_name = "route-origin"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "route-origin"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                    class RiBv4Enter(_Entity_):
                                        """
                                        Entry point of IPv4 RIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                            self.yang_name = "ri-bv4-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                    class RiBv4Exit(_Entity_):
                                        """
                                        Exit point from IPv4 RIB to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                            self.yang_name = "ri-bv4-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                    class RiBv4Redistribute(_Entity_):
                                        """
                                        Route Redistribute point from IPv4 RIB to LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                            self.yang_name = "ri-bv4-redistribute"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ri-bv4-redistribute"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                    class LdpEnter(_Entity_):
                                        """
                                        Entry point of LDP
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                            self.yang_name = "ldp-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                    class LdpExit(_Entity_):
                                        """
                                        Exit point of LDP to LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                            self.yang_name = "ldp-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "ldp-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                    class LsdEnter(_Entity_):
                                        """
                                        Entry point of LSD
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                            self.yang_name = "lsd-enter"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-enter"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                    class LsdExit(_Entity_):
                                        """
                                        Exit point of LSD to FIBs
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                            self.yang_name = "lsd-exit"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "lsd-exit"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                    class LcIp(_Entity_):
                                        """
                                        List of Linecards' completion point for IP
                                        routes
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                            self.yang_name = "lc-ip"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-ip"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-ip"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                    class LcMpls(_Entity_):
                                        """
                                        List of Linecards' completion point for MPLS
                                        labels
                                        
                                        .. attribute:: fib_complete
                                        
                                        	Completion point of FIB
                                        	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: node_name
                                        
                                        	Linecard node name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: speed
                                        
                                        	Relative convergence speed
                                        	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                            self.yang_name = "lc-mpls"
                                            self.yang_parent_name = "convergence-timeline"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                            self._leafs = OrderedDict([
                                                ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                                ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                            ])
                                            self.node_name = None
                                            self.speed = None

                                            self.fib_complete = Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                            self.fib_complete.parent = self
                                            self._children_name_map["fib_complete"] = "fib-complete"
                                            self._segment_path = lambda: "lc-mpls"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                        class FibComplete(_Entity_):
                                            """
                                            Completion point of FIB
                                            
                                            .. attribute:: start_time
                                            
                                            	First route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: end_time
                                            
                                            	Last route process time relative to event trigger time (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration of processing (in ss.msec)
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'infra-rcmd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                                self.yang_name = "fib-complete"
                                                self.yang_parent_name = "lc-mpls"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                    ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                                ])
                                                self.start_time = None
                                                self.end_time = None
                                                self.duration = None
                                                self._segment_path = lambda: "fib-complete"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.ConvergenceTimeline']['meta_info']


                                class LeafNetworksAdded(_Entity_):
                                    """
                                    List of Leaf Networks Added
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksAdded, self).__init__()

                                        self.yang_name = "leaf-networks-added"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-added"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksAdded']['meta_info']


                                class LeafNetworksDeleted(_Entity_):
                                    """
                                    List of Leaf Networks Deleted
                                    
                                    .. attribute:: address
                                    
                                    	IP address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: net_mask
                                    
                                    	Mask
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksDeleted, self).__init__()

                                        self.yang_name = "leaf-networks-deleted"
                                        self.yang_parent_name = "priority"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                        ])
                                        self.address = None
                                        self.net_mask = None
                                        self._segment_path = lambda: "leaf-networks-deleted"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority.LeafNetworksDeleted']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal.Priority']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline.InterAreaAndExternal']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines.SpfRunOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SpfRunOfflines']['meta_info']


                class SummaryExternalEventSummaries(_Entity_):
                    """
                    OSPF Summary\-External Prefix events summary
                    data
                    
                    .. attribute:: summary_external_event_summary
                    
                    	OSPF Summary\-External Prefix Event data
                    	**type**\: list of  		 :py:class:`SummaryExternalEventSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries, self).__init__()

                        self.yang_name = "summary-external-event-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("summary-external-event-summary", ("summary_external_event_summary", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary))])
                        self._leafs = OrderedDict()

                        self.summary_external_event_summary = YList(self)
                        self._segment_path = lambda: "summary-external-event-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries, [], name, value)


                    class SummaryExternalEventSummary(_Entity_):
                        """
                        OSPF Summary\-External Prefix Event data
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary, self).__init__()

                            self.yang_name = "summary-external-event-summary"
                            self.yang_parent_name = "summary-external-event-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime)), ("path", ("path", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TriggerLsa)), ("time-line", ("time_line", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "summary-external-event-summary" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "summary-external-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries.SummaryExternalEventSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventSummaries']['meta_info']


                class PrefixEventSummaries(_Entity_):
                    """
                    OSPF Prefix events summary data
                    
                    .. attribute:: prefix_event_summary
                    
                    	OSPF Prefix Event data
                    	**type**\: list of  		 :py:class:`PrefixEventSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries, self).__init__()

                        self.yang_name = "prefix-event-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-summary", ("prefix_event_summary", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary))])
                        self._leafs = OrderedDict()

                        self.prefix_event_summary = YList(self)
                        self._segment_path = lambda: "prefix-event-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries, [], name, value)


                    class PrefixEventSummary(_Entity_):
                        """
                        OSPF Prefix Event data
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary, self).__init__()

                            self.yang_name = "prefix-event-summary"
                            self.yang_parent_name = "prefix-event-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime)), ("path", ("path", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa)), ("time-line", ("time_line", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "prefix-event-summary" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries.PrefixEventSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventSummaries']['meta_info']


                class SummaryExternalEventOfflines(_Entity_):
                    """
                    OSPF Summary\-External Prefix events offline
                    data
                    
                    .. attribute:: summary_external_event_offline
                    
                    	Offline operational data for particular OSPF Prefix Event
                    	**type**\: list of  		 :py:class:`SummaryExternalEventOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines, self).__init__()

                        self.yang_name = "summary-external-event-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("summary-external-event-offline", ("summary_external_event_offline", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline))])
                        self._leafs = OrderedDict()

                        self.summary_external_event_offline = YList(self)
                        self._segment_path = lambda: "summary-external-event-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines, [], name, value)


                    class SummaryExternalEventOffline(_Entity_):
                        """
                        Offline operational data for particular OSPF
                        Prefix Event
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline, self).__init__()

                            self.yang_name = "summary-external-event-offline"
                            self.yang_parent_name = "summary-external-event-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime)), ("path", ("path", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TriggerLsa)), ("time-line", ("time_line", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "summary-external-event-offline" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "summary-external-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines.SummaryExternalEventOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventOfflines']['meta_info']


                class PrefixEventOfflines(_Entity_):
                    """
                    OSPF Prefix events offline data
                    
                    .. attribute:: prefix_event_offline
                    
                    	Offline operational data for particular OSPF Prefix Event
                    	**type**\: list of  		 :py:class:`PrefixEventOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines, self).__init__()

                        self.yang_name = "prefix-event-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-offline", ("prefix_event_offline", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline))])
                        self._leafs = OrderedDict()

                        self.prefix_event_offline = YList(self)
                        self._segment_path = lambda: "prefix-event-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines, [], name, value)


                    class PrefixEventOffline(_Entity_):
                        """
                        Offline operational data for particular OSPF
                        Prefix Event
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline, self).__init__()

                            self.yang_name = "prefix-event-offline"
                            self.yang_parent_name = "prefix-event-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime)), ("path", ("path", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa)), ("time-line", ("time_line", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "prefix-event-offline" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines.PrefixEventOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.PrefixEventOfflines']['meta_info']


                class SummaryExternalEventStatistics(_Entity_):
                    """
                    Summary\-External prefix monitoring statistics
                    
                    .. attribute:: inter_area_routes
                    
                    	Total Inter\-Area Routes
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_added
                    
                    	Total IA Routes Added
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_modified
                    
                    	Total IA Routes Modified
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_deleted
                    
                    	Total IA Routes Deleted
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_critical
                    
                    	Total IA Routes Critical
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_high
                    
                    	Total IA Routes High
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_medium
                    
                    	Total IA Routes Medium
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: inter_area_low
                    
                    	Total IA Routes Low
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_routes
                    
                    	Total External Routes
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_added
                    
                    	Total Ext Routes Added
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_modified
                    
                    	Total Ext Routes Modified
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_deleted
                    
                    	Total Ext Routes Deleted
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_critical
                    
                    	Total Ext Routes Critical
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_high
                    
                    	Total Ext Routes High
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_medium
                    
                    	Total Ext Routes Medium
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: external_low
                    
                    	Total Ext Routes Low
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics, self).__init__()

                        self.yang_name = "summary-external-event-statistics"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('inter_area_routes', (YLeaf(YType.uint32, 'inter-area-routes'), ['int'])),
                            ('inter_area_added', (YLeaf(YType.uint32, 'inter-area-added'), ['int'])),
                            ('inter_area_modified', (YLeaf(YType.uint32, 'inter-area-modified'), ['int'])),
                            ('inter_area_deleted', (YLeaf(YType.uint32, 'inter-area-deleted'), ['int'])),
                            ('inter_area_critical', (YLeaf(YType.uint32, 'inter-area-critical'), ['int'])),
                            ('inter_area_high', (YLeaf(YType.uint32, 'inter-area-high'), ['int'])),
                            ('inter_area_medium', (YLeaf(YType.uint32, 'inter-area-medium'), ['int'])),
                            ('inter_area_low', (YLeaf(YType.uint32, 'inter-area-low'), ['int'])),
                            ('external_routes', (YLeaf(YType.uint32, 'external-routes'), ['int'])),
                            ('external_added', (YLeaf(YType.uint32, 'external-added'), ['int'])),
                            ('external_modified', (YLeaf(YType.uint32, 'external-modified'), ['int'])),
                            ('external_deleted', (YLeaf(YType.uint32, 'external-deleted'), ['int'])),
                            ('external_critical', (YLeaf(YType.uint32, 'external-critical'), ['int'])),
                            ('external_high', (YLeaf(YType.uint32, 'external-high'), ['int'])),
                            ('external_medium', (YLeaf(YType.uint32, 'external-medium'), ['int'])),
                            ('external_low', (YLeaf(YType.uint32, 'external-low'), ['int'])),
                        ])
                        self.inter_area_routes = None
                        self.inter_area_added = None
                        self.inter_area_modified = None
                        self.inter_area_deleted = None
                        self.inter_area_critical = None
                        self.inter_area_high = None
                        self.inter_area_medium = None
                        self.inter_area_low = None
                        self.external_routes = None
                        self.external_added = None
                        self.external_modified = None
                        self.external_deleted = None
                        self.external_critical = None
                        self.external_high = None
                        self.external_medium = None
                        self.external_low = None
                        self._segment_path = lambda: "summary-external-event-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics, ['inter_area_routes', 'inter_area_added', 'inter_area_modified', 'inter_area_deleted', 'inter_area_critical', 'inter_area_high', 'inter_area_medium', 'inter_area_low', 'external_routes', 'external_added', 'external_modified', 'external_deleted', 'external_critical', 'external_high', 'external_medium', 'external_low'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ospf.Instances.Instance.SummaryExternalEventStatistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Ospf.Instances.Instance']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Ospf.Instances']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Ospf']['meta_info']


    class Server(_Entity_):
        """
        Server Info
        
        .. attribute:: normal
        
        	Server Info
        	**type**\:  :py:class:`Normal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Normal>`
        
        	**config**\: False
        
        .. attribute:: detail
        
        	Server Info
        	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Detail>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Server, self).__init__()

            self.yang_name = "server"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("normal", ("normal", Rcmd.Server.Normal)), ("detail", ("detail", Rcmd.Server.Detail))])
            self._leafs = OrderedDict()

            self.normal = Rcmd.Server.Normal()
            self.normal.parent = self
            self._children_name_map["normal"] = "normal"

            self.detail = Rcmd.Server.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._segment_path = lambda: "server"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Server, [], name, value)


        class Normal(_Entity_):
            """
            Server Info
            
            .. attribute:: host_name
            
            	Configured Hostname
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: status
            
            	Server Status
            	**type**\:  :py:class:`RcmdBagEnableDisable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBagEnableDisable>`
            
            	**config**\: False
            
            .. attribute:: max_events
            
            	Maximum Events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: event_buffer_size
            
            	Event Buffer Size
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: monitoring_interval
            
            	Configured Monitor Interval
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: next_interval
            
            	Time for next processing
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: max_interface_count
            
            	Max Interface events count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: interface_count
            
            	Interface events count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_rp_count
            
            	RP count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_lc_count
            
            	LC count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: diag_node_count
            
            	Diag Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: disabled_node_count
            
            	Disabled Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: in_active_node_count
            
            	Disabled Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_process_start_time
            
            	Last Processing Start Time
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_process_duration
            
            	Last Processing Duration
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_process_state
            
            	Process state
            	**type**\:  :py:class:`RcmdShowPrcsState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowPrcsState>`
            
            	**config**\: False
            
            .. attribute:: process_count
            
            	Post Processing count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: spf_process_count
            
            	SPF Processing count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: reports_archive_path
            
            	Reports Archival Path
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: reports_archive_node
            
            	Reports Archival Node (Applicable for local location)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_status
            
            	Last Archival Status
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_error
            
            	Last Archival Error
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_error_time
            
            	Last Archival Status
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: archive_count
            
            	Archive Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: diagnostics_archive_path
            
            	Diagnostics Archival Path
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: diagnostics_archive_node
            
            	Diagnostics Archival Node (Applicable for local location)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol_config
            
            	Protocol level configuration
            	**type**\: list of  		 :py:class:`ProtocolConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Normal.ProtocolConfig>`
            
            	**config**\: False
            
            .. attribute:: server_detail
            
            	Detailed Information
            	**type**\: list of  		 :py:class:`ServerDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Normal.ServerDetail>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Server.Normal, self).__init__()

                self.yang_name = "normal"
                self.yang_parent_name = "server"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protocol-config", ("protocol_config", Rcmd.Server.Normal.ProtocolConfig)), ("server-detail", ("server_detail", Rcmd.Server.Normal.ServerDetail))])
                self._leafs = OrderedDict([
                    ('host_name', (YLeaf(YType.str, 'host-name'), ['str'])),
                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBagEnableDisable', '')])),
                    ('max_events', (YLeaf(YType.uint32, 'max-events'), ['int'])),
                    ('event_buffer_size', (YLeaf(YType.uint32, 'event-buffer-size'), ['int'])),
                    ('monitoring_interval', (YLeaf(YType.uint32, 'monitoring-interval'), ['int'])),
                    ('next_interval', (YLeaf(YType.uint32, 'next-interval'), ['int'])),
                    ('max_interface_count', (YLeaf(YType.uint32, 'max-interface-count'), ['int'])),
                    ('interface_count', (YLeaf(YType.uint32, 'interface-count'), ['int'])),
                    ('node_rp_count', (YLeaf(YType.uint32, 'node-rp-count'), ['int'])),
                    ('node_lc_count', (YLeaf(YType.uint32, 'node-lc-count'), ['int'])),
                    ('diag_node_count', (YLeaf(YType.uint32, 'diag-node-count'), ['int'])),
                    ('disabled_node_count', (YLeaf(YType.uint32, 'disabled-node-count'), ['int'])),
                    ('in_active_node_count', (YLeaf(YType.uint32, 'in-active-node-count'), ['int'])),
                    ('last_process_start_time', (YLeaf(YType.str, 'last-process-start-time'), ['str'])),
                    ('last_process_duration', (YLeaf(YType.str, 'last-process-duration'), ['str'])),
                    ('last_process_state', (YLeaf(YType.enumeration, 'last-process-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowPrcsState', '')])),
                    ('process_count', (YLeaf(YType.uint32, 'process-count'), ['int'])),
                    ('spf_process_count', (YLeaf(YType.uint32, 'spf-process-count'), ['int'])),
                    ('reports_archive_path', (YLeaf(YType.str, 'reports-archive-path'), ['str'])),
                    ('reports_archive_node', (YLeaf(YType.str, 'reports-archive-node'), ['str'])),
                    ('last_archival_status', (YLeaf(YType.str, 'last-archival-status'), ['str'])),
                    ('last_archival_error', (YLeaf(YType.str, 'last-archival-error'), ['str'])),
                    ('last_archival_error_time', (YLeaf(YType.str, 'last-archival-error-time'), ['str'])),
                    ('archive_count', (YLeaf(YType.uint32, 'archive-count'), ['int'])),
                    ('diagnostics_archive_path', (YLeaf(YType.str, 'diagnostics-archive-path'), ['str'])),
                    ('diagnostics_archive_node', (YLeaf(YType.str, 'diagnostics-archive-node'), ['str'])),
                ])
                self.host_name = None
                self.status = None
                self.max_events = None
                self.event_buffer_size = None
                self.monitoring_interval = None
                self.next_interval = None
                self.max_interface_count = None
                self.interface_count = None
                self.node_rp_count = None
                self.node_lc_count = None
                self.diag_node_count = None
                self.disabled_node_count = None
                self.in_active_node_count = None
                self.last_process_start_time = None
                self.last_process_duration = None
                self.last_process_state = None
                self.process_count = None
                self.spf_process_count = None
                self.reports_archive_path = None
                self.reports_archive_node = None
                self.last_archival_status = None
                self.last_archival_error = None
                self.last_archival_error_time = None
                self.archive_count = None
                self.diagnostics_archive_path = None
                self.diagnostics_archive_node = None

                self.protocol_config = YList(self)
                self.server_detail = YList(self)
                self._segment_path = lambda: "normal"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Server.Normal, ['host_name', 'status', 'max_events', 'event_buffer_size', 'monitoring_interval', 'next_interval', 'max_interface_count', 'interface_count', 'node_rp_count', 'node_lc_count', 'diag_node_count', 'disabled_node_count', 'in_active_node_count', 'last_process_start_time', 'last_process_duration', 'last_process_state', 'process_count', 'spf_process_count', 'reports_archive_path', 'reports_archive_node', 'last_archival_status', 'last_archival_error', 'last_archival_error_time', 'archive_count', 'diagnostics_archive_path', 'diagnostics_archive_node'], name, value)


            class ProtocolConfig(_Entity_):
                """
                Protocol level configuration
                
                .. attribute:: protocol_name
                
                	Protocol Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: priority
                
                	Priority level configuration
                	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Normal.ProtocolConfig.Priority>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Server.Normal.ProtocolConfig, self).__init__()

                    self.yang_name = "protocol-config"
                    self.yang_parent_name = "normal"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("priority", ("priority", Rcmd.Server.Normal.ProtocolConfig.Priority))])
                    self._leafs = OrderedDict([
                        ('protocol_name', (YLeaf(YType.str, 'protocol-name'), ['str'])),
                    ])
                    self.protocol_name = None

                    self.priority = YList(self)
                    self._segment_path = lambda: "protocol-config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/normal/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Server.Normal.ProtocolConfig, ['protocol_name'], name, value)


                class Priority(_Entity_):
                    """
                    Priority level configuration
                    
                    .. attribute:: priority_name
                    
                    	Priority Level
                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                    
                    	**config**\: False
                    
                    .. attribute:: threshold
                    
                    	threshold value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: disable
                    
                    	Enable/Disable cfg
                    	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Server.Normal.ProtocolConfig.Priority, self).__init__()

                        self.yang_name = "priority"
                        self.yang_parent_name = "protocol-config"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority_name', (YLeaf(YType.enumeration, 'priority-name'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                            ('threshold', (YLeaf(YType.uint32, 'threshold'), ['int'])),
                            ('disable', (YLeaf(YType.enumeration, 'disable'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                        ])
                        self.priority_name = None
                        self.threshold = None
                        self.disable = None
                        self._segment_path = lambda: "priority"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/normal/protocol-config/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Server.Normal.ProtocolConfig.Priority, ['priority_name', 'threshold', 'disable'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Server.Normal.ProtocolConfig.Priority']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Server.Normal.ProtocolConfig']['meta_info']


            class ServerDetail(_Entity_):
                """
                Detailed Information
                
                .. attribute:: overload_suspend
                
                	Overload suspend
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: memory_suspend
                
                	Memory Suspend
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: trace_information
                
                	Trace Information
                	**type**\: list of  		 :py:class:`TraceInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Normal.ServerDetail.TraceInformation>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Server.Normal.ServerDetail, self).__init__()

                    self.yang_name = "server-detail"
                    self.yang_parent_name = "normal"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("trace-information", ("trace_information", Rcmd.Server.Normal.ServerDetail.TraceInformation))])
                    self._leafs = OrderedDict([
                        ('overload_suspend', (YLeaf(YType.uint32, 'overload-suspend'), ['int'])),
                        ('memory_suspend', (YLeaf(YType.uint32, 'memory-suspend'), ['int'])),
                    ])
                    self.overload_suspend = None
                    self.memory_suspend = None

                    self.trace_information = YList(self)
                    self._segment_path = lambda: "server-detail"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/normal/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Server.Normal.ServerDetail, ['overload_suspend', 'memory_suspend'], name, value)


                class TraceInformation(_Entity_):
                    """
                    Trace Information
                    
                    .. attribute:: trace_name
                    
                    	Configured Hostname
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: total_stats
                    
                    	Server Total Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: last_run_stats
                    
                    	Server Last Run Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: error_stats
                    
                    	Server Error Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Server.Normal.ServerDetail.TraceInformation, self).__init__()

                        self.yang_name = "trace-information"
                        self.yang_parent_name = "server-detail"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('trace_name', (YLeaf(YType.str, 'trace-name'), ['str'])),
                            ('total_stats', (YLeaf(YType.uint32, 'total-stats'), ['int'])),
                            ('last_run_stats', (YLeaf(YType.uint32, 'last-run-stats'), ['int'])),
                            ('error_stats', (YLeaf(YType.uint32, 'error-stats'), ['int'])),
                        ])
                        self.trace_name = None
                        self.total_stats = None
                        self.last_run_stats = None
                        self.error_stats = None
                        self._segment_path = lambda: "trace-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/normal/server-detail/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Server.Normal.ServerDetail.TraceInformation, ['trace_name', 'total_stats', 'last_run_stats', 'error_stats'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Server.Normal.ServerDetail.TraceInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Server.Normal.ServerDetail']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Server.Normal']['meta_info']


        class Detail(_Entity_):
            """
            Server Info
            
            .. attribute:: host_name
            
            	Configured Hostname
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: status
            
            	Server Status
            	**type**\:  :py:class:`RcmdBagEnableDisable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBagEnableDisable>`
            
            	**config**\: False
            
            .. attribute:: max_events
            
            	Maximum Events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: event_buffer_size
            
            	Event Buffer Size
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: monitoring_interval
            
            	Configured Monitor Interval
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: next_interval
            
            	Time for next processing
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: max_interface_count
            
            	Max Interface events count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: interface_count
            
            	Interface events count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_rp_count
            
            	RP count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_lc_count
            
            	LC count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: diag_node_count
            
            	Diag Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: disabled_node_count
            
            	Disabled Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: in_active_node_count
            
            	Disabled Node count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_process_start_time
            
            	Last Processing Start Time
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_process_duration
            
            	Last Processing Duration
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_process_state
            
            	Process state
            	**type**\:  :py:class:`RcmdShowPrcsState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowPrcsState>`
            
            	**config**\: False
            
            .. attribute:: process_count
            
            	Post Processing count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: spf_process_count
            
            	SPF Processing count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: reports_archive_path
            
            	Reports Archival Path
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: reports_archive_node
            
            	Reports Archival Node (Applicable for local location)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_status
            
            	Last Archival Status
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_error
            
            	Last Archival Error
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: last_archival_error_time
            
            	Last Archival Status
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: archive_count
            
            	Archive Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: diagnostics_archive_path
            
            	Diagnostics Archival Path
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: diagnostics_archive_node
            
            	Diagnostics Archival Node (Applicable for local location)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol_config
            
            	Protocol level configuration
            	**type**\: list of  		 :py:class:`ProtocolConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Detail.ProtocolConfig>`
            
            	**config**\: False
            
            .. attribute:: server_detail
            
            	Detailed Information
            	**type**\: list of  		 :py:class:`ServerDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Detail.ServerDetail>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Server.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "server"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protocol-config", ("protocol_config", Rcmd.Server.Detail.ProtocolConfig)), ("server-detail", ("server_detail", Rcmd.Server.Detail.ServerDetail))])
                self._leafs = OrderedDict([
                    ('host_name', (YLeaf(YType.str, 'host-name'), ['str'])),
                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBagEnableDisable', '')])),
                    ('max_events', (YLeaf(YType.uint32, 'max-events'), ['int'])),
                    ('event_buffer_size', (YLeaf(YType.uint32, 'event-buffer-size'), ['int'])),
                    ('monitoring_interval', (YLeaf(YType.uint32, 'monitoring-interval'), ['int'])),
                    ('next_interval', (YLeaf(YType.uint32, 'next-interval'), ['int'])),
                    ('max_interface_count', (YLeaf(YType.uint32, 'max-interface-count'), ['int'])),
                    ('interface_count', (YLeaf(YType.uint32, 'interface-count'), ['int'])),
                    ('node_rp_count', (YLeaf(YType.uint32, 'node-rp-count'), ['int'])),
                    ('node_lc_count', (YLeaf(YType.uint32, 'node-lc-count'), ['int'])),
                    ('diag_node_count', (YLeaf(YType.uint32, 'diag-node-count'), ['int'])),
                    ('disabled_node_count', (YLeaf(YType.uint32, 'disabled-node-count'), ['int'])),
                    ('in_active_node_count', (YLeaf(YType.uint32, 'in-active-node-count'), ['int'])),
                    ('last_process_start_time', (YLeaf(YType.str, 'last-process-start-time'), ['str'])),
                    ('last_process_duration', (YLeaf(YType.str, 'last-process-duration'), ['str'])),
                    ('last_process_state', (YLeaf(YType.enumeration, 'last-process-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowPrcsState', '')])),
                    ('process_count', (YLeaf(YType.uint32, 'process-count'), ['int'])),
                    ('spf_process_count', (YLeaf(YType.uint32, 'spf-process-count'), ['int'])),
                    ('reports_archive_path', (YLeaf(YType.str, 'reports-archive-path'), ['str'])),
                    ('reports_archive_node', (YLeaf(YType.str, 'reports-archive-node'), ['str'])),
                    ('last_archival_status', (YLeaf(YType.str, 'last-archival-status'), ['str'])),
                    ('last_archival_error', (YLeaf(YType.str, 'last-archival-error'), ['str'])),
                    ('last_archival_error_time', (YLeaf(YType.str, 'last-archival-error-time'), ['str'])),
                    ('archive_count', (YLeaf(YType.uint32, 'archive-count'), ['int'])),
                    ('diagnostics_archive_path', (YLeaf(YType.str, 'diagnostics-archive-path'), ['str'])),
                    ('diagnostics_archive_node', (YLeaf(YType.str, 'diagnostics-archive-node'), ['str'])),
                ])
                self.host_name = None
                self.status = None
                self.max_events = None
                self.event_buffer_size = None
                self.monitoring_interval = None
                self.next_interval = None
                self.max_interface_count = None
                self.interface_count = None
                self.node_rp_count = None
                self.node_lc_count = None
                self.diag_node_count = None
                self.disabled_node_count = None
                self.in_active_node_count = None
                self.last_process_start_time = None
                self.last_process_duration = None
                self.last_process_state = None
                self.process_count = None
                self.spf_process_count = None
                self.reports_archive_path = None
                self.reports_archive_node = None
                self.last_archival_status = None
                self.last_archival_error = None
                self.last_archival_error_time = None
                self.archive_count = None
                self.diagnostics_archive_path = None
                self.diagnostics_archive_node = None

                self.protocol_config = YList(self)
                self.server_detail = YList(self)
                self._segment_path = lambda: "detail"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Server.Detail, ['host_name', 'status', 'max_events', 'event_buffer_size', 'monitoring_interval', 'next_interval', 'max_interface_count', 'interface_count', 'node_rp_count', 'node_lc_count', 'diag_node_count', 'disabled_node_count', 'in_active_node_count', 'last_process_start_time', 'last_process_duration', 'last_process_state', 'process_count', 'spf_process_count', 'reports_archive_path', 'reports_archive_node', 'last_archival_status', 'last_archival_error', 'last_archival_error_time', 'archive_count', 'diagnostics_archive_path', 'diagnostics_archive_node'], name, value)


            class ProtocolConfig(_Entity_):
                """
                Protocol level configuration
                
                .. attribute:: protocol_name
                
                	Protocol Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: priority
                
                	Priority level configuration
                	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Detail.ProtocolConfig.Priority>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Server.Detail.ProtocolConfig, self).__init__()

                    self.yang_name = "protocol-config"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("priority", ("priority", Rcmd.Server.Detail.ProtocolConfig.Priority))])
                    self._leafs = OrderedDict([
                        ('protocol_name', (YLeaf(YType.str, 'protocol-name'), ['str'])),
                    ])
                    self.protocol_name = None

                    self.priority = YList(self)
                    self._segment_path = lambda: "protocol-config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Server.Detail.ProtocolConfig, ['protocol_name'], name, value)


                class Priority(_Entity_):
                    """
                    Priority level configuration
                    
                    .. attribute:: priority_name
                    
                    	Priority Level
                    	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                    
                    	**config**\: False
                    
                    .. attribute:: threshold
                    
                    	threshold value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: disable
                    
                    	Enable/Disable cfg
                    	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Server.Detail.ProtocolConfig.Priority, self).__init__()

                        self.yang_name = "priority"
                        self.yang_parent_name = "protocol-config"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority_name', (YLeaf(YType.enumeration, 'priority-name'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                            ('threshold', (YLeaf(YType.uint32, 'threshold'), ['int'])),
                            ('disable', (YLeaf(YType.enumeration, 'disable'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                        ])
                        self.priority_name = None
                        self.threshold = None
                        self.disable = None
                        self._segment_path = lambda: "priority"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/detail/protocol-config/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Server.Detail.ProtocolConfig.Priority, ['priority_name', 'threshold', 'disable'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Server.Detail.ProtocolConfig.Priority']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Server.Detail.ProtocolConfig']['meta_info']


            class ServerDetail(_Entity_):
                """
                Detailed Information
                
                .. attribute:: overload_suspend
                
                	Overload suspend
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: memory_suspend
                
                	Memory Suspend
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: trace_information
                
                	Trace Information
                	**type**\: list of  		 :py:class:`TraceInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Server.Detail.ServerDetail.TraceInformation>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Server.Detail.ServerDetail, self).__init__()

                    self.yang_name = "server-detail"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("trace-information", ("trace_information", Rcmd.Server.Detail.ServerDetail.TraceInformation))])
                    self._leafs = OrderedDict([
                        ('overload_suspend', (YLeaf(YType.uint32, 'overload-suspend'), ['int'])),
                        ('memory_suspend', (YLeaf(YType.uint32, 'memory-suspend'), ['int'])),
                    ])
                    self.overload_suspend = None
                    self.memory_suspend = None

                    self.trace_information = YList(self)
                    self._segment_path = lambda: "server-detail"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Server.Detail.ServerDetail, ['overload_suspend', 'memory_suspend'], name, value)


                class TraceInformation(_Entity_):
                    """
                    Trace Information
                    
                    .. attribute:: trace_name
                    
                    	Configured Hostname
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: total_stats
                    
                    	Server Total Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: last_run_stats
                    
                    	Server Last Run Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: error_stats
                    
                    	Server Error Status
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Server.Detail.ServerDetail.TraceInformation, self).__init__()

                        self.yang_name = "trace-information"
                        self.yang_parent_name = "server-detail"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('trace_name', (YLeaf(YType.str, 'trace-name'), ['str'])),
                            ('total_stats', (YLeaf(YType.uint32, 'total-stats'), ['int'])),
                            ('last_run_stats', (YLeaf(YType.uint32, 'last-run-stats'), ['int'])),
                            ('error_stats', (YLeaf(YType.uint32, 'error-stats'), ['int'])),
                        ])
                        self.trace_name = None
                        self.total_stats = None
                        self.last_run_stats = None
                        self.error_stats = None
                        self._segment_path = lambda: "trace-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/server/detail/server-detail/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Server.Detail.ServerDetail.TraceInformation, ['trace_name', 'total_stats', 'last_run_stats', 'error_stats'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Server.Detail.ServerDetail.TraceInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Server.Detail.ServerDetail']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Server.Detail']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Server']['meta_info']


    class Node(_Entity_):
        """
        Node Info
        
        .. attribute:: node_information
        
        	Node Info
        	**type**\: list of  		 :py:class:`NodeInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Node.NodeInformation>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Node, self).__init__()

            self.yang_name = "node"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("node-information", ("node_information", Rcmd.Node.NodeInformation))])
            self._leafs = OrderedDict()

            self.node_information = YList(self)
            self._segment_path = lambda: "node"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Node, [], name, value)


        class NodeInformation(_Entity_):
            """
            Node Info
            
            .. attribute:: node_id
            
            	Node Id
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_name
            
            	Node Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: rack_id
            
            	Rack Id
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_update_time
            
            	Last Updated Time
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: fwd_referenced
            
            	Forward Referenced
            	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
            
            	**config**\: False
            
            .. attribute:: node_type
            
            	Node Type
            	**type**\:  :py:class:`RcmdShowNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowNode>`
            
            	**config**\: False
            
            .. attribute:: software_state
            
            	Software State
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: card_state
            
            	Card State
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_state
            
            	Node State
            	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
            
            	**config**\: False
            
            .. attribute:: status
            
            	Status
            	**type**\:  :py:class:`RcmdBagEnblDsbl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBagEnblDsbl>`
            
            	**config**\: False
            
            .. attribute:: diag_mode
            
            	Diag Mode
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: redundancy_state
            
            	Redundancy State
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Node.NodeInformation, self).__init__()

                self.yang_name = "node-information"
                self.yang_parent_name = "node"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('node_id', (YLeaf(YType.uint32, 'node-id'), ['int'])),
                    ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                    ('rack_id', (YLeaf(YType.uint32, 'rack-id'), ['int'])),
                    ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                    ('fwd_referenced', (YLeaf(YType.enumeration, 'fwd-referenced'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                    ('node_type', (YLeaf(YType.enumeration, 'node-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowNode', '')])),
                    ('software_state', (YLeaf(YType.uint32, 'software-state'), ['int'])),
                    ('card_state', (YLeaf(YType.uint32, 'card-state'), ['int'])),
                    ('node_state', (YLeaf(YType.enumeration, 'node-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBagEnblDsbl', '')])),
                    ('diag_mode', (YLeaf(YType.uint32, 'diag-mode'), ['int'])),
                    ('redundancy_state', (YLeaf(YType.uint32, 'redundancy-state'), ['int'])),
                ])
                self.node_id = None
                self.node_name = None
                self.rack_id = None
                self.last_update_time = None
                self.fwd_referenced = None
                self.node_type = None
                self.software_state = None
                self.card_state = None
                self.node_state = None
                self.status = None
                self.diag_mode = None
                self.redundancy_state = None
                self._segment_path = lambda: "node-information"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/node/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Node.NodeInformation, ['node_id', 'node_name', 'rack_id', 'last_update_time', 'fwd_referenced', 'node_type', 'software_state', 'card_state', 'node_state', 'status', 'diag_mode', 'redundancy_state'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Node.NodeInformation']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Node']['meta_info']


    class Isis(_Entity_):
        """
        Operational data for ISIS
        
        .. attribute:: instances
        
        	Operational data
        	**type**\:  :py:class:`Instances <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Isis, self).__init__()

            self.yang_name = "isis"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("instances", ("instances", Rcmd.Isis.Instances))])
            self._leafs = OrderedDict()

            self.instances = Rcmd.Isis.Instances()
            self.instances.parent = self
            self._children_name_map["instances"] = "instances"
            self._segment_path = lambda: "isis"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Isis, [], name, value)


        class Instances(_Entity_):
            """
            Operational data
            
            .. attribute:: instance
            
            	Operational data for a particular instance
            	**type**\: list of  		 :py:class:`Instance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Isis.Instances, self).__init__()

                self.yang_name = "instances"
                self.yang_parent_name = "isis"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("instance", ("instance", Rcmd.Isis.Instances.Instance))])
                self._leafs = OrderedDict()

                self.instance = YList(self)
                self._segment_path = lambda: "instances"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/isis/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Isis.Instances, [], name, value)


            class Instance(_Entity_):
                """
                Operational data for a particular instance
                
                .. attribute:: instance_name  (key)
                
                	Operational data for a particular instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_summaries
                
                	ISIS IP\-FRR events summary data
                	**type**\:  :py:class:`IpfrrEventSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventSummaries>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_statistics
                
                	ISIS Prefix events statistics data
                	**type**\:  :py:class:`PrefixEventStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventStatistics>`
                
                	**config**\: False
                
                .. attribute:: spf_run_summaries
                
                	ISIS SPF run summary data
                	**type**\:  :py:class:`SpfRunSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries>`
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_offlines
                
                	ISIS IP\-FRR Event offline data
                	**type**\:  :py:class:`IpfrrEventOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventOfflines>`
                
                	**config**\: False
                
                .. attribute:: spf_run_offlines
                
                	ISIS SPF run offline data
                	**type**\:  :py:class:`SpfRunOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_summaries
                
                	ISIS Prefix events summary data
                	**type**\:  :py:class:`PrefixEventSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries>`
                
                	**config**\: False
                
                .. attribute:: prefix_event_offlines
                
                	ISIS Prefix events offline data
                	**type**\:  :py:class:`PrefixEventOfflines <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines>`
                
                	**config**\: False
                
                .. attribute:: lsp_regenerateds
                
                	Regenerated LSP data
                	**type**\:  :py:class:`LspRegenerateds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.LspRegenerateds>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Isis.Instances.Instance, self).__init__()

                    self.yang_name = "instance"
                    self.yang_parent_name = "instances"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['instance_name']
                    self._child_classes = OrderedDict([("ipfrr-event-summaries", ("ipfrr_event_summaries", Rcmd.Isis.Instances.Instance.IpfrrEventSummaries)), ("prefix-event-statistics", ("prefix_event_statistics", Rcmd.Isis.Instances.Instance.PrefixEventStatistics)), ("spf-run-summaries", ("spf_run_summaries", Rcmd.Isis.Instances.Instance.SpfRunSummaries)), ("ipfrr-event-offlines", ("ipfrr_event_offlines", Rcmd.Isis.Instances.Instance.IpfrrEventOfflines)), ("spf-run-offlines", ("spf_run_offlines", Rcmd.Isis.Instances.Instance.SpfRunOfflines)), ("prefix-event-summaries", ("prefix_event_summaries", Rcmd.Isis.Instances.Instance.PrefixEventSummaries)), ("prefix-event-offlines", ("prefix_event_offlines", Rcmd.Isis.Instances.Instance.PrefixEventOfflines)), ("lsp-regenerateds", ("lsp_regenerateds", Rcmd.Isis.Instances.Instance.LspRegenerateds))])
                    self._leafs = OrderedDict([
                        ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ])
                    self.instance_name = None

                    self.ipfrr_event_summaries = Rcmd.Isis.Instances.Instance.IpfrrEventSummaries()
                    self.ipfrr_event_summaries.parent = self
                    self._children_name_map["ipfrr_event_summaries"] = "ipfrr-event-summaries"

                    self.prefix_event_statistics = Rcmd.Isis.Instances.Instance.PrefixEventStatistics()
                    self.prefix_event_statistics.parent = self
                    self._children_name_map["prefix_event_statistics"] = "prefix-event-statistics"

                    self.spf_run_summaries = Rcmd.Isis.Instances.Instance.SpfRunSummaries()
                    self.spf_run_summaries.parent = self
                    self._children_name_map["spf_run_summaries"] = "spf-run-summaries"

                    self.ipfrr_event_offlines = Rcmd.Isis.Instances.Instance.IpfrrEventOfflines()
                    self.ipfrr_event_offlines.parent = self
                    self._children_name_map["ipfrr_event_offlines"] = "ipfrr-event-offlines"

                    self.spf_run_offlines = Rcmd.Isis.Instances.Instance.SpfRunOfflines()
                    self.spf_run_offlines.parent = self
                    self._children_name_map["spf_run_offlines"] = "spf-run-offlines"

                    self.prefix_event_summaries = Rcmd.Isis.Instances.Instance.PrefixEventSummaries()
                    self.prefix_event_summaries.parent = self
                    self._children_name_map["prefix_event_summaries"] = "prefix-event-summaries"

                    self.prefix_event_offlines = Rcmd.Isis.Instances.Instance.PrefixEventOfflines()
                    self.prefix_event_offlines.parent = self
                    self._children_name_map["prefix_event_offlines"] = "prefix-event-offlines"

                    self.lsp_regenerateds = Rcmd.Isis.Instances.Instance.LspRegenerateds()
                    self.lsp_regenerateds.parent = self
                    self._children_name_map["lsp_regenerateds"] = "lsp-regenerateds"
                    self._segment_path = lambda: "instance" + "[instance-name='" + str(self.instance_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/isis/instances/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Isis.Instances.Instance, ['instance_name'], name, value)


                class IpfrrEventSummaries(_Entity_):
                    """
                    ISIS IP\-FRR events summary data
                    
                    .. attribute:: ipfrr_event_summary
                    
                    	IP\-FRR Event data
                    	**type**\: list of  		 :py:class:`IpfrrEventSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries, self).__init__()

                        self.yang_name = "ipfrr-event-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipfrr-event-summary", ("ipfrr_event_summary", Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary))])
                        self._leafs = OrderedDict()

                        self.ipfrr_event_summary = YList(self)
                        self._segment_path = lambda: "ipfrr-event-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries, [], name, value)


                    class IpfrrEventSummary(_Entity_):
                        """
                        IP\-FRR Event data
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific IP\-FRR Event
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: event_id_xr
                        
                        	IP\-Frr Event ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Trigger time  (eg\: Apr 24 13\:16\:04.961)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_spf_run
                        
                        	IP\-Frr Triggered reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Waiting Time (in milliseconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: start_time_offset
                        
                        	Start Time offset from trigger time (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: duration
                        
                        	Duration for the calculation (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: completed_spf_run
                        
                        	IP\-Frr Completed reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_routes
                        
                        	Cumulative Number of Routes for all priorities
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fully_protected_routes
                        
                        	Cumulative Number of Fully Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: partially_protected_routes
                        
                        	Cumulative Number of Partially Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: coverage
                        
                        	Coverage in percentage for all priorities
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: percentage
                        
                        .. attribute:: ipfrr_statistic
                        
                        	IP\-Frr Statistics categorized by priority
                        	**type**\: list of  		 :py:class:`IpfrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_node
                        
                        	Remote Node Information
                        	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary, self).__init__()

                            self.yang_name = "ipfrr-event-summary"
                            self.yang_parent_name = "ipfrr-event-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ipfrr-statistic", ("ipfrr_statistic", Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic)), ("remote-node", ("remote_node", Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                ('trigger_spf_run', (YLeaf(YType.uint32, 'trigger-spf-run'), ['int'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('start_time_offset', (YLeaf(YType.str, 'start-time-offset'), ['str'])),
                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ('completed_spf_run', (YLeaf(YType.uint32, 'completed-spf-run'), ['int'])),
                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                            ])
                            self.event_id = None
                            self.event_id_xr = None
                            self.trigger_time = None
                            self.trigger_spf_run = None
                            self.wait_time = None
                            self.start_time_offset = None
                            self.duration = None
                            self.completed_spf_run = None
                            self.total_routes = None
                            self.fully_protected_routes = None
                            self.partially_protected_routes = None
                            self.coverage = None

                            self.ipfrr_statistic = YList(self)
                            self.remote_node = YList(self)
                            self._segment_path = lambda: "ipfrr-event-summary" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary, ['event_id', 'event_id_xr', 'trigger_time', 'trigger_spf_run', 'wait_time', 'start_time_offset', 'duration', 'completed_spf_run', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)


                        class IpfrrStatistic(_Entity_):
                            """
                            IP\-Frr Statistics categorized by priority
                            
                            .. attribute:: priority
                            
                            	Priority
                            	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                            
                            	**config**\: False
                            
                            .. attribute:: total_routes
                            
                            	Total Number of Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fully_protected_routes
                            
                            	Fully Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: partially_protected_routes
                            
                            	Partially Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: coverage
                            
                            	Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: local_lfa_coverage
                            
                            	Local LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: remote_lfa_coverage
                            
                            	Remote LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: below_threshold
                            
                            	Covearge is below Configured Threshold
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic, self).__init__()

                                self.yang_name = "ipfrr-statistic"
                                self.yang_parent_name = "ipfrr-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                    ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                    ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                    ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                    ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                    ('local_lfa_coverage', (YLeaf(YType.str, 'local-lfa-coverage'), ['str'])),
                                    ('remote_lfa_coverage', (YLeaf(YType.str, 'remote-lfa-coverage'), ['str'])),
                                    ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                                ])
                                self.priority = None
                                self.total_routes = None
                                self.fully_protected_routes = None
                                self.partially_protected_routes = None
                                self.coverage = None
                                self.local_lfa_coverage = None
                                self.remote_lfa_coverage = None
                                self.below_threshold = None
                                self._segment_path = lambda: "ipfrr-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic, ['priority', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage', 'local_lfa_coverage', 'remote_lfa_coverage', 'below_threshold'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.IpfrrStatistic']['meta_info']


                        class RemoteNode(_Entity_):
                            """
                            Remote Node Information
                            
                            .. attribute:: remote_node_id
                            
                            	Remote\-LFA Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_count
                            
                            	Number of paths protected by this Remote Node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: in_use_time
                            
                            	Inuse time of the Remote Node (eg\: Apr 24 13\:16 \:04.961)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: primary_path
                            
                            	Protected Primary Paths
                            	**type**\: list of  		 :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode, self).__init__()

                                self.yang_name = "remote-node"
                                self.yang_parent_name = "ipfrr-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-path", ("primary_path", Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath))])
                                self._leafs = OrderedDict([
                                    ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                                    ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                                ])
                                self.remote_node_id = None
                                self.interface_name = None
                                self.neighbour_address = None
                                self.path_count = None
                                self.in_use_time = None

                                self.primary_path = YList(self)
                                self._segment_path = lambda: "remote-node"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode, ['remote_node_id', 'interface_name', 'neighbour_address', 'path_count', 'in_use_time'], name, value)


                            class PrimaryPath(_Entity_):
                                """
                                Protected Primary Paths
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath, self).__init__()

                                    self.yang_name = "primary-path"
                                    self.yang_parent_name = "remote-node"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ])
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self._segment_path = lambda: "primary-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath, ['interface_name', 'neighbour_address'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode.PrimaryPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary.RemoteNode']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventSummaries.IpfrrEventSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventSummaries']['meta_info']


                class PrefixEventStatistics(_Entity_):
                    """
                    ISIS Prefix events statistics data
                    
                    .. attribute:: prefix_event_statistic
                    
                    	Monitoring Statistics
                    	**type**\: list of  		 :py:class:`PrefixEventStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.PrefixEventStatistics, self).__init__()

                        self.yang_name = "prefix-event-statistics"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-statistic", ("prefix_event_statistic", Rcmd.Isis.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic))])
                        self._leafs = OrderedDict()

                        self.prefix_event_statistic = YList(self)
                        self._segment_path = lambda: "prefix-event-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventStatistics, [], name, value)


                    class PrefixEventStatistic(_Entity_):
                        """
                        Monitoring Statistics
                        
                        .. attribute:: prefix_info  (key)
                        
                        	Events with Prefix
                        	**type**\: union of the below types:
                        
                        		**type**\: str
                        
                        			**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                        
                        		**type**\: str
                        
                        			**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_event_time
                        
                        	Last event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: last_priority
                        
                        	Last event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_route_type
                        
                        	Last event Route Type
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_change_type
                        
                        	Last event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_cost
                        
                        	Last Known Cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: critical_priority
                        
                        	No. of times processed under Critical Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_priority
                        
                        	No. of times processed under High Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: medium_priority
                        
                        	No. of times processed under Medium Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: low_priority
                        
                        	No. of times processed under Low Priority
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: add_count
                        
                        	No. of times route gets Added
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: modify_count
                        
                        	No. of times route gets Deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: delete_count
                        
                        	No. of times route gets Deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceed_count
                        
                        	No. of times threshold got exceeded
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic, self).__init__()

                            self.yang_name = "prefix-event-statistic"
                            self.yang_parent_name = "prefix-event-statistics"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['prefix_info']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('prefix_info', (YLeaf(YType.str, 'prefix-info'), ['str','str'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('last_event_time', (YLeaf(YType.str, 'last-event-time'), ['str'])),
                                ('last_priority', (YLeaf(YType.enumeration, 'last-priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('last_route_type', (YLeaf(YType.enumeration, 'last-route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('last_change_type', (YLeaf(YType.enumeration, 'last-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('last_cost', (YLeaf(YType.uint32, 'last-cost'), ['int'])),
                                ('critical_priority', (YLeaf(YType.uint32, 'critical-priority'), ['int'])),
                                ('high_priority', (YLeaf(YType.uint32, 'high-priority'), ['int'])),
                                ('medium_priority', (YLeaf(YType.uint32, 'medium-priority'), ['int'])),
                                ('low_priority', (YLeaf(YType.uint32, 'low-priority'), ['int'])),
                                ('add_count', (YLeaf(YType.uint32, 'add-count'), ['int'])),
                                ('modify_count', (YLeaf(YType.uint32, 'modify-count'), ['int'])),
                                ('delete_count', (YLeaf(YType.uint32, 'delete-count'), ['int'])),
                                ('threshold_exceed_count', (YLeaf(YType.uint32, 'threshold-exceed-count'), ['int'])),
                            ])
                            self.prefix_info = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.last_event_time = None
                            self.last_priority = None
                            self.last_route_type = None
                            self.last_change_type = None
                            self.last_cost = None
                            self.critical_priority = None
                            self.high_priority = None
                            self.medium_priority = None
                            self.low_priority = None
                            self.add_count = None
                            self.modify_count = None
                            self.delete_count = None
                            self.threshold_exceed_count = None
                            self._segment_path = lambda: "prefix-event-statistic" + "[prefix-info='" + str(self.prefix_info) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic, ['prefix_info', 'prefix', 'prefix_lenth', 'last_event_time', 'last_priority', 'last_route_type', 'last_change_type', 'last_cost', 'critical_priority', 'high_priority', 'medium_priority', 'low_priority', 'add_count', 'modify_count', 'delete_count', 'threshold_exceed_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventStatistics.PrefixEventStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventStatistics']['meta_info']


                class SpfRunSummaries(_Entity_):
                    """
                    ISIS SPF run summary data
                    
                    .. attribute:: spf_run_summary
                    
                    	SPF Event data
                    	**type**\: list of  		 :py:class:`SpfRunSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries, self).__init__()

                        self.yang_name = "spf-run-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("spf-run-summary", ("spf_run_summary", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary))])
                        self._leafs = OrderedDict()

                        self.spf_run_summary = YList(self)
                        self._segment_path = lambda: "spf-run-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries, [], name, value)


                    class SpfRunSummary(_Entity_):
                        """
                        SPF Event data
                        
                        .. attribute:: spf_run_number  (key)
                        
                        	Specific SPF run
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_summary
                        
                        	SPF summary information
                        	**type**\:  :py:class:`SpfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary>`
                        
                        	**config**\: False
                        
                        .. attribute:: node_statistics
                        
                        	SPF Node statistics
                        	**type**\:  :py:class:`NodeStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: start_time
                        
                        	Start time (offset from event trigger time in ss .msec)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Wait time applied at SPF schedule (in msec)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reason
                        
                        	Trigger reasons for SPF run. Example\: pr^ \- periodic, cr^ \- clear (Check the documentation for the entire list)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsp
                        
                        	Trigger LSP
                        	**type**\: list of  		 :py:class:`TriggerLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.TriggerLsp>`
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Convergence information on per\-priority basis
                        	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_processed
                        
                        	List of LSP changes processed
                        	**type**\: list of  		 :py:class:`LspProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspProcessed>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_regenerated
                        
                        	List of LSP regenerated
                        	**type**\: list of  		 :py:class:`LspRegenerated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspRegenerated>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary, self).__init__()

                            self.yang_name = "spf-run-summary"
                            self.yang_parent_name = "spf-run-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['spf_run_number']
                            self._child_classes = OrderedDict([("spf-summary", ("spf_summary", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary)), ("node-statistics", ("node_statistics", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics)), ("trigger-lsp", ("trigger_lsp", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.TriggerLsp)), ("priority", ("priority", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority)), ("lsp-processed", ("lsp_processed", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspProcessed)), ("lsp-regenerated", ("lsp_regenerated", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspRegenerated))])
                            self._leafs = OrderedDict([
                                ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('reason', (YLeaf(YType.str, 'reason'), ['str'])),
                            ])
                            self.spf_run_number = None
                            self.start_time = None
                            self.wait_time = None
                            self.reason = None

                            self.spf_summary = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary()
                            self.spf_summary.parent = self
                            self._children_name_map["spf_summary"] = "spf-summary"

                            self.node_statistics = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics()
                            self.node_statistics.parent = self
                            self._children_name_map["node_statistics"] = "node-statistics"

                            self.trigger_lsp = YList(self)
                            self.priority = YList(self)
                            self.lsp_processed = YList(self)
                            self.lsp_regenerated = YList(self)
                            self._segment_path = lambda: "spf-run-summary" + "[spf-run-number='" + str(self.spf_run_number) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary, ['spf_run_number', 'start_time', 'wait_time', 'reason'], name, value)


                        class SpfSummary(_Entity_):
                            """
                            SPF summary information
                            
                            .. attribute:: topology
                            
                            	Topology index (multi\-topology)
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: isis_level
                            
                            	ISIS Level
                            	**type**\:  :py:class:`RcmdIsisLvl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisLvl>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type of SPF
                            	**type**\:  :py:class:`RcmdIsisSpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisSpf>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: state
                            
                            	SPF state
                            	**type**\:  :py:class:`RcmdSpfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdSpfState>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_data_complete
                            
                            	Whether the event has all information
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of SPF calculation (in ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: total_lsp_changes
                            
                            	Total number of LSP changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: priority_summary
                            
                            	Convergence information summary on per\-priority basis
                            	**type**\: list of  		 :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary, self).__init__()

                                self.yang_name = "spf-summary"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary))])
                                self._leafs = OrderedDict([
                                    ('topology', (YLeaf(YType.uint32, 'topology'), ['int'])),
                                    ('isis_level', (YLeaf(YType.enumeration, 'isis-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisLvl', '')])),
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisSpf', '')])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdSpfState', '')])),
                                    ('is_data_complete', (YLeaf(YType.boolean, 'is-data-complete'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                    ('total_lsp_changes', (YLeaf(YType.uint16, 'total-lsp-changes'), ['int'])),
                                ])
                                self.topology = None
                                self.isis_level = None
                                self.type = None
                                self.threshold_exceeded = None
                                self.state = None
                                self.is_data_complete = None
                                self.trigger_time = None
                                self.duration = None
                                self.total_lsp_changes = None

                                self.priority_summary = YList(self)
                                self._segment_path = lambda: "spf-summary"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary, ['topology', 'isis_level', 'type', 'threshold_exceeded', 'state', 'is_data_complete', 'trigger_time', 'duration', 'total_lsp_changes'], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Convergence information summary on per\-priority
                                basis
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "spf-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary.PrioritySummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.SpfSummary']['meta_info']


                        class NodeStatistics(_Entity_):
                            """
                            SPF Node statistics
                            
                            .. attribute:: adds
                            
                            	Added
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: deletes
                            
                            	Deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: modifies
                            
                            	Modified
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reachables
                            
                            	Reachable
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: unreachables
                            
                            	Unreachable
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: touches
                            
                            	Touched
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics, self).__init__()

                                self.yang_name = "node-statistics"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                    ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                    ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                    ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                    ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                    ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                ])
                                self.adds = None
                                self.deletes = None
                                self.modifies = None
                                self.reachables = None
                                self.unreachables = None
                                self.touches = None
                                self._segment_path = lambda: "node-statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.NodeStatistics']['meta_info']


                        class TriggerLsp(_Entity_):
                            """
                            Trigger LSP
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.TriggerLsp, self).__init__()

                                self.yang_name = "trigger-lsp"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsp_id = None
                                self.sequence_number = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.TriggerLsp, ['lsp_id', 'sequence_number', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.TriggerLsp']['meta_info']


                        class Priority(_Entity_):
                            """
                            Convergence information on per\-priority basis
                            
                            .. attribute:: priority_summary
                            
                            	Summary of the priority
                            	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary>`
                            
                            	**config**\: False
                            
                            .. attribute:: convergence_timeline
                            
                            	Convergence timeline details
                            	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline>`
                            
                            	**config**\: False
                            
                            .. attribute:: leaf_networks_added
                            
                            	List of Leaf Networks Added
                            	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksAdded>`
                            
                            	**config**\: False
                            
                            .. attribute:: leaf_networks_deleted
                            
                            	List of Leaf Networks Deleted
                            	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksDeleted>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority, self).__init__()

                                self.yang_name = "priority"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksDeleted))])
                                self._leafs = OrderedDict()

                                self.priority_summary = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary()
                                self.priority_summary.parent = self
                                self._children_name_map["priority_summary"] = "priority-summary"

                                self.convergence_timeline = YList(self)
                                self.leaf_networks_added = YList(self)
                                self.leaf_networks_deleted = YList(self)
                                self._segment_path = lambda: "priority"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority, [], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Summary of the priority
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.PrioritySummary']['meta_info']


                            class ConvergenceTimeline(_Entity_):
                                """
                                Convergence timeline details
                                
                                .. attribute:: route_origin
                                
                                	Route origin (routing protocol)
                                	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_enter
                                
                                	Entry point of IPv4 RIB
                                	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_exit
                                
                                	Exit point from IPv4 RIB to FIBs
                                	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_redistribute
                                
                                	Route Redistribute point from IPv4 RIB to LDP
                                	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: ldp_enter
                                
                                	Entry point of LDP
                                	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter>`
                                
                                	**config**\: False
                                
                                .. attribute:: ldp_exit
                                
                                	Exit point of LDP to LSD
                                	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsd_enter
                                
                                	Entry point of LSD
                                	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsd_exit
                                
                                	Exit point of LSD to FIBs
                                	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit>`
                                
                                	**config**\: False
                                
                                .. attribute:: lc_ip
                                
                                	List of Linecards' completion point for IP routes
                                	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp>`
                                
                                	**config**\: False
                                
                                .. attribute:: lc_mpls
                                
                                	List of Linecards' completion point for MPLS labels
                                	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline, self).__init__()

                                    self.yang_name = "convergence-timeline"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls))])
                                    self._leafs = OrderedDict()

                                    self.route_origin = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin()
                                    self.route_origin.parent = self
                                    self._children_name_map["route_origin"] = "route-origin"

                                    self.ri_bv4_enter = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter()
                                    self.ri_bv4_enter.parent = self
                                    self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                    self.ri_bv4_exit = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit()
                                    self.ri_bv4_exit.parent = self
                                    self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                    self.ri_bv4_redistribute = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                    self.ri_bv4_redistribute.parent = self
                                    self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                    self.ldp_enter = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter()
                                    self.ldp_enter.parent = self
                                    self._children_name_map["ldp_enter"] = "ldp-enter"

                                    self.ldp_exit = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit()
                                    self.ldp_exit.parent = self
                                    self._children_name_map["ldp_exit"] = "ldp-exit"

                                    self.lsd_enter = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter()
                                    self.lsd_enter.parent = self
                                    self._children_name_map["lsd_enter"] = "lsd-enter"

                                    self.lsd_exit = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit()
                                    self.lsd_exit.parent = self
                                    self._children_name_map["lsd_exit"] = "lsd-exit"

                                    self.lc_ip = YList(self)
                                    self.lc_mpls = YList(self)
                                    self._segment_path = lambda: "convergence-timeline"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline, [], name, value)


                                class RouteOrigin(_Entity_):
                                    """
                                    Route origin (routing protocol)
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                        self.yang_name = "route-origin"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "route-origin"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                class RiBv4Enter(_Entity_):
                                    """
                                    Entry point of IPv4 RIB
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                        self.yang_name = "ri-bv4-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                class RiBv4Exit(_Entity_):
                                    """
                                    Exit point from IPv4 RIB to FIBs
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                        self.yang_name = "ri-bv4-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                class RiBv4Redistribute(_Entity_):
                                    """
                                    Route Redistribute point from IPv4 RIB to LDP
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                        self.yang_name = "ri-bv4-redistribute"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-redistribute"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                class LdpEnter(_Entity_):
                                    """
                                    Entry point of LDP
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                        self.yang_name = "ldp-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ldp-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                class LdpExit(_Entity_):
                                    """
                                    Exit point of LDP to LSD
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                        self.yang_name = "ldp-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ldp-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                class LsdEnter(_Entity_):
                                    """
                                    Entry point of LSD
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                        self.yang_name = "lsd-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "lsd-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                class LsdExit(_Entity_):
                                    """
                                    Exit point of LSD to FIBs
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                        self.yang_name = "lsd-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "lsd-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                class LcIp(_Entity_):
                                    """
                                    List of Linecards' completion point for IP
                                    routes
                                    
                                    .. attribute:: fib_complete
                                    
                                    	Completion point of FIB
                                    	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: node_name
                                    
                                    	Linecard node name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: speed
                                    
                                    	Relative convergence speed
                                    	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                        self.yang_name = "lc-ip"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                        self._leafs = OrderedDict([
                                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                            ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ])
                                        self.node_name = None
                                        self.speed = None

                                        self.fib_complete = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                        self.fib_complete.parent = self
                                        self._children_name_map["fib_complete"] = "fib-complete"
                                        self._segment_path = lambda: "lc-ip"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                    class FibComplete(_Entity_):
                                        """
                                        Completion point of FIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                            self.yang_name = "fib-complete"
                                            self.yang_parent_name = "lc-ip"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "fib-complete"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                class LcMpls(_Entity_):
                                    """
                                    List of Linecards' completion point for MPLS
                                    labels
                                    
                                    .. attribute:: fib_complete
                                    
                                    	Completion point of FIB
                                    	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: node_name
                                    
                                    	Linecard node name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: speed
                                    
                                    	Relative convergence speed
                                    	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                        self.yang_name = "lc-mpls"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                        self._leafs = OrderedDict([
                                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                            ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ])
                                        self.node_name = None
                                        self.speed = None

                                        self.fib_complete = Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                        self.fib_complete.parent = self
                                        self._children_name_map["fib_complete"] = "fib-complete"
                                        self._segment_path = lambda: "lc-mpls"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                    class FibComplete(_Entity_):
                                        """
                                        Completion point of FIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                            self.yang_name = "fib-complete"
                                            self.yang_parent_name = "lc-mpls"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "fib-complete"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.ConvergenceTimeline']['meta_info']


                            class LeafNetworksAdded(_Entity_):
                                """
                                List of Leaf Networks Added
                                
                                .. attribute:: address
                                
                                	IP address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: net_mask
                                
                                	Mask
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksAdded, self).__init__()

                                    self.yang_name = "leaf-networks-added"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                    ])
                                    self.address = None
                                    self.net_mask = None
                                    self._segment_path = lambda: "leaf-networks-added"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksAdded']['meta_info']


                            class LeafNetworksDeleted(_Entity_):
                                """
                                List of Leaf Networks Deleted
                                
                                .. attribute:: address
                                
                                	IP address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: net_mask
                                
                                	Mask
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksDeleted, self).__init__()

                                    self.yang_name = "leaf-networks-deleted"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                    ])
                                    self.address = None
                                    self.net_mask = None
                                    self._segment_path = lambda: "leaf-networks-deleted"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority.LeafNetworksDeleted']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.Priority']['meta_info']


                        class LspProcessed(_Entity_):
                            """
                            List of LSP changes processed
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspProcessed, self).__init__()

                                self.yang_name = "lsp-processed"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsp_id = None
                                self.sequence_number = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsp-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspProcessed, ['lsp_id', 'sequence_number', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspProcessed']['meta_info']


                        class LspRegenerated(_Entity_):
                            """
                            List of LSP regenerated
                            
                            .. attribute:: serial_number_xr
                            
                            	Serial Number of the session event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: isis_level
                            
                            	ISIS Level
                            	**type**\:  :py:class:`RcmdIsisLvl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisLvl>`
                            
                            	**config**\: False
                            
                            .. attribute:: spf_run_number
                            
                            	SPF Run Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Trigger reasons for LSP regeneration. Example\: pr^ \- periodic, cr^ \- clear (Check the documentation for the entire list)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspRegenerated, self).__init__()

                                self.yang_name = "lsp-regenerated"
                                self.yang_parent_name = "spf-run-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('serial_number_xr', (YLeaf(YType.uint32, 'serial-number-xr'), ['int'])),
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ('isis_level', (YLeaf(YType.enumeration, 'isis-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisLvl', '')])),
                                    ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                                    ('reason', (YLeaf(YType.str, 'reason'), ['str'])),
                                ])
                                self.serial_number_xr = None
                                self.lsp_id = None
                                self.sequence_number = None
                                self.reception_time = None
                                self.isis_level = None
                                self.spf_run_number = None
                                self.reason = None
                                self._segment_path = lambda: "lsp-regenerated"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspRegenerated, ['serial_number_xr', 'lsp_id', 'sequence_number', 'reception_time', 'isis_level', 'spf_run_number', 'reason'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary.LspRegenerated']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries.SpfRunSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunSummaries']['meta_info']


                class IpfrrEventOfflines(_Entity_):
                    """
                    ISIS IP\-FRR Event offline data
                    
                    .. attribute:: ipfrr_event_offline
                    
                    	Offline operational data for particular ISIS IP\-FRR Event
                    	**type**\: list of  		 :py:class:`IpfrrEventOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines, self).__init__()

                        self.yang_name = "ipfrr-event-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ipfrr-event-offline", ("ipfrr_event_offline", Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline))])
                        self._leafs = OrderedDict()

                        self.ipfrr_event_offline = YList(self)
                        self._segment_path = lambda: "ipfrr-event-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines, [], name, value)


                    class IpfrrEventOffline(_Entity_):
                        """
                        Offline operational data for particular ISIS
                        IP\-FRR Event
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific IP\-FRR Event
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: event_id_xr
                        
                        	IP\-Frr Event ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Trigger time  (eg\: Apr 24 13\:16\:04.961)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_spf_run
                        
                        	IP\-Frr Triggered reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Waiting Time (in milliseconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: start_time_offset
                        
                        	Start Time offset from trigger time (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: duration
                        
                        	Duration for the calculation (in milliseconds)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: completed_spf_run
                        
                        	IP\-Frr Completed reference SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_routes
                        
                        	Cumulative Number of Routes for all priorities
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fully_protected_routes
                        
                        	Cumulative Number of Fully Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: partially_protected_routes
                        
                        	Cumulative Number of Partially Protected Routes
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: coverage
                        
                        	Coverage in percentage for all priorities
                        	**type**\: str
                        
                        	**config**\: False
                        
                        	**units**\: percentage
                        
                        .. attribute:: ipfrr_statistic
                        
                        	IP\-Frr Statistics categorized by priority
                        	**type**\: list of  		 :py:class:`IpfrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_node
                        
                        	Remote Node Information
                        	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline, self).__init__()

                            self.yang_name = "ipfrr-event-offline"
                            self.yang_parent_name = "ipfrr-event-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ipfrr-statistic", ("ipfrr_statistic", Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic)), ("remote-node", ("remote_node", Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                ('trigger_spf_run', (YLeaf(YType.uint32, 'trigger-spf-run'), ['int'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('start_time_offset', (YLeaf(YType.str, 'start-time-offset'), ['str'])),
                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                ('completed_spf_run', (YLeaf(YType.uint32, 'completed-spf-run'), ['int'])),
                                ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                            ])
                            self.event_id = None
                            self.event_id_xr = None
                            self.trigger_time = None
                            self.trigger_spf_run = None
                            self.wait_time = None
                            self.start_time_offset = None
                            self.duration = None
                            self.completed_spf_run = None
                            self.total_routes = None
                            self.fully_protected_routes = None
                            self.partially_protected_routes = None
                            self.coverage = None

                            self.ipfrr_statistic = YList(self)
                            self.remote_node = YList(self)
                            self._segment_path = lambda: "ipfrr-event-offline" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline, ['event_id', 'event_id_xr', 'trigger_time', 'trigger_spf_run', 'wait_time', 'start_time_offset', 'duration', 'completed_spf_run', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)


                        class IpfrrStatistic(_Entity_):
                            """
                            IP\-Frr Statistics categorized by priority
                            
                            .. attribute:: priority
                            
                            	Priority
                            	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                            
                            	**config**\: False
                            
                            .. attribute:: total_routes
                            
                            	Total Number of Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fully_protected_routes
                            
                            	Fully Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: partially_protected_routes
                            
                            	Partially Protected Routes
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: coverage
                            
                            	Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: local_lfa_coverage
                            
                            	Local LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: remote_lfa_coverage
                            
                            	Remote LFA Coverage in percentage
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: percentage
                            
                            .. attribute:: below_threshold
                            
                            	Covearge is below Configured Threshold
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic, self).__init__()

                                self.yang_name = "ipfrr-statistic"
                                self.yang_parent_name = "ipfrr-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                    ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                    ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                    ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                    ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                    ('local_lfa_coverage', (YLeaf(YType.str, 'local-lfa-coverage'), ['str'])),
                                    ('remote_lfa_coverage', (YLeaf(YType.str, 'remote-lfa-coverage'), ['str'])),
                                    ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                                ])
                                self.priority = None
                                self.total_routes = None
                                self.fully_protected_routes = None
                                self.partially_protected_routes = None
                                self.coverage = None
                                self.local_lfa_coverage = None
                                self.remote_lfa_coverage = None
                                self.below_threshold = None
                                self._segment_path = lambda: "ipfrr-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic, ['priority', 'total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage', 'local_lfa_coverage', 'remote_lfa_coverage', 'below_threshold'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.IpfrrStatistic']['meta_info']


                        class RemoteNode(_Entity_):
                            """
                            Remote Node Information
                            
                            .. attribute:: remote_node_id
                            
                            	Remote\-LFA Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_count
                            
                            	Number of paths protected by this Remote Node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: in_use_time
                            
                            	Inuse time of the Remote Node (eg\: Apr 24 13\:16 \:04.961)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: primary_path
                            
                            	Protected Primary Paths
                            	**type**\: list of  		 :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode, self).__init__()

                                self.yang_name = "remote-node"
                                self.yang_parent_name = "ipfrr-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-path", ("primary_path", Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath))])
                                self._leafs = OrderedDict([
                                    ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                                    ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                                ])
                                self.remote_node_id = None
                                self.interface_name = None
                                self.neighbour_address = None
                                self.path_count = None
                                self.in_use_time = None

                                self.primary_path = YList(self)
                                self._segment_path = lambda: "remote-node"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode, ['remote_node_id', 'interface_name', 'neighbour_address', 'path_count', 'in_use_time'], name, value)


                            class PrimaryPath(_Entity_):
                                """
                                Protected Primary Paths
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath, self).__init__()

                                    self.yang_name = "primary-path"
                                    self.yang_parent_name = "remote-node"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ])
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self._segment_path = lambda: "primary-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath, ['interface_name', 'neighbour_address'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode.PrimaryPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline.RemoteNode']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventOfflines.IpfrrEventOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.IpfrrEventOfflines']['meta_info']


                class SpfRunOfflines(_Entity_):
                    """
                    ISIS SPF run offline data
                    
                    .. attribute:: spf_run_offline
                    
                    	Offline operational data for particular ISIS SPF run
                    	**type**\: list of  		 :py:class:`SpfRunOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines, self).__init__()

                        self.yang_name = "spf-run-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("spf-run-offline", ("spf_run_offline", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline))])
                        self._leafs = OrderedDict()

                        self.spf_run_offline = YList(self)
                        self._segment_path = lambda: "spf-run-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines, [], name, value)


                    class SpfRunOffline(_Entity_):
                        """
                        Offline operational data for particular ISIS
                        SPF run
                        
                        .. attribute:: spf_run_number  (key)
                        
                        	Specific SPF run
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_summary
                        
                        	SPF summary information
                        	**type**\:  :py:class:`SpfSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary>`
                        
                        	**config**\: False
                        
                        .. attribute:: node_statistics
                        
                        	SPF Node statistics
                        	**type**\:  :py:class:`NodeStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: start_time
                        
                        	Start time (offset from event trigger time in ss .msec)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: wait_time
                        
                        	Wait time applied at SPF schedule (in msec)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reason
                        
                        	Trigger reasons for SPF run. Example\: pr^ \- periodic, cr^ \- clear (Check the documentation for the entire list)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsp
                        
                        	Trigger LSP
                        	**type**\: list of  		 :py:class:`TriggerLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.TriggerLsp>`
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Convergence information on per\-priority basis
                        	**type**\: list of  		 :py:class:`Priority <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_processed
                        
                        	List of LSP changes processed
                        	**type**\: list of  		 :py:class:`LspProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspProcessed>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_regenerated
                        
                        	List of LSP regenerated
                        	**type**\: list of  		 :py:class:`LspRegenerated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspRegenerated>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline, self).__init__()

                            self.yang_name = "spf-run-offline"
                            self.yang_parent_name = "spf-run-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['spf_run_number']
                            self._child_classes = OrderedDict([("spf-summary", ("spf_summary", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary)), ("node-statistics", ("node_statistics", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics)), ("trigger-lsp", ("trigger_lsp", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.TriggerLsp)), ("priority", ("priority", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority)), ("lsp-processed", ("lsp_processed", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspProcessed)), ("lsp-regenerated", ("lsp_regenerated", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspRegenerated))])
                            self._leafs = OrderedDict([
                                ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                ('wait_time', (YLeaf(YType.uint32, 'wait-time'), ['int'])),
                                ('reason', (YLeaf(YType.str, 'reason'), ['str'])),
                            ])
                            self.spf_run_number = None
                            self.start_time = None
                            self.wait_time = None
                            self.reason = None

                            self.spf_summary = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary()
                            self.spf_summary.parent = self
                            self._children_name_map["spf_summary"] = "spf-summary"

                            self.node_statistics = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics()
                            self.node_statistics.parent = self
                            self._children_name_map["node_statistics"] = "node-statistics"

                            self.trigger_lsp = YList(self)
                            self.priority = YList(self)
                            self.lsp_processed = YList(self)
                            self.lsp_regenerated = YList(self)
                            self._segment_path = lambda: "spf-run-offline" + "[spf-run-number='" + str(self.spf_run_number) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline, ['spf_run_number', 'start_time', 'wait_time', 'reason'], name, value)


                        class SpfSummary(_Entity_):
                            """
                            SPF summary information
                            
                            .. attribute:: topology
                            
                            	Topology index (multi\-topology)
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: isis_level
                            
                            	ISIS Level
                            	**type**\:  :py:class:`RcmdIsisLvl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisLvl>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type of SPF
                            	**type**\:  :py:class:`RcmdIsisSpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisSpf>`
                            
                            	**config**\: False
                            
                            .. attribute:: threshold_exceeded
                            
                            	Threshold exceeded
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: state
                            
                            	SPF state
                            	**type**\:  :py:class:`RcmdSpfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdSpfState>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_data_complete
                            
                            	Whether the event has all information
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: trigger_time
                            
                            	Trigger time (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: duration
                            
                            	Duration of SPF calculation (in ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: total_lsp_changes
                            
                            	Total number of LSP changes processed
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: priority_summary
                            
                            	Convergence information summary on per\-priority basis
                            	**type**\: list of  		 :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary, self).__init__()

                                self.yang_name = "spf-summary"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary))])
                                self._leafs = OrderedDict([
                                    ('topology', (YLeaf(YType.uint32, 'topology'), ['int'])),
                                    ('isis_level', (YLeaf(YType.enumeration, 'isis-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisLvl', '')])),
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisSpf', '')])),
                                    ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdSpfState', '')])),
                                    ('is_data_complete', (YLeaf(YType.boolean, 'is-data-complete'), ['bool'])),
                                    ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                                    ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                    ('total_lsp_changes', (YLeaf(YType.uint16, 'total-lsp-changes'), ['int'])),
                                ])
                                self.topology = None
                                self.isis_level = None
                                self.type = None
                                self.threshold_exceeded = None
                                self.state = None
                                self.is_data_complete = None
                                self.trigger_time = None
                                self.duration = None
                                self.total_lsp_changes = None

                                self.priority_summary = YList(self)
                                self._segment_path = lambda: "spf-summary"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary, ['topology', 'isis_level', 'type', 'threshold_exceeded', 'state', 'is_data_complete', 'trigger_time', 'duration', 'total_lsp_changes'], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Convergence information summary on per\-priority
                                basis
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "spf-summary"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary.PrioritySummary']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.SpfSummary']['meta_info']


                        class NodeStatistics(_Entity_):
                            """
                            SPF Node statistics
                            
                            .. attribute:: adds
                            
                            	Added
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: deletes
                            
                            	Deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: modifies
                            
                            	Modified
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reachables
                            
                            	Reachable
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: unreachables
                            
                            	Unreachable
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: touches
                            
                            	Touched
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics, self).__init__()

                                self.yang_name = "node-statistics"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                    ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                    ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                    ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                    ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                    ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                ])
                                self.adds = None
                                self.deletes = None
                                self.modifies = None
                                self.reachables = None
                                self.unreachables = None
                                self.touches = None
                                self._segment_path = lambda: "node-statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.NodeStatistics']['meta_info']


                        class TriggerLsp(_Entity_):
                            """
                            Trigger LSP
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.TriggerLsp, self).__init__()

                                self.yang_name = "trigger-lsp"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsp_id = None
                                self.sequence_number = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.TriggerLsp, ['lsp_id', 'sequence_number', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.TriggerLsp']['meta_info']


                        class Priority(_Entity_):
                            """
                            Convergence information on per\-priority basis
                            
                            .. attribute:: priority_summary
                            
                            	Summary of the priority
                            	**type**\:  :py:class:`PrioritySummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary>`
                            
                            	**config**\: False
                            
                            .. attribute:: convergence_timeline
                            
                            	Convergence timeline details
                            	**type**\: list of  		 :py:class:`ConvergenceTimeline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline>`
                            
                            	**config**\: False
                            
                            .. attribute:: leaf_networks_added
                            
                            	List of Leaf Networks Added
                            	**type**\: list of  		 :py:class:`LeafNetworksAdded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksAdded>`
                            
                            	**config**\: False
                            
                            .. attribute:: leaf_networks_deleted
                            
                            	List of Leaf Networks Deleted
                            	**type**\: list of  		 :py:class:`LeafNetworksDeleted <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksDeleted>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority, self).__init__()

                                self.yang_name = "priority"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("priority-summary", ("priority_summary", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary)), ("convergence-timeline", ("convergence_timeline", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline)), ("leaf-networks-added", ("leaf_networks_added", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksAdded)), ("leaf-networks-deleted", ("leaf_networks_deleted", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksDeleted))])
                                self._leafs = OrderedDict()

                                self.priority_summary = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary()
                                self.priority_summary.parent = self
                                self._children_name_map["priority_summary"] = "priority-summary"

                                self.convergence_timeline = YList(self)
                                self.leaf_networks_added = YList(self)
                                self.leaf_networks_deleted = YList(self)
                                self._segment_path = lambda: "priority"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority, [], name, value)


                            class PrioritySummary(_Entity_):
                                """
                                Summary of the priority
                                
                                .. attribute:: route_statistics
                                
                                	Route statistics
                                	**type**\:  :py:class:`RouteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: ip_convergence_time
                                
                                	Convergence time for IP route programming
                                	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: mpls_convergence_time
                                
                                	Convergence time for MPLS label programming
                                	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime>`
                                
                                	**config**\: False
                                
                                .. attribute:: level
                                
                                	Critical, High, Medium or Low
                                	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: threshold_exceeded
                                
                                	Threshold exceeded
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: frr_statistic
                                
                                	Fast Re\-Route Statistics
                                	**type**\: list of  		 :py:class:`FrrStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.FrrStatistic>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary, self).__init__()

                                    self.yang_name = "priority-summary"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-statistics", ("route_statistics", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics)), ("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime)), ("frr-statistic", ("frr_statistic", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.FrrStatistic))])
                                    self._leafs = OrderedDict([
                                        ('level', (YLeaf(YType.enumeration, 'level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                        ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                    ])
                                    self.level = None
                                    self.threshold_exceeded = None

                                    self.route_statistics = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics()
                                    self.route_statistics.parent = self
                                    self._children_name_map["route_statistics"] = "route-statistics"

                                    self.ip_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime()
                                    self.ip_convergence_time.parent = self
                                    self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                                    self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime()
                                    self.mpls_convergence_time.parent = self
                                    self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                                    self.frr_statistic = YList(self)
                                    self._segment_path = lambda: "priority-summary"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary, ['level', 'threshold_exceeded'], name, value)


                                class RouteStatistics(_Entity_):
                                    """
                                    Route statistics
                                    
                                    .. attribute:: adds
                                    
                                    	Added
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: deletes
                                    
                                    	Deleted
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: modifies
                                    
                                    	Modified
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: reachables
                                    
                                    	Reachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unreachables
                                    
                                    	Unreachable
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: touches
                                    
                                    	Touched
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics, self).__init__()

                                        self.yang_name = "route-statistics"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('adds', (YLeaf(YType.uint32, 'adds'), ['int'])),
                                            ('deletes', (YLeaf(YType.uint32, 'deletes'), ['int'])),
                                            ('modifies', (YLeaf(YType.uint32, 'modifies'), ['int'])),
                                            ('reachables', (YLeaf(YType.uint32, 'reachables'), ['int'])),
                                            ('unreachables', (YLeaf(YType.uint32, 'unreachables'), ['int'])),
                                            ('touches', (YLeaf(YType.uint32, 'touches'), ['int'])),
                                        ])
                                        self.adds = None
                                        self.deletes = None
                                        self.modifies = None
                                        self.reachables = None
                                        self.unreachables = None
                                        self.touches = None
                                        self._segment_path = lambda: "route-statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics, ['adds', 'deletes', 'modifies', 'reachables', 'unreachables', 'touches'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.RouteStatistics']['meta_info']


                                class IpConvergenceTime(_Entity_):
                                    """
                                    Convergence time for IP route programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime, self).__init__()

                                        self.yang_name = "ip-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "ip-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.IpConvergenceTime']['meta_info']


                                class MplsConvergenceTime(_Entity_):
                                    """
                                    Convergence time for MPLS label programming
                                    
                                    .. attribute:: minimum_time
                                    
                                    	Minimum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: maximum_time
                                    
                                    	Maximum time(in seconds.milliseconds)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: millisecond
                                    
                                    .. attribute:: slowest_node_name
                                    
                                    	Linecard node name which took the maximum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fastest_node_name
                                    
                                    	Linecard node name which took the minimum time
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime, self).__init__()

                                        self.yang_name = "mpls-convergence-time"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                            ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                            ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                            ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                        ])
                                        self.minimum_time = None
                                        self.maximum_time = None
                                        self.slowest_node_name = None
                                        self.fastest_node_name = None
                                        self._segment_path = lambda: "mpls-convergence-time"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.MplsConvergenceTime']['meta_info']


                                class FrrStatistic(_Entity_):
                                    """
                                    Fast Re\-Route Statistics
                                    
                                    .. attribute:: total_routes
                                    
                                    	Total Number of Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fully_protected_routes
                                    
                                    	Fully Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: partially_protected_routes
                                    
                                    	Partially Protected Routes
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: coverage
                                    
                                    	Coverage in percentage
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    	**units**\: percentage
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.FrrStatistic, self).__init__()

                                        self.yang_name = "frr-statistic"
                                        self.yang_parent_name = "priority-summary"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('total_routes', (YLeaf(YType.uint32, 'total-routes'), ['int'])),
                                            ('fully_protected_routes', (YLeaf(YType.uint32, 'fully-protected-routes'), ['int'])),
                                            ('partially_protected_routes', (YLeaf(YType.uint32, 'partially-protected-routes'), ['int'])),
                                            ('coverage', (YLeaf(YType.str, 'coverage'), ['str'])),
                                        ])
                                        self.total_routes = None
                                        self.fully_protected_routes = None
                                        self.partially_protected_routes = None
                                        self.coverage = None
                                        self._segment_path = lambda: "frr-statistic"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.FrrStatistic, ['total_routes', 'fully_protected_routes', 'partially_protected_routes', 'coverage'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary.FrrStatistic']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.PrioritySummary']['meta_info']


                            class ConvergenceTimeline(_Entity_):
                                """
                                Convergence timeline details
                                
                                .. attribute:: route_origin
                                
                                	Route origin (routing protocol)
                                	**type**\:  :py:class:`RouteOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_enter
                                
                                	Entry point of IPv4 RIB
                                	**type**\:  :py:class:`RiBv4Enter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_exit
                                
                                	Exit point from IPv4 RIB to FIBs
                                	**type**\:  :py:class:`RiBv4Exit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit>`
                                
                                	**config**\: False
                                
                                .. attribute:: ri_bv4_redistribute
                                
                                	Route Redistribute point from IPv4 RIB to LDP
                                	**type**\:  :py:class:`RiBv4Redistribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: ldp_enter
                                
                                	Entry point of LDP
                                	**type**\:  :py:class:`LdpEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter>`
                                
                                	**config**\: False
                                
                                .. attribute:: ldp_exit
                                
                                	Exit point of LDP to LSD
                                	**type**\:  :py:class:`LdpExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsd_enter
                                
                                	Entry point of LSD
                                	**type**\:  :py:class:`LsdEnter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsd_exit
                                
                                	Exit point of LSD to FIBs
                                	**type**\:  :py:class:`LsdExit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit>`
                                
                                	**config**\: False
                                
                                .. attribute:: lc_ip
                                
                                	List of Linecards' completion point for IP routes
                                	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp>`
                                
                                	**config**\: False
                                
                                .. attribute:: lc_mpls
                                
                                	List of Linecards' completion point for MPLS labels
                                	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline, self).__init__()

                                    self.yang_name = "convergence-timeline"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("route-origin", ("route_origin", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin)), ("ri-bv4-enter", ("ri_bv4_enter", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter)), ("ri-bv4-exit", ("ri_bv4_exit", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit)), ("ri-bv4-redistribute", ("ri_bv4_redistribute", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute)), ("ldp-enter", ("ldp_enter", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter)), ("ldp-exit", ("ldp_exit", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit)), ("lsd-enter", ("lsd_enter", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter)), ("lsd-exit", ("lsd_exit", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit)), ("lc-ip", ("lc_ip", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls))])
                                    self._leafs = OrderedDict()

                                    self.route_origin = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin()
                                    self.route_origin.parent = self
                                    self._children_name_map["route_origin"] = "route-origin"

                                    self.ri_bv4_enter = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter()
                                    self.ri_bv4_enter.parent = self
                                    self._children_name_map["ri_bv4_enter"] = "ri-bv4-enter"

                                    self.ri_bv4_exit = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit()
                                    self.ri_bv4_exit.parent = self
                                    self._children_name_map["ri_bv4_exit"] = "ri-bv4-exit"

                                    self.ri_bv4_redistribute = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute()
                                    self.ri_bv4_redistribute.parent = self
                                    self._children_name_map["ri_bv4_redistribute"] = "ri-bv4-redistribute"

                                    self.ldp_enter = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter()
                                    self.ldp_enter.parent = self
                                    self._children_name_map["ldp_enter"] = "ldp-enter"

                                    self.ldp_exit = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit()
                                    self.ldp_exit.parent = self
                                    self._children_name_map["ldp_exit"] = "ldp-exit"

                                    self.lsd_enter = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter()
                                    self.lsd_enter.parent = self
                                    self._children_name_map["lsd_enter"] = "lsd-enter"

                                    self.lsd_exit = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit()
                                    self.lsd_exit.parent = self
                                    self._children_name_map["lsd_exit"] = "lsd-exit"

                                    self.lc_ip = YList(self)
                                    self.lc_mpls = YList(self)
                                    self._segment_path = lambda: "convergence-timeline"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline, [], name, value)


                                class RouteOrigin(_Entity_):
                                    """
                                    Route origin (routing protocol)
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin, self).__init__()

                                        self.yang_name = "route-origin"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "route-origin"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RouteOrigin']['meta_info']


                                class RiBv4Enter(_Entity_):
                                    """
                                    Entry point of IPv4 RIB
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter, self).__init__()

                                        self.yang_name = "ri-bv4-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Enter']['meta_info']


                                class RiBv4Exit(_Entity_):
                                    """
                                    Exit point from IPv4 RIB to FIBs
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit, self).__init__()

                                        self.yang_name = "ri-bv4-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Exit']['meta_info']


                                class RiBv4Redistribute(_Entity_):
                                    """
                                    Route Redistribute point from IPv4 RIB to LDP
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute, self).__init__()

                                        self.yang_name = "ri-bv4-redistribute"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ri-bv4-redistribute"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.RiBv4Redistribute']['meta_info']


                                class LdpEnter(_Entity_):
                                    """
                                    Entry point of LDP
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter, self).__init__()

                                        self.yang_name = "ldp-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ldp-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpEnter']['meta_info']


                                class LdpExit(_Entity_):
                                    """
                                    Exit point of LDP to LSD
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit, self).__init__()

                                        self.yang_name = "ldp-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "ldp-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LdpExit']['meta_info']


                                class LsdEnter(_Entity_):
                                    """
                                    Entry point of LSD
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter, self).__init__()

                                        self.yang_name = "lsd-enter"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "lsd-enter"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdEnter']['meta_info']


                                class LsdExit(_Entity_):
                                    """
                                    Exit point of LSD to FIBs
                                    
                                    .. attribute:: start_time
                                    
                                    	First route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: end_time
                                    
                                    	Last route process time relative to event trigger time (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: duration
                                    
                                    	Duration of processing (in ss.msec)
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit, self).__init__()

                                        self.yang_name = "lsd-exit"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                            ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                            ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                        ])
                                        self.start_time = None
                                        self.end_time = None
                                        self.duration = None
                                        self._segment_path = lambda: "lsd-exit"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit, ['start_time', 'end_time', 'duration'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LsdExit']['meta_info']


                                class LcIp(_Entity_):
                                    """
                                    List of Linecards' completion point for IP
                                    routes
                                    
                                    .. attribute:: fib_complete
                                    
                                    	Completion point of FIB
                                    	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: node_name
                                    
                                    	Linecard node name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: speed
                                    
                                    	Relative convergence speed
                                    	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp, self).__init__()

                                        self.yang_name = "lc-ip"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete))])
                                        self._leafs = OrderedDict([
                                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                            ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ])
                                        self.node_name = None
                                        self.speed = None

                                        self.fib_complete = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete()
                                        self.fib_complete.parent = self
                                        self._children_name_map["fib_complete"] = "fib-complete"
                                        self._segment_path = lambda: "lc-ip"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp, ['node_name', 'speed'], name, value)


                                    class FibComplete(_Entity_):
                                        """
                                        Completion point of FIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete, self).__init__()

                                            self.yang_name = "fib-complete"
                                            self.yang_parent_name = "lc-ip"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "fib-complete"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp.FibComplete']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcIp']['meta_info']


                                class LcMpls(_Entity_):
                                    """
                                    List of Linecards' completion point for MPLS
                                    labels
                                    
                                    .. attribute:: fib_complete
                                    
                                    	Completion point of FIB
                                    	**type**\:  :py:class:`FibComplete <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: node_name
                                    
                                    	Linecard node name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: speed
                                    
                                    	Relative convergence speed
                                    	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'infra-rcmd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls, self).__init__()

                                        self.yang_name = "lc-mpls"
                                        self.yang_parent_name = "convergence-timeline"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fib-complete", ("fib_complete", Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete))])
                                        self._leafs = OrderedDict([
                                            ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                            ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ])
                                        self.node_name = None
                                        self.speed = None

                                        self.fib_complete = Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete()
                                        self.fib_complete.parent = self
                                        self._children_name_map["fib_complete"] = "fib-complete"
                                        self._segment_path = lambda: "lc-mpls"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls, ['node_name', 'speed'], name, value)


                                    class FibComplete(_Entity_):
                                        """
                                        Completion point of FIB
                                        
                                        .. attribute:: start_time
                                        
                                        	First route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: end_time
                                        
                                        	Last route process time relative to event trigger time (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration of processing (in ss.msec)
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'infra-rcmd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete, self).__init__()

                                            self.yang_name = "fib-complete"
                                            self.yang_parent_name = "lc-mpls"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('start_time', (YLeaf(YType.str, 'start-time'), ['str'])),
                                                ('end_time', (YLeaf(YType.str, 'end-time'), ['str'])),
                                                ('duration', (YLeaf(YType.str, 'duration'), ['str'])),
                                            ])
                                            self.start_time = None
                                            self.end_time = None
                                            self.duration = None
                                            self._segment_path = lambda: "fib-complete"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete, ['start_time', 'end_time', 'duration'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls.FibComplete']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline.LcMpls']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.ConvergenceTimeline']['meta_info']


                            class LeafNetworksAdded(_Entity_):
                                """
                                List of Leaf Networks Added
                                
                                .. attribute:: address
                                
                                	IP address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: net_mask
                                
                                	Mask
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksAdded, self).__init__()

                                    self.yang_name = "leaf-networks-added"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                    ])
                                    self.address = None
                                    self.net_mask = None
                                    self._segment_path = lambda: "leaf-networks-added"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksAdded, ['address', 'net_mask'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksAdded']['meta_info']


                            class LeafNetworksDeleted(_Entity_):
                                """
                                List of Leaf Networks Deleted
                                
                                .. attribute:: address
                                
                                	IP address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: net_mask
                                
                                	Mask
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksDeleted, self).__init__()

                                    self.yang_name = "leaf-networks-deleted"
                                    self.yang_parent_name = "priority"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('net_mask', (YLeaf(YType.uint8, 'net-mask'), ['int'])),
                                    ])
                                    self.address = None
                                    self.net_mask = None
                                    self._segment_path = lambda: "leaf-networks-deleted"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksDeleted, ['address', 'net_mask'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority.LeafNetworksDeleted']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.Priority']['meta_info']


                        class LspProcessed(_Entity_):
                            """
                            List of LSP changes processed
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspProcessed, self).__init__()

                                self.yang_name = "lsp-processed"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsp_id = None
                                self.sequence_number = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsp-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspProcessed, ['lsp_id', 'sequence_number', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspProcessed']['meta_info']


                        class LspRegenerated(_Entity_):
                            """
                            List of LSP regenerated
                            
                            .. attribute:: serial_number_xr
                            
                            	Serial Number of the session event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: isis_level
                            
                            	ISIS Level
                            	**type**\:  :py:class:`RcmdIsisLvl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisLvl>`
                            
                            	**config**\: False
                            
                            .. attribute:: spf_run_number
                            
                            	SPF Run Number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Trigger reasons for LSP regeneration. Example\: pr^ \- periodic, cr^ \- clear (Check the documentation for the entire list)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspRegenerated, self).__init__()

                                self.yang_name = "lsp-regenerated"
                                self.yang_parent_name = "spf-run-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('serial_number_xr', (YLeaf(YType.uint32, 'serial-number-xr'), ['int'])),
                                    ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                    ('isis_level', (YLeaf(YType.enumeration, 'isis-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisLvl', '')])),
                                    ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                                    ('reason', (YLeaf(YType.str, 'reason'), ['str'])),
                                ])
                                self.serial_number_xr = None
                                self.lsp_id = None
                                self.sequence_number = None
                                self.reception_time = None
                                self.isis_level = None
                                self.spf_run_number = None
                                self.reason = None
                                self._segment_path = lambda: "lsp-regenerated"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspRegenerated, ['serial_number_xr', 'lsp_id', 'sequence_number', 'reception_time', 'isis_level', 'spf_run_number', 'reason'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline.LspRegenerated']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines.SpfRunOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.SpfRunOfflines']['meta_info']


                class PrefixEventSummaries(_Entity_):
                    """
                    ISIS Prefix events summary data
                    
                    .. attribute:: prefix_event_summary
                    
                    	Prefix Event data
                    	**type**\: list of  		 :py:class:`PrefixEventSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries, self).__init__()

                        self.yang_name = "prefix-event-summaries"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-summary", ("prefix_event_summary", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary))])
                        self._leafs = OrderedDict()

                        self.prefix_event_summary = YList(self)
                        self._segment_path = lambda: "prefix-event-summaries"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries, [], name, value)


                    class PrefixEventSummary(_Entity_):
                        """
                        Prefix Event data
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary, self).__init__()

                            self.yang_name = "prefix-event-summary"
                            self.yang_parent_name = "prefix-event-summaries"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime)), ("path", ("path", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa)), ("time-line", ("time_line", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "prefix-event-summary" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "prefix-event-summary"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries.PrefixEventSummary']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventSummaries']['meta_info']


                class PrefixEventOfflines(_Entity_):
                    """
                    ISIS Prefix events offline data
                    
                    .. attribute:: prefix_event_offline
                    
                    	Offline operational data for particular ISIS Prefix Event
                    	**type**\: list of  		 :py:class:`PrefixEventOffline <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines, self).__init__()

                        self.yang_name = "prefix-event-offlines"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("prefix-event-offline", ("prefix_event_offline", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline))])
                        self._leafs = OrderedDict()

                        self.prefix_event_offline = YList(self)
                        self._segment_path = lambda: "prefix-event-offlines"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines, [], name, value)


                    class PrefixEventOffline(_Entity_):
                        """
                        Offline operational data for particular ISIS
                        Prefix Event
                        
                        .. attribute:: event_id  (key)
                        
                        	Specific Event ID
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ip_convergence_time
                        
                        	Convergence time for IP route programming
                        	**type**\:  :py:class:`IpConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_convergence_time
                        
                        	Convergence time for MPLS label programming
                        	**type**\:  :py:class:`MplsConvergenceTime <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime>`
                        
                        	**config**\: False
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_lenth
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_no
                        
                        	Referenced SPF Run No (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: ipfrr_event_id
                        
                        	Referenced IP\-FRR Event ID (0 \- Not Applicable)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_exceeded
                        
                        	Threshold exceeded
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: priority
                        
                        	Event processed priority
                        	**type**\:  :py:class:`RcmdPriorityLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdPriorityLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: change_type
                        
                        	Event Add/Delete
                        	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_type
                        
                        	Route Type intra/inter/l1/l2
                        	**type**\:  :py:class:`RcmdShowRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoute>`
                        
                        	**config**\: False
                        
                        .. attribute:: route_path_change_type
                        
                        	Route Path Change Type
                        	**type**\:  :py:class:`RcmdShowRoutePathChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowRoutePathChange>`
                        
                        	**config**\: False
                        
                        .. attribute:: cost
                        
                        	Protocol route cost
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_time
                        
                        	Event trigger time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path
                        
                        	Path information
                        	**type**\: list of  		 :py:class:`Path <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path>`
                        
                        	**config**\: False
                        
                        .. attribute:: trigger_lsa
                        
                        	LSA that triggered this event
                        	**type**\: list of  		 :py:class:`TriggerLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa>`
                        
                        	**config**\: False
                        
                        .. attribute:: time_line
                        
                        	Timeline information
                        	**type**\: list of  		 :py:class:`TimeLine <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsa_processed
                        
                        	List of LSAs processed
                        	**type**\: list of  		 :py:class:`LsaProcessed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline, self).__init__()

                            self.yang_name = "prefix-event-offline"
                            self.yang_parent_name = "prefix-event-offlines"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['event_id']
                            self._child_classes = OrderedDict([("ip-convergence-time", ("ip_convergence_time", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime)), ("mpls-convergence-time", ("mpls_convergence_time", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime)), ("path", ("path", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path)), ("trigger-lsa", ("trigger_lsa", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa)), ("time-line", ("time_line", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine)), ("lsa-processed", ("lsa_processed", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed))])
                            self._leafs = OrderedDict([
                                ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                                ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                                ('prefix_lenth', (YLeaf(YType.uint32, 'prefix-lenth'), ['int'])),
                                ('spf_run_no', (YLeaf(YType.uint32, 'spf-run-no'), ['int'])),
                                ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                                ('threshold_exceeded', (YLeaf(YType.boolean, 'threshold-exceeded'), ['bool'])),
                                ('priority', (YLeaf(YType.enumeration, 'priority'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdPriorityLevel', '')])),
                                ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                ('route_type', (YLeaf(YType.enumeration, 'route-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoute', '')])),
                                ('route_path_change_type', (YLeaf(YType.enumeration, 'route-path-change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowRoutePathChange', '')])),
                                ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                                ('trigger_time', (YLeaf(YType.str, 'trigger-time'), ['str'])),
                            ])
                            self.event_id = None
                            self.prefix = None
                            self.prefix_lenth = None
                            self.spf_run_no = None
                            self.ipfrr_event_id = None
                            self.threshold_exceeded = None
                            self.priority = None
                            self.change_type = None
                            self.route_type = None
                            self.route_path_change_type = None
                            self.cost = None
                            self.trigger_time = None

                            self.ip_convergence_time = Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime()
                            self.ip_convergence_time.parent = self
                            self._children_name_map["ip_convergence_time"] = "ip-convergence-time"

                            self.mpls_convergence_time = Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime()
                            self.mpls_convergence_time.parent = self
                            self._children_name_map["mpls_convergence_time"] = "mpls-convergence-time"

                            self.path = YList(self)
                            self.trigger_lsa = YList(self)
                            self.time_line = YList(self)
                            self.lsa_processed = YList(self)
                            self._segment_path = lambda: "prefix-event-offline" + "[event-id='" + str(self.event_id) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline, ['event_id', 'prefix', 'prefix_lenth', 'spf_run_no', 'ipfrr_event_id', 'threshold_exceeded', 'priority', 'change_type', 'route_type', 'route_path_change_type', 'cost', 'trigger_time'], name, value)


                        class IpConvergenceTime(_Entity_):
                            """
                            Convergence time for IP route programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime, self).__init__()

                                self.yang_name = "ip-convergence-time"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "ip-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.IpConvergenceTime']['meta_info']


                        class MplsConvergenceTime(_Entity_):
                            """
                            Convergence time for MPLS label programming
                            
                            .. attribute:: minimum_time
                            
                            	Minimum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: maximum_time
                            
                            	Maximum time(in seconds.milliseconds)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            	**units**\: millisecond
                            
                            .. attribute:: slowest_node_name
                            
                            	Linecard node name which took the maximum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: fastest_node_name
                            
                            	Linecard node name which took the minimum time
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime, self).__init__()

                                self.yang_name = "mpls-convergence-time"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('minimum_time', (YLeaf(YType.str, 'minimum-time'), ['str'])),
                                    ('maximum_time', (YLeaf(YType.str, 'maximum-time'), ['str'])),
                                    ('slowest_node_name', (YLeaf(YType.str, 'slowest-node-name'), ['str'])),
                                    ('fastest_node_name', (YLeaf(YType.str, 'fastest-node-name'), ['str'])),
                                ])
                                self.minimum_time = None
                                self.maximum_time = None
                                self.slowest_node_name = None
                                self.fastest_node_name = None
                                self._segment_path = lambda: "mpls-convergence-time"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime, ['minimum_time', 'maximum_time', 'slowest_node_name', 'fastest_node_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.MplsConvergenceTime']['meta_info']


                        class Path(_Entity_):
                            """
                            Path information
                            
                            .. attribute:: interface_name
                            
                            	Interface Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbour_address
                            
                            	Nexthop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Event Add/Delete
                            	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_metric
                            
                            	Path Metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lfa_path
                            
                            	Backup Path Informatoin
                            	**type**\: list of  		 :py:class:`LfaPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path, self).__init__()

                                self.yang_name = "path"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lfa-path", ("lfa_path", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath))])
                                self._leafs = OrderedDict([
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                    ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                ])
                                self.interface_name = None
                                self.neighbour_address = None
                                self.change_type = None
                                self.path_metric = None

                                self.lfa_path = YList(self)
                                self._segment_path = lambda: "path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path, ['interface_name', 'neighbour_address', 'change_type', 'path_metric'], name, value)


                            class LfaPath(_Entity_):
                                """
                                Backup Path Informatoin
                                
                                .. attribute:: lfa_type
                                
                                	Type of LFA
                                	**type**\:  :py:class:`RcmdShowIpfrrLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIpfrrLfa>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_name
                                
                                	Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: neighbour_address
                                
                                	Nexthop Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: change_type
                                
                                	Event Add/Delete
                                	**type**\:  :py:class:`RcmdChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdChange>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_metric
                                
                                	Path Metric
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: remote_node_id
                                
                                	Remote Node ID, in case of Remote LFA
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath, self).__init__()

                                    self.yang_name = "lfa-path"
                                    self.yang_parent_name = "path"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lfa_type', (YLeaf(YType.enumeration, 'lfa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIpfrrLfa', '')])),
                                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                        ('neighbour_address', (YLeaf(YType.str, 'neighbour-address'), ['str'])),
                                        ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdChange', '')])),
                                        ('path_metric', (YLeaf(YType.uint32, 'path-metric'), ['int'])),
                                        ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                                    ])
                                    self.lfa_type = None
                                    self.interface_name = None
                                    self.neighbour_address = None
                                    self.change_type = None
                                    self.path_metric = None
                                    self.remote_node_id = None
                                    self._segment_path = lambda: "lfa-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath, ['lfa_type', 'interface_name', 'neighbour_address', 'change_type', 'path_metric', 'remote_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path.LfaPath']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.Path']['meta_info']


                        class TriggerLsa(_Entity_):
                            """
                            LSA that triggered this event
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa, self).__init__()

                                self.yang_name = "trigger-lsa"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "trigger-lsa"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TriggerLsa']['meta_info']


                        class TimeLine(_Entity_):
                            """
                            Timeline information
                            
                            .. attribute:: route_origin
                            
                            	Route origin (routing protocol)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_enter
                            
                            	Entry point of IPv4 RIB
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_exit
                            
                            	Exit point from IPv4 RIB to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ri_bv4_redistribute
                            
                            	Route Redistribute point from IPv4 RIB to LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_enter
                            
                            	Entry point of LDP
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: ldp_exit
                            
                            	Exit point of LDP to LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_enter
                            
                            	Entry point of LSD
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsd_exit
                            
                            	Exit point of LSD to FIBs
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lc_ip
                            
                            	List of Linecards' completion point for IP routes
                            	**type**\: list of  		 :py:class:`LcIp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp>`
                            
                            	**config**\: False
                            
                            .. attribute:: lc_mpls
                            
                            	List of Linecards' completion point for MPLS labels
                            	**type**\: list of  		 :py:class:`LcMpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine, self).__init__()

                                self.yang_name = "time-line"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("lc-ip", ("lc_ip", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp)), ("lc-mpls", ("lc_mpls", Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls))])
                                self._leafs = OrderedDict([
                                    ('route_origin', (YLeaf(YType.str, 'route-origin'), ['str'])),
                                    ('ri_bv4_enter', (YLeaf(YType.str, 'ri-bv4-enter'), ['str'])),
                                    ('ri_bv4_exit', (YLeaf(YType.str, 'ri-bv4-exit'), ['str'])),
                                    ('ri_bv4_redistribute', (YLeaf(YType.str, 'ri-bv4-redistribute'), ['str'])),
                                    ('ldp_enter', (YLeaf(YType.str, 'ldp-enter'), ['str'])),
                                    ('ldp_exit', (YLeaf(YType.str, 'ldp-exit'), ['str'])),
                                    ('lsd_enter', (YLeaf(YType.str, 'lsd-enter'), ['str'])),
                                    ('lsd_exit', (YLeaf(YType.str, 'lsd-exit'), ['str'])),
                                ])
                                self.route_origin = None
                                self.ri_bv4_enter = None
                                self.ri_bv4_exit = None
                                self.ri_bv4_redistribute = None
                                self.ldp_enter = None
                                self.ldp_exit = None
                                self.lsd_enter = None
                                self.lsd_exit = None

                                self.lc_ip = YList(self)
                                self.lc_mpls = YList(self)
                                self._segment_path = lambda: "time-line"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine, ['route_origin', 'ri_bv4_enter', 'ri_bv4_exit', 'ri_bv4_redistribute', 'ldp_enter', 'ldp_exit', 'lsd_enter', 'lsd_exit'], name, value)


                            class LcIp(_Entity_):
                                """
                                List of Linecards' completion point for IP
                                routes
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp, self).__init__()

                                    self.yang_name = "lc-ip"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-ip"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcIp']['meta_info']


                            class LcMpls(_Entity_):
                                """
                                List of Linecards' completion point for MPLS
                                labels
                                
                                .. attribute:: node_name
                                
                                	Linecard node name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: speed
                                
                                	Relative convergence speed
                                	**type**\:  :py:class:`RcmdLinecardSpeed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLinecardSpeed>`
                                
                                	**config**\: False
                                
                                .. attribute:: fib_complete
                                
                                	Completion point of FIB
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'infra-rcmd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls, self).__init__()

                                    self.yang_name = "lc-mpls"
                                    self.yang_parent_name = "time-line"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('node_name', (YLeaf(YType.str, 'node-name'), ['str'])),
                                        ('speed', (YLeaf(YType.enumeration, 'speed'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLinecardSpeed', '')])),
                                        ('fib_complete', (YLeaf(YType.str, 'fib-complete'), ['str'])),
                                    ])
                                    self.node_name = None
                                    self.speed = None
                                    self.fib_complete = None
                                    self._segment_path = lambda: "lc-mpls"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls, ['node_name', 'speed', 'fib_complete'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                    return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine.LcMpls']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.TimeLine']['meta_info']


                        class LsaProcessed(_Entity_):
                            """
                            List of LSAs processed
                            
                            .. attribute:: lsa_id
                            
                            	LSA ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sequence_number
                            
                            	Sequence Number
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsa_type
                            
                            	LSA type
                            	**type**\:  :py:class:`RcmdLsa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsa>`
                            
                            	**config**\: False
                            
                            .. attribute:: origin_router_id
                            
                            	Originating Router ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: change_type
                            
                            	Add, Delete, Modify
                            	**type**\:  :py:class:`RcmdLsChange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLsChange>`
                            
                            	**config**\: False
                            
                            .. attribute:: reception_time
                            
                            	Reception Time on router (in hh\:mm\:ss.msec)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'infra-rcmd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed, self).__init__()

                                self.yang_name = "lsa-processed"
                                self.yang_parent_name = "prefix-event-offline"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsa_id', (YLeaf(YType.str, 'lsa-id'), ['str'])),
                                    ('sequence_number', (YLeaf(YType.str, 'sequence-number'), ['str'])),
                                    ('lsa_type', (YLeaf(YType.enumeration, 'lsa-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsa', '')])),
                                    ('origin_router_id', (YLeaf(YType.str, 'origin-router-id'), ['str'])),
                                    ('change_type', (YLeaf(YType.enumeration, 'change-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLsChange', '')])),
                                    ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ])
                                self.lsa_id = None
                                self.sequence_number = None
                                self.lsa_type = None
                                self.origin_router_id = None
                                self.change_type = None
                                self.reception_time = None
                                self._segment_path = lambda: "lsa-processed"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed, ['lsa_id', 'sequence_number', 'lsa_type', 'origin_router_id', 'change_type', 'reception_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                                return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline.LsaProcessed']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines.PrefixEventOffline']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.PrefixEventOfflines']['meta_info']


                class LspRegenerateds(_Entity_):
                    """
                    Regenerated LSP data
                    
                    .. attribute:: lsp_regenerated
                    
                    	Regenerated LSP data
                    	**type**\: list of  		 :py:class:`LspRegenerated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Isis.Instances.Instance.LspRegenerateds.LspRegenerated>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Isis.Instances.Instance.LspRegenerateds, self).__init__()

                        self.yang_name = "lsp-regenerateds"
                        self.yang_parent_name = "instance"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-regenerated", ("lsp_regenerated", Rcmd.Isis.Instances.Instance.LspRegenerateds.LspRegenerated))])
                        self._leafs = OrderedDict()

                        self.lsp_regenerated = YList(self)
                        self._segment_path = lambda: "lsp-regenerateds"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Isis.Instances.Instance.LspRegenerateds, [], name, value)


                    class LspRegenerated(_Entity_):
                        """
                        Regenerated LSP data
                        
                        .. attribute:: serial_number  (key)
                        
                        	Data for a particular regenerated LSP
                        	**type**\: int
                        
                        	**range:** 1..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: serial_number_xr
                        
                        	Serial Number of the session event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_id
                        
                        	LSP ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: sequence_number
                        
                        	Sequence Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reception_time
                        
                        	Reception Time on router (in hh\:mm\:ss.msec)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: isis_level
                        
                        	ISIS Level
                        	**type**\:  :py:class:`RcmdIsisLvl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdIsisLvl>`
                        
                        	**config**\: False
                        
                        .. attribute:: spf_run_number
                        
                        	SPF Run Number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reason
                        
                        	Trigger reasons for LSP regeneration. Example\: pr^ \- periodic, cr^ \- clear (Check the documentation for the entire list)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Isis.Instances.Instance.LspRegenerateds.LspRegenerated, self).__init__()

                            self.yang_name = "lsp-regenerated"
                            self.yang_parent_name = "lsp-regenerateds"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = ['serial_number']
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('serial_number', (YLeaf(YType.uint32, 'serial-number'), ['int'])),
                                ('serial_number_xr', (YLeaf(YType.uint32, 'serial-number-xr'), ['int'])),
                                ('lsp_id', (YLeaf(YType.str, 'lsp-id'), ['str'])),
                                ('sequence_number', (YLeaf(YType.uint32, 'sequence-number'), ['int'])),
                                ('reception_time', (YLeaf(YType.str, 'reception-time'), ['str'])),
                                ('isis_level', (YLeaf(YType.enumeration, 'isis-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdIsisLvl', '')])),
                                ('spf_run_number', (YLeaf(YType.uint32, 'spf-run-number'), ['int'])),
                                ('reason', (YLeaf(YType.str, 'reason'), ['str'])),
                            ])
                            self.serial_number = None
                            self.serial_number_xr = None
                            self.lsp_id = None
                            self.sequence_number = None
                            self.reception_time = None
                            self.isis_level = None
                            self.spf_run_number = None
                            self.reason = None
                            self._segment_path = lambda: "lsp-regenerated" + "[serial-number='" + str(self.serial_number) + "']"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Isis.Instances.Instance.LspRegenerateds.LspRegenerated, ['serial_number', 'serial_number_xr', 'lsp_id', 'sequence_number', 'reception_time', 'isis_level', 'spf_run_number', 'reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Isis.Instances.Instance.LspRegenerateds.LspRegenerated']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Isis.Instances.Instance.LspRegenerateds']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Isis.Instances.Instance']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Isis.Instances']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Isis']['meta_info']


    class Memory(_Entity_):
        """
        Memory Info
        
        .. attribute:: memory_info
        
        	Memory Info
        	**type**\: list of  		 :py:class:`MemoryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Memory.MemoryInfo>`
        
        	**config**\: False
        
        .. attribute:: edm_memory_info
        
        	Memory Info
        	**type**\: list of  		 :py:class:`EdmMemoryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Memory.EdmMemoryInfo>`
        
        	**config**\: False
        
        .. attribute:: string_memory_info
        
        	Memory Info
        	**type**\: list of  		 :py:class:`StringMemoryInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Memory.StringMemoryInfo>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Memory, self).__init__()

            self.yang_name = "memory"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("memory-info", ("memory_info", Rcmd.Memory.MemoryInfo)), ("edm-memory-info", ("edm_memory_info", Rcmd.Memory.EdmMemoryInfo)), ("string-memory-info", ("string_memory_info", Rcmd.Memory.StringMemoryInfo))])
            self._leafs = OrderedDict()

            self.memory_info = YList(self)
            self.edm_memory_info = YList(self)
            self.string_memory_info = YList(self)
            self._segment_path = lambda: "memory"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Memory, [], name, value)


        class MemoryInfo(_Entity_):
            """
            Memory Info
            
            .. attribute:: structure_name
            
            	Structure Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: size
            
            	Size of the datastructure
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: current_count
            
            	Current Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: alloc_fails
            
            	Allocation Fails
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: alloc_count
            
            	Allocated count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: freed_count
            
            	Freed Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: memory_type
            
            	Memory Type
            	**type**\:  :py:class:`RcmdShowMem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowMem>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Memory.MemoryInfo, self).__init__()

                self.yang_name = "memory-info"
                self.yang_parent_name = "memory"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('structure_name', (YLeaf(YType.str, 'structure-name'), ['str'])),
                    ('size', (YLeaf(YType.uint32, 'size'), ['int'])),
                    ('current_count', (YLeaf(YType.uint32, 'current-count'), ['int'])),
                    ('alloc_fails', (YLeaf(YType.uint32, 'alloc-fails'), ['int'])),
                    ('alloc_count', (YLeaf(YType.uint32, 'alloc-count'), ['int'])),
                    ('freed_count', (YLeaf(YType.uint32, 'freed-count'), ['int'])),
                    ('memory_type', (YLeaf(YType.enumeration, 'memory-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowMem', '')])),
                ])
                self.structure_name = None
                self.size = None
                self.current_count = None
                self.alloc_fails = None
                self.alloc_count = None
                self.freed_count = None
                self.memory_type = None
                self._segment_path = lambda: "memory-info"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/memory/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Memory.MemoryInfo, ['structure_name', 'size', 'current_count', 'alloc_fails', 'alloc_count', 'freed_count', 'memory_type'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Memory.MemoryInfo']['meta_info']


        class EdmMemoryInfo(_Entity_):
            """
            Memory Info
            
            .. attribute:: size
            
            	Size of the block
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total
            
            	Total request
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: success
            
            	Cache\-hit success
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: failure
            
            	Cache\-hit failure
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Memory.EdmMemoryInfo, self).__init__()

                self.yang_name = "edm-memory-info"
                self.yang_parent_name = "memory"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('size', (YLeaf(YType.uint32, 'size'), ['int'])),
                    ('total', (YLeaf(YType.uint32, 'total'), ['int'])),
                    ('success', (YLeaf(YType.uint32, 'success'), ['int'])),
                    ('failure', (YLeaf(YType.uint32, 'failure'), ['int'])),
                ])
                self.size = None
                self.total = None
                self.success = None
                self.failure = None
                self._segment_path = lambda: "edm-memory-info"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/memory/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Memory.EdmMemoryInfo, ['size', 'total', 'success', 'failure'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Memory.EdmMemoryInfo']['meta_info']


        class StringMemoryInfo(_Entity_):
            """
            Memory Info
            
            .. attribute:: size
            
            	Size of the block
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total
            
            	Total request
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: success
            
            	Cache\-hit success
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: failure
            
            	Cache\-hit failure
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Memory.StringMemoryInfo, self).__init__()

                self.yang_name = "string-memory-info"
                self.yang_parent_name = "memory"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('size', (YLeaf(YType.uint32, 'size'), ['int'])),
                    ('total', (YLeaf(YType.uint32, 'total'), ['int'])),
                    ('success', (YLeaf(YType.uint32, 'success'), ['int'])),
                    ('failure', (YLeaf(YType.uint32, 'failure'), ['int'])),
                ])
                self.size = None
                self.total = None
                self.success = None
                self.failure = None
                self._segment_path = lambda: "string-memory-info"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/memory/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Memory.StringMemoryInfo, ['size', 'total', 'success', 'failure'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Memory.StringMemoryInfo']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Memory']['meta_info']


    class Ldp(_Entity_):
        """
        LDP data
        
        .. attribute:: sessions
        
        	Session Events
        	**type**\:  :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.Sessions>`
        
        	**config**\: False
        
        .. attribute:: remote_lfa_s
        
        	Remote LFA Coverage Events
        	**type**\:  :py:class:`RemoteLfaS <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaS>`
        
        	**config**\: False
        
        .. attribute:: remote_lfa_summaries
        
        	Remote LFA Coverage Events
        	**type**\:  :py:class:`RemoteLfaSummaries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaSummaries>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Ldp, self).__init__()

            self.yang_name = "ldp"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("sessions", ("sessions", Rcmd.Ldp.Sessions)), ("remote-lfa-s", ("remote_lfa_s", Rcmd.Ldp.RemoteLfaS)), ("remote-lfa-summaries", ("remote_lfa_summaries", Rcmd.Ldp.RemoteLfaSummaries))])
            self._leafs = OrderedDict()

            self.sessions = Rcmd.Ldp.Sessions()
            self.sessions.parent = self
            self._children_name_map["sessions"] = "sessions"

            self.remote_lfa_s = Rcmd.Ldp.RemoteLfaS()
            self.remote_lfa_s.parent = self
            self._children_name_map["remote_lfa_s"] = "remote-lfa-s"

            self.remote_lfa_summaries = Rcmd.Ldp.RemoteLfaSummaries()
            self.remote_lfa_summaries.parent = self
            self._children_name_map["remote_lfa_summaries"] = "remote-lfa-summaries"
            self._segment_path = lambda: "ldp"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Ldp, [], name, value)


        class Sessions(_Entity_):
            """
            Session Events
            
            .. attribute:: session
            
            	Session
            	**type**\: list of  		 :py:class:`Session <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.Sessions.Session>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Ldp.Sessions, self).__init__()

                self.yang_name = "sessions"
                self.yang_parent_name = "ldp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("session", ("session", Rcmd.Ldp.Sessions.Session))])
                self._leafs = OrderedDict()

                self.session = YList(self)
                self._segment_path = lambda: "sessions"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Ldp.Sessions, [], name, value)


            class Session(_Entity_):
                """
                Session
                
                .. attribute:: event_id  (key)
                
                	Specific Event ID
                	**type**\: int
                
                	**range:** 1..4294967295
                
                	**config**\: False
                
                .. attribute:: event_id_xr
                
                	Event ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: event_type
                
                	Type of event
                	**type**\:  :py:class:`RcmdLdpEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdLdpEvent>`
                
                	**config**\: False
                
                .. attribute:: event_time
                
                	Event Time
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: lsr_id
                
                	Label Space Router ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: interface_name
                
                	Interface Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: address
                
                	transport address or adjacency address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: state
                
                	Adjacency Session Status
                	**type**\:  :py:class:`RcmdShowLdpNeighbourStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpNeighbourStatus>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Ldp.Sessions.Session, self).__init__()

                    self.yang_name = "session"
                    self.yang_parent_name = "sessions"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['event_id']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                        ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdLdpEvent', '')])),
                        ('event_time', (YLeaf(YType.str, 'event-time'), ['str'])),
                        ('lsr_id', (YLeaf(YType.str, 'lsr-id'), ['str'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpNeighbourStatus', '')])),
                    ])
                    self.event_id = None
                    self.event_id_xr = None
                    self.event_type = None
                    self.event_time = None
                    self.lsr_id = None
                    self.interface_name = None
                    self.address = None
                    self.state = None
                    self._segment_path = lambda: "session" + "[event-id='" + str(self.event_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/sessions/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Ldp.Sessions.Session, ['event_id', 'event_id_xr', 'event_type', 'event_time', 'lsr_id', 'interface_name', 'address', 'state'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Ldp.Sessions.Session']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Ldp.Sessions']['meta_info']


        class RemoteLfaS(_Entity_):
            """
            Remote LFA Coverage Events
            
            .. attribute:: remote_lfa
            
            	RemoteLFA
            	**type**\: list of  		 :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaS.RemoteLfa>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Ldp.RemoteLfaS, self).__init__()

                self.yang_name = "remote-lfa-s"
                self.yang_parent_name = "ldp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("remote-lfa", ("remote_lfa", Rcmd.Ldp.RemoteLfaS.RemoteLfa))])
                self._leafs = OrderedDict()

                self.remote_lfa = YList(self)
                self._segment_path = lambda: "remote-lfa-s"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Ldp.RemoteLfaS, [], name, value)


            class RemoteLfa(_Entity_):
                """
                RemoteLFA
                
                .. attribute:: event_id  (key)
                
                	Specific Event ID
                	**type**\: int
                
                	**range:** 1..4294967295
                
                	**config**\: False
                
                .. attribute:: event_id_xr
                
                	LDP\-rLFA Event ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_of_calculation_time
                
                	End of IGP LFA Calculation Time (eg\: Apr 24 13 \:16\:04.961)
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_protocol
                
                	IGP Protocol
                	**type**\:  :py:class:`RcmdProtocolId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdProtocolId>`
                
                	**config**\: False
                
                .. attribute:: process_name
                
                	Process Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_id
                
                	IGP IP\-FRR Event ID (ref\: rcmd\_show\_ipfrr\_event\_info(EventID))
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: below_threshold
                
                	Coverage Below Threshold
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: session_statistic
                
                	RLFA Statistics categorized by session state
                	**type**\: list of  		 :py:class:`SessionStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaS.RemoteLfa.SessionStatistic>`
                
                	**config**\: False
                
                .. attribute:: remote_node
                
                	Remote Node Information
                	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaS.RemoteLfa.RemoteNode>`
                
                	**config**\: False
                
                .. attribute:: logs
                
                	Logs Information
                	**type**\: list of  		 :py:class:`Logs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaS.RemoteLfa.Logs>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Ldp.RemoteLfaS.RemoteLfa, self).__init__()

                    self.yang_name = "remote-lfa"
                    self.yang_parent_name = "remote-lfa-s"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['event_id']
                    self._child_classes = OrderedDict([("session-statistic", ("session_statistic", Rcmd.Ldp.RemoteLfaS.RemoteLfa.SessionStatistic)), ("remote-node", ("remote_node", Rcmd.Ldp.RemoteLfaS.RemoteLfa.RemoteNode)), ("logs", ("logs", Rcmd.Ldp.RemoteLfaS.RemoteLfa.Logs))])
                    self._leafs = OrderedDict([
                        ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                        ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                        ('end_of_calculation_time', (YLeaf(YType.str, 'end-of-calculation-time'), ['str'])),
                        ('igp_protocol', (YLeaf(YType.enumeration, 'igp-protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdProtocolId', '')])),
                        ('process_name', (YLeaf(YType.str, 'process-name'), ['str'])),
                        ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                        ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                    ])
                    self.event_id = None
                    self.event_id_xr = None
                    self.end_of_calculation_time = None
                    self.igp_protocol = None
                    self.process_name = None
                    self.ipfrr_event_id = None
                    self.below_threshold = None

                    self.session_statistic = YList(self)
                    self.remote_node = YList(self)
                    self.logs = YList(self)
                    self._segment_path = lambda: "remote-lfa" + "[event-id='" + str(self.event_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/remote-lfa-s/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Ldp.RemoteLfaS.RemoteLfa, ['event_id', 'event_id_xr', 'end_of_calculation_time', 'igp_protocol', 'process_name', 'ipfrr_event_id', 'below_threshold'], name, value)


                class SessionStatistic(_Entity_):
                    """
                    RLFA Statistics categorized by session state
                    
                    .. attribute:: session_state
                    
                    	Session State
                    	**type**\:  :py:class:`RcmdShowLdpSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpSessionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: session_count
                    
                    	LDP Session Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_count
                    
                    	Total Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_route_count
                    
                    	Protected Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_path_count
                    
                    	Protected Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaS.RemoteLfa.SessionStatistic, self).__init__()

                        self.yang_name = "session-statistic"
                        self.yang_parent_name = "remote-lfa"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpSessionState', '')])),
                            ('session_count', (YLeaf(YType.uint32, 'session-count'), ['int'])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                            ('protected_route_count', (YLeaf(YType.uint32, 'protected-route-count'), ['int'])),
                            ('protected_path_count', (YLeaf(YType.uint32, 'protected-path-count'), ['int'])),
                        ])
                        self.session_state = None
                        self.session_count = None
                        self.route_count = None
                        self.path_count = None
                        self.remote_label_count = None
                        self.protected_route_count = None
                        self.protected_path_count = None
                        self._segment_path = lambda: "session-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaS.RemoteLfa.SessionStatistic, ['session_state', 'session_count', 'route_count', 'path_count', 'remote_label_count', 'protected_route_count', 'protected_path_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaS.RemoteLfa.SessionStatistic']['meta_info']


                class RemoteNode(_Entity_):
                    """
                    Remote Node Information
                    
                    .. attribute:: remote_node_id
                    
                    	Remote Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: lsr_id
                    
                    	Label Space Router ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: transport_address
                    
                    	Transport Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_use_time
                    
                    	Inuse time of the Session
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: session_state
                    
                    	Session State
                    	**type**\:  :py:class:`RcmdShowLdpSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpSessionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_count
                    
                    	Total Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_route_count
                    
                    	Protected Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_path_count
                    
                    	Protected Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaS.RemoteLfa.RemoteNode, self).__init__()

                        self.yang_name = "remote-node"
                        self.yang_parent_name = "remote-lfa"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                            ('lsr_id', (YLeaf(YType.str, 'lsr-id'), ['str'])),
                            ('transport_address', (YLeaf(YType.str, 'transport-address'), ['str'])),
                            ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                            ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpSessionState', '')])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                            ('protected_route_count', (YLeaf(YType.uint32, 'protected-route-count'), ['int'])),
                            ('protected_path_count', (YLeaf(YType.uint32, 'protected-path-count'), ['int'])),
                        ])
                        self.remote_node_id = None
                        self.lsr_id = None
                        self.transport_address = None
                        self.in_use_time = None
                        self.session_state = None
                        self.route_count = None
                        self.path_count = None
                        self.remote_label_count = None
                        self.protected_route_count = None
                        self.protected_path_count = None
                        self._segment_path = lambda: "remote-node"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaS.RemoteLfa.RemoteNode, ['remote_node_id', 'lsr_id', 'transport_address', 'in_use_time', 'session_state', 'route_count', 'path_count', 'remote_label_count', 'protected_route_count', 'protected_path_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaS.RemoteLfa.RemoteNode']['meta_info']


                class Logs(_Entity_):
                    """
                    Logs Information
                    
                    .. attribute:: log_time
                    
                    	Event Time (eg\: Apr 24 13\:16\:04.961)
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: label_coverage_state
                    
                    	Label Coverage State
                    	**type**\:  :py:class:`RcmdShowLdpConvState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpConvState>`
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaS.RemoteLfa.Logs, self).__init__()

                        self.yang_name = "logs"
                        self.yang_parent_name = "remote-lfa"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('log_time', (YLeaf(YType.str, 'log-time'), ['str'])),
                            ('label_coverage_state', (YLeaf(YType.enumeration, 'label-coverage-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpConvState', '')])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                        ])
                        self.log_time = None
                        self.label_coverage_state = None
                        self.route_count = None
                        self.remote_label_count = None
                        self._segment_path = lambda: "logs"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaS.RemoteLfa.Logs, ['log_time', 'label_coverage_state', 'route_count', 'remote_label_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaS.RemoteLfa.Logs']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Ldp.RemoteLfaS.RemoteLfa']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Ldp.RemoteLfaS']['meta_info']


        class RemoteLfaSummaries(_Entity_):
            """
            Remote LFA Coverage Events
            
            .. attribute:: remote_lfa_summary
            
            	Summary operational data for Remote LFA
            	**type**\: list of  		 :py:class:`RemoteLfaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Ldp.RemoteLfaSummaries, self).__init__()

                self.yang_name = "remote-lfa-summaries"
                self.yang_parent_name = "ldp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("remote-lfa-summary", ("remote_lfa_summary", Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary))])
                self._leafs = OrderedDict()

                self.remote_lfa_summary = YList(self)
                self._segment_path = lambda: "remote-lfa-summaries"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Ldp.RemoteLfaSummaries, [], name, value)


            class RemoteLfaSummary(_Entity_):
                """
                Summary operational data for Remote LFA
                
                .. attribute:: event_id  (key)
                
                	Specific Event ID
                	**type**\: int
                
                	**range:** 1..4294967295
                
                	**config**\: False
                
                .. attribute:: event_id_xr
                
                	LDP\-rLFA Event ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_of_calculation_time
                
                	End of IGP LFA Calculation Time (eg\: Apr 24 13 \:16\:04.961)
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_protocol
                
                	IGP Protocol
                	**type**\:  :py:class:`RcmdProtocolId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdProtocolId>`
                
                	**config**\: False
                
                .. attribute:: process_name
                
                	Process Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: ipfrr_event_id
                
                	IGP IP\-FRR Event ID (ref\: rcmd\_show\_ipfrr\_event\_info(EventID))
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: below_threshold
                
                	Coverage Below Threshold
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: session_statistic
                
                	RLFA Statistics categorized by session state
                	**type**\: list of  		 :py:class:`SessionStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.SessionStatistic>`
                
                	**config**\: False
                
                .. attribute:: remote_node
                
                	Remote Node Information
                	**type**\: list of  		 :py:class:`RemoteNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.RemoteNode>`
                
                	**config**\: False
                
                .. attribute:: logs
                
                	Logs Information
                	**type**\: list of  		 :py:class:`Logs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.Logs>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary, self).__init__()

                    self.yang_name = "remote-lfa-summary"
                    self.yang_parent_name = "remote-lfa-summaries"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['event_id']
                    self._child_classes = OrderedDict([("session-statistic", ("session_statistic", Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.SessionStatistic)), ("remote-node", ("remote_node", Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.RemoteNode)), ("logs", ("logs", Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.Logs))])
                    self._leafs = OrderedDict([
                        ('event_id', (YLeaf(YType.uint32, 'event-id'), ['int'])),
                        ('event_id_xr', (YLeaf(YType.uint32, 'event-id-xr'), ['int'])),
                        ('end_of_calculation_time', (YLeaf(YType.str, 'end-of-calculation-time'), ['str'])),
                        ('igp_protocol', (YLeaf(YType.enumeration, 'igp-protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdProtocolId', '')])),
                        ('process_name', (YLeaf(YType.str, 'process-name'), ['str'])),
                        ('ipfrr_event_id', (YLeaf(YType.uint32, 'ipfrr-event-id'), ['int'])),
                        ('below_threshold', (YLeaf(YType.boolean, 'below-threshold'), ['bool'])),
                    ])
                    self.event_id = None
                    self.event_id_xr = None
                    self.end_of_calculation_time = None
                    self.igp_protocol = None
                    self.process_name = None
                    self.ipfrr_event_id = None
                    self.below_threshold = None

                    self.session_statistic = YList(self)
                    self.remote_node = YList(self)
                    self.logs = YList(self)
                    self._segment_path = lambda: "remote-lfa-summary" + "[event-id='" + str(self.event_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/ldp/remote-lfa-summaries/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary, ['event_id', 'event_id_xr', 'end_of_calculation_time', 'igp_protocol', 'process_name', 'ipfrr_event_id', 'below_threshold'], name, value)


                class SessionStatistic(_Entity_):
                    """
                    RLFA Statistics categorized by session state
                    
                    .. attribute:: session_state
                    
                    	Session State
                    	**type**\:  :py:class:`RcmdShowLdpSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpSessionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: session_count
                    
                    	LDP Session Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_count
                    
                    	Total Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_route_count
                    
                    	Protected Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_path_count
                    
                    	Protected Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.SessionStatistic, self).__init__()

                        self.yang_name = "session-statistic"
                        self.yang_parent_name = "remote-lfa-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpSessionState', '')])),
                            ('session_count', (YLeaf(YType.uint32, 'session-count'), ['int'])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                            ('protected_route_count', (YLeaf(YType.uint32, 'protected-route-count'), ['int'])),
                            ('protected_path_count', (YLeaf(YType.uint32, 'protected-path-count'), ['int'])),
                        ])
                        self.session_state = None
                        self.session_count = None
                        self.route_count = None
                        self.path_count = None
                        self.remote_label_count = None
                        self.protected_route_count = None
                        self.protected_path_count = None
                        self._segment_path = lambda: "session-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.SessionStatistic, ['session_state', 'session_count', 'route_count', 'path_count', 'remote_label_count', 'protected_route_count', 'protected_path_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.SessionStatistic']['meta_info']


                class RemoteNode(_Entity_):
                    """
                    Remote Node Information
                    
                    .. attribute:: remote_node_id
                    
                    	Remote Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: lsr_id
                    
                    	Label Space Router ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: transport_address
                    
                    	Transport Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_use_time
                    
                    	Inuse time of the Session
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: session_state
                    
                    	Session State
                    	**type**\:  :py:class:`RcmdShowLdpSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpSessionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_count
                    
                    	Total Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_route_count
                    
                    	Protected Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_path_count
                    
                    	Protected Path Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.RemoteNode, self).__init__()

                        self.yang_name = "remote-node"
                        self.yang_parent_name = "remote-lfa-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('remote_node_id', (YLeaf(YType.str, 'remote-node-id'), ['str'])),
                            ('lsr_id', (YLeaf(YType.str, 'lsr-id'), ['str'])),
                            ('transport_address', (YLeaf(YType.str, 'transport-address'), ['str'])),
                            ('in_use_time', (YLeaf(YType.str, 'in-use-time'), ['str'])),
                            ('session_state', (YLeaf(YType.enumeration, 'session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpSessionState', '')])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('path_count', (YLeaf(YType.uint32, 'path-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                            ('protected_route_count', (YLeaf(YType.uint32, 'protected-route-count'), ['int'])),
                            ('protected_path_count', (YLeaf(YType.uint32, 'protected-path-count'), ['int'])),
                        ])
                        self.remote_node_id = None
                        self.lsr_id = None
                        self.transport_address = None
                        self.in_use_time = None
                        self.session_state = None
                        self.route_count = None
                        self.path_count = None
                        self.remote_label_count = None
                        self.protected_route_count = None
                        self.protected_path_count = None
                        self._segment_path = lambda: "remote-node"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.RemoteNode, ['remote_node_id', 'lsr_id', 'transport_address', 'in_use_time', 'session_state', 'route_count', 'path_count', 'remote_label_count', 'protected_route_count', 'protected_path_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.RemoteNode']['meta_info']


                class Logs(_Entity_):
                    """
                    Logs Information
                    
                    .. attribute:: log_time
                    
                    	Event Time (eg\: Apr 24 13\:16\:04.961)
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: label_coverage_state
                    
                    	Label Coverage State
                    	**type**\:  :py:class:`RcmdShowLdpConvState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowLdpConvState>`
                    
                    	**config**\: False
                    
                    .. attribute:: route_count
                    
                    	Total Route Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_label_count
                    
                    	Remote Label Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.Logs, self).__init__()

                        self.yang_name = "logs"
                        self.yang_parent_name = "remote-lfa-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('log_time', (YLeaf(YType.str, 'log-time'), ['str'])),
                            ('label_coverage_state', (YLeaf(YType.enumeration, 'label-coverage-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowLdpConvState', '')])),
                            ('route_count', (YLeaf(YType.uint32, 'route-count'), ['int'])),
                            ('remote_label_count', (YLeaf(YType.uint32, 'remote-label-count'), ['int'])),
                        ])
                        self.log_time = None
                        self.label_coverage_state = None
                        self.route_count = None
                        self.remote_label_count = None
                        self._segment_path = lambda: "logs"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.Logs, ['log_time', 'label_coverage_state', 'route_count', 'remote_label_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary.Logs']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Ldp.RemoteLfaSummaries.RemoteLfaSummary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Ldp.RemoteLfaSummaries']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Ldp']['meta_info']


    class Intf(_Entity_):
        """
        Interface data
        
        .. attribute:: events
        
        	Events
        	**type**\:  :py:class:`Events <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Intf.Events>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Intf, self).__init__()

            self.yang_name = "intf"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("events", ("events", Rcmd.Intf.Events))])
            self._leafs = OrderedDict()

            self.events = Rcmd.Intf.Events()
            self.events.parent = self
            self._children_name_map["events"] = "events"
            self._segment_path = lambda: "intf"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Intf, [], name, value)


        class Events(_Entity_):
            """
            Events
            
            .. attribute:: event
            
            	Events
            	**type**\: list of  		 :py:class:`Event <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Intf.Events.Event>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Intf.Events, self).__init__()

                self.yang_name = "events"
                self.yang_parent_name = "intf"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("event", ("event", Rcmd.Intf.Events.Event))])
                self._leafs = OrderedDict()

                self.event = YList(self)
                self._segment_path = lambda: "events"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/intf/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Intf.Events, [], name, value)


            class Event(_Entity_):
                """
                Events
                
                .. attribute:: event_no  (key)
                
                	Specific Event No
                	**type**\: int
                
                	**range:** 1..4294967295
                
                	**config**\: False
                
                .. attribute:: sequence_no
                
                	Sequence No
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: interface_name
                
                	Interface Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: component
                
                	Component info
                	**type**\:  :py:class:`RcmdShowCompId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowCompId>`
                
                	**config**\: False
                
                .. attribute:: event_type
                
                	Event Info
                	**type**\:  :py:class:`RcmdShowIntfEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowIntfEvent>`
                
                	**config**\: False
                
                .. attribute:: event_time
                
                	Event Time
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: primary_address
                
                	Primary Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Intf.Events.Event, self).__init__()

                    self.yang_name = "event"
                    self.yang_parent_name = "events"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['event_no']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('event_no', (YLeaf(YType.uint32, 'event-no'), ['int'])),
                        ('sequence_no', (YLeaf(YType.uint32, 'sequence-no'), ['int'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('component', (YLeaf(YType.enumeration, 'component'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowCompId', '')])),
                        ('event_type', (YLeaf(YType.enumeration, 'event-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowIntfEvent', '')])),
                        ('event_time', (YLeaf(YType.str, 'event-time'), ['str'])),
                        ('primary_address', (YLeaf(YType.str, 'primary-address'), ['str'])),
                    ])
                    self.event_no = None
                    self.sequence_no = None
                    self.interface_name = None
                    self.component = None
                    self.event_type = None
                    self.event_time = None
                    self.primary_address = None
                    self._segment_path = lambda: "event" + "[event-no='" + str(self.event_no) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/intf/events/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Intf.Events.Event, ['event_no', 'sequence_no', 'interface_name', 'component', 'event_type', 'event_time', 'primary_address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Intf.Events.Event']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Intf.Events']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Intf']['meta_info']


    class Process(_Entity_):
        """
        Process information
        
        .. attribute:: isis
        
        	ISIS Process Information
        	**type**\:  :py:class:`Isis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Isis>`
        
        	**config**\: False
        
        .. attribute:: ospf
        
        	OSPF Process Information
        	**type**\:  :py:class:`Ospf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ospf>`
        
        	**config**\: False
        
        .. attribute:: ldp
        
        	LDP Process Information
        	**type**\:  :py:class:`Ldp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ldp>`
        
        	**config**\: False
        
        

        """

        _prefix = 'infra-rcmd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(Rcmd.Process, self).__init__()

            self.yang_name = "process"
            self.yang_parent_name = "rcmd"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("isis", ("isis", Rcmd.Process.Isis)), ("ospf", ("ospf", Rcmd.Process.Ospf)), ("ldp", ("ldp", Rcmd.Process.Ldp))])
            self._leafs = OrderedDict()

            self.isis = Rcmd.Process.Isis()
            self.isis.parent = self
            self._children_name_map["isis"] = "isis"

            self.ospf = Rcmd.Process.Ospf()
            self.ospf.parent = self
            self._children_name_map["ospf"] = "ospf"

            self.ldp = Rcmd.Process.Ldp()
            self.ldp.parent = self
            self._children_name_map["ldp"] = "ldp"
            self._segment_path = lambda: "process"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(Rcmd.Process, [], name, value)


        class Isis(_Entity_):
            """
            ISIS Process Information
            
            .. attribute:: process
            
            	Process Information
            	**type**\: list of  		 :py:class:`Process_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Isis.Process_>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Process.Isis, self).__init__()

                self.yang_name = "isis"
                self.yang_parent_name = "process"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("process", ("process", Rcmd.Process.Isis.Process_))])
                self._leafs = OrderedDict()

                self.process = YList(self)
                self._segment_path = lambda: "isis"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Process.Isis, [], name, value)


            class Process_(_Entity_):
                """
                Process Information
                
                .. attribute:: protocol_id
                
                	Protocol id
                	**type**\:  :py:class:`RcmdProtocolId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdProtocolId>`
                
                	**config**\: False
                
                .. attribute:: process_name
                
                	Process Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: instance_name
                
                	Instance/VRF Name
                	**type**\: list of  		 :py:class:`InstanceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Isis.Process_.InstanceName>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Process.Isis.Process_, self).__init__()

                    self.yang_name = "process"
                    self.yang_parent_name = "isis"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("instance-name", ("instance_name", Rcmd.Process.Isis.Process_.InstanceName))])
                    self._leafs = OrderedDict([
                        ('protocol_id', (YLeaf(YType.enumeration, 'protocol-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdProtocolId', '')])),
                        ('process_name', (YLeaf(YType.str, 'process-name'), ['str'])),
                    ])
                    self.protocol_id = None
                    self.process_name = None

                    self.instance_name = YList(self)
                    self._segment_path = lambda: "process"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/isis/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Process.Isis.Process_, ['protocol_id', 'process_name'], name, value)


                class InstanceName(_Entity_):
                    """
                    Instance/VRF Name
                    
                    .. attribute:: name
                    
                    	Instance Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: last_update_time
                    
                    	Last Updated Time
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: total_spf_nos
                    
                    	Total spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: route_change_spf_nos
                    
                    	Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: no_route_change_spf_nos
                    
                    	No Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: not_interested_spf_nos
                    
                    	Not Interested SPF nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_count
                    
                    	LSP Regen Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_serial
                    
                    	Last Serial
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_spf_event
                    
                    	Archive SPF event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_lsp_regeneration
                    
                    	Archive Lsp regen
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: instance
                    
                    	Instance Information
                    	**type**\: list of  		 :py:class:`Instance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Isis.Process_.InstanceName.Instance>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Process.Isis.Process_.InstanceName, self).__init__()

                        self.yang_name = "instance-name"
                        self.yang_parent_name = "process"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("instance", ("instance", Rcmd.Process.Isis.Process_.InstanceName.Instance))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                            ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                            ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                            ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                            ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                            ('lsp_regeneration_count', (YLeaf(YType.uint32, 'lsp-regeneration-count'), ['int'])),
                            ('lsp_regeneration_serial', (YLeaf(YType.uint32, 'lsp-regeneration-serial'), ['int'])),
                            ('arch_spf_event', (YLeaf(YType.uint32, 'arch-spf-event'), ['int'])),
                            ('arch_lsp_regeneration', (YLeaf(YType.uint32, 'arch-lsp-regeneration'), ['int'])),
                        ])
                        self.name = None
                        self.last_update_time = None
                        self.total_spf_nos = None
                        self.route_change_spf_nos = None
                        self.no_route_change_spf_nos = None
                        self.not_interested_spf_nos = None
                        self.lsp_regeneration_count = None
                        self.lsp_regeneration_serial = None
                        self.arch_spf_event = None
                        self.arch_lsp_regeneration = None

                        self.instance = YList(self)
                        self._segment_path = lambda: "instance-name"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/isis/process/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Process.Isis.Process_.InstanceName, ['name', 'last_update_time', 'total_spf_nos', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'lsp_regeneration_count', 'lsp_regeneration_serial', 'arch_spf_event', 'arch_lsp_regeneration'], name, value)


                    class Instance(_Entity_):
                        """
                        Instance Information
                        
                        .. attribute:: instance_id
                        
                        	Instance Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: instance_state
                        
                        	Instance State
                        	**type**\:  :py:class:`RcmdShowInstState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowInstState>`
                        
                        	**config**\: False
                        
                        .. attribute:: instance_deleted
                        
                        	Instance Deleted
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fwd_referenced
                        
                        	Forward Referenced
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_update_time
                        
                        	Last Updated Time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Node Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_offset
                        
                        	SPF Offset
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spf_nos
                        
                        	Total spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: arch_spf_run
                        
                        	spf run can be archived
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: route_change_spf_nos
                        
                        	Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: no_route_change_spf_nos
                        
                        	No Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: not_interested_spf_nos
                        
                        	Not Interested SPF nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spt_nos
                        
                        	Total spt nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Process.Isis.Process_.InstanceName.Instance, self).__init__()

                            self.yang_name = "instance"
                            self.yang_parent_name = "instance-name"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('instance_id', (YLeaf(YType.uint32, 'instance-id'), ['int'])),
                                ('instance_state', (YLeaf(YType.enumeration, 'instance-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowInstState', '')])),
                                ('instance_deleted', (YLeaf(YType.enumeration, 'instance-deleted'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('fwd_referenced', (YLeaf(YType.enumeration, 'fwd-referenced'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                                ('node_id', (YLeaf(YType.uint32, 'node-id'), ['int'])),
                                ('spf_offset', (YLeaf(YType.uint32, 'spf-offset'), ['int'])),
                                ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                                ('arch_spf_run', (YLeaf(YType.uint32, 'arch-spf-run'), ['int'])),
                                ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                                ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                                ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                                ('total_spt_nos', (YLeaf(YType.uint32, 'total-spt-nos'), ['int'])),
                            ])
                            self.instance_id = None
                            self.instance_state = None
                            self.instance_deleted = None
                            self.fwd_referenced = None
                            self.last_update_time = None
                            self.node_id = None
                            self.spf_offset = None
                            self.total_spf_nos = None
                            self.arch_spf_run = None
                            self.route_change_spf_nos = None
                            self.no_route_change_spf_nos = None
                            self.not_interested_spf_nos = None
                            self.total_spt_nos = None
                            self._segment_path = lambda: "instance"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/isis/process/instance-name/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Process.Isis.Process_.InstanceName.Instance, ['instance_id', 'instance_state', 'instance_deleted', 'fwd_referenced', 'last_update_time', 'node_id', 'spf_offset', 'total_spf_nos', 'arch_spf_run', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'total_spt_nos'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Process.Isis.Process_.InstanceName.Instance']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Process.Isis.Process_.InstanceName']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Process.Isis.Process_']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Process.Isis']['meta_info']


        class Ospf(_Entity_):
            """
            OSPF Process Information
            
            .. attribute:: process
            
            	Process Information
            	**type**\: list of  		 :py:class:`Process_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ospf.Process_>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Process.Ospf, self).__init__()

                self.yang_name = "ospf"
                self.yang_parent_name = "process"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("process", ("process", Rcmd.Process.Ospf.Process_))])
                self._leafs = OrderedDict()

                self.process = YList(self)
                self._segment_path = lambda: "ospf"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Process.Ospf, [], name, value)


            class Process_(_Entity_):
                """
                Process Information
                
                .. attribute:: protocol_id
                
                	Protocol id
                	**type**\:  :py:class:`RcmdProtocolId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdProtocolId>`
                
                	**config**\: False
                
                .. attribute:: process_name
                
                	Process Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: instance_name
                
                	Instance/VRF Name
                	**type**\: list of  		 :py:class:`InstanceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ospf.Process_.InstanceName>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Process.Ospf.Process_, self).__init__()

                    self.yang_name = "process"
                    self.yang_parent_name = "ospf"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("instance-name", ("instance_name", Rcmd.Process.Ospf.Process_.InstanceName))])
                    self._leafs = OrderedDict([
                        ('protocol_id', (YLeaf(YType.enumeration, 'protocol-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdProtocolId', '')])),
                        ('process_name', (YLeaf(YType.str, 'process-name'), ['str'])),
                    ])
                    self.protocol_id = None
                    self.process_name = None

                    self.instance_name = YList(self)
                    self._segment_path = lambda: "process"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ospf/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Process.Ospf.Process_, ['protocol_id', 'process_name'], name, value)


                class InstanceName(_Entity_):
                    """
                    Instance/VRF Name
                    
                    .. attribute:: name
                    
                    	Instance Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: last_update_time
                    
                    	Last Updated Time
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: total_spf_nos
                    
                    	Total spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: route_change_spf_nos
                    
                    	Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: no_route_change_spf_nos
                    
                    	No Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: not_interested_spf_nos
                    
                    	Not Interested SPF nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_count
                    
                    	LSP Regen Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_serial
                    
                    	Last Serial
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_spf_event
                    
                    	Archive SPF event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_lsp_regeneration
                    
                    	Archive Lsp regen
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: instance
                    
                    	Instance Information
                    	**type**\: list of  		 :py:class:`Instance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ospf.Process_.InstanceName.Instance>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Process.Ospf.Process_.InstanceName, self).__init__()

                        self.yang_name = "instance-name"
                        self.yang_parent_name = "process"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("instance", ("instance", Rcmd.Process.Ospf.Process_.InstanceName.Instance))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                            ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                            ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                            ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                            ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                            ('lsp_regeneration_count', (YLeaf(YType.uint32, 'lsp-regeneration-count'), ['int'])),
                            ('lsp_regeneration_serial', (YLeaf(YType.uint32, 'lsp-regeneration-serial'), ['int'])),
                            ('arch_spf_event', (YLeaf(YType.uint32, 'arch-spf-event'), ['int'])),
                            ('arch_lsp_regeneration', (YLeaf(YType.uint32, 'arch-lsp-regeneration'), ['int'])),
                        ])
                        self.name = None
                        self.last_update_time = None
                        self.total_spf_nos = None
                        self.route_change_spf_nos = None
                        self.no_route_change_spf_nos = None
                        self.not_interested_spf_nos = None
                        self.lsp_regeneration_count = None
                        self.lsp_regeneration_serial = None
                        self.arch_spf_event = None
                        self.arch_lsp_regeneration = None

                        self.instance = YList(self)
                        self._segment_path = lambda: "instance-name"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ospf/process/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Process.Ospf.Process_.InstanceName, ['name', 'last_update_time', 'total_spf_nos', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'lsp_regeneration_count', 'lsp_regeneration_serial', 'arch_spf_event', 'arch_lsp_regeneration'], name, value)


                    class Instance(_Entity_):
                        """
                        Instance Information
                        
                        .. attribute:: instance_id
                        
                        	Instance Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: instance_state
                        
                        	Instance State
                        	**type**\:  :py:class:`RcmdShowInstState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowInstState>`
                        
                        	**config**\: False
                        
                        .. attribute:: instance_deleted
                        
                        	Instance Deleted
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fwd_referenced
                        
                        	Forward Referenced
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_update_time
                        
                        	Last Updated Time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Node Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_offset
                        
                        	SPF Offset
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spf_nos
                        
                        	Total spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: arch_spf_run
                        
                        	spf run can be archived
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: route_change_spf_nos
                        
                        	Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: no_route_change_spf_nos
                        
                        	No Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: not_interested_spf_nos
                        
                        	Not Interested SPF nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spt_nos
                        
                        	Total spt nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Process.Ospf.Process_.InstanceName.Instance, self).__init__()

                            self.yang_name = "instance"
                            self.yang_parent_name = "instance-name"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('instance_id', (YLeaf(YType.uint32, 'instance-id'), ['int'])),
                                ('instance_state', (YLeaf(YType.enumeration, 'instance-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowInstState', '')])),
                                ('instance_deleted', (YLeaf(YType.enumeration, 'instance-deleted'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('fwd_referenced', (YLeaf(YType.enumeration, 'fwd-referenced'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                                ('node_id', (YLeaf(YType.uint32, 'node-id'), ['int'])),
                                ('spf_offset', (YLeaf(YType.uint32, 'spf-offset'), ['int'])),
                                ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                                ('arch_spf_run', (YLeaf(YType.uint32, 'arch-spf-run'), ['int'])),
                                ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                                ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                                ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                                ('total_spt_nos', (YLeaf(YType.uint32, 'total-spt-nos'), ['int'])),
                            ])
                            self.instance_id = None
                            self.instance_state = None
                            self.instance_deleted = None
                            self.fwd_referenced = None
                            self.last_update_time = None
                            self.node_id = None
                            self.spf_offset = None
                            self.total_spf_nos = None
                            self.arch_spf_run = None
                            self.route_change_spf_nos = None
                            self.no_route_change_spf_nos = None
                            self.not_interested_spf_nos = None
                            self.total_spt_nos = None
                            self._segment_path = lambda: "instance"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ospf/process/instance-name/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Process.Ospf.Process_.InstanceName.Instance, ['instance_id', 'instance_state', 'instance_deleted', 'fwd_referenced', 'last_update_time', 'node_id', 'spf_offset', 'total_spf_nos', 'arch_spf_run', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'total_spt_nos'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Process.Ospf.Process_.InstanceName.Instance']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Process.Ospf.Process_.InstanceName']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Process.Ospf.Process_']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Process.Ospf']['meta_info']


        class Ldp(_Entity_):
            """
            LDP Process Information
            
            .. attribute:: process
            
            	Process Information
            	**type**\: list of  		 :py:class:`Process_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ldp.Process_>`
            
            	**config**\: False
            
            

            """

            _prefix = 'infra-rcmd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(Rcmd.Process.Ldp, self).__init__()

                self.yang_name = "ldp"
                self.yang_parent_name = "process"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("process", ("process", Rcmd.Process.Ldp.Process_))])
                self._leafs = OrderedDict()

                self.process = YList(self)
                self._segment_path = lambda: "ldp"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(Rcmd.Process.Ldp, [], name, value)


            class Process_(_Entity_):
                """
                Process Information
                
                .. attribute:: protocol_id
                
                	Protocol id
                	**type**\:  :py:class:`RcmdProtocolId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdProtocolId>`
                
                	**config**\: False
                
                .. attribute:: process_name
                
                	Process Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: instance_name
                
                	Instance/VRF Name
                	**type**\: list of  		 :py:class:`InstanceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ldp.Process_.InstanceName>`
                
                	**config**\: False
                
                

                """

                _prefix = 'infra-rcmd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(Rcmd.Process.Ldp.Process_, self).__init__()

                    self.yang_name = "process"
                    self.yang_parent_name = "ldp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("instance-name", ("instance_name", Rcmd.Process.Ldp.Process_.InstanceName))])
                    self._leafs = OrderedDict([
                        ('protocol_id', (YLeaf(YType.enumeration, 'protocol-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdProtocolId', '')])),
                        ('process_name', (YLeaf(YType.str, 'process-name'), ['str'])),
                    ])
                    self.protocol_id = None
                    self.process_name = None

                    self.instance_name = YList(self)
                    self._segment_path = lambda: "process"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ldp/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(Rcmd.Process.Ldp.Process_, ['protocol_id', 'process_name'], name, value)


                class InstanceName(_Entity_):
                    """
                    Instance/VRF Name
                    
                    .. attribute:: name
                    
                    	Instance Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: last_update_time
                    
                    	Last Updated Time
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: total_spf_nos
                    
                    	Total spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: route_change_spf_nos
                    
                    	Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: no_route_change_spf_nos
                    
                    	No Route change spf nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: not_interested_spf_nos
                    
                    	Not Interested SPF nos
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_count
                    
                    	LSP Regen Count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_regeneration_serial
                    
                    	Last Serial
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_spf_event
                    
                    	Archive SPF event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: arch_lsp_regeneration
                    
                    	Archive Lsp regen
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: instance
                    
                    	Instance Information
                    	**type**\: list of  		 :py:class:`Instance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.Rcmd.Process.Ldp.Process_.InstanceName.Instance>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'infra-rcmd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(Rcmd.Process.Ldp.Process_.InstanceName, self).__init__()

                        self.yang_name = "instance-name"
                        self.yang_parent_name = "process"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("instance", ("instance", Rcmd.Process.Ldp.Process_.InstanceName.Instance))])
                        self._leafs = OrderedDict([
                            ('name', (YLeaf(YType.str, 'name'), ['str'])),
                            ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                            ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                            ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                            ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                            ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                            ('lsp_regeneration_count', (YLeaf(YType.uint32, 'lsp-regeneration-count'), ['int'])),
                            ('lsp_regeneration_serial', (YLeaf(YType.uint32, 'lsp-regeneration-serial'), ['int'])),
                            ('arch_spf_event', (YLeaf(YType.uint32, 'arch-spf-event'), ['int'])),
                            ('arch_lsp_regeneration', (YLeaf(YType.uint32, 'arch-lsp-regeneration'), ['int'])),
                        ])
                        self.name = None
                        self.last_update_time = None
                        self.total_spf_nos = None
                        self.route_change_spf_nos = None
                        self.no_route_change_spf_nos = None
                        self.not_interested_spf_nos = None
                        self.lsp_regeneration_count = None
                        self.lsp_regeneration_serial = None
                        self.arch_spf_event = None
                        self.arch_lsp_regeneration = None

                        self.instance = YList(self)
                        self._segment_path = lambda: "instance-name"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ldp/process/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(Rcmd.Process.Ldp.Process_.InstanceName, ['name', 'last_update_time', 'total_spf_nos', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'lsp_regeneration_count', 'lsp_regeneration_serial', 'arch_spf_event', 'arch_lsp_regeneration'], name, value)


                    class Instance(_Entity_):
                        """
                        Instance Information
                        
                        .. attribute:: instance_id
                        
                        	Instance Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: instance_state
                        
                        	Instance State
                        	**type**\:  :py:class:`RcmdShowInstState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdShowInstState>`
                        
                        	**config**\: False
                        
                        .. attribute:: instance_deleted
                        
                        	Instance Deleted
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fwd_referenced
                        
                        	Forward Referenced
                        	**type**\:  :py:class:`RcmdBoolYesNo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper.RcmdBoolYesNo>`
                        
                        	**config**\: False
                        
                        .. attribute:: last_update_time
                        
                        	Last Updated Time
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Node Id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: spf_offset
                        
                        	SPF Offset
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spf_nos
                        
                        	Total spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: arch_spf_run
                        
                        	spf run can be archived
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: route_change_spf_nos
                        
                        	Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: no_route_change_spf_nos
                        
                        	No Route change spf nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: not_interested_spf_nos
                        
                        	Not Interested SPF nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_spt_nos
                        
                        	Total spt nos
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'infra-rcmd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(Rcmd.Process.Ldp.Process_.InstanceName.Instance, self).__init__()

                            self.yang_name = "instance"
                            self.yang_parent_name = "instance-name"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('instance_id', (YLeaf(YType.uint32, 'instance-id'), ['int'])),
                                ('instance_state', (YLeaf(YType.enumeration, 'instance-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdShowInstState', '')])),
                                ('instance_deleted', (YLeaf(YType.enumeration, 'instance-deleted'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('fwd_referenced', (YLeaf(YType.enumeration, 'fwd-referenced'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_rcmd_oper', 'RcmdBoolYesNo', '')])),
                                ('last_update_time', (YLeaf(YType.str, 'last-update-time'), ['str'])),
                                ('node_id', (YLeaf(YType.uint32, 'node-id'), ['int'])),
                                ('spf_offset', (YLeaf(YType.uint32, 'spf-offset'), ['int'])),
                                ('total_spf_nos', (YLeaf(YType.uint32, 'total-spf-nos'), ['int'])),
                                ('arch_spf_run', (YLeaf(YType.uint32, 'arch-spf-run'), ['int'])),
                                ('route_change_spf_nos', (YLeaf(YType.uint32, 'route-change-spf-nos'), ['int'])),
                                ('no_route_change_spf_nos', (YLeaf(YType.uint32, 'no-route-change-spf-nos'), ['int'])),
                                ('not_interested_spf_nos', (YLeaf(YType.uint32, 'not-interested-spf-nos'), ['int'])),
                                ('total_spt_nos', (YLeaf(YType.uint32, 'total-spt-nos'), ['int'])),
                            ])
                            self.instance_id = None
                            self.instance_state = None
                            self.instance_deleted = None
                            self.fwd_referenced = None
                            self.last_update_time = None
                            self.node_id = None
                            self.spf_offset = None
                            self.total_spf_nos = None
                            self.arch_spf_run = None
                            self.route_change_spf_nos = None
                            self.no_route_change_spf_nos = None
                            self.not_interested_spf_nos = None
                            self.total_spt_nos = None
                            self._segment_path = lambda: "instance"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-rcmd-oper:rcmd/process/ldp/process/instance-name/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(Rcmd.Process.Ldp.Process_.InstanceName.Instance, ['instance_id', 'instance_state', 'instance_deleted', 'fwd_referenced', 'last_update_time', 'node_id', 'spf_offset', 'total_spf_nos', 'arch_spf_run', 'route_change_spf_nos', 'no_route_change_spf_nos', 'not_interested_spf_nos', 'total_spt_nos'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                            return meta._meta_table['Rcmd.Process.Ldp.Process_.InstanceName.Instance']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                        return meta._meta_table['Rcmd.Process.Ldp.Process_.InstanceName']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                    return meta._meta_table['Rcmd.Process.Ldp.Process_']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
                return meta._meta_table['Rcmd.Process.Ldp']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
            return meta._meta_table['Rcmd.Process']['meta_info']

    def clone_ptr(self):
        self._top_entity = Rcmd()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_infra_rcmd_oper as meta
        return meta._meta_table['Rcmd']['meta_info']


